package com.yihu.wlyy.entity.doctor;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.wlyy.entity.IdEntity;

/**
 * 三师团队/医生工作组成员对象
 * @author George
 *
 */

@Entity
@Table(name = "wlyy_doctor_team_info")
public class DoctorTeamInfo extends IdEntity {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1842055458720630738L;

	// 团队编码，关联wlyy_doctor_team表
	private String team;
	// 医生标识，关联wlyy_doctor表
	private String doctor;
	// 医生姓名
	private String name;
	// 医生类型：1专科医生，2全科医生，3健康管理师，4营养师 5.患者
	private Integer type;
	// 更新时间
	private Date czrq;
	// 是否作废，1正常，0作废
	private String del;

	public DoctorTeamInfo() {

	}

	public String getTeam() {
		return team;
	}

	public void setTeam(String team) {
		this.team = team;
	}

	public String getDoctor() {
		return doctor;
	}

	public void setDoctor(String doctor) {
		this.doctor = doctor;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Integer getType() {
		return type;
	}

	public void setType(Integer type) {
		this.type = type;
	}

	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getCzrq() {
		return czrq;
	}

	public void setCzrq(Date czrq) {
		this.czrq = czrq;
	}

	public String getDel() {
		return del;
	}

	public void setDel(String del) {
		this.del = del;
	}

}
