/*
SQLyog v10.2 
MySQL - 5.6.29 : Database - wlyy
*********************************************************************
*/


/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`wlyy` /*!40100 DEFAULT CHARACTER SET utf8mb4 */;

USE `wlyy`;

/*Table structure for table `dm_city` */

DROP TABLE IF EXISTS `dm_city`;

CREATE TABLE `dm_city` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `province` varchar(10) DEFAULT NULL COMMENT '省编码',
  `code` varchar(50) DEFAULT NULL COMMENT '城市编码',
  `name` varchar(50) DEFAULT NULL COMMENT '城市名称',
  PRIMARY KEY (`id`),
  KEY `idx_dm_city_province` (`province`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb4 COMMENT='城市字典表';

/*Data for the table `dm_city` */

insert  into `dm_city`(`id`,`province`,`code`,`name`) values (1,'350000','350200','厦门市');

/*Table structure for table `dm_device_category` */

DROP TABLE IF EXISTS `dm_device_category`;

CREATE TABLE `dm_device_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '设备类型标识',
  `name` varchar(50) NOT NULL COMMENT '设备类型名称',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='设备分类表';

/*Data for the table `dm_device_category` */

insert  into `dm_device_category`(`id`,`code`,`name`,`czrq`,`del`) values (1,'1','血糖仪','2016-05-09 06:28:27','1'),(2,'2','血压仪','2016-05-09 06:28:32','1');

/*Table structure for table `dm_disease` */

DROP TABLE IF EXISTS `dm_disease`;

CREATE TABLE `dm_disease` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '疾病标识',
  `name` varchar(100) DEFAULT NULL COMMENT '疾病名称',
  `dept` varchar(20) DEFAULT NULL COMMENT '科室标识',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0删除',
  PRIMARY KEY (`id`),
  KEY `idx_dm_disease_1` (`dept`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='疾病字典表';

/*Data for the table `dm_disease` */

/*Table structure for table `dm_error_code` */

DROP TABLE IF EXISTS `dm_error_code`;

CREATE TABLE `dm_error_code` (
  `code` varchar(50) NOT NULL COMMENT '错误编码',
  `des` varchar(200) NOT NULL COMMENT '错误描述'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='错误代码表';

/*Data for the table `dm_error_code` */

/*Table structure for table `dm_hospital` */

DROP TABLE IF EXISTS `dm_hospital`;

CREATE TABLE `dm_hospital` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '医院标识/街道+中心站点',
  `province` varchar(50) DEFAULT NULL COMMENT '省份标识',
  `city` varchar(50) DEFAULT NULL COMMENT '城市标识',
  `town` varchar(50) DEFAULT NULL COMMENT '区县标识',
  `name` varchar(100) DEFAULT NULL COMMENT '医院名称',
  `level` int(11) DEFAULT '1' COMMENT '级别，1医院，2社区医院',
  `address` varchar(300) DEFAULT NULL COMMENT '医院详细地址',
  `intro` text COMMENT '医院简介',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  `province_name` varchar(50) DEFAULT NULL COMMENT '省份名称',
  `city_name` varchar(50) DEFAULT NULL COMMENT '城市名称',
  `town_name` varchar(50) DEFAULT NULL COMMENT '区县名称',
  `photo` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_dm_hospital_1` (`province`)
) ENGINE=InnoDB AUTO_INCREMENT=45 DEFAULT CHARSET=utf8mb4 COMMENT='医院字典表';

/*Data for the table `dm_hospital` */

insert  into `dm_hospital`(`id`,`code`,`province`,`city`,`town`,`name`,`level`,`address`,`intro`,`del`,`province_name`,`city_name`,`town_name`,`photo`) values (1,'3502030100','350000','350200','350203','中华社区医疗服务中心',2,'升平路40号（原思明区中医骨伤门诊部）及定安路60号',NULL,'1',NULL,NULL,NULL,NULL),(2,'3502030200','350000','350200','350203','厦港社区医疗服务中心',2,'蜂巢山路3号',NULL,'1',NULL,NULL,NULL,NULL),(3,'3502030300','350000','350200','350203','开元社区医疗服务中心',2,'白鹤山路3号',NULL,'1',NULL,NULL,NULL,NULL),(4,'3502030400','350000','350200','350203','莲前第一社区医疗服务中心',2,'文兴东路398号',NULL,'1',NULL,NULL,NULL,NULL),(5,'3502030500','350000','350200','350203','嘉莲社区医疗服务中心',2,'莲景路62号',NULL,'1',NULL,NULL,NULL,NULL),(6,'3502030600','350000','350200','350203','滨海社区医疗服务中心',2,'曾厝安上李龙虎南里二里15号',NULL,'1',NULL,NULL,NULL,NULL),(7,'3502030700','350000','350200','350203','梧村社区医疗服务中心',2,'文屏路6号（文灶加油站后面）',NULL,'1',NULL,NULL,NULL,NULL),(8,'3502030800','350000','350200','350203','筼筜街道社区卫生服务中心',2,'莲岳路179号',NULL,'1',NULL,NULL,NULL,NULL),(9,'3502030900','350000','350200','350203','鹭江社区医疗服务中心',2,'厦禾路100号',NULL,'1',NULL,NULL,NULL,NULL),(10,'3502031000','350000','350200','350203','鼓浪屿社区医疗服务中心',2,'鼓浪屿福建路60号',NULL,'1',NULL,NULL,NULL,NULL),(11,'3502050100','350000','350200','350205','嵩屿社区卫生服务中心',2,'海沧区嵩屿南路118号',NULL,'1',NULL,NULL,NULL,NULL),(12,'3502050101','350000','350200','350205','海沧社区卫生服务站',2,'',NULL,'1',NULL,NULL,NULL,NULL),(13,'3502050200','350000','350200','350205','石塘社区卫生服务中心',2,'海沧区兴港一里198号',NULL,'1',NULL,NULL,NULL,NULL),(14,'3502050300','350000','350200','350205','东孚卫生院',2,'海沧区东孚镇大庵',NULL,'1',NULL,NULL,NULL,NULL),(15,'3502050301','350000','350200','350205','天竺社区卫生服务站',2,'',NULL,'1',NULL,NULL,NULL,NULL),(16,'3502050302','350000','350200','350205','国营厦门第一农场社区卫生服务站',2,'',NULL,'1',NULL,NULL,NULL,NULL),(17,'3502050400','350000','350200','350205','新阳社区卫生服务中心',2,'海沧区新阳街道新景西三路8号',NULL,'1',NULL,NULL,NULL,NULL),(18,'3502060100','350000','350200','350206','湖里社区医疗服务中心',2,'海天路53号',NULL,'1',NULL,NULL,NULL,NULL),(19,'3502060101','350000','350200','350206','康乐社区卫生服务站',2,'',NULL,'1',NULL,NULL,NULL,NULL),(20,'3502060200','350000','350200','350206','江头社区医疗服务中心',2,'台湾街331号',NULL,'1',NULL,NULL,NULL,NULL),(21,'3502060300','350000','350200','350206','禾山社区医疗服务中心',2,'枋湖南路185号（车管所后面）',NULL,'1',NULL,NULL,NULL,NULL),(22,'3502060301','350000','350200','350206','围里社区卫生服务站',2,'',NULL,'1',NULL,NULL,NULL,NULL),(23,'3502060400','350000','350200','350206','金山社区医疗服务中心',2,'金山街道高林社468号',NULL,'1',NULL,NULL,NULL,NULL),(24,'3502060500','350000','350200','350206','殿前社区医疗服务中心',2,'殿前街道高殿文化中心旁',NULL,'1',NULL,NULL,NULL,NULL),(25,'3502060501','350000','350200','350206','马垅社区卫生服务站',2,'',NULL,'1',NULL,NULL,NULL,NULL),(26,'3502110100','350000','350200','350211','集美街道社区卫生服务中心',2,'集美区集源路82号',NULL,'1',NULL,NULL,NULL,NULL),(27,'3502110200','350000','350200','350211','杏林街道社区卫生服务中心',2,'集美区杏林街道月台路13号',NULL,'1',NULL,NULL,NULL,NULL),(28,'3502110300','350000','350200','350211','杏滨街道社区卫生服务中心',2,'杏滨街道日新路29号',NULL,'1',NULL,NULL,NULL,NULL),(29,'3502110400','350000','350200','350211','集美区灌口医院',2,'集美区灌口镇景山路270号',NULL,'1',NULL,NULL,NULL,NULL),(30,'3502110500','350000','350200','350211','集美区后溪卫生院',2,'集美区后溪镇中秋街23号',NULL,'1',NULL,NULL,NULL,NULL),(31,'3502110700','350000','350200','350211','侨英街道社区卫生服务中心',2,'集美区侨英街道霞梧里120号',NULL,'1',NULL,NULL,NULL,NULL),(32,'3502120100','350000','350200','350212','大同街道社区卫生服务中心',2,'环城北路892号',NULL,'1',NULL,NULL,NULL,NULL),(33,'3502120200','350000','350200','350212','祥平街道社区卫生服务中心',2,'祥平银湖路联谊花园703-704号',NULL,'1',NULL,NULL,NULL,NULL),(34,'3502120300','350000','350200','350212','洪塘卫生院',2,'洪塘镇洪塘村洪塘里226号',NULL,'1',NULL,NULL,NULL,NULL),(35,'3502120400','350000','350200','350212','五显卫生院',2,'五显镇垵炉村五显宫里1号',NULL,'1',NULL,NULL,NULL,NULL),(36,'3502120500','350000','350200','350212','汀溪卫生院',2,'汀溪镇汀溪街423号',NULL,'1',NULL,NULL,NULL,NULL),(37,'3502120600','350000','350200','350212','新民卫生院',2,'新民镇乌涂村溪仔尾',NULL,'1',NULL,NULL,NULL,NULL),(38,'3502120700','350000','350200','350212','同安区西柯中心卫生院',2,'西柯针镇西柯村',NULL,'1',NULL,NULL,NULL,NULL),(39,'3502120800','350000','350200','350212','莲花卫生院',2,'莲花镇美埔村91号',NULL,'1',NULL,NULL,NULL,NULL),(40,'3502130100','350000','350200','350213','大嶝卫生院（或）大嶝社区卫生服务中心',2,'大嶝街道田乾社区路口94号',NULL,'1',NULL,NULL,NULL,NULL),(41,'3502130200','350000','350200','350213','新店中心卫生院',2,'新店镇新兴街永兴路9号',NULL,'1',NULL,NULL,NULL,NULL),(42,'3502130300','350000','350200','350213','马巷卫生院',2,'马巷镇民安路123号',NULL,'1',NULL,NULL,NULL,NULL),(43,'3502130400','350000','350200','350213','内厝卫生院',2,'内厝镇上塘村240号',NULL,'1',NULL,NULL,NULL,NULL),(44,'3502130500','350000','350200','350213','新圩中心卫生院',2,'新圩镇龙新街',NULL,'1',NULL,NULL,NULL,NULL);

/*Table structure for table `dm_hospital_dept` */

DROP TABLE IF EXISTS `dm_hospital_dept`;

CREATE TABLE `dm_hospital_dept` (
  `code` varchar(50) NOT NULL COMMENT '科室标识',
  `name` varchar(50) NOT NULL COMMENT '科室名称',
  `del` varchar(1) DEFAULT '1' COMMENT '删除标识，1正常，0删除',
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '非业务主键',
  `hospital` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='医院科室字典表';

/*Data for the table `dm_hospital_dept` */

insert  into `dm_hospital_dept`(`code`,`name`,`del`,`id`,`hospital`) values ('1','妇科','1',1,NULL),('2','心脑血管','1',2,NULL),('3','耳鼻喉外科','1',3,NULL);

/*Table structure for table `dm_intervene_item_type` */

DROP TABLE IF EXISTS `dm_intervene_item_type`;

CREATE TABLE `dm_intervene_item_type` (
  `code` varchar(50) NOT NULL COMMENT '血糖记录类型标识',
  `name` varchar(50) NOT NULL COMMENT '血糖记录类型名称',
  `type` int(11) NOT NULL COMMENT '健康指标类型（1血糖，2血压，3体重，4腰围，5运动，6用药）',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1否，0是'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='健康干预选项类型表';

/*Data for the table `dm_intervene_item_type` */

/*Table structure for table `dm_job` */

DROP TABLE IF EXISTS `dm_job`;

CREATE TABLE `dm_job` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '非业务主键',
  `code` varchar(50) DEFAULT NULL COMMENT '职称标识',
  `name` varchar(20) DEFAULT NULL COMMENT '职称名',
  `del` varchar(1) DEFAULT NULL COMMENT '是否正常 1正常 0异常',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4;

/*Data for the table `dm_job` */

insert  into `dm_job`(`id`,`code`,`name`,`del`) values (1,'1','主任医师','1'),(2,'2','副主任医师','1');

/*Table structure for table `dm_medicines` */

DROP TABLE IF EXISTS `dm_medicines`;

CREATE TABLE `dm_medicines` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '药品编码',
  `name` varchar(50) NOT NULL COMMENT '药品名称',
  `type` int(11) DEFAULT NULL COMMENT '药品类型：1健康记录',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_dm_medicines_1` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='药品字典';

/*Data for the table `dm_medicines` */

insert  into `dm_medicines`(`id`,`code`,`name`,`type`,`del`) values (1,'1','基础胰岛素',1,'1'),(2,'2','预混胰岛素',1,'1'),(3,'3','阿司匹林',1,'1');

/*Table structure for table `dm_province` */

DROP TABLE IF EXISTS `dm_province`;

CREATE TABLE `dm_province` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(50) NOT NULL COMMENT '省份编码',
  `name` varchar(50) NOT NULL COMMENT '省份名称',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8mb4 COMMENT='省份表';

/*Data for the table `dm_province` */

insert  into `dm_province`(`id`,`code`,`name`) values (1,'350000','福建省');

/*Table structure for table `dm_relationship` */

DROP TABLE IF EXISTS `dm_relationship`;

CREATE TABLE `dm_relationship` (
  `code` varchar(50) NOT NULL COMMENT '关系标识',
  `name` varchar(50) NOT NULL COMMENT '关系名称',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  KEY `idx_dm_relationship_1` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='家族关系字典表';

/*Data for the table `dm_relationship` */

/*Table structure for table `dm_rsa` */

DROP TABLE IF EXISTS `dm_rsa`;

CREATE TABLE `dm_rsa` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `data` blob,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='RSA加密信息';

/*Data for the table `dm_rsa` */

insert  into `dm_rsa`(`id`,`data`) values (1,'\0sr\0java.security.KeyPair:\0L\0\nprivateKeyt\0\ZLjava/security/PrivateKey;L\0	publicKeyt\0Ljava/security/PublicKey;xpsr\01org.bouncycastle.jce.provider.JCERSAPrivateCrtKeylsU.\0L\0crtCoefficientt\0Ljava/math/BigInteger;L\0primeExponentPq\0~\0L\0primeExponentQq\0~\0L\0primePq\0~\0L\0primeQq\0~\0L\0publicExponentq\0~\0xr\0.org.bouncycastle.jce.provider.JCERSAPrivateKeyF	A\0L\0attrCarriert\0=Lorg/bouncycastle/jce/provider/PKCS12BagAttributeCarrierImpl;L\0modulusq\0~\0L\0privateExponentq\0~\0xpsr\0java.math.BigInteger;\0I\0bitCountI\0	bitLengthI\0firstNonzeroByteNumI\0lowestSetBitI\0signum[\0	magnitudet\0[Bxr\0java.lang.Number\0\0xp\0\0\0ur\0[BT\0\0xp\0\0\0xքxشݐV3X׸uL2N#(c|*9HJV̐ÒҞ@iq\'˦q޺ܟs3SԃfFpj7\0\ZEܻ`ztAxsr\0java.util.Hashtable%!J\0F\0\nloadFactorI\0	thresholdxp?@\0\0\0\0\0w\0\0\0\0\0\0\0xsr\0java.util.Vectorٗ}[;\0I\0capacityIncrementI\0elementCount[\0elementDatat\0[Ljava/lang/Object;xp\0\0\0\0\0\0\0\0ur\0[Ljava.lang.Object;Xs)l\0\0xp\0\0\0\nppppppppppxsq\0~\0	\0\0\0uq\0~\0\r\0\0\0%NZy] ,W,&?2D_\' L%5*~0ImS#Vgb0c67Oՙc[i|e@4aɖҗcJgyz}q\"ysO\neOXi@;,Axxsq\0~\0	\0\0\0uq\0~\0\r\0\0\0@#.ܿw$?iGrPD+[2jպV%˽A#xsq\0~\0	\0\0\0uq\0~\0\r\0\0\0@U$<bCu6A}2$+E^i1VNpE#vvL\r%:OevRKwxsq\0~\0	\0\0\0uq\0~\0\r\0\0\0@HuW}1\nÒH	KcO+Al;ɓ7e²	̤G+dZ{Ǆxsq\0~\0	\0\0\0uq\0~\0\r\0\0\0@A@x/v-yXeX:\\ݒ п6}?˧\\msOX8xsq\0~\0	\0\0\0uq\0~\0\r\0\0\0@Lʎ\06	xTsjB+ħ2>b=w?*jS!0.~=xsq\0~\0	\0\0\0uq\0~\0\r\0\0\0\0xsr\0-org.bouncycastle.jce.provider.JCERSAPublicKey%\"j[l\0L\0modulusq\0~\0L\0publicExponentq\0~\0xpq\0~\0q\0~\0\"');

/*Table structure for table `dm_sequence` */

DROP TABLE IF EXISTS `dm_sequence`;

CREATE TABLE `dm_sequence` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `prefix` varchar(10) NOT NULL COMMENT '前缀，如DOC',
  `time` varchar(8) NOT NULL COMMENT '日期，如20160301',
  `seq` int(8) NOT NULL COMMENT '当前序号',
  `len` int(11) NOT NULL COMMENT '序号长度，不足默认补0',
  `flag` int(11) DEFAULT NULL COMMENT '是否要包含前缀，1包含，0不包含',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_dm_sequence_1` (`prefix`,`time`)
) ENGINE=InnoDB AUTO_INCREMENT=162 DEFAULT CHARSET=utf8mb4 COMMENT='序列生成记录表';

/*Data for the table `dm_sequence` */

insert  into `dm_sequence`(`id`,`prefix`,`time`,`seq`,`len`,`flag`) values (15,'PATIENT','20160322',2,6,0),(45,'FUP','20160323',3,8,1),(46,'MSG','20160323',3,8,1),(47,'PHA','20160324',1,6,1),(49,'PRE','20160326',3,8,1),(53,'PRIN','20160326',2,8,1),(54,'TEMP','20160326',1,8,1),(57,'CONS','20160326',5,6,0),(59,'REF','20160326',2,8,1),(60,'INS','20160326',1,8,1),(61,'INSI','20160326',2,8,1),(62,'FUP','20160326',1,8,1),(63,'PAR','20160328',2,8,1),(64,'CHK','20160328',1,8,1),(66,'IMG','20160328',3,8,1),(67,'POS','20160328',1,8,1),(68,'INS','20160328',1,8,1),(69,'IMG','20160329',55,8,1),(81,'CONS','20160329',36,6,0),(82,'PAR','20160330',11,8,1),(83,'CONS','20160330',23,8,1),(84,'IMG','20160330',18,8,1),(85,'INS','20160330',13,8,1),(89,'ORD','20160330',5,8,1),(91,'CONS','20160331',96,6,0),(92,'PRE','20160331',2,8,1),(93,'PRIN','20160331',4,8,1),(94,'ORD','20160331',4,8,1),(95,'CHK','20160331',13,8,1),(96,'INS','20160331',2,8,1),(97,'IMG','20160331',1,8,1),(98,'CONS','20160401',36,6,0),(99,'PRE','20160401',5,8,1),(100,'PRIN','20160401',10,8,1),(101,'CHK','20160401',12,8,1),(107,'INS','20160401',3,8,1),(108,'IMG','20160401',1,8,1),(109,'PAR','20160401',1,8,1),(115,'CHK','20160402',4,8,1),(116,'PRE','20160402',1,8,1),(117,'PRIN','20160402',2,8,1),(123,'CONS','20160405',9,6,0),(129,'PAR','20160405',5,8,1),(135,'INS','20160406',1,8,1),(136,'CONS','20160406',3,6,0),(139,'ORD','20160406',9,8,1),(140,'IMG','20160406',1,8,1),(141,'PAR','20160406',7,8,1),(142,'CONS','20160407',46,6,0),(143,'INS','20160407',5,8,1),(144,'PAR','20160407',7,8,1),(145,'ORD','20160407',15,8,1),(146,'PRE','20160407',1,8,1),(147,'PRIN','20160407',2,8,1),(148,'IMG','20160407',16,8,1),(149,'CHK','20160408',2,8,1),(150,'PAR','20160408',1,8,1),(151,'CONS','20160408',7,6,0),(152,'IMG','20160408',1,8,1),(153,'CONS','20160411',1,6,0),(154,'PAR','20160411',9,8,1),(155,'CONS','20160412',27,6,0),(156,'ORD','20160408',11,8,1),(157,'PRE','20160412',4,8,1),(158,'PRIN','20160412',8,8,1),(159,'PAR','20160412',1,8,1),(160,'PRE','20160413',1,8,1),(161,'PRIN','20160413',2,8,1);

/*Table structure for table `dm_service` */

DROP TABLE IF EXISTS `dm_service`;

CREATE TABLE `dm_service` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '服务标识',
  `logo` varchar(300) NOT NULL COMMENT '服务LOGO http地址',
  `title` varchar(100) NOT NULL COMMENT '服务标题',
  `content` varchar(200) NOT NULL COMMENT '服务介绍',
  `url` varchar(300) NOT NULL COMMENT '服务访问URL',
  `czrq` datetime NOT NULL COMMENT '服务添加时间',
  PRIMARY KEY (`id`),
  KEY `idx_dm_service_1` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医生服务类型表';

/*Data for the table `dm_service` */

/*Table structure for table `dm_sports` */

DROP TABLE IF EXISTS `dm_sports`;

CREATE TABLE `dm_sports` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '运动编码',
  `name` varchar(100) DEFAULT NULL COMMENT '运动名称',
  `type` varchar(20) DEFAULT NULL COMMENT '运动强度类型标识',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_dm_sports_1` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COMMENT='运动类型字典表';

/*Data for the table `dm_sports` */

insert  into `dm_sports`(`id`,`code`,`name`,`type`,`del`) values (1,'1','购物',NULL,'1'),(2,'2','散步',NULL,'1'),(3,'3','做操',NULL,'1'),(4,'4','太极拳',NULL,'1'),(5,'5','气功',NULL,'1'),(6,'6','跑步',NULL,'1');

/*Table structure for table `dm_sports_type` */

DROP TABLE IF EXISTS `dm_sports_type`;

CREATE TABLE `dm_sports_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '强度编码',
  `name` varchar(100) DEFAULT NULL COMMENT '强度名称',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_dm_sports_type_1` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='运动强度字典表';

/*Data for the table `dm_sports_type` */

insert  into `dm_sports_type`(`id`,`code`,`name`,`del`) values (1,'1','轻度运动','1'),(2,'2','中度运动','1'),(3,'3','稍强运动','1'),(4,'4','强度运动','1');

/*Table structure for table `dm_town` */

DROP TABLE IF EXISTS `dm_town`;

CREATE TABLE `dm_town` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `province` varchar(50) DEFAULT NULL COMMENT '省编码',
  `city` varchar(50) DEFAULT NULL COMMENT '城市编码',
  `code` varchar(50) DEFAULT NULL COMMENT '区县编码',
  `name` varchar(50) DEFAULT NULL COMMENT '区县名称',
  PRIMARY KEY (`id`),
  KEY `idx_dm_town_1` (`city`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COMMENT='区县字典表';

/*Data for the table `dm_town` */

insert  into `dm_town`(`id`,`province`,`city`,`code`,`name`) values (1,'350000','350200','350201','市辖区'),(2,'350000','350200','350203','思明区'),(3,'350000','350200','350205','海沧区'),(4,'350000','350200','350206','湖里区'),(5,'350000','350200','350211','集美区'),(6,'350000','350200','350212','同安区'),(7,'350000','350200','350213','翔安区');

/*Table structure for table `region` */

DROP TABLE IF EXISTS `region`;

CREATE TABLE `region` (
  `REGION_ID` double NOT NULL,
  `REGION_CODE` varchar(100) NOT NULL,
  `REGION_NAME` varchar(100) NOT NULL,
  `PARENT_ID` double NOT NULL,
  `REGION_LEVEL` double NOT NULL,
  `REGION_ORDER` double NOT NULL,
  `REGION_NAME_EN` varchar(100) NOT NULL,
  `REGION_SHORTNAME_EN` varchar(10) NOT NULL,
  PRIMARY KEY (`REGION_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `region` */

insert  into `region`(`REGION_ID`,`REGION_CODE`,`REGION_NAME`,`PARENT_ID`,`REGION_LEVEL`,`REGION_ORDER`,`REGION_NAME_EN`,`REGION_SHORTNAME_EN`) values (1,'中国','中国',0,0,0,'Zhong Guo','2'),(2,'110000','北京市',1,0,0,'Beijing Shi','BJ'),(3,'120000','天津市',1,0,0,'Tianjin Shi','TJ'),(4,'130000','河北省',1,0,0,'Hebei Sheng','HE'),(5,'140000','山西省',1,0,0,'Shanxi Sheng ','SX'),(6,'150000','内蒙古自治区',1,0,0,'Nei Mongol Zizhiqu','NM'),(7,'210000','辽宁省',1,0,0,'Liaoning Sheng','LN'),(8,'220000','吉林省',1,0,0,'Jilin Sheng','JL'),(9,'230000','黑龙江省',1,0,0,'Heilongjiang Sheng','HL'),(10,'310000','上海市',1,0,0,'Shanghai Shi','SH'),(11,'320000','江苏省',1,0,0,'Jiangsu Sheng','JS'),(12,'330000','浙江省',1,0,0,'Zhejiang Sheng','ZJ'),(13,'340000','安徽省',1,0,0,'Anhui Sheng','AH'),(14,'350000','福建省',1,0,0,'Fujian Sheng ','FJ'),(15,'360000','江西省',1,0,0,'Jiangxi Sheng','JX'),(16,'370000','山东省',1,0,0,'Shandong Sheng ','SD'),(17,'410000','河南省',1,0,0,'Henan Sheng','HA'),(18,'420000','湖北省',1,0,0,'Hubei Sheng','HB'),(19,'430000','湖南省',1,0,0,'Hunan Sheng','HN'),(20,'440000','广东省',1,0,0,'Guangdong Sheng','GD'),(21,'450000','广西壮族自治区',1,0,0,'Guangxi Zhuangzu Zizhiqu','GX'),(22,'460000','海南省',1,0,0,'Hainan Sheng','HI'),(23,'500000','重庆市',1,0,0,'Chongqing Shi','CQ'),(24,'510000','四川省',1,0,0,'Sichuan Sheng','SC'),(25,'520000','贵州省',1,0,0,'Guizhou Sheng','GZ'),(26,'530000','云南省',1,0,0,'Yunnan Sheng','YN'),(27,'540000','西藏自治区',1,0,0,'Xizang Zizhiqu','XZ'),(28,'610000','陕西省',1,0,0,'Shanxi Sheng ','SN'),(29,'620000','甘肃省',1,0,0,'Gansu Sheng','GS'),(30,'630000','青海省',1,0,0,'Qinghai Sheng','QH'),(31,'640000','宁夏回族自治区',1,0,0,'Ningxia Huizu Zizhiqu','NX'),(32,'650000','新疆维吾尔自治区',1,0,0,'Xinjiang Uygur Zizhiqu','XJ'),(33,'110100','市辖区',2,0,0,'Shixiaqu','2'),(34,'110200','县',2,0,0,'Xian','2'),(35,'120100','市辖区',3,0,0,'Shixiaqu','2'),(36,'120200','县',3,0,0,'Xian','2'),(37,'130100','石家庄市',4,0,0,'Shijiazhuang Shi','SJW'),(38,'130200','唐山市',4,0,0,'Tangshan Shi','TGS'),(39,'130300','秦皇岛市',4,0,0,'Qinhuangdao Shi','SHP'),(40,'130400','邯郸市',4,0,0,'Handan Shi','HDS'),(41,'130500','邢台市',4,0,0,'Xingtai Shi','XTS'),(42,'130600','保定市',4,0,0,'Baoding Shi','BDS'),(43,'130700','张家口市',4,0,0,'Zhangjiakou Shi ','ZJK'),(44,'130800','承德市',4,0,0,'Chengde Shi','CDS'),(45,'130900','沧州市',4,0,0,'Cangzhou Shi','CGZ'),(46,'131000','廊坊市',4,0,0,'Langfang Shi','LFS'),(47,'131100','衡水市',4,0,0,'Hengshui Shi ','HGS'),(48,'140100','太原市',5,0,0,'Taiyuan Shi','TYN'),(49,'140200','大同市',5,0,0,'Datong Shi ','DTG'),(50,'140300','阳泉市',5,0,0,'Yangquan Shi','YQS'),(51,'140400','长治市',5,0,0,'Changzhi Shi','CZS'),(52,'140500','晋城市',5,0,0,'Jincheng Shi ','JCG'),(53,'140600','朔州市',5,0,0,'Shuozhou Shi ','SZJ'),(54,'140700','晋中市',5,0,0,'Jinzhong Shi','2'),(55,'140800','运城市',5,0,0,'Yuncheng Shi','2'),(56,'140900','忻州市',5,0,0,'Xinzhou Shi','2'),(57,'141000','临汾市',5,0,0,'Linfen Shi','2'),(58,'141100','吕梁市',5,0,0,'Lvliang Shi','2'),(59,'150100','呼和浩特市',6,0,0,'Hohhot Shi','Hhht'),(60,'150200','包头市',6,0,0,'Baotou Shi ','BTS'),(61,'150300','乌海市',6,0,0,'Wuhai Shi','WHM'),(62,'150400','赤峰市',6,0,0,'Chifeng (Ulanhad)Shi','CFS'),(63,'150500','通辽市',6,0,0,'Tongliao Shi','2'),(64,'150600','鄂尔多斯市',6,0,0,'Eerduosi Shi','2'),(65,'150700','呼伦贝尔市',6,0,0,'Hulunbeier Shi ','2'),(66,'150800','巴彦淖尔市',6,0,0,'Bayannaoer Shi','2'),(67,'150900','乌兰察布市',6,0,0,'Wulanchabu Shi','2'),(68,'152200','兴安盟',6,0,0,'Hinggan Meng','HIN'),(69,'152500','锡林郭勒盟',6,0,0,'Xilin Gol Meng','XGO'),(70,'152900','阿拉善盟',6,0,0,'Alxa Meng','ALM'),(71,'210100','沈阳市',7,0,0,'Shenyang Shi','SHE'),(72,'210200','大连市',7,0,0,'Dalian Shi','DLC'),(73,'210300','鞍山市',7,0,0,'AnShan Shi','ASN'),(74,'210400','抚顺市',7,0,0,'Fushun Shi','FSN'),(75,'210500','本溪市',7,0,0,'Benxi Shi','BXS'),(76,'210600','丹东市',7,0,0,'Dandong Shi','DDG'),(77,'210700','锦州市',7,0,0,'Jinzhou Shi','JNZ'),(78,'210800','营口市',7,0,0,'Yingkou Shi','YIK'),(79,'210900','阜新市',7,0,0,'Fuxin Shi','FXS'),(80,'211000','辽阳市',7,0,0,'Liaoyang Shi','LYL'),(81,'211100','盘锦市',7,0,0,'Panjin Shi','PJS'),(82,'211200','铁岭市',7,0,0,'Tieling Shi','TLS'),(83,'211300','朝阳市',7,0,0,'Chaoyang Shi','CYS'),(84,'211400','葫芦岛市',7,0,0,'Huludao Shi','HLD'),(85,'220100','长春市',8,0,0,'Changchun Shi ','CGQ'),(86,'220200','吉林市',8,0,0,'Jilin Shi ','JLS'),(87,'220300','四平市',8,0,0,'Siping Shi','SPS'),(88,'220400','辽源市',8,0,0,'Liaoyuan Shi','LYH'),(89,'220500','通化市',8,0,0,'Tonghua Shi','THS'),(90,'220600','白山市',8,0,0,'Baishan Shi','BSN'),(91,'220700','松原市',8,0,0,'Songyuan Shi','SYU'),(92,'220800','白城市',8,0,0,'Baicheng Shi','BCS'),(93,'222400','延边朝鲜族自治州',8,0,0,'Yanbian Chosenzu Zizhizhou','YBZ'),(94,'230100','哈尔滨市',9,0,0,'Harbin Shi','HRB'),(95,'230200','齐齐哈尔市',9,0,0,'Qiqihar Shi','NDG'),(96,'230300','鸡西市',9,0,0,'Jixi Shi','JXI'),(97,'230400','鹤岗市',9,0,0,'Hegang Shi','HEG'),(98,'230500','双鸭山市',9,0,0,'Shuangyashan Shi','SYS'),(99,'230600','大庆市',9,0,0,'Daqing Shi','DQG'),(100,'230700','伊春市',9,0,0,'Yichun Shi','YCH'),(101,'230800','佳木斯市',9,0,0,'Jiamusi Shi','JMU'),(102,'230900','七台河市',9,0,0,'Qitaihe Shi','QTH'),(103,'231000','牡丹江市',9,0,0,'Mudanjiang Shi','MDG'),(104,'231100','黑河市',9,0,0,'Heihe Shi','HEK'),(105,'231200','绥化市',9,0,0,'Suihua Shi','2'),(106,'232700','大兴安岭地区',9,0,0,'Da Hinggan Ling Diqu','DHL'),(107,'310100','市辖区',10,0,0,'Shixiaqu','2'),(108,'310200','县',10,0,0,'Xian','2'),(109,'320100','南京市',11,0,0,'Nanjing Shi','NKG'),(110,'320200','无锡市',11,0,0,'Wuxi Shi','WUX'),(111,'320300','徐州市',11,0,0,'Xuzhou Shi','XUZ'),(112,'320400','常州市',11,0,0,'Changzhou Shi','CZX'),(113,'320500','苏州市',11,0,0,'Suzhou Shi','SZH'),(114,'320600','南通市',11,0,0,'Nantong Shi','NTG'),(115,'320700','连云港市',11,0,0,'Lianyungang Shi','LYG'),(116,'320800','淮安市',11,0,0,'Huai,an Xian','2'),(117,'320900','盐城市',11,0,0,'Yancheng Shi','YCK'),(118,'321000','扬州市',11,0,0,'Yangzhou Shi','YZH'),(119,'321100','镇江市',11,0,0,'Zhenjiang Shi','ZHE'),(120,'321200','泰州市',11,0,0,'Taizhou Shi','TZS'),(121,'321300','宿迁市',11,0,0,'Suqian Shi','SUQ'),(122,'330100','杭州市',12,0,0,'Hangzhou Shi','HGH'),(123,'330200','宁波市',12,0,0,'Ningbo Shi','NGB'),(124,'330300','温州市',12,0,0,'Wenzhou Shi','WNZ'),(125,'330400','嘉兴市',12,0,0,'Jiaxing Shi','JIX'),(126,'330500','湖州市',12,0,0,'Huzhou Shi ','HZH'),(127,'330600','绍兴市',12,0,0,'Shaoxing Shi','SXG'),(128,'330700','金华市',12,0,0,'Jinhua Shi','JHA'),(129,'330800','衢州市',12,0,0,'Quzhou Shi','QUZ'),(130,'330900','舟山市',12,0,0,'Zhoushan Shi','ZOS'),(131,'331000','台州市',12,0,0,'Taizhou Shi','TZZ'),(132,'331100','丽水市',12,0,0,'Lishui Shi','2'),(133,'340100','合肥市',13,0,0,'Hefei Shi','HFE'),(134,'340200','芜湖市',13,0,0,'Wuhu Shi','WHI'),(135,'340300','蚌埠市',13,0,0,'Bengbu Shi','BBU'),(136,'340400','淮南市',13,0,0,'Huainan Shi','HNS'),(137,'340500','马鞍山市',13,0,0,'Ma,anshan Shi','MAA'),(138,'340600','淮北市',13,0,0,'Huaibei Shi','HBE'),(139,'340700','铜陵市',13,0,0,'Tongling Shi','TOL'),(140,'340800','安庆市',13,0,0,'Anqing Shi','AQG'),(141,'341000','黄山市',13,0,0,'Huangshan Shi','HSN'),(142,'341100','滁州市',13,0,0,'Chuzhou Shi','CUZ'),(143,'341200','阜阳市',13,0,0,'Fuyang Shi','FYS'),(144,'341300','宿州市',13,0,0,'Suzhou Shi','SUZ'),(145,'341400','巢湖市',13,0,0,'Chaohu Shi','2'),(146,'341500','六安市',13,0,0,'Liu,an Shi','2'),(147,'341600','亳州市',13,0,0,'Bozhou Shi','2'),(148,'341700','池州市',13,0,0,'Chizhou Shi','2'),(149,'341800','宣城市',13,0,0,'Xuancheng Shi','2'),(150,'350100','福州市',14,0,0,'Fuzhou Shi','FOC'),(151,'350200','厦门市',14,0,0,'Xiamen Shi','XMN'),(152,'350300','莆田市',14,0,0,'Putian Shi','PUT'),(153,'350400','三明市',14,0,0,'Sanming Shi','SMS'),(154,'350500','泉州市',14,0,0,'Quanzhou Shi','QZJ'),(155,'350600','漳州市',14,0,0,'Zhangzhou Shi','ZZU'),(156,'350700','南平市',14,0,0,'Nanping Shi','NPS'),(157,'350800','龙岩市',14,0,0,'Longyan Shi','LYF'),(158,'350900','宁德市',14,0,0,'Ningde Shi','2'),(159,'360100','南昌市',15,0,0,'Nanchang Shi','KHN'),(160,'360200','景德镇市',15,0,0,'Jingdezhen Shi','JDZ'),(161,'360300','萍乡市',15,0,0,'Pingxiang Shi','PXS'),(162,'360400','九江市',15,0,0,'Jiujiang Shi','JIU'),(163,'360500','新余市',15,0,0,'Xinyu Shi','XYU'),(164,'360600','鹰潭市',15,0,0,'Yingtan Shi','2'),(165,'360700','赣州市',15,0,0,'Ganzhou Shi','GZH'),(166,'360800','吉安市',15,0,0,'Ji,an Shi','2'),(167,'360900','宜春市',15,0,0,'Yichun Shi','2'),(168,'361000','抚州市',15,0,0,'Wuzhou Shi','2'),(169,'361100','上饶市',15,0,0,'Shangrao Shi','2'),(170,'370100','济南市',16,0,0,'Jinan Shi','TNA'),(171,'370200','青岛市',16,0,0,'Qingdao Shi','TAO'),(172,'370300','淄博市',16,0,0,'Zibo Shi','ZBO'),(173,'370400','枣庄市',16,0,0,'Zaozhuang Shi','ZZG'),(174,'370500','东营市',16,0,0,'Dongying Shi','DYG'),(175,'370600','烟台市',16,0,0,'Yantai Shi','YNT'),(176,'370700','潍坊市',16,0,0,'Weifang Shi','WEF'),(177,'370800','济宁市',16,0,0,'Jining Shi','JNG'),(178,'370900','泰安市',16,0,0,'Tai,an Shi','TAI'),(179,'371000','威海市',16,0,0,'Weihai Shi','WEH'),(180,'371100','日照市',16,0,0,'Rizhao Shi','RZH'),(181,'371200','莱芜市',16,0,0,'Laiwu Shi','LWS'),(182,'371300','临沂市',16,0,0,'Linyi Shi','LYI'),(183,'371400','德州市',16,0,0,'Dezhou Shi','DZS'),(184,'371500','聊城市',16,0,0,'Liaocheng Shi','LCH'),(185,'371600','滨州市',16,0,0,'Binzhou Shi','2'),(186,'371700','菏泽市',16,3,0,'Heze Shi','HZ'),(187,'410100','郑州市',17,0,0,'Zhengzhou Shi','CGO'),(188,'410200','开封市',17,0,0,'Kaifeng Shi','KFS'),(189,'410300','洛阳市',17,0,0,'Luoyang Shi','LYA'),(190,'410400','平顶山市',17,0,0,'Pingdingshan Shi','PDS'),(191,'410500','安阳市',17,0,0,'Anyang Shi','AYS'),(192,'410600','鹤壁市',17,0,0,'Hebi Shi','HBS'),(193,'410700','新乡市',17,0,0,'Xinxiang Shi','XXS'),(194,'410800','焦作市',17,0,0,'Jiaozuo Shi','JZY'),(195,'410900','濮阳市',17,0,0,'Puyang Shi','PYS'),(196,'411000','许昌市',17,0,0,'Xuchang Shi','XCS'),(197,'411100','漯河市',17,0,0,'Luohe Shi','LHS'),(198,'411200','三门峡市',17,0,0,'Sanmenxia Shi','SMX'),(199,'411300','南阳市',17,0,0,'Nanyang Shi','NYS'),(200,'411400','商丘市',17,0,0,'Shangqiu Shi','SQS'),(201,'411500','信阳市',17,0,0,'Xinyang Shi','XYG'),(202,'411600','周口市',17,0,0,'Zhoukou Shi','2'),(203,'411700','驻马店市',17,0,0,'Zhumadian Shi','2'),(204,'420100','武汉市',18,0,0,'Wuhan Shi','WUH'),(205,'420200','黄石市',18,0,0,'Huangshi Shi','HIS'),(206,'420300','十堰市',18,0,0,'Shiyan Shi','SYE'),(207,'420500','宜昌市',18,0,0,'Yichang Shi','YCO'),(208,'420600','襄樊市',18,0,0,'Xiangfan Shi','XFN'),(209,'420700','鄂州市',18,0,0,'Ezhou Shi','EZS'),(210,'420800','荆门市',18,0,0,'Jingmen Shi','JMS'),(211,'420900','孝感市',18,0,0,'Xiaogan Shi','XGE'),(212,'421000','荆州市',18,0,0,'Jingzhou Shi','JGZ'),(213,'421100','黄冈市',18,0,0,'Huanggang Shi','HE'),(214,'421200','咸宁市',18,0,0,'Xianning Xian','XNS'),(215,'421300','随州市',18,0,0,'Suizhou Shi','2'),(216,'422800','恩施土家族苗族自治州',18,0,0,'Enshi Tujiazu Miaozu Zizhizhou','ESH'),(217,'429000','省直辖县级行政区划',18,0,0,'shengzhixiaxianjixingzhengquhua','2'),(218,'430100','长沙市',19,0,0,'Changsha Shi','CSX'),(219,'430200','株洲市',19,0,0,'Zhuzhou Shi','ZZS'),(220,'430300','湘潭市',19,0,0,'Xiangtan Shi','XGT'),(221,'430400','衡阳市',19,0,0,'Hengyang Shi','HNY'),(222,'430500','邵阳市',19,0,0,'Shaoyang Shi','SYR'),(223,'430600','岳阳市',19,0,0,'Yueyang Shi','YYG'),(224,'430700','常德市',19,0,0,'Changde Shi','CDE'),(225,'430800','张家界市',19,0,0,'Zhangjiajie Shi','ZJJ'),(226,'430900','益阳市',19,0,0,'Yiyang Shi','YYS'),(227,'431000','郴州市',19,0,0,'Chenzhou Shi','CNZ'),(228,'431100','永州市',19,0,0,'Yongzhou Shi','YZS'),(229,'431200','怀化市',19,0,0,'Huaihua Shi','HHS'),(230,'431300','娄底市',19,0,0,'Loudi Shi','2'),(231,'433100','湘西土家族苗族自治州',19,0,0,'Xiangxi Tujiazu Miaozu Zizhizhou ','XXZ'),(232,'440100','广州市',20,0,0,'Guangzhou Shi','CAN'),(233,'440200','韶关市',20,0,0,'Shaoguan Shi','HSC'),(234,'440300','深圳市',20,0,0,'Shenzhen Shi','SZX'),(235,'440400','珠海市',20,0,0,'Zhuhai Shi','ZUH'),(236,'440500','汕头市',20,0,0,'Shantou Shi','SWA'),(237,'440600','佛山市',20,0,0,'Foshan Shi','FOS'),(238,'440700','江门市',20,0,0,'Jiangmen Shi','JMN'),(239,'440800','湛江市',20,0,0,'Zhanjiang Shi','ZHA'),(240,'440900','茂名市',20,0,0,'Maoming Shi','MMI'),(241,'441200','肇庆市',20,0,0,'Zhaoqing Shi','ZQG'),(242,'441300','惠州市',20,0,0,'Huizhou Shi','HUI'),(243,'441400','梅州市',20,0,0,'Meizhou Shi','MXZ'),(244,'441500','汕尾市',20,0,0,'Shanwei Shi','SWE'),(245,'441600','河源市',20,0,0,'Heyuan Shi','HEY'),(246,'441700','阳江市',20,0,0,'Yangjiang Shi','YJI'),(247,'441800','清远市',20,0,0,'Qingyuan Shi','QYN'),(248,'441900','东莞市',20,0,0,'Dongguan Shi','DGG'),(249,'442000','中山市',20,0,0,'Zhongshan Shi','ZSN'),(250,'445100','潮州市',20,0,0,'Chaozhou Shi','CZY'),(251,'445200','揭阳市',20,0,0,'Jieyang Shi','JIY'),(252,'445300','云浮市',20,0,0,'Yunfu Shi','YFS'),(253,'450100','南宁市',21,0,0,'Nanning Shi','NNG'),(254,'450200','柳州市',21,0,0,'Liuzhou Shi','LZH'),(255,'450300','桂林市',21,0,0,'Guilin Shi','KWL'),(256,'450400','梧州市',21,0,0,'Wuzhou Shi','WUZ'),(257,'450500','北海市',21,0,0,'Beihai Shi','BHY'),(258,'450600','防城港市',21,0,0,'Fangchenggang Shi','FAN'),(259,'450700','钦州市',21,0,0,'Qinzhou Shi','QZH'),(260,'450800','贵港市',21,0,0,'Guigang Shi','GUG'),(261,'450900','玉林市',21,0,0,'Yulin Shi','YUL'),(262,'451000','百色市',21,0,0,'Baise Shi','2'),(263,'451100','贺州市',21,0,0,'Hezhou Shi','2'),(264,'451200','河池市',21,0,0,'Hechi Shi','2'),(265,'451300','来宾市',21,0,0,'Laibin Shi','2'),(266,'451400','崇左市',21,0,0,'Chongzuo Shi','2'),(267,'460100','海口市',22,0,0,'Haikou Shi','HAK'),(268,'460200','三亚市',22,0,0,'Sanya Shi','SYX'),(269,'469000','省直辖县级行政区划',22,0,0,'shengzhixiaxianjixingzhengquhua','2'),(270,'500100','市辖区',23,0,0,'Shixiaqu','2'),(271,'500200','县',23,0,0,'Xian','2'),(273,'510100','成都市',24,0,0,'Chengdu Shi','CTU'),(274,'510300','自贡市',24,0,0,'Zigong Shi','ZGS'),(275,'510400','攀枝花市',24,0,0,'Panzhihua Shi','PZH'),(276,'510500','泸州市',24,0,0,'Luzhou Shi','LUZ'),(277,'510600','德阳市',24,0,0,'Deyang Shi','DEY'),(278,'510700','绵阳市',24,0,0,'Mianyang Shi','MYG'),(279,'510800','广元市',24,0,0,'Guangyuan Shi','GYC'),(280,'510900','遂宁市',24,0,0,'Suining Shi','SNS'),(281,'511000','内江市',24,0,0,'Neijiang Shi','NJS'),(282,'511100','乐山市',24,0,0,'Leshan Shi','LES'),(283,'511300','南充市',24,0,0,'Nanchong Shi','NCO'),(284,'511400','眉山市',24,0,0,'Meishan Shi','2'),(285,'511500','宜宾市',24,0,0,'Yibin Shi','YBS'),(286,'511600','广安市',24,0,0,'Guang,an Shi','GAC'),(287,'511700','达州市',24,0,0,'Dazhou Shi','2'),(288,'511800','雅安市',24,0,0,'Ya,an Shi','2'),(289,'511900','巴中市',24,0,0,'Bazhong Shi','2'),(290,'512000','资阳市',24,0,0,'Ziyang Shi','2'),(291,'513200','阿坝藏族羌族自治州',24,0,0,'Aba(Ngawa) Zangzu Qiangzu Zizhizhou','ABA'),(292,'513300','甘孜藏族自治州',24,0,0,'Garze Zangzu Zizhizhou','GAZ'),(293,'513400','凉山彝族自治州',24,0,0,'Liangshan Yizu Zizhizhou','LSY'),(294,'520100','贵阳市',25,0,0,'Guiyang Shi','KWE'),(295,'520200','六盘水市',25,0,0,'Liupanshui Shi','LPS'),(296,'520300','遵义市',25,0,0,'Zunyi Shi','ZNY'),(297,'520400','安顺市',25,0,0,'Anshun Xian','2'),(298,'522200','铜仁地区',25,0,0,'Tongren Diqu','TRD'),(299,'522300','黔西南布依族苗族自治州',25,0,0,'Qianxinan Buyeizu Zizhizhou','QXZ'),(300,'522400','毕节地区',25,0,0,'Bijie Diqu','BJD'),(301,'522600','黔东南苗族侗族自治州',25,0,0,'Qiandongnan Miaozu Dongzu Zizhizhou','QND'),(302,'522700','黔南布依族苗族自治州',25,0,0,'Qiannan Buyeizu Miaozu Zizhizhou','QNZ'),(303,'530100','昆明市',26,0,0,'Kunming Shi','KMG'),(304,'530300','曲靖市',26,0,0,'Qujing Shi','QJS'),(305,'530400','玉溪市',26,0,0,'Yuxi Shi','YXS'),(306,'530500','保山市',26,0,0,'Baoshan Shi','2'),(307,'530600','昭通市',26,0,0,'Zhaotong Shi','2'),(308,'530700','丽江市',26,0,0,'Lijiang Shi','2'),(309,'530800','普洱市',26,0,0,'Simao Shi','2'),(310,'530900','临沧市',26,0,0,'Lincang Shi','2'),(311,'532300','楚雄彝族自治州',26,0,0,'Chuxiong Yizu Zizhizhou','CXD'),(312,'532500','红河哈尼族彝族自治州',26,0,0,'Honghe Hanizu Yizu Zizhizhou','HHZ'),(313,'532600','文山壮族苗族自治州',26,0,0,'Wenshan Zhuangzu Miaozu Zizhizhou','WSZ'),(314,'532800','西双版纳傣族自治州',26,0,0,'Xishuangbanna Daizu Zizhizhou','XSB'),(315,'532900','大理白族自治州',26,0,0,'Dali Baizu Zizhizhou','DLZ'),(316,'533100','德宏傣族景颇族自治州',26,0,0,'Dehong Daizu Jingpozu Zizhizhou','DHG'),(317,'533300','怒江傈僳族自治州',26,0,0,'Nujiang Lisuzu Zizhizhou','NUJ'),(318,'533400','迪庆藏族自治州',26,0,0,'Deqen Zangzu Zizhizhou','DEZ'),(319,'540100','拉萨市',27,0,0,'Lhasa Shi','LXA'),(320,'542100','昌都地区',27,0,0,'Qamdo Diqu','QAD'),(321,'542200','山南地区',27,0,0,'Shannan Diqu','SND'),(322,'542300','日喀则地区',27,0,0,'Xigaze Diqu','XID'),(323,'542400','那曲地区',27,0,0,'Nagqu Diqu','NAD'),(324,'542500','阿里地区',27,0,0,'Ngari Diqu','NGD'),(325,'542600','林芝地区',27,0,0,'Nyingchi Diqu','NYD'),(326,'610100','西安市',28,0,0,'Xi,an Shi','SIA'),(327,'610200','铜川市',28,0,0,'Tongchuan Shi','TCN'),(328,'610300','宝鸡市',28,0,0,'Baoji Shi','BJI'),(329,'610400','咸阳市',28,0,0,'Xianyang Shi','XYS'),(330,'610500','渭南市',28,0,0,'Weinan Shi','WNA'),(331,'610600','延安市',28,0,0,'Yan,an Shi','YNA'),(332,'610700','汉中市',28,0,0,'Hanzhong Shi','HZJ'),(333,'610800','榆林市',28,0,0,'Yulin Shi','2'),(334,'610900','安康市',28,0,0,'Ankang Shi','2'),(335,'611000','商洛市',28,0,0,'Shangluo Shi','2'),(336,'620100','兰州市',29,0,0,'Lanzhou Shi','LHW'),(337,'620200','嘉峪关市',29,0,0,'Jiayuguan Shi','JYG'),(338,'620300','金昌市',29,0,0,'Jinchang Shi','JCS'),(339,'620400','白银市',29,0,0,'Baiyin Shi','BYS'),(340,'620500','天水市',29,0,0,'Tianshui Shi','TSU'),(341,'620600','武威市',29,0,0,'Wuwei Shi','2'),(342,'620700','张掖市',29,0,0,'Zhangye Shi','2'),(343,'620800','平凉市',29,0,0,'Pingliang Shi','2'),(344,'620900','酒泉市',29,0,0,'Jiuquan Shi','2'),(345,'621000','庆阳市',29,0,0,'Qingyang Shi','2'),(346,'621100','定西市',29,0,0,'Dingxi Shi','2'),(347,'621200','陇南市',29,0,0,'Longnan Shi','2'),(348,'622900','临夏回族自治州',29,0,0,'Linxia Huizu Zizhizhou ','LXH'),(349,'623000','甘南藏族自治州',29,0,0,'Gannan Zangzu Zizhizhou','GNZ'),(350,'630100','西宁市',30,0,0,'Xining Shi','XNN'),(351,'632100','海东地区',30,0,0,'Haidong Diqu','HDD'),(352,'632200','海北藏族自治州',30,0,0,'Haibei Zangzu Zizhizhou','HBZ'),(353,'632300','黄南藏族自治州',30,0,0,'Huangnan Zangzu Zizhizhou','HNZ'),(354,'632500','海南藏族自治州',30,0,0,'Hainan Zangzu Zizhizhou','HNN'),(355,'632600','果洛藏族自治州',30,0,0,'Golog Zangzu Zizhizhou','GOL'),(356,'632700','玉树藏族自治州',30,0,0,'Yushu Zangzu Zizhizhou','YSZ'),(357,'632800','海西蒙古族藏族自治州',30,0,0,'Haixi Mongolzu Zangzu Zizhizhou','HXZ'),(358,'640100','银川市',31,0,0,'Yinchuan Shi','INC'),(359,'640200','石嘴山市',31,0,0,'Shizuishan Shi','SZS'),(360,'640300','吴忠市',31,0,0,'Wuzhong Shi','WZS'),(361,'640400','固原市',31,0,0,'Guyuan Shi','2'),(362,'640500','中卫市',31,0,0,'Zhongwei Shi','2'),(363,'650100','乌鲁木齐市',32,0,0,'Urumqi Shi','URC'),(364,'650200','克拉玛依市',32,0,0,'Karamay Shi','KAR'),(365,'652100','吐鲁番地区',32,0,0,'Turpan Diqu','TUD'),(366,'652200','哈密地区',32,0,0,'Hami(kumul) Diqu','HMD'),(367,'652300','昌吉回族自治州',32,0,0,'Changji Huizu Zizhizhou','CJZ'),(368,'652700','博尔塔拉蒙古自治州',32,0,0,'Bortala Monglo Zizhizhou','BOR'),(369,'652800','巴音郭楞蒙古自治州',32,0,0,'bayinguolengmengguzizhizhou','2'),(370,'652900','阿克苏地区',32,0,0,'Aksu Diqu','AKD'),(371,'653000','克孜勒苏柯尔克孜自治州',32,0,0,'Kizilsu Kirgiz Zizhizhou','KIZ'),(372,'653100','喀什地区',32,0,0,'Kashi(Kaxgar) Diqu','KSI'),(373,'653200','和田地区',32,0,0,'Hotan Diqu','HOD'),(374,'654000','伊犁哈萨克自治州',32,0,0,'Ili Kazak Zizhizhou','ILD'),(375,'654200','塔城地区',32,0,0,'Tacheng(Qoqek) Diqu','TCD'),(376,'654300','阿勒泰地区',32,0,0,'Altay Diqu','ALD'),(377,'659000','自治区直辖县级行政区划',32,0,0,'zizhiquzhixiaxianjixingzhengquhua','2'),(378,'110101','东城区',33,0,0,'Dongcheng Qu','DCQ'),(379,'110102','西城区',33,0,0,'Xicheng Qu','XCQ'),(382,'110105','朝阳区',33,0,0,'Chaoyang Qu','CYQ'),(383,'110106','丰台区',33,0,0,'Fengtai Qu','FTQ'),(384,'110107','石景山区',33,0,0,'Shijingshan Qu','SJS'),(385,'110108','海淀区',33,0,0,'Haidian Qu','HDN'),(386,'110109','门头沟区',33,0,0,'Mentougou Qu','MTG'),(387,'110111','房山区',33,0,0,'Fangshan Qu','FSQ'),(388,'110112','通州区',33,0,0,'Tongzhou Qu','TZQ'),(389,'110113','顺义区',33,0,0,'Shunyi Qu','SYI'),(390,'110114','昌平区',33,0,0,'Changping Qu','CP Q'),(391,'110115','大兴区',33,0,0,'Daxing Qu','DX Q'),(392,'110116','怀柔区',33,0,0,'Huairou Qu','HR Q'),(393,'110117','平谷区',33,0,0,'Pinggu Qu','PG Q'),(394,'110228','密云县',34,0,0,'Miyun Xian ','MYN'),(395,'110229','延庆县',34,0,0,'Yanqing Xian','YQX'),(396,'120101','和平区',35,0,0,'Heping Qu','HPG'),(397,'120102','河东区',35,0,0,'Hedong Qu','HDQ'),(398,'120103','河西区',35,0,0,'Hexi Qu','HXQ'),(399,'120104','南开区',35,0,0,'Nankai Qu','NKQ'),(400,'120105','河北区',35,0,0,'Hebei Qu','HBQ'),(401,'120106','红桥区',35,0,0,'Hongqiao Qu','HQO'),(404,'120116','滨海新区',35,0,0,'Dagang Qu','2'),(405,'120110','东丽区',35,0,0,'Dongli Qu','DLI'),(406,'120111','西青区',35,0,0,'Xiqing Qu','XQG'),(407,'120112','津南区',35,0,0,'Jinnan Qu','JNQ'),(408,'120113','北辰区',35,0,0,'Beichen Qu','BCQ'),(409,'120114','武清区',35,0,0,'Wuqing Qu','WQ Q'),(410,'120115','宝坻区',35,0,0,'Baodi Qu','BDI'),(411,'120221','宁河县',36,0,0,'Ninghe Xian','NHE'),(412,'120223','静海县',36,0,0,'Jinghai Xian','JHT'),(413,'120225','蓟县',36,0,0,'Ji Xian','JIT'),(414,'130101','市辖区',37,0,0,'Shixiaqu','2'),(415,'130102','长安区',37,0,0,'Chang,an Qu','CAQ'),(416,'130103','桥东区',37,0,0,'Qiaodong Qu','QDQ'),(417,'130104','桥西区',37,0,0,'Qiaoxi Qu','QXQ'),(418,'130105','新华区',37,0,0,'Xinhua Qu','XHK'),(419,'130107','井陉矿区',37,0,0,'Jingxing Kuangqu','JXK'),(420,'130108','裕华区',37,0,0,'Yuhua Qu','2'),(421,'130121','井陉县',37,0,0,'Jingxing Xian','JXJ'),(422,'130123','正定县',37,0,0,'Zhengding Xian','ZDJ'),(423,'130124','栾城县',37,0,0,'Luancheng Xian','LCG'),(424,'130125','行唐县',37,0,0,'Xingtang Xian','XTG'),(425,'130126','灵寿县',37,0,0,'Lingshou Xian ','LSO'),(426,'130127','高邑县',37,0,0,'Gaoyi Xian','GYJ'),(427,'130128','深泽县',37,0,0,'Shenze Xian','2'),(428,'130129','赞皇县',37,0,0,'Zanhuang Xian','ZHG'),(429,'130130','无极县',37,0,0,'Wuji Xian','WJI'),(430,'130131','平山县',37,0,0,'Pingshan Xian','PSH'),(431,'130132','元氏县',37,0,0,'Yuanshi Xian','YSI'),(432,'130133','赵县',37,0,0,'Zhao Xian','ZAO'),(433,'130181','辛集市',37,0,0,'Xinji Shi','XJS'),(434,'130182','藁城市',37,0,0,'Gaocheng Shi','GCS'),(435,'130183','晋州市',37,0,0,'Jinzhou Shi','JZJ'),(436,'130184','新乐市',37,0,0,'Xinle Shi','XLE'),(437,'130185','鹿泉市',37,0,0,'Luquan Shi','LUQ'),(438,'130201','市辖区',38,0,0,'Shixiaqu','2'),(439,'130202','路南区',38,0,0,'Lunan Qu','LNB'),(440,'130203','路北区',38,0,0,'Lubei Qu','LBQ'),(441,'130204','古冶区',38,0,0,'Guye Qu','GYE'),(442,'130205','开平区',38,0,0,'Kaiping Qu','KPQ'),(443,'130207','丰南区',38,0,0,'Fengnan Qu','2'),(444,'130208','丰润区',38,0,0,'Fengrun Qu','2'),(445,'130223','滦县',38,0,0,'Luan Xian','LUA'),(446,'130224','滦南县',38,0,0,'Luannan Xian','LNJ'),(447,'130225','乐亭县',38,0,0,'Leting Xian','LTJ'),(448,'130227','迁西县',38,0,0,'Qianxi Xian','QXX'),(449,'130229','玉田县',38,0,0,'Yutian Xian','YTJ'),(450,'130230','唐海县',38,0,0,'Tanghai Xian ','THA'),(451,'130281','遵化市',38,0,0,'Zunhua Shi','ZNH'),(452,'130283','迁安市',38,0,0,'Qian,an Shi','QAS'),(453,'130301','市辖区',39,0,0,'Shixiaqu','2'),(454,'130302','海港区',39,0,0,'Haigang Qu','HGG'),(455,'130303','山海关区',39,0,0,'Shanhaiguan Qu','SHG'),(456,'130304','北戴河区',39,0,0,'Beidaihe Qu','BDH'),(457,'130321','青龙满族自治县',39,0,0,'Qinglong Manzu Zizhixian','QLM'),(458,'130322','昌黎县',39,0,0,'Changli Xian','CGL'),(459,'130323','抚宁县',39,0,0,'Funing Xian ','FUN'),(460,'130324','卢龙县',39,0,0,'Lulong Xian','LLG'),(461,'130401','市辖区',40,0,0,'Shixiaqu','2'),(462,'130402','邯山区',40,0,0,'Hanshan Qu','HHD'),(463,'130403','丛台区',40,0,0,'Congtai Qu','CTQ'),(464,'130404','复兴区',40,0,0,'Fuxing Qu','FXQ'),(465,'130406','峰峰矿区',40,0,0,'Fengfeng Kuangqu','FFK'),(466,'130421','邯郸县',40,0,0,'Handan Xian ','HDX'),(467,'130423','临漳县',40,0,0,'Linzhang Xian ','LNZ'),(468,'130424','成安县',40,0,0,'Cheng,an Xian','CAJ'),(469,'130425','大名县',40,0,0,'Daming Xian','DMX'),(470,'130426','涉县',40,0,0,'She Xian','SEJ'),(471,'130427','磁县',40,0,0,'Ci Xian','CIX'),(472,'130428','肥乡县',40,0,0,'Feixiang Xian','FXJ'),(473,'130429','永年县',40,0,0,'Yongnian Xian','YON'),(474,'130430','邱县',40,0,0,'Qiu Xian','QIU'),(475,'130431','鸡泽县',40,0,0,'Jize Xian','JZE'),(476,'130432','广平县',40,0,0,'Guangping Xian ','GPX'),(477,'130433','馆陶县',40,0,0,'Guantao Xian','GTO'),(478,'130434','魏县',40,0,0,'Wei Xian ','WEI'),(479,'130435','曲周县',40,0,0,'Quzhou Xian ','QZX'),(480,'130481','武安市',40,0,0,'Wu,an Shi','WUA'),(481,'130501','市辖区',41,0,0,'Shixiaqu','2'),(482,'130502','桥东区',41,0,0,'Qiaodong Qu','QDG'),(483,'130503','桥西区',41,0,0,'Qiaoxi Qu','QXT'),(484,'130521','邢台县',41,0,0,'Xingtai Xian','XTJ'),(485,'130522','临城县',41,0,0,'Lincheng Xian ','LNC'),(486,'130523','内丘县',41,0,0,'Neiqiu Xian ','NQU'),(487,'130524','柏乡县',41,0,0,'Baixiang Xian','BXG'),(488,'130525','隆尧县',41,0,0,'Longyao Xian','LYO'),(489,'130526','任县',41,0,0,'Ren Xian','REN'),(490,'130527','南和县',41,0,0,'Nanhe Xian','NHX'),(491,'130528','宁晋县',41,0,0,'Ningjin Xian','NJN'),(492,'130529','巨鹿县',41,0,0,'Julu Xian','JLU'),(493,'130530','新河县',41,0,0,'Xinhe Xian ','XHJ'),(494,'130531','广宗县',41,0,0,'Guangzong Xian ','GZJ'),(495,'130532','平乡县',41,0,0,'Pingxiang Xian','PXX'),(496,'130533','威县',41,0,0,'Wei Xian ','WEX'),(497,'130534','清河县',41,0,0,'Qinghe Xian','QHE'),(498,'130535','临西县',41,0,0,'Linxi Xian','LXI'),(499,'130581','南宫市',41,0,0,'Nangong Shi','NGO'),(500,'130582','沙河市',41,0,0,'Shahe Shi','SHS'),(501,'130601','市辖区',42,0,0,'Shixiaqu','2'),(502,'130600','新市区',42,0,0,'Xinshi Qu','2'),(503,'130603','北市区',42,0,0,'Beishi Qu','BSI'),(504,'130604','南市区',42,0,0,'Nanshi Qu','NSB'),(505,'130621','满城县',42,0,0,'Mancheng Xian ','MCE'),(506,'130622','清苑县',42,0,0,'Qingyuan Xian','QYJ'),(507,'130623','涞水县',42,0,0,'Laishui Xian','LSM'),(508,'130624','阜平县',42,0,0,'Fuping Xian ','FUP'),(509,'130625','徐水县',42,0,0,'Xushui Xian ','XSJ'),(510,'130626','定兴县',42,0,0,'Dingxing Xian ','DXG'),(511,'130627','唐县',42,0,0,'Tang Xian ','TAG'),(512,'130628','高阳县',42,0,0,'Gaoyang Xian ','GAY'),(513,'130629','容城县',42,0,0,'Rongcheng Xian ','RCX'),(514,'130630','涞源县',42,0,0,'Laiyuan Xian ','LIY'),(515,'130631','望都县',42,0,0,'Wangdu Xian ','WDU'),(516,'130632','安新县',42,0,0,'Anxin Xian ','AXX'),(517,'130633','易县',42,0,0,'Yi Xian','YII'),(518,'130634','曲阳县',42,0,0,'Quyang Xian ','QUY'),(519,'130635','蠡县',42,0,0,'Li Xian','LXJ'),(520,'130636','顺平县',42,0,0,'Shunping Xian ','SPI'),(521,'130637','博野县',42,0,0,'Boye Xian ','BYE'),(522,'130638','雄县',42,0,0,'Xiong Xian','XOX'),(523,'130681','涿州市',42,0,0,'Zhuozhou Shi','ZZO'),(524,'130682','定州市',42,0,0,'Dingzhou Shi ','DZO'),(525,'130683','安国市',42,0,0,'Anguo Shi ','AGO'),(526,'130684','高碑店市',42,0,0,'Gaobeidian Shi','GBD'),(527,'130701','市辖区',43,0,0,'Shixiaqu','2'),(528,'130702','桥东区',43,0,0,'Qiaodong Qu','QDZ'),(529,'130703','桥西区',43,0,0,'Qiaoxi Qu','QXI'),(530,'130705','宣化区',43,0,0,'Xuanhua Qu','XHZ'),(531,'130706','下花园区',43,0,0,'Xiahuayuan Qu ','XHY'),(532,'130721','宣化县',43,0,0,'Xuanhua Xian ','XHX'),(533,'130722','张北县',43,0,0,'Zhangbei Xian ','ZGB'),(534,'130723','康保县',43,0,0,'Kangbao Xian','KBO'),(535,'130724','沽源县',43,0,0,'Guyuan Xian','2'),(536,'130725','尚义县',43,0,0,'Shangyi Xian','SYK'),(537,'130726','蔚县',43,0,0,'Yu Xian','YXJ'),(538,'130727','阳原县',43,0,0,'Yangyuan Xian','YYN'),(539,'130728','怀安县',43,0,0,'Huai,an Xian','HAX'),(540,'130729','万全县',43,0,0,'Wanquan Xian ','WQN'),(541,'130730','怀来县',43,0,0,'Huailai Xian','HLA'),(542,'130731','涿鹿县',43,0,0,'Zhuolu Xian ','ZLU'),(543,'130732','赤城县',43,0,0,'Chicheng Xian','CCX'),(544,'130733','崇礼县',43,0,0,'Chongli Xian','COL'),(545,'130801','市辖区',44,0,0,'Shixiaqu','2'),(546,'130802','双桥区',44,0,0,'Shuangqiao Qu ','SQO'),(547,'130803','双滦区',44,0,0,'Shuangluan Qu','SLQ'),(548,'130804','鹰手营子矿区',44,0,0,'Yingshouyingzi Kuangqu','YSY'),(549,'130821','承德县',44,0,0,'Chengde Xian','CDX'),(550,'130822','兴隆县',44,0,0,'Xinglong Xian','XLJ'),(551,'130823','平泉县',44,0,0,'Pingquan Xian','PQN'),(552,'130824','滦平县',44,0,0,'Luanping Xian ','LUP'),(553,'130825','隆化县',44,0,0,'Longhua Xian','LHJ'),(554,'130826','丰宁满族自治县',44,0,0,'Fengning Manzu Zizhixian','FNJ'),(555,'130827','宽城满族自治县',44,0,0,'Kuancheng Manzu Zizhixian','KCX'),(556,'130828','围场满族蒙古族自治县',44,0,0,'Weichang Manzu Menggolzu Zizhixian','WCJ'),(557,'130901','市辖区',45,0,0,'Shixiaqu','2'),(558,'130902','新华区',45,0,0,'Xinhua Qu','XHF'),(559,'130903','运河区',45,0,0,'Yunhe Qu','YHC'),(560,'130921','沧县',45,0,0,'Cang Xian','CAG'),(561,'130922','青县',45,0,0,'Qing Xian','QIG'),(562,'130923','东光县',45,0,0,'Dongguang Xian ','DGU'),(563,'130924','海兴县',45,0,0,'Haixing Xian','HXG'),(564,'130925','盐山县',45,0,0,'Yanshan Xian','YNS'),(565,'130926','肃宁县',45,0,0,'Suning Xian ','SNG'),(566,'130927','南皮县',45,0,0,'Nanpi Xian','NPI'),(567,'130928','吴桥县',45,0,0,'Wuqiao Xian ','WUQ'),(568,'130929','献县',45,0,0,'Xian Xian ','XXN'),(569,'130930','孟村回族自治县',45,0,0,'Mengcun Huizu Zizhixian','MCN'),(570,'130981','泊头市',45,0,0,'Botou Shi ','BOT'),(571,'130982','任丘市',45,0,0,'Renqiu Shi','RQS'),(572,'130983','黄骅市',45,0,0,'Huanghua Shi','HHJ'),(573,'130984','河间市',45,0,0,'Hejian Shi','HJN'),(574,'131001','市辖区',46,0,0,'Shixiaqu','2'),(575,'131002','安次区',46,0,0,'Anci Qu','ACI'),(576,'131003','广阳区',46,0,0,'Guangyang Qu','2'),(577,'131022','固安县',46,0,0,'Gu,an Xian','GUA'),(578,'131023','永清县',46,0,0,'Yongqing Xian ','YQG'),(579,'131024','香河县',46,0,0,'Xianghe Xian','XGH'),(580,'131025','大城县',46,0,0,'Dacheng Xian','DCJ'),(581,'131026','文安县',46,0,0,'Wen,an Xian','WEA'),(582,'131028','大厂回族自治县',46,0,0,'Dachang Huizu Zizhixian','DCG'),(583,'131081','霸州市',46,0,0,'Bazhou Shi','BZO'),(584,'131082','三河市',46,0,0,'Sanhe Shi','SNH'),(585,'131101','市辖区',47,0,0,'Shixiaqu','2'),(586,'131102','桃城区',47,0,0,'Taocheng Qu','TOC'),(587,'131121','枣强县',47,0,0,'Zaoqiang Xian ','ZQJ'),(588,'131122','武邑县',47,0,0,'Wuyi Xian','WYI'),(589,'131123','武强县',47,0,0,'Wuqiang Xian ','WQG'),(590,'131124','饶阳县',47,0,0,'Raoyang Xian','RYG'),(591,'131125','安平县',47,0,0,'Anping Xian','APG'),(592,'131126','故城县',47,0,0,'Gucheng Xian','GCE'),(593,'131127','景县',47,0,0,'Jing Xian ','JIG'),(594,'131128','阜城县',47,0,0,'Fucheng Xian ','FCE'),(595,'131181','冀州市',47,0,0,'Jizhou Shi ','JIZ'),(596,'131182','深州市',47,0,0,'Shenzhou Shi','SNZ'),(597,'140101','市辖区',48,0,0,'Shixiaqu','2'),(598,'140105','小店区',48,0,0,'Xiaodian Qu','XDQ'),(599,'140106','迎泽区',48,0,0,'Yingze Qu','YZT'),(600,'140107','杏花岭区',48,0,0,'Xinghualing Qu','XHL'),(601,'140108','尖草坪区',48,0,0,'Jiancaoping Qu','JCP'),(602,'140109','万柏林区',48,0,0,'Wanbailin Qu','WBL'),(603,'140110','晋源区',48,0,0,'Jinyuan Qu','JYM'),(604,'140121','清徐县',48,0,0,'Qingxu Xian ','QXU'),(605,'140122','阳曲县',48,0,0,'Yangqu Xian ','YGQ'),(606,'140123','娄烦县',48,0,0,'Loufan Xian','LFA'),(607,'140181','古交市',48,0,0,'Gujiao Shi','GUJ'),(608,'140201','市辖区',49,0,0,'Shixiaqu','2'),(609,'140202','城区',49,0,0,'Chengqu','CQD'),(610,'140203','矿区',49,0,0,'Kuangqu','KQD'),(611,'140211','南郊区',49,0,0,'Nanjiao Qu','NJQ'),(612,'140212','新荣区',49,0,0,'Xinrong Qu','XRQ'),(613,'140221','阳高县',49,0,0,'Yanggao Xian ','YGO'),(614,'140222','天镇县',49,0,0,'Tianzhen Xian ','TZE'),(615,'140223','广灵县',49,0,0,'Guangling Xian ','GLJ'),(616,'140224','灵丘县',49,0,0,'Lingqiu Xian ','LQX'),(617,'140225','浑源县',49,0,0,'Hunyuan Xian','HYM'),(618,'140226','左云县',49,0,0,'Zuoyun Xian','ZUY'),(619,'140227','大同县',49,0,0,'Datong Xian ','DTX'),(620,'140301','市辖区',50,0,0,'Shixiaqu','2'),(621,'140302','城区',50,0,0,'Chengqu','CQU'),(622,'140303','矿区',50,0,0,'Kuangqu','KQY'),(623,'140311','郊区',50,0,0,'Jiaoqu','JQY'),(624,'140321','平定县',50,0,0,'Pingding Xian','PDG'),(625,'140322','盂县',50,0,0,'Yu Xian','YUX'),(626,'140401','市辖区',51,0,0,'Shixiaqu','2'),(627,'140402','城区',51,0,0,'Chengqu ','CQC'),(628,'140411','郊区',51,0,0,'Jiaoqu','JQZ'),(629,'140421','长治县',51,0,0,'Changzhi Xian','CZI'),(630,'140423','襄垣县',51,0,0,'Xiangyuan Xian','XYJ'),(631,'140424','屯留县',51,0,0,'Tunliu Xian','TNL'),(632,'140425','平顺县',51,0,0,'Pingshun Xian','PSX'),(633,'140426','黎城县',51,0,0,'Licheng Xian','LIC'),(634,'140427','壶关县',51,0,0,'Huguan Xian','HGN'),(635,'140428','长子县',51,0,0,'Zhangzi Xian ','ZHZ'),(636,'140429','武乡县',51,0,0,'Wuxiang Xian','WXG'),(637,'140430','沁县',51,0,0,'Qin Xian','QIN'),(638,'140431','沁源县',51,0,0,'Qinyuan Xian ','QYU'),(639,'140481','潞城市',51,0,0,'Lucheng Shi','LCS'),(640,'140501','市辖区',52,0,0,'Shixiaqu','2'),(641,'140502','城区',52,0,0,'Chengqu ','CQJ'),(642,'140521','沁水县',52,0,0,'Qinshui Xian','QSI'),(643,'140522','阳城县',52,0,0,'Yangcheng Xian ','YGC'),(644,'140524','陵川县',52,0,0,'Lingchuan Xian','LGC'),(645,'140525','泽州县',52,0,0,'Zezhou Xian','ZEZ'),(646,'140581','高平市',52,0,0,'Gaoping Shi ','GPG'),(647,'140601','市辖区',53,0,0,'Shixiaqu','2'),(648,'140602','朔城区',53,0,0,'Shuocheng Qu','SCH'),(649,'140603','平鲁区',53,0,0,'Pinglu Qu','PLU'),(650,'140621','山阴县',53,0,0,'Shanyin Xian','SYP'),(651,'140622','应县',53,0,0,'Ying Xian','YIG'),(652,'140623','右玉县',53,0,0,'Youyu Xian ','YOY'),(653,'140624','怀仁县',53,0,0,'Huairen Xian','HRN'),(654,'140701','市辖区',54,0,0,'1','2'),(655,'140702','榆次区',54,0,0,'Yuci Qu','2'),(656,'140721','榆社县',54,0,0,'Yushe Xian','2'),(657,'140722','左权县',54,0,0,'Zuoquan Xian','2'),(658,'140723','和顺县',54,0,0,'Heshun Xian','2'),(659,'140724','昔阳县',54,0,0,'Xiyang Xian','2'),(660,'140725','寿阳县',54,0,0,'Shouyang Xian','2'),(661,'140726','太谷县',54,0,0,'Taigu Xian','2'),(662,'140727','祁县',54,0,0,'Qi Xian','2'),(663,'140728','平遥县',54,0,0,'Pingyao Xian','2'),(664,'140729','灵石县',54,0,0,'Lingshi Xian','2'),(665,'140781','介休市',54,0,0,'Jiexiu Shi','2'),(666,'140801','市辖区',55,0,0,'1','2'),(667,'140802','盐湖区',55,0,0,'Yanhu Qu','2'),(668,'140821','临猗县',55,0,0,'Linyi Xian','2'),(669,'140822','万荣县',55,0,0,'Wanrong Xian','2'),(670,'140823','闻喜县',55,0,0,'Wenxi Xian','2'),(671,'140824','稷山县',55,0,0,'Jishan Xian','2'),(672,'140825','新绛县',55,0,0,'Xinjiang Xian','2'),(673,'140826','绛县',55,0,0,'Jiang Xian','2'),(674,'140827','垣曲县',55,0,0,'Yuanqu Xian','2'),(675,'140828','夏县',55,0,0,'Xia Xian ','2'),(676,'140829','平陆县',55,0,0,'Pinglu Xian','2'),(677,'140830','芮城县',55,0,0,'Ruicheng Xian','2'),(678,'140881','永济市',55,0,0,'Yongji Shi ','2'),(679,'140882','河津市',55,0,0,'Hejin Shi','2'),(680,'140901','市辖区',56,0,0,'1','2'),(681,'140902','忻府区',56,0,0,'Xinfu Qu','2'),(682,'140921','定襄县',56,0,0,'Dingxiang Xian','2'),(683,'140922','五台县',56,0,0,'Wutai Xian','2'),(684,'140923','代县',56,0,0,'Dai Xian','2'),(685,'140924','繁峙县',56,0,0,'Fanshi Xian','2'),(686,'140925','宁武县',56,0,0,'Ningwu Xian','2'),(687,'140926','静乐县',56,0,0,'Jingle Xian','2'),(688,'140927','神池县',56,0,0,'Shenchi Xian','2'),(689,'140928','五寨县',56,0,0,'Wuzhai Xian','2'),(690,'140929','岢岚县',56,0,0,'Kelan Xian','2'),(691,'140930','河曲县',56,0,0,'Hequ Xian ','2'),(692,'140931','保德县',56,0,0,'Baode Xian','2'),(693,'140932','偏关县',56,0,0,'Pianguan Xian','2'),(694,'140981','原平市',56,0,0,'Yuanping Shi','2'),(695,'141001','市辖区',57,0,0,'1','2'),(696,'141002','尧都区',57,0,0,'Yaodu Qu','2'),(697,'141021','曲沃县',57,0,0,'Quwo Xian ','2'),(698,'141022','翼城县',57,0,0,'Yicheng Xian','2'),(699,'141023','襄汾县',57,0,0,'Xiangfen Xian','2'),(700,'141024','洪洞县',57,0,0,'Hongtong Xian','2'),(701,'141025','古县',57,0,0,'Gu Xian','2'),(702,'141026','安泽县',57,0,0,'Anze Xian','2'),(703,'141027','浮山县',57,0,0,'Fushan Xian ','2'),(704,'141028','吉县',57,0,0,'Ji Xian','2'),(705,'141029','乡宁县',57,0,0,'Xiangning Xian','2'),(706,'141030','大宁县',57,0,0,'Daning Xian','2'),(707,'141031','隰县',57,0,0,'Xi Xian','2'),(708,'141032','永和县',57,0,0,'Yonghe Xian','2'),(709,'141033','蒲县',57,0,0,'Pu Xian','2'),(710,'141034','汾西县',57,0,0,'Fenxi Xian','2'),(711,'141081','侯马市',57,0,0,'Houma Shi ','2'),(712,'141082','霍州市',57,0,0,'Huozhou Shi ','2'),(713,'141101','市辖区',58,0,0,'1','2'),(714,'141102','离石区',58,0,0,'Lishi Qu','2'),(715,'141121','文水县',58,0,0,'Wenshui Xian','2'),(716,'141122','交城县',58,0,0,'Jiaocheng Xian','2'),(717,'141123','兴县',58,0,0,'Xing Xian','2'),(718,'141124','临县',58,0,0,'Lin Xian ','2'),(719,'141125','柳林县',58,0,0,'Liulin Xian','2'),(720,'141126','石楼县',58,0,0,'Shilou Xian','2'),(721,'141127','岚县',58,0,0,'Lan Xian','2'),(722,'141128','方山县',58,0,0,'Fangshan Xian','2'),(723,'141129','中阳县',58,0,0,'Zhongyang Xian','2'),(724,'141130','交口县',58,0,0,'Jiaokou Xian','2'),(725,'141181','孝义市',58,0,0,'Xiaoyi Shi','2'),(726,'141182','汾阳市',58,0,0,'Fenyang Shi','2'),(727,'150101','市辖区',59,0,0,'Shixiaqu','2'),(728,'150102','新城区',59,0,0,'Xincheng Qu','XCN'),(729,'150103','回民区',59,0,0,'Huimin Qu','HMQ'),(730,'150104','玉泉区',59,0,0,'Yuquan Qu','YQN'),(731,'150105','赛罕区',59,0,0,'Saihan Qu','2'),(732,'150121','土默特左旗',59,0,0,'Tumd Zuoqi','TUZ'),(733,'150122','托克托县',59,0,0,'Togtoh Xian','TOG'),(734,'150123','和林格尔县',59,0,0,'Horinger Xian','HOR'),(735,'150124','清水河县',59,0,0,'Qingshuihe Xian','QSH'),(736,'150125','武川县',59,0,0,'Wuchuan Xian','WCX'),(737,'150201','市辖区',60,0,0,'Shixiaqu','2'),(738,'150202','东河区',60,0,0,'Donghe Qu','DHE'),(739,'150203','昆都仑区',60,0,0,'Kundulun Qu','2'),(740,'150204','青山区',60,0,0,'Qingshan Qu','QSB'),(741,'150205','石拐区',60,0,0,'Shiguai Qu','2'),(742,'150206','白云鄂博矿区',60,0,0,'Baiyun Kuangqu','2'),(743,'150207','九原区',60,0,0,'Jiuyuan Qu','2'),(744,'150221','土默特右旗',60,0,0,'Tumd Youqi','TUY'),(745,'150222','固阳县',60,0,0,'Guyang Xian','GYM'),(746,'150223','达尔罕茂明安联合旗',60,0,0,'Darhan Muminggan Lianheqi','DML'),(747,'150301','市辖区',61,0,0,'Shixiaqu','2'),(748,'150302','海勃湾区',61,0,0,'Haibowan Qu','HBW'),(749,'150303','海南区',61,0,0,'Hainan Qu','HNU'),(750,'150304','乌达区',61,0,0,'Ud Qu','UDQ'),(751,'150401','市辖区',62,0,0,'Shixiaqu','2'),(752,'150402','红山区',62,0,0,'Hongshan Qu','HSZ'),(753,'150403','元宝山区',62,0,0,'Yuanbaoshan Qu','YBO'),(754,'150404','松山区',62,0,0,'Songshan Qu','SSQ'),(755,'150421','阿鲁科尔沁旗',62,0,0,'Ar Horqin Qi','AHO'),(756,'150422','巴林左旗',62,0,0,'Bairin Zuoqi','BAZ'),(757,'150423','巴林右旗',62,0,0,'Bairin Youqi','BAY'),(758,'150424','林西县',62,0,0,'Linxi Xian','LXM'),(759,'150425','克什克腾旗',62,0,0,'Hexigten Qi','HXT'),(760,'150426','翁牛特旗',62,0,0,'Ongniud Qi','ONG'),(761,'150428','喀喇沁旗',62,0,0,'Harqin Qi','HAR'),(762,'150429','宁城县',62,0,0,'Ningcheng Xian','NCH'),(763,'150430','敖汉旗',62,0,0,'Aohan Qi','AHN'),(764,'150501','市辖区',63,0,0,'1','2'),(765,'150502','科尔沁区',63,0,0,'Keermi Qu','2'),(766,'150521','科尔沁左翼中旗',63,0,0,'Horqin Zuoyi Zhongqi','2'),(767,'150522','科尔沁左翼后旗',63,0,0,'Horqin Zuoyi Houqi','2'),(768,'150523','开鲁县',63,0,0,'Kailu Xian','2'),(769,'150524','库伦旗',63,0,0,'Hure Qi','2'),(770,'150525','奈曼旗',63,0,0,'Naiman Qi','2'),(771,'150526','扎鲁特旗',63,0,0,'Jarud Qi','2'),(772,'150581','霍林郭勒市',63,0,0,'Holingol Shi','2'),(773,'150602','东胜区',64,0,0,'Dongsheng Qu','2'),(774,'150621','达拉特旗',64,0,0,'Dalad Qi','2'),(775,'150622','准格尔旗',64,0,0,'Jungar Qi','2'),(776,'150623','鄂托克前旗',64,0,0,'Otog Qianqi','2'),(777,'150624','鄂托克旗',64,0,0,'Otog Qi','2'),(778,'150625','杭锦旗',64,0,0,'Hanggin Qi','2'),(779,'150626','乌审旗',64,0,0,'Uxin Qi','2'),(780,'150627','伊金霍洛旗',64,0,0,'Ejin Horo Qi','2'),(781,'150701','市辖区',65,0,0,'1','2'),(782,'150702','海拉尔区',65,0,0,'Hailaer Qu','2'),(783,'150721','阿荣旗',65,0,0,'Arun Qi','2'),(784,'150722','莫力达瓦达斡尔族自治旗',65,0,0,'Morin Dawa Daurzu Zizhiqi','2'),(785,'150723','鄂伦春自治旗',65,0,0,'Oroqen Zizhiqi','2'),(786,'150724','鄂温克族自治旗',65,0,0,'Ewenkizu Zizhiqi','2'),(787,'150725','陈巴尔虎旗',65,0,0,'Chen Barag Qi','2'),(788,'150726','新巴尔虎左旗',65,0,0,'Xin Barag Zuoqi','2'),(789,'150727','新巴尔虎右旗',65,0,0,'Xin Barag Youqi','2'),(790,'150781','满洲里市',65,0,0,'Manzhouli Shi','2'),(791,'150782','牙克石市',65,0,0,'Yakeshi Shi','2'),(792,'150783','扎兰屯市',65,0,0,'Zalantun Shi','2'),(793,'150784','额尔古纳市',65,0,0,'Ergun Shi','2'),(794,'150785','根河市',65,0,0,'Genhe Shi','2'),(795,'150801','市辖区',66,0,0,'1','2'),(796,'150802','临河区',66,0,0,'Linhe Qu','2'),(797,'150821','五原县',66,0,0,'Wuyuan Xian','2'),(798,'150822','磴口县',66,0,0,'Dengkou Xian','2'),(799,'150823','乌拉特前旗',66,0,0,'Urad Qianqi','2'),(800,'150824','乌拉特中旗',66,0,0,'Urad Zhongqi','2'),(801,'150825','乌拉特后旗',66,0,0,'Urad Houqi','2'),(802,'150826','杭锦后旗',66,0,0,'Hanggin Houqi','2'),(803,'150901','市辖区',67,0,0,'1','2'),(804,'150902','集宁区',67,0,0,'Jining Qu','2'),(805,'150921','卓资县',67,0,0,'Zhuozi Xian','2'),(806,'150922','化德县',67,0,0,'Huade Xian','2'),(807,'150923','商都县',67,0,0,'Shangdu Xian','2'),(808,'150924','兴和县',67,0,0,'Xinghe Xian','2'),(809,'150925','凉城县',67,0,0,'Liangcheng Xian','2'),(810,'150926','察哈尔右翼前旗',67,0,0,'Qahar Youyi Qianqi','2'),(811,'150927','察哈尔右翼中旗',67,0,0,'Qahar Youyi Zhongqi','2'),(812,'150928','察哈尔右翼后旗',67,0,0,'Qahar Youyi Houqi','2'),(813,'150929','四子王旗',67,0,0,'Dorbod Qi','2'),(814,'150981','丰镇市',67,0,0,'Fengzhen Shi','2'),(815,'152201','乌兰浩特市',68,0,0,'Ulan Hot Shi','ULO'),(816,'152202','阿尔山市',68,0,0,'Arxan Shi','ARS'),(817,'152221','科尔沁右翼前旗',68,0,0,'Horqin Youyi Qianqi','HYQ'),(818,'152222','科尔沁右翼中旗',68,0,0,'Horqin Youyi Zhongqi','HYZ'),(819,'152223','扎赉特旗',68,0,0,'Jalaid Qi','JAL'),(820,'152224','突泉县',68,0,0,'Tuquan Xian','TUQ'),(821,'152501','二连浩特市',69,0,0,'Erenhot Shi','ERC'),(822,'152502','锡林浩特市',69,0,0,'Xilinhot Shi','XLI'),(823,'152522','阿巴嘎旗',69,0,0,'Abag Qi','ABG'),(824,'152523','苏尼特左旗',69,0,0,'Sonid Zuoqi','SOZ'),(825,'152524','苏尼特右旗',69,0,0,'Sonid Youqi','SOY'),(826,'152525','东乌珠穆沁旗',69,0,0,'Dong Ujimqin Qi','DUJ'),(827,'152526','西乌珠穆沁旗',69,0,0,'Xi Ujimqin Qi','XUJ'),(828,'152527','太仆寺旗',69,0,0,'Taibus Qi','TAB'),(829,'152528','镶黄旗',69,0,0,'Xianghuang(Hobot Xar) Qi','XHG'),(830,'152529','正镶白旗',69,0,0,'Zhengxiangbai(Xulun Hobot Qagan)Qi','ZXB'),(831,'152530','正蓝旗',69,0,0,'Zhenglan(Xulun Hoh)Qi','ZLM'),(832,'152531','多伦县',69,0,0,'Duolun (Dolonnur)Xian','DLM'),(833,'152921','阿拉善左旗',70,0,0,'Alxa Zuoqi','ALZ'),(834,'152922','阿拉善右旗',70,0,0,'Alxa Youqi','ALY'),(835,'152923','额济纳旗',70,0,0,'Ejin Qi','EJI'),(836,'210101','市辖区',71,0,0,'Shixiaqu','2'),(837,'210102','和平区',71,0,0,'Heping Qu','HEP'),(838,'210103','沈河区',71,0,0,'Shenhe Qu ','SHQ'),(839,'210104','大东区',71,0,0,'Dadong Qu ','DDQ'),(840,'210105','皇姑区',71,0,0,'Huanggu Qu','HGU'),(841,'210106','铁西区',71,0,0,'Tiexi Qu','TXI'),(842,'210111','苏家屯区',71,0,0,'Sujiatun Qu','SJT'),(843,'210112','东陵区',71,0,0,'Dongling Qu ','DLQ'),(844,'210113','沈北新区',71,0,0,'Xinchengzi Qu','2'),(845,'210114','于洪区',71,0,0,'Yuhong Qu ','YHQ'),(846,'210122','辽中县',71,0,0,'Liaozhong Xian','LZL'),(847,'210123','康平县',71,0,0,'Kangping Xian','KPG'),(848,'210124','法库县',71,0,0,'Faku Xian','FKU'),(849,'210181','新民市',71,0,0,'Xinmin Shi','XMS'),(850,'210201','市辖区',72,0,0,'Shixiaqu','2'),(851,'210202','中山区',72,0,0,'Zhongshan Qu','ZSD'),(852,'210203','西岗区',72,0,0,'Xigang Qu','XGD'),(853,'210204','沙河口区',72,0,0,'Shahekou Qu','SHK'),(854,'210211','甘井子区',72,0,0,'Ganjingzi Qu','GJZ'),(855,'210212','旅顺口区',72,0,0,'Lvshunkou Qu ','LSK'),(856,'210213','金州区',72,0,0,'Jinzhou Qu','JZH'),(857,'210224','长海县',72,0,0,'Changhai Xian','CHX'),(858,'210281','瓦房店市',72,0,0,'Wafangdian Shi','WFD'),(859,'210282','普兰店市',72,0,0,'Pulandian Shi','PLD'),(860,'210283','庄河市',72,0,0,'Zhuanghe Shi','ZHH'),(861,'210301','市辖区',73,0,0,'Shixiaqu','2'),(862,'210302','铁东区',73,0,0,'Tiedong Qu ','TED'),(863,'210303','铁西区',73,0,0,'Tiexi Qu','TXL'),(864,'210304','立山区',73,0,0,'Lishan Qu','LAS'),(865,'210311','千山区',73,0,0,'Qianshan Qu ','QSQ'),(866,'210321','台安县',73,0,0,'Tai,an Xian','TAX'),(867,'210323','岫岩满族自治县',73,0,0,'Xiuyan Manzu Zizhixian','XYL'),(868,'210381','海城市',73,0,0,'Haicheng Shi','HCL'),(869,'210401','市辖区',74,0,0,'Shixiaqu','2'),(870,'210402','新抚区',74,0,0,'Xinfu Qu','XFU'),(871,'210403','东洲区',74,0,0,'Dongzhou Qu','2'),(872,'210404','望花区',74,0,0,'Wanghua Qu','WHF'),(873,'210411','顺城区',74,0,0,'Shuncheng Qu','SCF'),(874,'210421','抚顺县',74,0,0,'Fushun Xian','FSX'),(875,'210422','新宾满族自治县',74,0,0,'Xinbinmanzuzizhi Xian','2'),(876,'210423','清原满族自治县',74,0,0,'Qingyuanmanzuzizhi Xian','2'),(877,'210501','市辖区',75,0,0,'Shixiaqu','2'),(878,'210502','平山区',75,0,0,'Pingshan Qu','PSN'),(879,'210503','溪湖区',75,0,0,'Xihu Qu ','XHB'),(880,'210504','明山区',75,0,0,'Mingshan Qu','MSB'),(881,'210505','南芬区',75,0,0,'Nanfen Qu','NFQ'),(882,'210521','本溪满族自治县',75,0,0,'Benxi Manzu Zizhixian','BXX'),(883,'210522','桓仁满族自治县',75,0,0,'Huanren Manzu Zizhixian','HRL'),(884,'210601','市辖区',76,0,0,'Shixiaqu','2'),(885,'210602','元宝区',76,0,0,'Yuanbao Qu','YBD'),(886,'210603','振兴区',76,0,0,'Zhenxing Qu ','ZXQ'),(887,'210604','振安区',76,0,0,'Zhen,an Qu','ZAQ'),(888,'210624','宽甸满族自治县',76,0,0,'Kuandian Manzu Zizhixian','KDN'),(889,'210681','东港市',76,0,0,'Donggang Shi','DGS'),(890,'210682','凤城市',76,0,0,'Fengcheng Shi','FCL'),(891,'210701','市辖区',77,0,0,'Shixiaqu','2'),(892,'210702','古塔区',77,0,0,'Guta Qu','GTQ'),(893,'210703','凌河区',77,0,0,'Linghe Qu','LHF'),(894,'210711','太和区',77,0,0,'Taihe Qu','2'),(895,'210726','黑山县',77,0,0,'Heishan Xian','HSL'),(896,'210727','义县',77,0,0,'Yi Xian','YXL'),(897,'210781','凌海市',77,0,0,'Linghai Shi ','LHL'),(898,'210782','北镇市',77,0,0,'Beining Shi','2'),(899,'210801','市辖区',78,0,0,'Shixiaqu','2'),(900,'210802','站前区',78,0,0,'Zhanqian Qu','ZQQ'),(901,'210803','西市区',78,0,0,'Xishi Qu','XII'),(902,'210804','鲅鱼圈区',78,0,0,'Bayuquan Qu','BYQ'),(903,'210811','老边区',78,0,0,'Laobian Qu','LOB'),(904,'210881','盖州市',78,0,0,'Gaizhou Shi','GZU'),(905,'210882','大石桥市',78,0,0,'Dashiqiao Shi','DSQ'),(906,'210901','市辖区',79,0,0,'Shixiaqu','2'),(907,'210902','海州区',79,0,0,'Haizhou Qu','HZF'),(908,'210903','新邱区',79,0,0,'Xinqiu Qu','XQF'),(909,'210904','太平区',79,0,0,'Taiping Qu','TPG'),(910,'210905','清河门区',79,0,0,'Qinghemen Qu','QHM'),(911,'210911','细河区',79,0,0,'Xihe Qu','XHO'),(912,'210921','阜新蒙古族自治县',79,0,0,'Fuxin Mongolzu Zizhixian','FXX'),(913,'210922','彰武县',79,0,0,'Zhangwu Xian','ZWU'),(914,'211001','市辖区',80,0,0,'Shixiaqu','2'),(915,'211002','白塔区',80,0,0,'Baita Qu','BTL'),(916,'211003','文圣区',80,0,0,'Wensheng Qu','WST'),(917,'211004','宏伟区',80,0,0,'Hongwei Qu','HWQ'),(918,'211005','弓长岭区',80,0,0,'Gongchangling Qu','GCL'),(919,'211011','太子河区',80,0,0,'Taizihe Qu','TZH'),(920,'211021','辽阳县',80,0,0,'Liaoyang Xian','LYX'),(921,'211081','灯塔市',80,0,0,'Dengta Shi','DTL'),(922,'211101','市辖区',81,0,0,'Shixiaqu','2'),(923,'211102','双台子区',81,0,0,'Shuangtaizi Qu','STZ'),(924,'211103','兴隆台区',81,0,0,'Xinglongtai Qu','XLT'),(925,'211121','大洼县',81,0,0,'Dawa Xian','DWA'),(926,'211122','盘山县',81,0,0,'Panshan Xian','PNS'),(927,'211201','市辖区',82,0,0,'Shixiaqu','2'),(928,'211202','银州区',82,0,0,'Yinzhou Qu','YZU'),(929,'211204','清河区',82,0,0,'Qinghe Qu','QHQ'),(930,'211221','铁岭县',82,0,0,'Tieling Xian','TLG'),(931,'211223','西丰县',82,0,0,'Xifeng Xian','XIF'),(932,'211224','昌图县',82,0,0,'Changtu Xian','CTX'),(933,'211281','调兵山市',82,0,0,'Diaobingshan Shi','2'),(934,'211282','开原市',82,0,0,'Kaiyuan Shi','KYS'),(935,'211301','市辖区',83,0,0,'Shixiaqu','2'),(936,'211302','双塔区',83,0,0,'Shuangta Qu','STQ'),(937,'211303','龙城区',83,0,0,'Longcheng Qu','LCL'),(938,'211321','朝阳县',83,0,0,'Chaoyang Xian','CYG'),(939,'211322','建平县',83,0,0,'Jianping Xian','JPG'),(940,'211324','喀喇沁左翼蒙古族自治县',83,0,0,'Harqin Zuoyi Mongolzu Zizhixian','HAZ'),(941,'211381','北票市',83,0,0,'Beipiao Shi','BPO'),(942,'211382','凌源市',83,0,0,'Lingyuan Shi','LYK'),(943,'211401','市辖区',84,0,0,'Shixiaqu','2'),(944,'211402','连山区',84,0,0,'Lianshan Qu','LSQ'),(945,'211403','龙港区',84,0,0,'Longgang Qu','LGD'),(946,'211404','南票区',84,0,0,'Nanpiao Qu','NPQ'),(947,'211421','绥中县',84,0,0,'Suizhong Xian','SZL'),(948,'211422','建昌县',84,0,0,'Jianchang Xian','JCL'),(949,'211481','兴城市',84,0,0,'Xingcheng Shi','XCL'),(950,'220101','市辖区',85,0,0,'Shixiaqu','2'),(951,'220102','南关区',85,0,0,'Nanguan Qu','NGN'),(952,'220103','宽城区',85,0,0,'Kuancheng Qu','KCQ'),(953,'220104','朝阳区',85,0,0,'Chaoyang Qu ','CYC'),(954,'220105','二道区',85,0,0,'Erdao Qu','EDQ'),(955,'220106','绿园区',85,0,0,'Lvyuan Qu','LYQ'),(956,'220112','双阳区',85,0,0,'Shuangyang Qu','SYQ'),(957,'220122','农安县',85,0,0,'Nong,an Xian ','NAJ'),(958,'220181','九台市',85,0,0,'Jiutai Shi','2'),(959,'220182','榆树市',85,0,0,'Yushu Shi','YSS'),(960,'220183','德惠市',85,0,0,'Dehui Shi','DEH'),(961,'220201','市辖区',86,0,0,'Shixiaqu','2'),(962,'220202','昌邑区',86,0,0,'Changyi Qu','CYI'),(963,'220203','龙潭区',86,0,0,'Longtan Qu','LTQ'),(964,'220204','船营区',86,0,0,'Chuanying Qu','CYJ'),(965,'220211','丰满区',86,0,0,'Fengman Qu','FMQ'),(966,'220221','永吉县',86,0,0,'Yongji Xian','YOJ'),(967,'220281','蛟河市',86,0,0,'Jiaohe Shi','JHJ'),(968,'220282','桦甸市',86,0,0,'Huadian Shi','HDJ'),(969,'220283','舒兰市',86,0,0,'Shulan Shi','SLN'),(970,'220284','磐石市',86,0,0,'Panshi Shi','PSI'),(971,'220301','市辖区',87,0,0,'Shixiaqu','2'),(972,'220302','铁西区',87,0,0,'Tiexi Qu','TXS'),(973,'220303','铁东区',87,0,0,'Tiedong Qu ','TDQ'),(974,'220322','梨树县',87,0,0,'Lishu Xian','LSU'),(975,'220323','伊通满族自治县',87,0,0,'Yitong Manzu Zizhixian','YTO'),(976,'220381','公主岭市',87,0,0,'Gongzhuling Shi','GZL'),(977,'220382','双辽市',87,0,0,'Shuangliao Shi','SLS'),(978,'220401','市辖区',88,0,0,'Shixiaqu','2'),(979,'220402','龙山区',88,0,0,'Longshan Qu','LGS'),(980,'220403','西安区',88,0,0,'Xi,an Qu','XAA'),(981,'220421','东丰县',88,0,0,'Dongfeng Xian','DGF'),(982,'220422','东辽县',88,0,0,'Dongliao Xian ','DLX'),(983,'220501','市辖区',89,0,0,'Shixiaqu','2'),(984,'220502','东昌区',89,0,0,'Dongchang Qu','DCT'),(985,'220503','二道江区',89,0,0,'Erdaojiang Qu','EDJ'),(986,'220521','通化县',89,0,0,'Tonghua Xian ','THX'),(987,'220523','辉南县',89,0,0,'Huinan Xian ','HNA'),(988,'220524','柳河县',89,0,0,'Liuhe Xian ','LHC'),(989,'220581','梅河口市',89,0,0,'Meihekou Shi','MHK'),(990,'220582','集安市',89,0,0,'Ji,an Shi','KNC'),(991,'220601','市辖区',90,0,0,'Shixiaqu','2'),(992,'220602','八道江区',90,0,0,'Badaojiang Qu','BDJ'),(993,'220621','抚松县',90,0,0,'Fusong Xian','FSG'),(994,'220622','靖宇县',90,0,0,'Jingyu Xian','JYJ'),(995,'220623','长白朝鲜族自治县',90,0,0,'Changbaichaoxianzuzizhi Xian','2'),(996,'220605','江源区',90,0,0,'Jiangyuan Xian','2'),(997,'220681','临江市',90,0,0,'Linjiang Shi','LIN'),(998,'220701','市辖区',91,0,0,'Shixiaqu','2'),(999,'220702','宁江区',91,0,0,'Ningjiang Qu','NJA'),(1000,'220721','前郭尔罗斯蒙古族自治县',91,0,0,'Qian Gorlos Mongolzu Zizhixian','QGO'),(1001,'220722','长岭县',91,0,0,'Changling Xian','CLG'),(1002,'220723','乾安县',91,0,0,'Qian,an Xian','QAJ'),(1003,'220724','扶余县',91,0,0,'Fuyu Xian','FYU'),(1004,'220801','市辖区',92,0,0,'Shixiaqu','2'),(1005,'220802','洮北区',92,0,0,'Taobei Qu','TBQ'),(1006,'220821','镇赉县',92,0,0,'Zhenlai Xian','ZLA'),(1007,'220822','通榆县',92,0,0,'Tongyu Xian','TGY'),(1008,'220881','洮南市',92,0,0,'Taonan Shi','TNS'),(1009,'220882','大安市',92,0,0,'Da,an Shi','DNA'),(1010,'222401','延吉市',93,0,0,'Yanji Shi','YNJ'),(1011,'222402','图们市',93,0,0,'Tumen Shi','TME'),(1012,'222403','敦化市',93,0,0,'Dunhua Shi','DHS'),(1013,'222404','珲春市',93,0,0,'Hunchun Shi','HUC'),(1014,'222405','龙井市',93,0,0,'Longjing Shi','LJJ'),(1015,'222406','和龙市',93,0,0,'Helong Shi','HEL'),(1016,'222424','汪清县',93,0,0,'Wangqing Xian','WGQ'),(1017,'222426','安图县',93,0,0,'Antu Xian','ATU'),(1018,'230101','市辖区',94,0,0,'Shixiaqu','2'),(1019,'230102','道里区',94,0,0,'Daoli Qu','DLH'),(1020,'230103','南岗区',94,0,0,'Nangang Qu','NGQ'),(1021,'230104','道外区',94,0,0,'Daowai Qu','DWQ'),(1022,'230110','香坊区',94,0,0,'Xiangfang Qu','2'),(1024,'230108','平房区',94,0,0,'Pingfang Qu','PFQ'),(1025,'230109','松北区',94,0,0,'Songbei Qu','2'),(1026,'230111','呼兰区',94,0,0,'Hulan Qu','2'),(1027,'230123','依兰县',94,0,0,'Yilan Xian','YLH'),(1028,'230124','方正县',94,0,0,'Fangzheng Xian','FZH'),(1029,'230125','宾县',94,0,0,'Bin Xian','BNX'),(1030,'230126','巴彦县',94,0,0,'Bayan Xian','BYH'),(1031,'230127','木兰县',94,0,0,'Mulan Xian ','MUL'),(1032,'230128','通河县',94,0,0,'Tonghe Xian','TOH'),(1033,'230129','延寿县',94,0,0,'Yanshou Xian','YSU'),(1034,'230112','阿城区',94,0,0,'Acheng Shi','2'),(1035,'230182','双城市',94,0,0,'Shuangcheng Shi','SCS'),(1036,'230183','尚志市',94,0,0,'Shangzhi Shi','SZI'),(1037,'230184','五常市',94,0,0,'Wuchang Shi','WCA'),(1038,'230201','市辖区',95,0,0,'Shixiaqu','2'),(1039,'230202','龙沙区',95,0,0,'Longsha Qu','LQQ'),(1040,'230203','建华区',95,0,0,'Jianhua Qu','JHQ'),(1041,'230204','铁锋区',95,0,0,'Tiefeng Qu','2'),(1042,'230205','昂昂溪区',95,0,0,'Ang,angxi Qu','AAX'),(1043,'230206','富拉尔基区',95,0,0,'Hulan Ergi Qu','HUE'),(1044,'230207','碾子山区',95,0,0,'Nianzishan Qu','NZS'),(1045,'230208','梅里斯达斡尔族区',95,0,0,'Meilisidawoerzu Qu','2'),(1046,'230221','龙江县',95,0,0,'Longjiang Xian','LGJ'),(1047,'230223','依安县',95,0,0,'Yi,an Xian','YAN'),(1048,'230224','泰来县',95,0,0,'Tailai Xian','TLA'),(1049,'230225','甘南县',95,0,0,'Gannan Xian','GNX'),(1050,'230227','富裕县',95,0,0,'Fuyu Xian','FYX'),(1051,'230229','克山县',95,0,0,'Keshan Xian','KSN'),(1052,'230230','克东县',95,0,0,'Kedong Xian','KDO'),(1053,'230231','拜泉县',95,0,0,'Baiquan Xian','BQN'),(1054,'230281','讷河市',95,0,0,'Nehe Shi','NEH'),(1055,'230301','市辖区',96,0,0,'Shixiaqu','2'),(1056,'230302','鸡冠区',96,0,0,'Jiguan Qu','JGU'),(1057,'230303','恒山区',96,0,0,'Hengshan Qu','HSD'),(1058,'230304','滴道区',96,0,0,'Didao Qu','DDO'),(1059,'230305','梨树区',96,0,0,'Lishu Qu','LJX'),(1060,'230306','城子河区',96,0,0,'Chengzihe Qu','CZH'),(1061,'230307','麻山区',96,0,0,'Mashan Qu','MSN'),(1062,'230321','鸡东县',96,0,0,'Jidong Xian','JID'),(1063,'230381','虎林市',96,0,0,'Hulin Shi','HUL'),(1064,'230382','密山市',96,0,0,'Mishan Shi','MIS'),(1065,'230401','市辖区',97,0,0,'Shixiaqu','2'),(1066,'230402','向阳区',97,0,0,'Xiangyang  Qu ','XYZ'),(1067,'230403','工农区',97,0,0,'Gongnong Qu','GNH'),(1068,'230404','南山区',97,0,0,'Nanshan Qu','NSQ'),(1069,'230405','兴安区',97,0,0,'Xing,an Qu','XAH'),(1070,'230406','东山区',97,0,0,'Dongshan Qu','DSA'),(1071,'230407','兴山区',97,0,0,'Xingshan Qu','XSQ'),(1072,'230421','萝北县',97,0,0,'Luobei Xian','LUB'),(1073,'230422','绥滨县',97,0,0,'Suibin Xian','2'),(1074,'230501','市辖区',98,0,0,'Shixiaqu','2'),(1075,'230502','尖山区',98,0,0,'Jianshan Qu','JSQ'),(1076,'230503','岭东区',98,0,0,'Lingdong Qu','LDQ'),(1077,'230505','四方台区',98,0,0,'Sifangtai Qu','SFT'),(1078,'230506','宝山区',98,0,0,'Baoshan Qu','BSQ'),(1079,'230521','集贤县',98,0,0,'Jixian Xian','JXH'),(1080,'230522','友谊县',98,0,0,'Youyi Xian','YYI'),(1081,'230523','宝清县',98,0,0,'Baoqing Xian','BQG'),(1082,'230524','饶河县',98,0,0,'Raohe Xian ','ROH'),(1083,'230601','市辖区',99,0,0,'Shixiaqu','2'),(1084,'230602','萨尔图区',99,0,0,'Sairt Qu','SAI'),(1085,'230603','龙凤区',99,0,0,'Longfeng Qu','LFQ'),(1086,'230604','让胡路区',99,0,0,'Ranghulu Qu','RHL'),(1087,'230605','红岗区',99,0,0,'Honggang Qu','HGD'),(1088,'230606','大同区',99,0,0,'Datong Qu','DHD'),(1089,'230621','肇州县',99,0,0,'Zhaozhou Xian','ZAZ'),(1090,'230622','肇源县',99,0,0,'Zhaoyuan Xian','ZYH'),(1091,'230623','林甸县',99,0,0,'Lindian Xian ','LDN'),(1092,'230624','杜尔伯特蒙古族自治县',99,0,0,'Dorbod Mongolzu Zizhixian','DOM'),(1093,'230701','市辖区',100,0,0,'Shixiaqu','2'),(1094,'230702','伊春区',100,0,0,'Yichun Qu','YYC'),(1095,'230703','南岔区',100,0,0,'Nancha Qu','NCQ'),(1096,'230704','友好区',100,0,0,'Youhao Qu','YOH'),(1097,'230705','西林区',100,0,0,'Xilin Qu','XIL'),(1098,'230706','翠峦区',100,0,0,'Cuiluan Qu','CLN'),(1099,'230707','新青区',100,0,0,'Xinqing Qu','XQQ'),(1100,'230708','美溪区',100,0,0,'Meixi Qu','MXQ'),(1101,'230709','金山屯区',100,0,0,'Jinshantun Qu','JST'),(1102,'230710','五营区',100,0,0,'Wuying Qu','WYQ'),(1103,'230711','乌马河区',100,0,0,'Wumahe Qu','WMH'),(1104,'230712','汤旺河区',100,0,0,'Tangwanghe Qu','TWH'),(1105,'230713','带岭区',100,0,0,'Dailing Qu','DLY'),(1106,'230714','乌伊岭区',100,0,0,'Wuyiling Qu','WYL'),(1107,'230715','红星区',100,0,0,'Hongxing Qu','HGX'),(1108,'230716','上甘岭区',100,0,0,'Shangganling Qu','SGL'),(1109,'230722','嘉荫县',100,0,0,'Jiayin Xian','2'),(1110,'230781','铁力市',100,0,0,'Tieli Shi','TEL'),(1111,'230801','市辖区',101,0,0,'Shixiaqu','2'),(1113,'230803','向阳区',101,0,0,'Xiangyang  Qu ','XYQ'),(1114,'230804','前进区',101,0,0,'Qianjin Qu','QJQ'),(1115,'230805','东风区',101,0,0,'Dongfeng Qu','DFQ'),(1116,'230811','郊区',101,0,0,'Jiaoqu','JQJ'),(1117,'230822','桦南县',101,0,0,'Huanan Xian','HNH'),(1118,'230826','桦川县',101,0,0,'Huachuan Xian','HCN'),(1119,'230828','汤原县',101,0,0,'Tangyuan Xian','TYX'),(1120,'230833','抚远县',101,0,0,'Fuyuan Xian','FUY'),(1121,'230881','同江市',101,0,0,'Tongjiang Shi','TOJ'),(1122,'230882','富锦市',101,0,0,'Fujin Shi','FUJ'),(1123,'230901','市辖区',102,0,0,'Shixiaqu','2'),(1124,'230902','新兴区',102,0,0,'Xinxing Qu','XXQ'),(1125,'230903','桃山区',102,0,0,'Taoshan Qu','TSC'),(1126,'230904','茄子河区',102,0,0,'Qiezihe Qu','QZI'),(1127,'230921','勃利县',102,0,0,'Boli Xian','BLI'),(1128,'231001','市辖区',103,0,0,'Shixiaqu','2'),(1129,'231002','东安区',103,0,0,'Dong,an Qu','DGA'),(1130,'231003','阳明区',103,0,0,'Yangming Qu','YMQ'),(1131,'231004','爱民区',103,0,0,'Aimin Qu','AMQ'),(1132,'231005','西安区',103,0,0,'Xi,an Qu','XAQ'),(1133,'231024','东宁县',103,0,0,'Dongning Xian','DON'),(1134,'231025','林口县',103,0,0,'Linkou Xian','LKO'),(1135,'231081','绥芬河市',103,0,0,'Suifenhe Shi','SFE'),(1136,'231083','海林市',103,0,0,'Hailin Shi','HLS'),(1137,'231084','宁安市',103,0,0,'Ning,an Shi','NAI'),(1138,'231085','穆棱市',103,0,0,'Muling Shi','MLG'),(1139,'231101','市辖区',104,0,0,'Shixiaqu','2'),(1140,'231102','爱辉区',104,0,0,'Aihui Qu','AHQ'),(1141,'231121','嫩江县',104,0,0,'Nenjiang Xian','NJH'),(1142,'231123','逊克县',104,0,0,'Xunke Xian','XUK'),(1143,'231124','孙吴县',104,0,0,'Sunwu Xian','SUW'),(1144,'231181','北安市',104,0,0,'Bei,an Shi','BAS'),(1145,'231182','五大连池市',104,0,0,'Wudalianchi Shi','WDL'),(1146,'231201','市辖区',105,0,0,'1','2'),(1147,'231202','北林区',105,0,0,'Beilin Qu','2'),(1148,'231221','望奎县',105,0,0,'Wangkui Xian','2'),(1149,'231222','兰西县',105,0,0,'Lanxi Xian','2'),(1150,'231223','青冈县',105,0,0,'Qinggang Xian','2'),(1151,'231224','庆安县',105,0,0,'Qing,an Xian','2'),(1152,'231225','明水县',105,0,0,'Mingshui Xian','2'),(1153,'231226','绥棱县',105,0,0,'Suileng Xian','2'),(1154,'231281','安达市',105,0,0,'Anda Shi','2'),(1155,'231282','肇东市',105,0,0,'Zhaodong Shi','2'),(1156,'231283','海伦市',105,0,0,'Hailun Shi','2'),(1157,'232721','呼玛县',106,0,0,'Huma Xian','HUM'),(1158,'232722','塔河县',106,0,0,'Tahe Xian','TAH'),(1159,'232723','漠河县',106,0,0,'Mohe Xian','MOH'),(1160,'310101','黄浦区',107,0,0,'Huangpu Qu','HGP'),(1161,'310103','卢湾区',107,0,0,'Luwan Qu','LWN'),(1162,'310104','徐汇区',107,0,0,'Xuhui Qu','XHI'),(1163,'310105','长宁区',107,0,0,'Changning Qu','CNQ'),(1164,'310106','静安区',107,0,0,'Jing,an Qu','JAQ'),(1165,'310107','普陀区',107,0,0,'Putuo Qu','PTQ'),(1166,'310108','闸北区',107,0,0,'Zhabei Qu','ZBE'),(1167,'310109','虹口区',107,0,0,'Hongkou Qu','HKQ'),(1168,'310110','杨浦区',107,0,0,'Yangpu Qu','YPU'),(1169,'310112','闵行区',107,0,0,'Minhang Qu','MHQ'),(1170,'310113','宝山区',107,0,0,'Baoshan Qu','BAO'),(1171,'310114','嘉定区',107,0,0,'Jiading Qu','JDG'),(1172,'310115','浦东新区',107,0,0,'Pudong Xinqu','PDX'),(1173,'310116','金山区',107,0,0,'Jinshan Qu','JSH'),(1174,'310117','松江区',107,0,0,'Songjiang Qu','SOJ'),(1175,'310118','青浦区',107,0,0,'Qingpu  Qu','QPU'),(1177,'310120','奉贤区',107,0,0,'Fengxian Qu','FXI'),(1178,'310230','崇明县',108,0,0,'Chongming Xian','CMI'),(1179,'320101','市辖区',109,0,0,'Shixiaqu','2'),(1180,'320102','玄武区',109,0,0,'Xuanwu Qu','XWU'),(1181,'320103','白下区',109,0,0,'Baixia Qu','BXQ'),(1182,'320104','秦淮区',109,0,0,'Qinhuai Qu','QHU'),(1183,'320105','建邺区',109,0,0,'Jianye Qu','JYQ'),(1184,'320106','鼓楼区',109,0,0,'Gulou Qu','GLQ'),(1185,'320107','下关区',109,0,0,'Xiaguan Qu','XGQ'),(1186,'320111','浦口区',109,0,0,'Pukou Qu','PKO'),(1187,'320113','栖霞区',109,0,0,'Qixia Qu','QAX'),(1188,'320114','雨花台区',109,0,0,'Yuhuatai Qu','YHT'),(1189,'320115','江宁区',109,0,0,'Jiangning Qu','2'),(1190,'320116','六合区',109,0,0,'Liuhe Qu','2'),(1191,'320124','溧水县',109,0,0,'Lishui Xian','LIS'),(1192,'320125','高淳县',109,0,0,'Gaochun Xian','GCN'),(1193,'320201','市辖区',110,0,0,'Shixiaqu','2'),(1194,'320202','崇安区',110,0,0,'Chong,an Qu','CGA'),(1195,'320203','南长区',110,0,0,'Nanchang Qu','NCG'),(1196,'320204','北塘区',110,0,0,'Beitang Qu','BTQ'),(1197,'320205','锡山区',110,0,0,'Xishan Qu','2'),(1198,'320206','惠山区',110,0,0,'Huishan Qu','2'),(1199,'320211','滨湖区',110,0,0,'Binhu Qu','2'),(1200,'320281','江阴市',110,0,0,'Jiangyin Shi','JIA'),(1201,'320282','宜兴市',110,0,0,'Yixing Shi','YIX'),(1202,'320301','市辖区',111,0,0,'Shixiaqu','2'),(1203,'320302','鼓楼区',111,0,0,'Gulou Qu','GLU'),(1204,'320303','云龙区',111,0,0,'Yunlong Qu','YLF'),(1206,'320305','贾汪区',111,0,0,'Jiawang Qu','JWQ'),(1207,'320311','泉山区',111,0,0,'Quanshan Qu','QSX'),(1208,'320321','丰县',111,0,0,'Feng Xian','FXN'),(1209,'320322','沛县',111,0,0,'Pei Xian','PEI'),(1210,'320312','铜山区',111,0,0,'Tongshan Xian','2'),(1211,'320324','睢宁县',111,0,0,'Suining Xian','SNI'),(1212,'320381','新沂市',111,0,0,'Xinyi Shi','XYW'),(1213,'320382','邳州市',111,0,0,'Pizhou Shi','PZO'),(1214,'320401','市辖区',112,0,0,'Shixiaqu','2'),(1215,'320402','天宁区',112,0,0,'Tianning Qu','TNQ'),(1216,'320404','钟楼区',112,0,0,'Zhonglou Qu','ZLQ'),(1217,'320405','戚墅堰区',112,0,0,'Qishuyan Qu','QSY'),(1218,'320411','新北区',112,0,0,'Xinbei Qu','2'),(1219,'320412','武进区',112,0,0,'Wujin Qu','2'),(1220,'320481','溧阳市',112,0,0,'Liyang Shi','LYR'),(1221,'320482','金坛市',112,0,0,'Jintan Shi','JTS'),(1222,'320501','市辖区',113,0,0,'Shixiaqu','2'),(1223,'320502','沧浪区',113,0,0,'Canglang Qu','CLQ'),(1224,'320503','平江区',113,0,0,'Pingjiang Qu','PJQ'),(1225,'320504','金阊区',113,0,0,'Jinchang Qu','JCA'),(1226,'320505','虎丘区',113,0,0,'Huqiu Qu','2'),(1227,'320506','吴中区',113,0,0,'Wuzhong Qu','2'),(1228,'320507','相城区',113,0,0,'Xiangcheng Qu','2'),(1229,'320581','常熟市',113,0,0,'Changshu Shi','CGS'),(1230,'320582','张家港市',113,0,0,'Zhangjiagang Shi ','ZJG'),(1231,'320583','昆山市',113,0,0,'Kunshan Shi','KUS'),(1232,'320584','吴江市',113,0,0,'Wujiang Shi','WUJ'),(1233,'320585','太仓市',113,0,0,'Taicang Shi','TAC'),(1234,'320601','市辖区',114,0,0,'Shixiaqu','2'),(1235,'320602','崇川区',114,0,0,'Chongchuan Qu','CCQ'),(1236,'320611','港闸区',114,0,0,'Gangzha Qu','GZQ'),(1237,'320621','海安县',114,0,0,'Hai,an Xian','HIA'),(1238,'320623','如东县',114,0,0,'Rudong Xian','RDG'),(1239,'320681','启东市',114,0,0,'Qidong Shi','QID'),(1240,'320682','如皋市',114,0,0,'Rugao Shi','RGO'),(1241,'320612','通州区',114,0,0,'Tongzhou Shi','2'),(1242,'320684','海门市',114,0,0,'Haimen Shi','HME'),(1243,'320701','市辖区',115,0,0,'Shixiaqu','2'),(1244,'320703','连云区',115,0,0,'Lianyun Qu','LYB'),(1245,'320705','新浦区',115,0,0,'Xinpu Qu','XPQ'),(1246,'320706','海州区',115,0,0,'Haizhou Qu','HIZ'),(1247,'320721','赣榆县',115,0,0,'Ganyu Xian','GYU'),(1248,'320722','东海县',115,0,0,'Donghai Xian','DHX'),(1249,'320723','灌云县',115,0,0,'Guanyun Xian','GYS'),(1250,'320724','灌南县',115,0,0,'Guannan Xian','GUN'),(1251,'320801','市辖区',116,0,0,'Shixiaqu','2'),(1252,'320802','清河区',116,0,0,'Qinghe Qu','QHH'),(1253,'320803','楚州区',116,0,0,'Chuzhou Qu','2'),(1254,'320804','淮阴区',116,0,0,'Huaiyin Qu','2'),(1255,'320811','清浦区',116,0,0,'Qingpu Qu','QPQ'),(1256,'320826','涟水县',116,0,0,'Lianshui Xian','LSI'),(1257,'320829','洪泽县',116,0,0,'Hongze Xian','HGZ'),(1258,'320830','盱眙县',116,0,0,'Xuyi Xian','XUY'),(1259,'320831','金湖县',116,0,0,'Jinhu Xian','JHU'),(1260,'320901','市辖区',117,0,0,'Shixiaqu','2'),(1261,'320902','亭湖区',117,0,0,'Tinghu Qu','2'),(1262,'320903','盐都区',117,0,0,'Yandu Qu','2'),(1263,'320921','响水县',117,0,0,'Xiangshui Xian','XSH'),(1264,'320922','滨海县',117,0,0,'Binhai Xian','BHI'),(1265,'320923','阜宁县',117,0,0,'Funing Xian','FNG'),(1266,'320924','射阳县',117,0,0,'Sheyang Xian','SEY'),(1267,'320925','建湖县',117,0,0,'Jianhu Xian','JIH'),(1268,'320981','东台市',117,0,0,'Dongtai Shi','DTS'),(1269,'320982','大丰市',117,0,0,'Dafeng Shi','DFS'),(1270,'321001','市辖区',118,0,0,'Shixiaqu','2'),(1271,'321002','广陵区',118,0,0,'Guangling Qu','GGL'),(1272,'321003','邗江区',118,0,0,'Hanjiang Qu','2'),(1273,'321011','维扬区',118,0,0,'Weiyang Qu','2'),(1274,'321023','宝应县',118,0,0,'Baoying Xian ','BYI'),(1275,'321081','仪征市',118,0,0,'Yizheng Shi','YZE'),(1276,'321084','高邮市',118,0,0,'Gaoyou Shi','GYO'),(1277,'321088','江都市',118,0,0,'Jiangdu Shi','JDU'),(1278,'321101','市辖区',119,0,0,'Shixiaqu','2'),(1279,'321102','京口区',119,0,0,'Jingkou Qu','2'),(1280,'321111','润州区',119,0,0,'Runzhou Qu','RZQ'),(1281,'321112','丹徒区',119,0,0,'Dantu Qu','2'),(1282,'321181','丹阳市',119,0,0,'Danyang Xian','DNY'),(1283,'321182','扬中市',119,0,0,'Yangzhong Shi','YZG'),(1284,'321183','句容市',119,0,0,'Jurong Shi','JRG'),(1285,'321201','市辖区',120,0,0,'Shixiaqu','2'),(1286,'321202','海陵区',120,0,0,'Hailing Qu','HIL'),(1287,'321203','高港区',120,0,0,'Gaogang Qu','GGQ'),(1288,'321281','兴化市',120,0,0,'Xinghua Shi','XHS'),(1289,'321282','靖江市',120,0,0,'Jingjiang Shi','JGJ'),(1290,'321283','泰兴市',120,0,0,'Taixing Shi','TXG'),(1291,'321284','姜堰市',120,0,0,'Jiangyan Shi','JYS'),(1292,'321301','市辖区',121,0,0,'Shixiaqu','2'),(1293,'321302','宿城区',121,0,0,'Sucheng Qu','SCE'),(1294,'321311','宿豫区',121,0,0,'Suyu Qu','2'),(1295,'321322','沭阳县',121,0,0,'Shuyang Xian','SYD'),(1296,'321323','泗阳县',121,0,0,'Siyang Xian ','SIY'),(1297,'321324','泗洪县',121,0,0,'Sihong Xian','SIH'),(1298,'330101','市辖区',122,0,0,'Shixiaqu','2'),(1299,'330102','上城区',122,0,0,'Shangcheng Qu','SCQ'),(1300,'330103','下城区',122,0,0,'Xiacheng Qu','XCG'),(1301,'330104','江干区',122,0,0,'Jianggan Qu','JGQ'),(1302,'330105','拱墅区',122,0,0,'Gongshu Qu','GSQ'),(1303,'330106','西湖区',122,0,0,'Xihu Qu ','XHU'),(1304,'330108','滨江区',122,0,0,'Binjiang Qu','BJQ'),(1305,'330109','萧山区',122,0,0,'Xiaoshan Qu','2'),(1306,'330110','余杭区',122,0,0,'Yuhang Qu','2'),(1307,'330122','桐庐县',122,0,0,'Tonglu Xian','TLU'),(1308,'330127','淳安县',122,0,0,'Chun,an Xian','CAZ'),(1309,'330182','建德市',122,0,0,'Jiande Shi','JDS'),(1310,'330183','富阳市',122,0,0,'Fuyang Shi','FYZ'),(1311,'330185','临安市',122,0,0,'Lin,an Shi','LNA'),(1312,'330201','市辖区',123,0,0,'Shixiaqu','2'),(1313,'330203','海曙区',123,0,0,'Haishu Qu','HNB'),(1314,'330204','江东区',123,0,0,'Jiangdong Qu','JDO'),(1315,'330205','江北区',123,0,0,'Jiangbei Qu','JBQ'),(1316,'330206','北仑区',123,0,0,'Beilun Qu','BLN'),(1317,'330211','镇海区',123,0,0,'Zhenhai Qu','ZHF'),(1318,'330212','鄞州区',123,0,0,'Yinzhou Qu','2'),(1319,'330225','象山县',123,0,0,'Xiangshan Xian','YSZ'),(1320,'330226','宁海县',123,0,0,'Ninghai Xian','NHI'),(1321,'330281','余姚市',123,0,0,'Yuyao Shi','YYO'),(1322,'330282','慈溪市',123,0,0,'Cixi Shi','CXI'),(1323,'330283','奉化市',123,0,0,'Fenghua Shi','FHU'),(1324,'330301','市辖区',124,0,0,'Shixiaqu','2'),(1325,'330302','鹿城区',124,0,0,'Lucheng Qu','LUW'),(1326,'330303','龙湾区',124,0,0,'Longwan Qu','LWW'),(1327,'330304','瓯海区',124,0,0,'Ouhai Qu','OHQ'),(1328,'330322','洞头县',124,0,0,'Dongtou Xian','DTO'),(1329,'330324','永嘉县',124,0,0,'Yongjia Xian','YJX'),(1330,'330326','平阳县',124,0,0,'Pingyang Xian','PYG'),(1331,'330327','苍南县',124,0,0,'Cangnan Xian','CAN'),(1332,'330328','文成县',124,0,0,'Wencheng Xian','WCZ'),(1333,'330329','泰顺县',124,0,0,'Taishun Xian','TSZ'),(1334,'330381','瑞安市',124,0,0,'Rui,an Xian','RAS'),(1335,'330382','乐清市',124,0,0,'Yueqing Shi','YQZ'),(1336,'330401','市辖区',125,0,0,'Shixiaqu','2'),(1338,'330411','秀洲区',125,0,0,'Xiuzhou Qu','2'),(1339,'330421','嘉善县',125,0,0,'Jiashan Xian','JSK'),(1340,'330424','海盐县',125,0,0,'Haiyan Xian','HYN'),(1341,'330481','海宁市',125,0,0,'Haining Shi','HNG'),(1342,'330482','平湖市',125,0,0,'Pinghu Shi','PHU'),(1343,'330483','桐乡市',125,0,0,'Tongxiang Shi','TXZ'),(1344,'330501','市辖区',126,0,0,'Shixiaqu','2'),(1345,'330502','吴兴区',126,0,0,'Wuxing Qu','2'),(1346,'330503','南浔区',126,0,0,'Nanxun Qu','2'),(1347,'330521','德清县',126,0,0,'Deqing Xian','DQX'),(1348,'330522','长兴县',126,0,0,'Changxing Xian','CXG'),(1349,'330523','安吉县',126,0,0,'Anji Xian','AJI'),(1350,'330601','市辖区',127,0,0,'Shixiaqu','2'),(1351,'330602','越城区',127,0,0,'Yuecheng Qu','YSX'),(1352,'330621','绍兴县',127,0,0,'Shaoxing Xian','SXZ'),(1353,'330624','新昌县',127,0,0,'Xinchang Xian','XCX'),(1354,'330681','诸暨市',127,0,0,'Zhuji Shi','ZHJ'),(1355,'330682','上虞市',127,0,0,'Shangyu Shi','SYZ'),(1356,'330683','嵊州市',127,0,0,'Shengzhou Shi','SGZ'),(1357,'330701','市辖区',128,0,0,'Shixiaqu','2'),(1358,'330702','婺城区',128,0,0,'Wucheng Qu','WCF'),(1359,'330703','金东区',128,0,0,'Jindong Qu','2'),(1360,'330723','武义县',128,0,0,'Wuyi Xian','WYX'),(1361,'330726','浦江县',128,0,0,'Pujiang Xian ','PJG'),(1362,'330727','磐安县',128,0,0,'Pan,an Xian','PAX'),(1363,'330781','兰溪市',128,0,0,'Lanxi Shi','LXZ'),(1364,'330782','义乌市',128,0,0,'Yiwu Shi','YWS'),(1365,'330783','东阳市',128,0,0,'Dongyang Shi','DGY'),(1366,'330784','永康市',128,0,0,'Yongkang Shi','YKG'),(1367,'330801','市辖区',129,0,0,'Shixiaqu','2'),(1368,'330802','柯城区',129,0,0,'Kecheng Qu','KEC'),(1369,'330803','衢江区',129,0,0,'Qujiang Qu','2'),(1370,'330822','常山县',129,0,0,'Changshan Xian','CSN'),(1371,'330824','开化县',129,0,0,'Kaihua Xian','KHU'),(1372,'330825','龙游县',129,0,0,'Longyou Xian ','LGY'),(1373,'330881','江山市',129,0,0,'Jiangshan Shi','JIS'),(1374,'330901','市辖区',130,0,0,'Shixiaqu','2'),(1375,'330902','定海区',130,0,0,'Dinghai Qu','DHQ'),(1376,'330903','普陀区',130,0,0,'Putuo Qu','PTO'),(1377,'330921','岱山县',130,0,0,'Daishan Xian','DSH'),(1378,'330922','嵊泗县',130,0,0,'Shengsi Xian','SSZ'),(1379,'331001','市辖区',131,0,0,'Shixiaqu','2'),(1380,'331002','椒江区',131,0,0,'Jiaojiang Qu','JJT'),(1381,'331003','黄岩区',131,0,0,'Huangyan Qu','HYT'),(1382,'331004','路桥区',131,0,0,'Luqiao Qu','LQT'),(1383,'331021','玉环县',131,0,0,'Yuhuan Xian','YHN'),(1384,'331022','三门县',131,0,0,'Sanmen Xian','SMN'),(1385,'331023','天台县',131,0,0,'Tiantai Xian','TTA'),(1386,'331024','仙居县',131,0,0,'Xianju Xian','XJU'),(1387,'331081','温岭市',131,0,0,'Wenling Shi','WLS'),(1388,'331082','临海市',131,0,0,'Linhai Shi','LHI'),(1389,'331101','市辖区',132,0,0,'1','2'),(1390,'331102','莲都区',132,0,0,'Liandu Qu','2'),(1391,'331121','青田县',132,0,0,'Qingtian Xian','2'),(1392,'331122','缙云县',132,0,0,'Jinyun Xian','2'),(1393,'331123','遂昌县',132,0,0,'Suichang Xian','2'),(1394,'331124','松阳县',132,0,0,'Songyang Xian','2'),(1395,'331125','云和县',132,0,0,'Yunhe Xian','2'),(1396,'331126','庆元县',132,0,0,'Qingyuan Xian','2'),(1397,'331127','景宁畲族自治县',132,0,0,'Jingning Shezu Zizhixian','2'),(1398,'331181','龙泉市',132,0,0,'Longquan Shi','2'),(1399,'340101','市辖区',133,0,0,'Shixiaqu','2'),(1400,'340102','瑶海区',133,0,0,'Yaohai Qu','2'),(1401,'340103','庐阳区',133,0,0,'Luyang Qu','2'),(1402,'340104','蜀山区',133,0,0,'Shushan Qu','2'),(1403,'340111','包河区',133,0,0,'Baohe Qu','2'),(1404,'340121','长丰县',133,0,0,'Changfeng Xian','CFG'),(1405,'340122','肥东县',133,0,0,'Feidong Xian','FDO'),(1406,'340123','肥西县',133,0,0,'Feixi Xian','FIX'),(1407,'340201','市辖区',1412,0,0,'Shixiaqu','2'),(1408,'340202','镜湖区',1412,0,0,'Jinghu Qu','JHW'),(1409,'340208','三山区',1412,0,0,'Matang Qu','2'),(1410,'340203','弋江区',1412,0,0,'Xinwu Qu','2'),(1411,'340207','鸠江区',1412,0,0,'Jiujiang Qu','JJW'),(1412,'340200','芜湖市',134,0,0,'Wuhu Shi','WHI'),(1413,'340222','繁昌县',1412,0,0,'Fanchang Xian','FCH'),(1414,'340223','南陵县',1412,0,0,'Nanling Xian','NLX'),(1415,'340301','市辖区',135,0,0,'Shixiaqu','2'),(1416,'340302','龙子湖区',135,0,0,'Longzihu Qu','2'),(1417,'340303','蚌山区',135,0,0,'Bangshan Qu','2'),(1418,'340304','禹会区',135,0,0,'Yuhui Qu','2'),(1419,'340311','淮上区',135,0,0,'Huaishang Qu','2'),(1420,'340321','怀远县',135,0,0,'Huaiyuan Qu','HYW'),(1421,'340322','五河县',135,0,0,'Wuhe Xian','WHE'),(1422,'340323','固镇县',135,0,0,'Guzhen Xian','GZX'),(1423,'340401','市辖区',136,0,0,'Shixiaqu','2'),(1424,'340402','大通区',136,0,0,'Datong Qu','DTQ'),(1425,'340403','田家庵区',136,0,0,'Tianjia,an Qu','TJA'),(1426,'340404','谢家集区',136,0,0,'Xiejiaji Qu','XJJ'),(1427,'340405','八公山区',136,0,0,'Bagongshan Qu','BGS'),(1428,'340406','潘集区',136,0,0,'Panji Qu','PJI'),(1429,'340421','凤台县',136,0,0,'Fengtai Xian','2'),(1430,'340501','市辖区',137,0,0,'Shixiaqu','2'),(1431,'340502','金家庄区',137,0,0,'Jinjiazhuang Qu','JJZ'),(1432,'340503','花山区',137,0,0,'Huashan Qu','HSM'),(1433,'340504','雨山区',137,0,0,'Yushan Qu','YSQ'),(1434,'340521','当涂县',137,0,0,'Dangtu Xian','DTU'),(1435,'340601','市辖区',138,0,0,'Shixiaqu','2'),(1436,'340602','杜集区',138,0,0,'Duji Qu','DJQ'),(1437,'340603','相山区',138,0,0,'Xiangshan Qu','XSA'),(1438,'340604','烈山区',138,0,0,'Lieshan Qu','LHB'),(1439,'340621','濉溪县',138,0,0,'Suixi Xian','SXW'),(1440,'340701','市辖区',139,0,0,'Shixiaqu','2'),(1441,'340702','铜官山区',139,0,0,'Tongguanshan Qu','TGQ'),(1442,'340703','狮子山区',139,0,0,'Shizishan Qu','SZN'),(1443,'340711','郊区',139,0,0,'Jiaoqu','JTL'),(1444,'340721','铜陵县',139,0,0,'Tongling Xian','TLX'),(1445,'340801','市辖区',140,0,0,'Shixiaqu','2'),(1446,'340802','迎江区',140,0,0,'Yingjiang Qu','YJQ'),(1447,'340803','大观区',140,0,0,'Daguan Qu','DGQ'),(1448,'340811','宜秀区',140,0,0,'Yixiu Qu','2'),(1449,'340822','怀宁县',140,0,0,'Huaining Xian','HNW'),(1450,'340823','枞阳县',140,0,0,'Zongyang Xian','ZYW'),(1451,'340824','潜山县',140,0,0,'Qianshan Xian','QSW'),(1452,'340825','太湖县',140,0,0,'Taihu Xian','THU'),(1453,'340826','宿松县',140,0,0,'Susong Xian','SUS'),(1454,'340827','望江县',140,0,0,'Wangjiang Xian','WJX'),(1455,'340828','岳西县',140,0,0,'Yuexi Xian','YXW'),(1456,'340881','桐城市',140,0,0,'Tongcheng Shi','TCW'),(1457,'341001','市辖区',141,0,0,'Shixiaqu','2'),(1458,'341002','屯溪区',141,0,0,'Tunxi Qu','TXN'),(1459,'341003','黄山区',141,0,0,'Huangshan Qu','HSK'),(1460,'341004','徽州区',141,0,0,'Huizhou Qu','HZQ'),(1461,'341021','歙县',141,0,0,'She Xian','SEX'),(1462,'341022','休宁县',141,0,0,'Xiuning Xian','XUN'),(1463,'341023','黟县',141,0,0,'Yi Xian','YIW'),(1464,'341024','祁门县',141,0,0,'Qimen Xian','QMN'),(1465,'341101','市辖区',142,0,0,'Shixiaqu','2'),(1466,'341102','琅琊区',142,0,0,'Langya Qu','LYU'),(1467,'341103','南谯区',142,0,0,'Nanqiao Qu','NQQ'),(1468,'341122','来安县',142,0,0,'Lai,an Xian','LAX'),(1469,'341124','全椒县',142,0,0,'Quanjiao Xian','QJO'),(1470,'341125','定远县',142,0,0,'Dingyuan Xian','DYW'),(1471,'341126','凤阳县',142,0,0,'Fengyang Xian','FYG'),(1472,'341181','天长市',142,0,0,'Tianchang Shi','TNC'),(1473,'341182','明光市',142,0,0,'Mingguang Shi','MGG'),(1474,'341201','市辖区',143,0,0,'Shixiaqu','2'),(1475,'341202','颍州区',143,0,0,'Yingzhou Qu','2'),(1476,'341203','颍东区',143,0,0,'Yingdong Qu','2'),(1477,'341204','颍泉区',143,0,0,'Yingquan Qu','2'),(1478,'341221','临泉县',143,0,0,'Linquan Xian','LQN'),(1479,'341222','太和县',143,0,0,'Taihe Xian','TIH'),(1480,'341225','阜南县',143,0,0,'Funan Xian','FNX'),(1481,'341226','颍上县',143,0,0,'Yingshang Xian','2'),(1482,'341282','界首市',143,0,0,'Jieshou Shi','JSW'),(1483,'341301','市辖区',144,0,0,'Shixiaqu','2'),(1484,'341302','埇桥区',144,0,0,'Yongqiao Qu','2'),(1485,'341321','砀山县',144,0,0,'Dangshan Xian','DSW'),(1486,'341322','萧县',144,0,0,'Xiao Xian','XIO'),(1487,'341323','灵璧县',144,0,0,'Lingbi Xian','LBI'),(1488,'341324','泗县',144,0,0,'Si Xian ','SIX'),(1489,'341401','市辖区',145,0,0,'1','2'),(1490,'341402','居巢区',145,0,0,'Juchao Qu','2'),(1491,'341421','庐江县',145,0,0,'Lujiang Xian','2'),(1492,'341422','无为县',145,0,0,'Wuwei Xian','2'),(1493,'341423','含山县',145,0,0,'Hanshan Xian','2'),(1494,'341424','和县',145,0,0,'He Xian ','2'),(1495,'341501','市辖区',146,0,0,'1','2'),(1496,'341502','金安区',146,0,0,'Jinan Qu','2'),(1497,'341503','裕安区',146,0,0,'Yuan Qu','2'),(1498,'341521','寿县',146,0,0,'Shou Xian','2'),(1499,'341522','霍邱县',146,0,0,'Huoqiu Xian','2'),(1500,'341523','舒城县',146,0,0,'Shucheng Xian','2'),(1501,'341524','金寨县',146,0,0,'Jingzhai Xian','2'),(1502,'341525','霍山县',146,0,0,'Huoshan Xian','2'),(1503,'341601','市辖区',147,0,0,'1','2'),(1504,'341602','谯城区',147,0,0,'Qiaocheng Qu','2'),(1505,'341621','涡阳县',147,0,0,'Guoyang Xian','2'),(1506,'341622','蒙城县',147,0,0,'Mengcheng Xian','2'),(1507,'341623','利辛县',147,0,0,'Lixin Xian','2'),(1508,'341701','市辖区',148,0,0,'1','2'),(1509,'341702','贵池区',148,0,0,'Guichi Qu','2'),(1510,'341721','东至县',148,0,0,'Dongzhi Xian','2'),(1511,'341722','石台县',148,0,0,'Shitai Xian','2'),(1512,'341723','青阳县',148,0,0,'Qingyang Xian','2'),(1513,'341801','市辖区',149,0,0,'1','2'),(1514,'341802','宣州区',149,0,0,'Xuanzhou Qu','2'),(1515,'341821','郎溪县',149,0,0,'Langxi Xian','2'),(1516,'341822','广德县',149,0,0,'Guangde Xian','2'),(1517,'341823','泾县',149,0,0,'Jing Xian','2'),(1518,'341824','绩溪县',149,0,0,'Jixi Xian','2'),(1519,'341825','旌德县',149,0,0,'Jingde Xian','2'),(1520,'341881','宁国市',149,0,0,'Ningguo Shi','2'),(1521,'350101','市辖区',150,0,0,'Shixiaqu','2'),(1522,'350102','鼓楼区',150,0,0,'Gulou Qu','GLR'),(1523,'350103','台江区',150,0,0,'Taijiang Qu','TJQ'),(1524,'350104','仓山区',150,0,0,'Cangshan Qu','CSQ'),(1525,'350105','马尾区',150,0,0,'Mawei Qu','MWQ'),(1526,'350111','晋安区',150,0,0,'Jin,an Qu','JAF'),(1527,'350121','闽侯县',150,0,0,'Minhou Qu','MHO'),(1528,'350122','连江县',150,0,0,'Lianjiang Xian','LJF'),(1529,'350123','罗源县',150,0,0,'Luoyuan Xian','LOY'),(1530,'350124','闽清县',150,0,0,'Minqing Xian','MQG'),(1531,'350125','永泰县',150,0,0,'Yongtai Xian','YTX'),(1532,'350128','平潭县',150,0,0,'Pingtan Xian','PTN'),(1533,'350181','福清市',150,0,0,'Fuqing Shi','FQS'),(1534,'350182','长乐市',150,0,0,'Changle Shi','CLS'),(1535,'350201','市辖区',151,0,0,'Shixiaqu','2'),(1536,'350203','思明区',151,0,0,'Siming Qu','SMQ'),(1537,'350205','海沧区',151,0,0,'Haicang Qu','2'),(1538,'350206','湖里区',151,0,0,'Huli Qu','HLQ'),(1539,'350211','集美区',151,0,0,'Jimei Qu','JMQ'),(1540,'350212','同安区',151,0,0,'Tong,an Qu','TAQ'),(1541,'350213','翔安区',151,0,0,'Xiangan Qu','2'),(1542,'350301','市辖区',152,0,0,'Shixiaqu','2'),(1543,'350302','城厢区',152,0,0,'Chengxiang Qu','CXP'),(1544,'350303','涵江区',152,0,0,'Hanjiang Qu','HJQ'),(1545,'350304','荔城区',152,0,0,'Licheng Qu','2'),(1546,'350305','秀屿区',152,0,0,'Xiuyu Qu','2'),(1547,'350322','仙游县',152,0,0,'Xianyou Xian','XYF'),(1548,'350401','市辖区',153,0,0,'Shixiaqu','2'),(1549,'350402','梅列区',153,0,0,'Meilie Qu','MLQ'),(1550,'350403','三元区',153,0,0,'Sanyuan Qu','SYB'),(1551,'350421','明溪县',153,0,0,'Mingxi Xian','MXI'),(1552,'350423','清流县',153,0,0,'Qingliu Xian','QLX'),(1553,'350424','宁化县',153,0,0,'Ninghua Xian','NGH'),(1554,'350425','大田县',153,0,0,'Datian Xian','DTM'),(1555,'350426','尤溪县',153,0,0,'Youxi Xian','YXF'),(1556,'350427','沙县',153,0,0,'Sha Xian','SAX'),(1557,'350428','将乐县',153,0,0,'Jiangle Xian','JLE'),(1558,'350429','泰宁县',153,0,0,'Taining Xian','TNG'),(1559,'350430','建宁县',153,0,0,'Jianning Xian','JNF'),(1560,'350481','永安市',153,0,0,'Yong,an Shi','YAF'),(1561,'350501','市辖区',154,0,0,'Shixiaqu','2'),(1562,'350502','鲤城区',154,0,0,'Licheng Qu','LCQ'),(1563,'350503','丰泽区',154,0,0,'Fengze Qu','FZE'),(1564,'350504','洛江区',154,0,0,'Luojiang Qu','LJQ'),(1565,'350505','泉港区',154,0,0,'Quangang Qu','2'),(1566,'350521','惠安县',154,0,0,'Hui,an Xian','HAF'),(1567,'350524','安溪县',154,0,0,'Anxi Xian','ANX'),(1568,'350525','永春县',154,0,0,'Yongchun Xian','YCM'),(1569,'350526','德化县',154,0,0,'Dehua Xian','DHA'),(1570,'350527','金门县',154,0,0,'Jinmen Xian','JME'),(1571,'350581','石狮市',154,0,0,'Shishi Shi','SHH'),(1572,'350582','晋江市',154,0,0,'Jinjiang Shi','JJG'),(1573,'350583','南安市',154,0,0,'Nan,an Shi','NAS'),(1574,'350601','市辖区',155,0,0,'Shixiaqu','2'),(1575,'350602','芗城区',155,0,0,'Xiangcheng Qu','XZZ'),(1576,'350603','龙文区',155,0,0,'Longwen Qu','LWZ'),(1577,'350622','云霄县',155,0,0,'Yunxiao Xian','YXO'),(1578,'350623','漳浦县',155,0,0,'Zhangpu Xian','ZPU'),(1579,'350624','诏安县',155,0,0,'Zhao,an Xian','ZAF'),(1580,'350625','长泰县',155,0,0,'Changtai Xian','CTA'),(1581,'350626','东山县',155,0,0,'Dongshan Xian','DSN'),(1582,'350627','南靖县',155,0,0,'Nanjing Xian','NJX'),(1583,'350628','平和县',155,0,0,'Pinghe Xian','PHE'),(1584,'350629','华安县',155,0,0,'Hua,an Xian','HAN'),(1585,'350681','龙海市',155,0,0,'Longhai Shi','LHM'),(1586,'350701','市辖区',156,0,0,'Shixiaqu','2'),(1587,'350702','延平区',156,0,0,'Yanping Qu','YPQ'),(1588,'350721','顺昌县',156,0,0,'Shunchang Xian','SCG'),(1589,'350722','浦城县',156,0,0,'Pucheng Xian','PCX'),(1590,'350723','光泽县',156,0,0,'Guangze Xian','GZE'),(1591,'350724','松溪县',156,0,0,'Songxi Xian','SOX'),(1592,'350725','政和县',156,0,0,'Zhenghe Xian','ZGH'),(1593,'350781','邵武市',156,0,0,'Shaowu Shi','SWU'),(1594,'350782','武夷山市',156,0,0,'Wuyishan Shi','WUS'),(1595,'350783','建瓯市',156,0,0,'Jian,ou Shi','JOU'),(1596,'350784','建阳市',156,0,0,'Jianyang Shi','JNY'),(1597,'350801','市辖区',157,0,0,'Shixiaqu','2'),(1598,'350802','新罗区',157,0,0,'Xinluo Qu','XNL'),(1599,'350821','长汀县',157,0,0,'Changting Xian','CTG'),(1600,'350822','永定县',157,0,0,'Yongding Xian','YDI'),(1601,'350823','上杭县',157,0,0,'Shanghang Xian','SHF'),(1602,'350824','武平县',157,0,0,'Wuping Xian','WPG'),(1603,'350825','连城县',157,0,0,'Liancheng Xian','LCF'),(1604,'350881','漳平市',157,0,0,'Zhangping Xian','ZGP'),(1605,'350901','市辖区',158,0,0,'1','2'),(1606,'350902','蕉城区',158,0,0,'Jiaocheng Qu','2'),(1607,'350921','霞浦县',158,0,0,'Xiapu Xian','2'),(1608,'350922','古田县',158,0,0,'Gutian Xian','2'),(1609,'350923','屏南县',158,0,0,'Pingnan Xian','2'),(1610,'350924','寿宁县',158,0,0,'Shouning Xian','2'),(1611,'350925','周宁县',158,0,0,'Zhouning Xian','2'),(1612,'350926','柘荣县',158,0,0,'Zherong Xian','2'),(1613,'350981','福安市',158,0,0,'Fu,an Shi','2'),(1614,'350982','福鼎市',158,0,0,'Fuding Shi','2'),(1615,'360101','市辖区',159,0,0,'Shixiaqu','2'),(1616,'360102','东湖区',159,0,0,'Donghu Qu','DHU'),(1617,'360103','西湖区',159,0,0,'Xihu Qu ','XHQ'),(1618,'360104','青云谱区',159,0,0,'Qingyunpu Qu','QYP'),(1619,'360105','湾里区',159,0,0,'Wanli Qu','WLI'),(1620,'360111','青山湖区',159,0,0,'Qingshanhu Qu','2'),(1621,'360121','南昌县',159,0,0,'Nanchang Xian','NCA'),(1622,'360122','新建县',159,0,0,'Xinjian Xian','XJN'),(1623,'360123','安义县',159,0,0,'Anyi Xian','AYI'),(1624,'360124','进贤县',159,0,0,'Jinxian Xian','JXX'),(1625,'360201','市辖区',160,0,0,'Shixiaqu','2'),(1626,'360202','昌江区',160,0,0,'Changjiang Qu','CJG'),(1627,'360203','珠山区',160,0,0,'Zhushan Qu','ZSJ'),(1628,'360222','浮梁县',160,0,0,'Fuliang Xian','FLX'),(1629,'360281','乐平市',160,0,0,'Leping Shi','LEP'),(1630,'360301','市辖区',161,0,0,'Shixiaqu','2'),(1631,'360302','安源区',161,0,0,'Anyuan Qu','AYQ'),(1632,'360313','湘东区',161,0,0,'Xiangdong Qu','XDG'),(1633,'360321','莲花县',161,0,0,'Lianhua Xian','LHG'),(1634,'360322','上栗县',161,0,0,'Shangli Xian','SLI'),(1635,'360323','芦溪县',161,0,0,'Lixi Xian','LXP'),(1636,'360401','市辖区',162,0,0,'Shixiaqu','2'),(1637,'360402','庐山区',162,0,0,'Lushan Qu','LSV'),(1638,'360403','浔阳区',162,0,0,'Xunyang Qu','XYC'),(1639,'360421','九江县',162,0,0,'Jiujiang Xian','JUJ'),(1640,'360423','武宁县',162,0,0,'Wuning Xian','WUN'),(1641,'360424','修水县',162,0,0,'Xiushui Xian','XSG'),(1642,'360425','永修县',162,0,0,'Yongxiu Xian','YOX'),(1643,'360426','德安县',162,0,0,'De,an Xian','DEA'),(1644,'360427','星子县',162,0,0,'Xingzi Xian','XZI'),(1645,'360428','都昌县',162,0,0,'Duchang Xian','DUC'),(1646,'360429','湖口县',162,0,0,'Hukou Xian','HUK'),(1647,'360430','彭泽县',162,0,0,'Pengze Xian','PZE'),(1648,'360481','瑞昌市',162,0,0,'Ruichang Shi','RCG'),(1649,'360501','市辖区',163,0,0,'Shixiaqu','2'),(1650,'360502','渝水区',163,0,0,'Yushui Qu','YSR'),(1651,'360521','分宜县',163,0,0,'Fenyi Xian','FYI'),(1652,'360601','市辖区',164,0,0,'Shixiaqu','2'),(1653,'360602','月湖区',164,0,0,'Yuehu Qu','YHY'),(1654,'360622','余江县',164,0,0,'Yujiang Xian','YUJ'),(1655,'360681','贵溪市',164,0,0,'Guixi Shi','GXS'),(1656,'360701','市辖区',165,0,0,'Shixiaqu','2'),(1657,'360702','章贡区',165,0,0,'Zhanggong Qu','ZGG'),(1658,'360721','赣县',165,0,0,'Gan Xian','GXN'),(1659,'360722','信丰县',165,0,0,'Xinfeng Xian ','XNF'),(1660,'360723','大余县',165,0,0,'Dayu Xian','DYX'),(1661,'360724','上犹县',165,0,0,'Shangyou Xian','SYO'),(1662,'360725','崇义县',165,0,0,'Chongyi Xian','CYX'),(1663,'360726','安远县',165,0,0,'Anyuan Xian','AYN'),(1664,'360727','龙南县',165,0,0,'Longnan Xian','LNX'),(1665,'360728','定南县',165,0,0,'Dingnan Xian','DNN'),(1666,'360729','全南县',165,0,0,'Quannan Xian','QNN'),(1667,'360730','宁都县',165,0,0,'Ningdu Xian','NDU'),(1668,'360731','于都县',165,0,0,'Yudu Xian','YUD'),(1669,'360732','兴国县',165,0,0,'Xingguo Xian','XGG'),(1670,'360733','会昌县',165,0,0,'Huichang Xian','HIC'),(1671,'360734','寻乌县',165,0,0,'Xunwu Xian','XNW'),(1672,'360735','石城县',165,0,0,'Shicheng Xian','SIC'),(1673,'360781','瑞金市',165,0,0,'Ruijin Shi','RJS'),(1674,'360782','南康市',165,0,0,'Nankang Shi','NNK'),(1675,'360801','市辖区',166,0,0,'1','2'),(1676,'360802','吉州区',166,0,0,'Jizhou Qu','2'),(1677,'360803','青原区',166,0,0,'Qingyuan Qu','2'),(1678,'360821','吉安县',166,0,0,'Ji,an Xian','2'),(1679,'360822','吉水县',166,0,0,'Jishui Xian','2'),(1680,'360823','峡江县',166,0,0,'Xiajiang Xian','2'),(1681,'360824','新干县',166,0,0,'Xingan Xian','2'),(1682,'360825','永丰县',166,0,0,'Yongfeng Xian','2'),(1683,'360826','泰和县',166,0,0,'Taihe Xian','2'),(1684,'360827','遂川县',166,0,0,'Suichuan Xian','2'),(1685,'360828','万安县',166,0,0,'Wan,an Xian','2'),(1686,'360829','安福县',166,0,0,'Anfu Xian','2'),(1687,'360830','永新县',166,0,0,'Yongxin Xian ','2'),(1688,'360881','井冈山市',166,0,0,'Jinggangshan Shi','2'),(1689,'360901','市辖区',167,0,0,'1','2'),(1690,'360902','袁州区',167,0,0,'Yuanzhou Qu','2'),(1691,'360921','奉新县',167,0,0,'Fengxin Xian','2'),(1692,'360922','万载县',167,0,0,'Wanzai Xian','2'),(1693,'360923','上高县',167,0,0,'Shanggao Xian','2'),(1694,'360924','宜丰县',167,0,0,'Yifeng Xian','2'),(1695,'360925','靖安县',167,0,0,'Jing,an Xian','2'),(1696,'360926','铜鼓县',167,0,0,'Tonggu Xian','2'),(1697,'360981','丰城市',167,0,0,'Fengcheng Shi','2'),(1698,'360982','樟树市',167,0,0,'Zhangshu Shi','2'),(1699,'360983','高安市',167,0,0,'Gao,an Shi','2'),(1700,'361001','市辖区',168,0,0,'1','2'),(1701,'361002','临川区',168,0,0,'Linchuan Qu','2'),(1702,'361021','南城县',168,0,0,'Nancheng Xian','2'),(1703,'361022','黎川县',168,0,0,'Lichuan Xian','2'),(1704,'361023','南丰县',168,0,0,'Nanfeng Xian','2'),(1705,'361024','崇仁县',168,0,0,'Chongren Xian','2'),(1706,'361025','乐安县',168,0,0,'Le,an Xian','2'),(1707,'361026','宜黄县',168,0,0,'Yihuang Xian','2'),(1708,'361027','金溪县',168,0,0,'Jinxi Xian','2'),(1709,'361028','资溪县',168,0,0,'Zixi Xian','2'),(1710,'361029','东乡县',168,0,0,'Dongxiang Xian','2'),(1711,'361030','广昌县',168,0,0,'Guangchang Xian','2'),(1712,'361101','市辖区',169,0,0,'1','2'),(1713,'361102','信州区',169,0,0,'Xinzhou Qu','XZQ'),(1714,'361121','上饶县',169,0,0,'Shangrao Xian ','2'),(1715,'361122','广丰县',169,0,0,'Guangfeng Xian','2'),(1716,'361123','玉山县',169,0,0,'Yushan Xian','2'),(1717,'361124','铅山县',169,0,0,'Qianshan Xian','2'),(1718,'361125','横峰县',169,0,0,'Hengfeng Xian','2'),(1719,'361126','弋阳县',169,0,0,'Yiyang Xian','2'),(1720,'361127','余干县',169,0,0,'Yugan Xian','2'),(1721,'361128','鄱阳县',169,0,0,'Poyang Xian','PYX'),(1722,'361129','万年县',169,0,0,'Wannian Xian','2'),(1723,'361130','婺源县',169,0,0,'Wuyuan Xian','2'),(1724,'361181','德兴市',169,0,0,'Dexing Shi','2'),(1725,'370101','市辖区',170,0,0,'Shixiaqu','2'),(1726,'370102','历下区',170,0,0,'Lixia Qu','LXQ'),(1727,'370101','市中区',170,0,0,'Shizhong Qu','SZQ'),(1728,'370104','槐荫区',170,0,0,'Huaiyin Qu','HYF'),(1729,'370105','天桥区',170,0,0,'Tianqiao Qu','TQQ'),(1730,'370112','历城区',170,0,0,'Licheng Qu','LCZ'),(1731,'370113','长清区',170,0,0,'Changqing Qu','2'),(1732,'370124','平阴县',170,0,0,'Pingyin Xian','PYL'),(1733,'370125','济阳县',170,0,0,'Jiyang Xian','JYL'),(1734,'370126','商河县',170,0,0,'Shanghe Xian','SGH'),(1735,'370181','章丘市',170,0,0,'Zhangqiu Shi','ZQS'),(1736,'370201','市辖区',171,0,0,'Shixiaqu','2'),(1737,'370202','市南区',171,0,0,'Shinan Qu','SNQ'),(1738,'370203','市北区',171,0,0,'Shibei Qu','SBQ'),(1739,'370205','四方区',171,0,0,'Sifang Qu','SFQ'),(1740,'370211','黄岛区',171,0,0,'Huangdao Qu','HDO'),(1741,'370212','崂山区',171,0,0,'Laoshan Qu','LQD'),(1742,'370213','李沧区',171,0,0,'Licang Qu','LCT'),(1743,'370214','城阳区',171,0,0,'Chengyang Qu','CEY'),(1744,'370281','胶州市',171,0,0,'Jiaozhou Shi','JZS'),(1745,'370282','即墨市',171,0,0,'Jimo Shi','JMO'),(1746,'370283','平度市',171,0,0,'Pingdu Shi','PDU'),(1747,'370284','胶南市',171,0,0,'Jiaonan Shi','JNS'),(1748,'370285','莱西市',171,0,0,'Laixi Shi','LXE'),(1749,'370301','市辖区',172,0,0,'Shixiaqu','2'),(1750,'370302','淄川区',172,0,0,'Zichuan Qu','ZCQ'),(1751,'370303','张店区',172,0,0,'Zhangdian Qu','ZDQ'),(1752,'370304','博山区',172,0,0,'Boshan Qu','BSZ'),(1753,'370305','临淄区',172,0,0,'Linzi Qu','LZQ'),(1754,'370306','周村区',172,0,0,'Zhoucun Qu','ZCN'),(1755,'370321','桓台县',172,0,0,'Huantai Xian','HTL'),(1756,'370322','高青县',172,0,0,'Gaoqing Xian','GQG'),(1757,'370323','沂源县',172,0,0,'Yiyuan Xian','YIY'),(1758,'370401','市辖区',173,0,0,'Shixiaqu','2'),(1759,'370402','市中区',173,0,0,'Shizhong Qu','SZZ'),(1760,'370403','薛城区',173,0,0,'Xuecheng Qu','XEC'),(1761,'370404','峄城区',173,0,0,'Yicheng Qu','YZZ'),(1762,'370405','台儿庄区',173,0,0,'Tai,erzhuang Qu','TEZ'),(1763,'370406','山亭区',173,0,0,'Shanting Qu','STG'),(1764,'370481','滕州市',173,0,0,'Tengzhou Shi','TZO'),(1765,'370501','市辖区',174,0,0,'Shixiaqu','2'),(1766,'370502','东营区',174,0,0,'Dongying Qu','DYQ'),(1767,'370503','河口区',174,0,0,'Hekou Qu','HKO'),(1768,'370521','垦利县',174,0,0,'Kenli Xian','KLI'),(1769,'370522','利津县',174,0,0,'Lijin Xian','LJN'),(1770,'370523','广饶县',174,0,0,'Guangrao Xian ','GRO'),(1771,'370601','市辖区',175,0,0,'Shixiaqu','2'),(1772,'370602','芝罘区',175,0,0,'Zhifu Qu','ZFQ'),(1773,'370611','福山区',175,0,0,'Fushan Qu','FUS'),(1774,'370612','牟平区',175,0,0,'Muping Qu','MPQ'),(1775,'370613','莱山区',175,0,0,'Laishan Qu','LYT'),(1776,'370634','长岛县',175,0,0,'Changdao Xian','CDO'),(1777,'370681','龙口市',175,0,0,'Longkou Shi','LKU'),(1778,'370682','莱阳市',175,0,0,'Laiyang Shi','LYD'),(1779,'370683','莱州市',175,0,0,'Laizhou Shi','LZG'),(1780,'370684','蓬莱市',175,0,0,'Penglai Shi','PLI'),(1781,'370685','招远市',175,0,0,'Zhaoyuan Shi','ZYL'),(1782,'370686','栖霞市',175,0,0,'Qixia Shi','QXS'),(1783,'370687','海阳市',175,0,0,'Haiyang Shi','HYL'),(1784,'370701','市辖区',176,0,0,'Shixiaqu','2'),(1785,'370702','潍城区',176,0,0,'Weicheng Qu','WCG'),(1786,'370703','寒亭区',176,0,0,'Hanting Qu','HNT'),(1787,'370704','坊子区',176,0,0,'Fangzi Qu','FZQ'),(1788,'370705','奎文区',176,0,0,'Kuiwen Qu','KWN'),(1789,'370724','临朐县',176,0,0,'Linqu Xian','LNQ'),(1790,'370725','昌乐县',176,0,0,'Changle Xian','CLX'),(1791,'370781','青州市',176,0,0,'Qingzhou Shi','QGZ'),(1792,'370782','诸城市',176,0,0,'Zhucheng Shi','ZCL'),(1793,'370783','寿光市',176,0,0,'Shouguang Shi','SGG'),(1794,'370784','安丘市',176,0,0,'Anqiu Shi','AQU'),(1795,'370785','高密市',176,0,0,'Gaomi Shi','GMI'),(1796,'370786','昌邑市',176,0,0,'Changyi Shi','CYL'),(1797,'370801','市辖区',177,0,0,'Shixiaqu','2'),(1798,'370802','市中区',177,0,0,'Shizhong Qu','SZU'),(1799,'370811','任城区',177,0,0,'Rencheng Qu','RCQ'),(1800,'370826','微山县',177,0,0,'Weishan Xian','WSA'),(1801,'370827','鱼台县',177,0,0,'Yutai Xian','YTL'),(1802,'370828','金乡县',177,0,0,'Jinxiang Xian','JXG'),(1803,'370829','嘉祥县',177,0,0,'Jiaxiang Xian','JXP'),(1804,'370830','汶上县',177,0,0,'Wenshang Xian','WNS'),(1805,'370831','泗水县',177,0,0,'Sishui Xian','SSH'),(1806,'370832','梁山县',177,0,0,'Liangshan Xian','LSN'),(1807,'370881','曲阜市',177,0,0,'Qufu Shi','QFU'),(1808,'370882','兖州市',177,0,0,'Yanzhou Shi','YZL'),(1809,'370883','邹城市',177,0,0,'Zoucheng Shi','ZCG'),(1810,'370901','市辖区',178,0,0,'Shixiaqu','2'),(1811,'370902','泰山区',178,0,0,'Taishan Qu','TSQ'),(1812,'370911','岱岳区',178,0,0,'Daiyue Qu','2'),(1813,'370921','宁阳县',178,0,0,'Ningyang Xian','NGY'),(1814,'370923','东平县',178,0,0,'Dongping Xian','DPG'),(1815,'370982','新泰市',178,0,0,'Xintai Shi','XTA'),(1816,'370983','肥城市',178,0,0,'Feicheng Shi','FEC'),(1817,'371001','市辖区',179,0,0,'Shixiaqu','2'),(1818,'371002','环翠区',179,0,0,'Huancui Qu','HNC'),(1819,'371081','文登市',179,0,0,'Wendeng Shi','WDS'),(1820,'371082','荣成市',179,0,0,'Rongcheng Shi','2'),(1821,'371083','乳山市',179,0,0,'Rushan Shi','RSN'),(1822,'371101','市辖区',180,0,0,'Shixiaqu','2'),(1823,'371102','东港区',180,0,0,'Donggang Qu','DGR'),(1824,'371103','岚山区',180,0,0,'Lanshan Qu','2'),(1825,'371121','五莲县',180,0,0,'Wulian Xian','WLN'),(1826,'371122','莒县',180,0,0,'Ju Xian','JUX'),(1827,'371201','市辖区',181,0,0,'Shixiaqu','2'),(1828,'371202','莱城区',181,0,0,'Laicheng Qu','LAC'),(1829,'371203','钢城区',181,0,0,'Gangcheng Qu','GCQ'),(1830,'371301','市辖区',182,0,0,'Shixiaqu','2'),(1831,'371302','兰山区',182,0,0,'Lanshan Qu','LLS'),(1832,'371311','罗庄区',182,0,0,'Luozhuang Qu','LZU'),(1833,'371301','河东区',182,0,0,'Hedong Qu','2'),(1834,'371321','沂南县',182,0,0,'Yinan Xian','YNN'),(1835,'371322','郯城县',182,0,0,'Tancheng Xian','TCE'),(1836,'371323','沂水县',182,0,0,'Yishui Xian','YIS'),(1837,'371324','苍山县',182,0,0,'Cangshan Xian','CSH'),(1838,'371325','费县',182,0,0,'Fei Xian','FEI'),(1839,'371326','平邑县',182,0,0,'Pingyi Xian','PYI'),(1840,'371327','莒南县',182,0,0,'Junan Xian','JNB'),(1841,'371328','蒙阴县',182,0,0,'Mengyin Xian','MYL'),(1842,'371329','临沭县',182,0,0,'Linshu Xian','LSP'),(1843,'371401','市辖区',183,0,0,'Shixiaqu','2'),(1844,'371402','德城区',183,0,0,'Decheng Qu','DCD'),(1845,'371421','陵县',183,0,0,'Ling Xian','LXL'),(1846,'371422','宁津县',183,0,0,'Ningjin Xian','NGJ'),(1847,'371423','庆云县',183,0,0,'Qingyun Xian','QYL'),(1848,'371424','临邑县',183,0,0,'Linyi xian','LYM'),(1849,'371425','齐河县',183,0,0,'Qihe Xian','QIH'),(1850,'371426','平原县',183,0,0,'Pingyuan Xian','PYN'),(1851,'371427','夏津县',183,0,0,'Xiajin Xian','XAJ'),(1852,'371428','武城县',183,0,0,'Wucheng Xian','WUC'),(1853,'371481','乐陵市',183,0,0,'Leling Shi','LEL'),(1854,'371482','禹城市',183,0,0,'Yucheng Shi','YCL'),(1855,'371501','市辖区',184,0,0,'Shixiaqu','2'),(1856,'371502','东昌府区',184,0,0,'Dongchangfu Qu','DCF'),(1857,'371521','阳谷县',184,0,0,'Yanggu Xian ','YGU'),(1858,'371522','莘县',184,0,0,'Shen Xian','SHN'),(1859,'371523','茌平县',184,0,0,'Chiping Xian ','CPG'),(1860,'371524','东阿县',184,0,0,'Dong,e Xian','DGE'),(1861,'371525','冠县',184,0,0,'Guan Xian','GXL'),(1862,'371526','高唐县',184,0,0,'Gaotang Xian','GTG'),(1863,'371581','临清市',184,0,0,'Linqing Xian','LQS'),(1864,'371601','市辖区',185,0,0,'1','2'),(1865,'371602','滨城区',185,0,0,'Bincheng Qu','2'),(1866,'371621','惠民县',185,0,0,'Huimin Xian','2'),(1867,'371622','阳信县',185,0,0,'Yangxin Xian','2'),(1868,'371623','无棣县',185,0,0,'Wudi Xian','2'),(1869,'371624','沾化县',185,0,0,'Zhanhua Xian','2'),(1870,'371625','博兴县',185,0,0,'Boxing Xian','2'),(1871,'371626','邹平县',185,0,0,'Zouping Xian','2'),(1873,'371702','牡丹区',186,0,0,'Mudan Qu','2'),(1874,'371721','曹县',186,0,0,'Cao Xian','2'),(1875,'371722','单县',186,0,0,'Shan Xian','2'),(1876,'371723','成武县',186,0,0,'Chengwu Xian','2'),(1877,'371724','巨野县',186,0,0,'Juye Xian','2'),(1878,'371725','郓城县',186,0,0,'Yuncheng Xian','2'),(1879,'371726','鄄城县',186,0,0,'Juancheng Xian','2'),(1880,'371727','定陶县',186,0,0,'Dingtao Xian','2'),(1881,'371728','东明县',186,0,0,'Dongming Xian','2'),(1882,'410101','市辖区',187,0,0,'Shixiaqu','2'),(1883,'410102','中原区',187,0,0,'Zhongyuan Qu','ZYQ'),(1884,'410103','二七区',187,0,0,'Erqi Qu','EQQ'),(1885,'410104','管城回族区',187,0,0,'Guancheng Huizu Qu','GCH'),(1886,'410105','金水区',187,0,0,'Jinshui Qu','JSU'),(1887,'410106','上街区',187,0,0,'Shangjie Qu','SJE'),(1888,'410108','惠济区',187,0,0,'Mangshan Qu','2'),(1889,'410122','中牟县',187,0,0,'Zhongmou Xian','ZMO'),(1890,'410181','巩义市',187,0,0,'Gongyi Shi','GYI'),(1891,'410182','荥阳市',187,0,0,'Xingyang Shi','XYK'),(1892,'410183','新密市',187,0,0,'Xinmi Shi','XMI'),(1893,'410184','新郑市',187,0,0,'Xinzheng Shi','XZG'),(1894,'410185','登封市',187,0,0,'Dengfeng Shi','2'),(1895,'410201','市辖区',188,0,0,'Shixiaqu','2'),(1896,'410202','龙亭区',188,0,0,'Longting Qu','LTK'),(1897,'410203','顺河回族区',188,0,0,'Shunhe Huizu Qu','SHR'),(1898,'410204','鼓楼区',188,0,0,'Gulou Qu','GLK'),(1899,'410205','禹王台区',188,0,0,'Yuwangtai Qu','2'),(1900,'410211','金明区',188,0,0,'Jinming Qu','2'),(1901,'410221','杞县',188,0,0,'Qi Xian','QIX'),(1902,'410222','通许县',188,0,0,'Tongxu Xian','TXY'),(1903,'410223','尉氏县',188,0,0,'Weishi Xian','WSI'),(1904,'410224','开封县',188,0,0,'Kaifeng Xian','KFX'),(1905,'410225','兰考县',188,0,0,'Lankao Xian','LKA'),(1906,'410301','市辖区',189,0,0,'Shixiaqu','2'),(1907,'410302','老城区',189,0,0,'Laocheng Qu','LLY'),(1908,'410303','西工区',189,0,0,'Xigong Qu','XGL'),(1909,'410304','瀍河回族区',189,0,0,'Chanhehuizu Qu','2'),(1910,'410305','涧西区',189,0,0,'Jianxi Qu','JXL'),(1911,'410306','吉利区',189,0,0,'Jili Qu','JLL'),(1912,'410311','洛龙区',189,0,0,'Luolong Qu','2'),(1913,'410322','孟津县',189,0,0,'Mengjin Xian','MGJ'),(1914,'410323','新安县',189,0,0,'Xin,an Xian','XAX'),(1915,'410324','栾川县',189,0,0,'Luanchuan Xian','LCK'),(1916,'410325','嵩县',189,0,0,'Song Xian','SON'),(1917,'410326','汝阳县',189,0,0,'Ruyang Xian','RUY'),(1918,'410327','宜阳县',189,0,0,'Yiyang Xian','YYY'),(1919,'410328','洛宁县',189,0,0,'Luoning Xian','LNI'),(1920,'410329','伊川县',189,0,0,'Yichuan Xian','YCZ'),(1921,'410381','偃师市',189,0,0,'Yanshi Shi','YST'),(1922,'410401','市辖区',190,0,0,'Shixiaqu','2'),(1923,'410402','新华区',190,0,0,'Xinhua Qu','XHP'),(1924,'410403','卫东区',190,0,0,'Weidong Qu','WDG'),(1925,'410404','石龙区',190,0,0,'Shilong Qu','SIL'),(1926,'410411','湛河区',190,0,0,'Zhanhe Qu','ZHQ'),(1927,'410421','宝丰县',190,0,0,'Baofeng Xian','BFG'),(1928,'410422','叶县',190,0,0,'Ye Xian','YEX'),(1929,'410423','鲁山县',190,0,0,'Lushan Xian','LUS'),(1930,'410425','郏县',190,0,0,'Jia Xian','JXY'),(1931,'410481','舞钢市',190,0,0,'Wugang Shi','WGY'),(1932,'410482','汝州市',190,0,0,'Ruzhou Shi','RZO'),(1933,'410501','市辖区',191,0,0,'Shixiaqu','2'),(1934,'410502','文峰区',191,0,0,'Wenfeng Qu','WFQ'),(1935,'410503','北关区',191,0,0,'Beiguan Qu','BGQ'),(1936,'410505','殷都区',191,0,0,'Yindu Qu','2'),(1937,'410506','龙安区',191,0,0,'Longan Qu','2'),(1938,'410522','安阳县',191,0,0,'Anyang Xian','AYX'),(1939,'410523','汤阴县',191,0,0,'Tangyin Xian','TYI'),(1940,'410526','滑县',191,0,0,'Hua Xian','HUA'),(1941,'410527','内黄县',191,0,0,'Neihuang Xian','NHG'),(1942,'410581','林州市',191,0,0,'Linzhou Shi','LZY'),(1943,'410601','市辖区',192,0,0,'Shixiaqu','2'),(1944,'410602','鹤山区',192,0,0,'Heshan Qu','HSF'),(1945,'410603','山城区',192,0,0,'Shancheng Qu','SCB'),(1946,'410611','淇滨区',192,0,0,'Qibin Qu','2'),(1947,'410621','浚县',192,0,0,'Xun Xian','XUX'),(1948,'410622','淇县',192,0,0,'Qi Xian','QXY'),(1949,'410701','市辖区',193,0,0,'Shixiaqu','2'),(1950,'410702','红旗区',193,0,0,'Hongqi Qu','HQQ'),(1951,'410703','卫滨区',193,0,0,'Weibin Qu','2'),(1952,'410704','凤泉区',193,0,0,'Fengquan Qu','2'),(1953,'410711','牧野区',193,0,0,'Muye Qu','2'),(1954,'410721','新乡县',193,0,0,'Xinxiang Xian','XXX'),(1955,'410724','获嘉县',193,0,0,'Huojia Xian','HOJ'),(1956,'410725','原阳县',193,0,0,'Yuanyang Xian','YYA'),(1957,'410726','延津县',193,0,0,'Yanjin Xian','YJN'),(1958,'410727','封丘县',193,0,0,'Fengqiu Xian','FQU'),(1959,'410728','长垣县',193,0,0,'Changyuan Xian','CYU'),(1960,'410781','卫辉市',193,0,0,'Weihui Shi','WHS'),(1961,'410782','辉县市',193,0,0,'Huixian Shi','HXS'),(1962,'410801','市辖区',194,0,0,'Shixiaqu','2'),(1963,'410802','解放区',194,0,0,'Jiefang Qu','JFQ'),(1964,'410803','中站区',194,0,0,'Zhongzhan Qu','ZZQ'),(1965,'410804','马村区',194,0,0,'Macun Qu','MCQ'),(1966,'410811','山阳区',194,0,0,'Shanyang Qu','SYC'),(1967,'410821','修武县',194,0,0,'Xiuwu Xian','XUW'),(1968,'410822','博爱县',194,0,0,'Bo,ai Xian','BOA'),(1969,'410823','武陟县',194,0,0,'Wuzhi Xian','WZI'),(1970,'410825','温县',194,0,0,'Wen Xian','WEN'),(1971,'419001','济源市',194,0,0,'Jiyuan Shi','2'),(1972,'410882','沁阳市',194,0,0,'Qinyang Shi','QYS'),(1973,'410883','孟州市',194,0,0,'Mengzhou Shi','MZO'),(1974,'410901','市辖区',195,0,0,'Shixiaqu','2'),(1975,'410902','华龙区',195,0,0,'Hualong Qu','2'),(1976,'410922','清丰县',195,0,0,'Qingfeng Xian','QFG'),(1977,'410923','南乐县',195,0,0,'Nanle Xian','NLE'),(1978,'410926','范县',195,0,0,'Fan Xian','FAX'),(1979,'410927','台前县',195,0,0,'Taiqian Xian','TQN'),(1980,'410928','濮阳县',195,0,0,'Puyang Xian','PUY'),(1981,'411001','市辖区',196,0,0,'Shixiaqu','2'),(1982,'411002','魏都区',196,0,0,'Weidu Qu','WED'),(1983,'411023','许昌县',196,0,0,'Xuchang Xian','XUC'),(1984,'411024','鄢陵县',196,0,0,'Yanling Xian','YLY'),(1985,'411025','襄城县',196,0,0,'Xiangcheng Xian','XAC'),(1986,'411081','禹州市',196,0,0,'Yuzhou Shi','YUZ'),(1987,'411082','长葛市',196,0,0,'Changge Shi','CGE'),(1988,'411101','市辖区',197,0,0,'Shixiaqu','2'),(1989,'411102','源汇区',197,0,0,'Yuanhui Qu','YHI'),(1990,'411103','郾城区',197,0,0,'Yancheng Qu','2'),(1991,'411104','召陵区',197,0,0,'Zhaoling Qu','2'),(1992,'411121','舞阳县',197,0,0,'Wuyang Xian','WYG'),(1993,'411122','临颍县',197,0,0,'Linying Xian','LNY'),(1994,'411201','市辖区',198,0,0,'Shixiaqu','2'),(1995,'411202','湖滨区',198,0,0,'Hubin Qu','HBI'),(1996,'411221','渑池县',198,0,0,'Mianchi Xian','MCI'),(1997,'411222','陕县',198,0,0,'Shan Xian','SHX'),(1998,'411224','卢氏县',198,0,0,'Lushi Xian','LUU'),(1999,'411281','义马市',198,0,0,'Yima Shi','YMA'),(2000,'411282','灵宝市',198,0,0,'Lingbao Shi','LBS'),(2001,'411301','市辖区',199,0,0,'Shixiaqu','2'),(2002,'411302','宛城区',199,0,0,'Wancheng Qu','WCN'),(2003,'411303','卧龙区',199,0,0,'Wolong Qu','WOL'),(2004,'411321','南召县',199,0,0,'Nanzhao Xian','NZO'),(2005,'411322','方城县',199,0,0,'Fangcheng Xian','FCX'),(2006,'411323','西峡县',199,0,0,'Xixia Xian','XXY'),(2007,'411324','镇平县',199,0,0,'Zhenping Xian','ZPX'),(2008,'411325','内乡县',199,0,0,'Neixiang Xian','NXG'),(2009,'411326','淅川县',199,0,0,'Xichuan Xian','XCY'),(2010,'411327','社旗县',199,0,0,'Sheqi Xian','SEQ'),(2011,'411328','唐河县',199,0,0,'Tanghe Xian','TGH'),(2012,'411329','新野县',199,0,0,'Xinye Xian','XYE'),(2013,'411330','桐柏县',199,0,0,'Tongbai Xian','TBX'),(2014,'411381','邓州市',199,0,0,'Dengzhou Shi','DGZ'),(2015,'411401','市辖区',200,0,0,'Shixiaqu','2'),(2016,'411402','梁园区',200,0,0,'Liangyuan Qu','LYY'),(2017,'411403','睢阳区',200,0,0,'Suiyang Qu','SYA'),(2018,'411421','民权县',200,0,0,'Minquan Xian','MQY'),(2019,'411422','睢县',200,0,0,'Sui Xian','SUI'),(2020,'411423','宁陵县',200,0,0,'Ningling Xian','NGL'),(2021,'411424','柘城县',200,0,0,'Zhecheng Xian','ZHC'),(2022,'411425','虞城县',200,0,0,'Yucheng Xian','YUC'),(2023,'411426','夏邑县',200,0,0,'Xiayi Xian','XAY'),(2024,'411481','永城市',200,0,0,'Yongcheng Shi','YOC'),(2025,'411501','市辖区',201,0,0,'Shixiaqu','2'),(2026,'411502','浉河区',201,0,0,'Shihe Qu','SHU'),(2027,'411503','平桥区',201,0,0,'Pingqiao Qu','PQQ'),(2028,'411521','罗山县',201,0,0,'Luoshan Xian','LSE'),(2029,'411522','光山县',201,0,0,'Guangshan Xian','GSX'),(2030,'411523','新县',201,0,0,'Xin Xian','XXI'),(2031,'411524','商城县',201,0,0,'Shangcheng Xian','SCX'),(2032,'411525','固始县',201,0,0,'Gushi Xian','GSI'),(2033,'411526','潢川县',201,0,0,'Huangchuan Xian','HCU'),(2034,'411527','淮滨县',201,0,0,'Huaibin Xian','HBN'),(2035,'411528','息县',201,0,0,'Xi Xian','XIX'),(2036,'411601','市辖区',202,0,0,'1','2'),(2037,'411602','川汇区',202,0,0,'Chuanhui Qu','2'),(2038,'411621','扶沟县',202,0,0,'Fugou Xian','2'),(2039,'411622','西华县',202,0,0,'Xihua Xian','2'),(2040,'411623','商水县',202,0,0,'Shangshui Xian','2'),(2041,'411624','沈丘县',202,0,0,'Shenqiu Xian','2'),(2042,'411625','郸城县',202,0,0,'Dancheng Xian','2'),(2043,'411626','淮阳县',202,0,0,'Huaiyang Xian','2'),(2044,'411627','太康县',202,0,0,'Taikang Xian','2'),(2045,'411628','鹿邑县',202,0,0,'Luyi Xian','2'),(2046,'411681','项城市',202,0,0,'Xiangcheng Shi','2'),(2047,'411701','市辖区',203,0,0,'1','2'),(2048,'411702','驿城区',203,0,0,'Yicheng Qu','2'),(2049,'411721','西平县',203,0,0,'Xiping Xian','2'),(2050,'411722','上蔡县',203,0,0,'Shangcai Xian','2'),(2051,'411723','平舆县',203,0,0,'Pingyu Xian','2'),(2052,'411724','正阳县',203,0,0,'Zhengyang Xian','2'),(2053,'411725','确山县',203,0,0,'Queshan Xian','2'),(2054,'411726','泌阳县',203,0,0,'Biyang Xian','2'),(2055,'411727','汝南县',203,0,0,'Runan Xian','2'),(2056,'411728','遂平县',203,0,0,'Suiping Xian','2'),(2057,'411729','新蔡县',203,0,0,'Xincai Xian','2'),(2058,'420101','市辖区',204,0,0,'Shixiaqu','2'),(2059,'420102','江岸区',204,0,0,'Jiang,an Qu','JAA'),(2060,'420103','江汉区',204,0,0,'Jianghan Qu','JHN'),(2061,'420104','硚口区',204,0,0,'Qiaokou Qu','QKQ'),(2062,'420105','汉阳区',204,0,0,'Hanyang Qu','HYA'),(2063,'420106','武昌区',204,0,0,'Wuchang Qu','WCQ'),(2064,'420107','青山区',204,0,0,'Qingshan Qu','QSN'),(2065,'420111','洪山区',204,0,0,'Hongshan Qu','HSQ'),(2066,'420112','东西湖区',204,0,0,'Dongxihu Qu','DXH'),(2067,'420113','汉南区',204,0,0,'Hannan Qu','HNQ'),(2068,'420114','蔡甸区',204,0,0,'Caidian Qu','CDN'),(2069,'420115','江夏区',204,0,0,'Jiangxia Qu','JXQ'),(2070,'420116','黄陂区',204,0,0,'Huangpi Qu','HPI'),(2071,'420117','新洲区',204,0,0,'Xinzhou Qu','XNZ'),(2072,'420201','市辖区',205,0,0,'Shixiaqu','2'),(2073,'420202','黄石港区',205,0,0,'Huangshigang Qu','HSG'),(2074,'420203','西塞山区',205,0,0,'Xisaishan Qu','2'),(2075,'420204','下陆区',205,0,0,'Xialu Qu','XAL'),(2076,'420205','铁山区',205,0,0,'Tieshan Qu','TSH'),(2077,'420222','阳新县',205,0,0,'Yangxin Xian','YXE'),(2078,'420281','大冶市',205,0,0,'Daye Shi','DYE'),(2079,'420301','市辖区',206,0,0,'Shixiaqu','2'),(2080,'420302','茅箭区',206,0,0,'Maojian Qu','MJN'),(2081,'420303','张湾区',206,0,0,'Zhangwan Qu','ZWQ'),(2082,'420321','郧县',206,0,0,'Yun Xian','YUN'),(2083,'420322','郧西县',206,0,0,'Yunxi Xian','YNX'),(2084,'420323','竹山县',206,0,0,'Zhushan Xian','ZHS'),(2085,'420324','竹溪县',206,0,0,'Zhuxi Xian','ZXX'),(2086,'420325','房县',206,0,0,'Fang Xian','FAG'),(2087,'420381','丹江口市',206,0,0,'Danjiangkou Shi','DJK'),(2088,'420501','市辖区',207,0,0,'Shixiaqu','2'),(2089,'420502','西陵区',207,0,0,'Xiling Qu','XLQ'),(2090,'420503','伍家岗区',207,0,0,'Wujiagang Qu','WJG'),(2091,'420504','点军区',207,0,0,'Dianjun Qu','DJN'),(2092,'420505','猇亭区',207,0,0,'Xiaoting Qu','XTQ'),(2093,'420506','夷陵区',207,0,0,'Yiling Qu','2'),(2094,'420525','远安县',207,0,0,'Yuan,an Xian','YAX'),(2095,'420526','兴山县',207,0,0,'Xingshan Xian','XSX'),(2096,'420527','秭归县',207,0,0,'Zigui Xian','ZGI'),(2097,'420528','长阳土家族自治县',207,0,0,'Changyang Tujiazu Zizhixian','CYA'),(2098,'420529','五峰土家族自治县',207,0,0,'Wufeng Tujiazu Zizhixian','WFG'),(2099,'420581','宜都市',207,0,0,'Yidu Shi','YID'),(2100,'420582','当阳市',207,0,0,'Dangyang Shi','DYS'),(2101,'420583','枝江市',207,0,0,'Zhijiang Shi','ZIJ'),(2102,'420601','市辖区',208,0,0,'Shixiaqu','2'),(2103,'420602','襄城区',208,0,0,'Xiangcheng Qu','XXF'),(2104,'420606','樊城区',208,0,0,'Fancheng Qu','FNC'),(2105,'420607','襄阳区',208,0,0,'Xiangyang Qu','2'),(2106,'420624','南漳县',208,0,0,'Nanzhang Xian','NZH'),(2107,'420625','谷城县',208,0,0,'Gucheng Xian','GUC'),(2108,'420626','保康县',208,0,0,'Baokang Xian','BKG'),(2109,'420682','老河口市',208,0,0,'Laohekou Shi','LHK'),(2110,'420683','枣阳市',208,0,0,'Zaoyang Shi','ZOY'),(2111,'420684','宜城市',208,0,0,'Yicheng Shi','YCW'),(2112,'420701','市辖区',209,0,0,'Shixiaqu','2'),(2113,'420702','梁子湖区',209,0,0,'Liangzihu Qu','LZI'),(2114,'420703','华容区',209,0,0,'Huarong Qu','HRQ'),(2115,'420704','鄂城区',209,0,0,'Echeng Qu','ECQ'),(2116,'420801','市辖区',210,0,0,'Shixiaqu','2'),(2117,'420802','东宝区',210,0,0,'Dongbao Qu','DBQ'),(2118,'420804','掇刀区',210,0,0,'Duodao Qu','2'),(2119,'420821','京山县',210,0,0,'Jingshan Xian','JSA'),(2120,'420822','沙洋县',210,0,0,'Shayang Xian','SYF'),(2121,'420881','钟祥市',210,0,0,'Zhongxiang Shi','2'),(2122,'420901','市辖区',211,0,0,'Shixiaqu','2'),(2123,'420902','孝南区',211,0,0,'Xiaonan Qu','XNA'),(2124,'420921','孝昌县',211,0,0,'Xiaochang Xian','XOC'),(2125,'420922','大悟县',211,0,0,'Dawu Xian','DWU'),(2126,'420923','云梦县',211,0,0,'Yunmeng Xian','YMX'),(2127,'420981','应城市',211,0,0,'Yingcheng Shi','YCG'),(2128,'420982','安陆市',211,0,0,'Anlu Shi','ALU'),(2129,'420984','汉川市',211,0,0,'Hanchuan Shi','HCH'),(2130,'421001','市辖区',212,0,0,'Shixiaqu','2'),(2131,'421002','沙市区',212,0,0,'Shashi Qu','SSJ'),(2132,'421003','荆州区',212,0,0,'Jingzhou Qu','JZQ'),(2133,'421022','公安县',212,0,0,'Gong,an Xian','GGA'),(2134,'421023','监利县',212,0,0,'Jianli Xian','JLI'),(2135,'421024','江陵县',212,0,0,'Jiangling Xian','JLX'),(2136,'421081','石首市',212,0,0,'Shishou Shi','SSO'),(2137,'421083','洪湖市',212,0,0,'Honghu Shi','HHU'),(2138,'421087','松滋市',212,0,0,'Songzi Shi','SZF'),(2139,'421101','市辖区',213,0,0,'Shixiaqu','2'),(2140,'421102','黄州区',213,0,0,'Huangzhou Qu','HZC'),(2141,'421121','团风县',213,0,0,'Tuanfeng Xian','TFG'),(2142,'421122','红安县',213,0,0,'Hong,an Xian','HGA'),(2143,'421123','罗田县',213,0,0,'Luotian Xian','LTE'),(2144,'421124','英山县',213,0,0,'Yingshan Xian','YSE'),(2145,'421125','浠水县',213,0,0,'Xishui Xian','XSE'),(2146,'421126','蕲春县',213,0,0,'Qichun Xian','QCN'),(2147,'421127','黄梅县',213,0,0,'Huangmei Xian','HGM'),(2148,'421181','麻城市',213,0,0,'Macheng Shi','MCS'),(2149,'421182','武穴市',213,0,0,'Wuxue Shi','WXE'),(2150,'421201','市辖区',214,0,0,'Shixiaqu','2'),(2151,'421202','咸安区',214,0,0,'Xian,an Qu','XAN'),(2152,'421221','嘉鱼县',214,0,0,'Jiayu Xian','JYX'),(2153,'421222','通城县',214,0,0,'Tongcheng Xian','TCX'),(2154,'421223','崇阳县',214,0,0,'Chongyang Xian','CGY'),(2155,'421224','通山县',214,0,0,'Tongshan Xian','TSA'),(2156,'421281','赤壁市',214,0,0,'Chibi Shi','CBI'),(2157,'421301','市辖区',215,0,0,'1','2'),(2158,'421303','曾都区',215,0,0,'Zengdu Qu','2'),(2159,'421381','广水市',215,0,0,'Guangshui Shi','2'),(2160,'422801','恩施市',216,0,0,'Enshi Shi','ESS'),(2161,'422802','利川市',216,0,0,'Lichuan Shi','LCE'),(2162,'422822','建始县',216,0,0,'Jianshi Xian','JSE'),(2163,'422823','巴东县',216,0,0,'Badong Xian','BDG'),(2164,'422825','宣恩县',216,0,0,'Xuan,en Xian','XEN'),(2165,'422826','咸丰县',216,0,0,'Xianfeng Xian','XFG'),(2166,'422827','来凤县',216,0,0,'Laifeng Xian','LFG'),(2167,'422828','鹤峰县',216,0,0,'Hefeng Xian','HEF'),(2168,'429004','仙桃市',217,0,0,'Xiantao Shi','XNT'),(2169,'429005','潜江市',217,0,0,'Qianjiang Shi','QNJ'),(2170,'429006','天门市',217,0,0,'Tianmen Shi','TMS'),(2171,'429021','神农架林区',217,0,0,'Shennongjia Linqu','SNJ'),(2172,'430101','市辖区',218,0,0,'Shixiaqu','2'),(2173,'430102','芙蓉区',218,0,0,'Furong Qu','FRQ'),(2174,'430103','天心区',218,0,0,'Tianxin Qu','TXQ'),(2175,'430104','岳麓区',218,0,0,'Yuelu Qu','YLU'),(2176,'430105','开福区',218,0,0,'Kaifu Qu','KFQ'),(2177,'430111','雨花区',218,0,0,'Yuhua Qu','YHA'),(2178,'430121','长沙县',218,0,0,'Changsha Xian','CSA'),(2179,'430122','望城县',218,0,0,'Wangcheng Xian','WCH'),(2180,'430124','宁乡县',218,0,0,'Ningxiang Xian','NXX'),(2181,'430181','浏阳市',218,0,0,'Liuyang Shi','LYS'),(2182,'430201','市辖区',219,0,0,'Shixiaqu','2'),(2183,'430202','荷塘区',219,0,0,'Hetang Qu','HTZ'),(2184,'430203','芦淞区',219,0,0,'Lusong Qu','LZZ'),(2185,'430204','石峰区',219,0,0,'Shifeng Qu','SFG'),(2186,'430211','天元区',219,0,0,'Tianyuan Qu','TYQ'),(2187,'430221','株洲县',219,0,0,'Zhuzhou Xian','ZZX'),(2188,'430223','攸县',219,0,0,'You Xian','YOU'),(2189,'430224','茶陵县',219,0,0,'Chaling Xian','CAL'),(2190,'430225','炎陵县',219,0,0,'Yanling Xian','YLX'),(2191,'430281','醴陵市',219,0,0,'Liling Shi','LIL'),(2192,'430301','市辖区',220,0,0,'Shixiaqu','2'),(2193,'430302','雨湖区',220,0,0,'Yuhu Qu','YHU'),(2194,'430304','岳塘区',220,0,0,'Yuetang Qu','YTG'),(2195,'430321','湘潭县',220,0,0,'Xiangtan Qu','XTX'),(2196,'430381','湘乡市',220,0,0,'Xiangxiang Shi','XXG'),(2197,'430382','韶山市',220,0,0,'Shaoshan Shi','SSN'),(2198,'430401','市辖区',221,0,0,'Shixiaqu','2'),(2199,'430405','珠晖区',221,0,0,'Zhuhui Qu','2'),(2200,'430406','雁峰区',221,0,0,'Yanfeng Qu','2'),(2201,'430407','石鼓区',221,0,0,'Shigu Qu','2'),(2202,'430408','蒸湘区',221,0,0,'Zhengxiang Qu','2'),(2203,'430412','南岳区',221,0,0,'Nanyue Qu','NYQ'),(2204,'430421','衡阳县',221,0,0,'Hengyang Xian','HYO'),(2205,'430422','衡南县',221,0,0,'Hengnan Xian','HNX'),(2206,'430423','衡山县',221,0,0,'Hengshan Xian','HSH'),(2207,'430424','衡东县',221,0,0,'Hengdong Xian','HED'),(2208,'430426','祁东县',221,0,0,'Qidong Xian','QDX'),(2209,'430481','耒阳市',221,0,0,'Leiyang Shi','LEY'),(2210,'430482','常宁市',221,0,0,'Changning Shi','CNS'),(2211,'430501','市辖区',222,0,0,'Shixiaqu','2'),(2212,'430502','双清区',222,0,0,'Shuangqing Qu','SGQ'),(2213,'430503','大祥区',222,0,0,'Daxiang Qu','DXS'),(2214,'430511','北塔区',222,0,0,'Beita Qu','BET'),(2215,'430521','邵东县',222,0,0,'Shaodong Xian','SDG'),(2216,'430522','新邵县',222,0,0,'Xinshao Xian','XSO'),(2217,'430523','邵阳县',222,0,0,'Shaoyang Xian','SYW'),(2218,'430524','隆回县',222,0,0,'Longhui Xian','LGH'),(2219,'430525','洞口县',222,0,0,'Dongkou Xian','DGK'),(2220,'430527','绥宁县',222,0,0,'Suining Xian','SNX'),(2221,'430528','新宁县',222,0,0,'Xinning Xian','XNI'),(2222,'430529','城步苗族自治县',222,0,0,'Chengbu Miaozu Zizhixian','CBU'),(2223,'430581','武冈市',222,0,0,'Wugang Shi','WGS'),(2224,'430601','市辖区',223,0,0,'Shixiaqu','2'),(2225,'430602','岳阳楼区',223,0,0,'Yueyanglou Qu','YYL'),(2226,'430603','云溪区',223,0,0,'Yunxi Qu','YXI'),(2227,'430611','君山区',223,0,0,'Junshan Qu','JUS'),(2228,'430621','岳阳县',223,0,0,'Yueyang Xian','YYX'),(2229,'430623','华容县',223,0,0,'Huarong Xian','HRG'),(2230,'430624','湘阴县',223,0,0,'Xiangyin Xian','XYN'),(2231,'430626','平江县',223,0,0,'Pingjiang Xian','PJH'),(2232,'430681','汨罗市',223,0,0,'Miluo Shi','MLU'),(2233,'430682','临湘市',223,0,0,'Linxiang Shi','LXY'),(2234,'430701','市辖区',224,0,0,'Shixiaqu','2'),(2235,'430702','武陵区',224,0,0,'Wuling Qu','WLQ'),(2236,'430703','鼎城区',224,0,0,'Dingcheng Qu','DCE'),(2237,'430721','安乡县',224,0,0,'Anxiang Xian','AXG'),(2238,'430722','汉寿县',224,0,0,'Hanshou Xian','HSO'),(2239,'430723','澧县',224,0,0,'Li Xian','LXX'),(2240,'430724','临澧县',224,0,0,'Linli Xian','LNL'),(2241,'430725','桃源县',224,0,0,'Taoyuan Xian','TOY'),(2242,'430726','石门县',224,0,0,'Shimen Xian','SHM'),(2243,'430781','津市市',224,0,0,'Jinshi Shi','JSS'),(2244,'430801','市辖区',225,0,0,'Shixiaqu','2'),(2245,'430802','永定区',225,0,0,'Yongding Qu','YDQ'),(2246,'430811','武陵源区',225,0,0,'Wulingyuan Qu','WLY'),(2247,'430821','慈利县',225,0,0,'Cili Xian','CLI'),(2248,'430822','桑植县',225,0,0,'Sangzhi Xian','SZT'),(2249,'430901','市辖区',226,0,0,'Shixiaqu','2'),(2250,'430902','资阳区',226,0,0,'Ziyang Qu','ZYC'),(2251,'430903','赫山区',226,0,0,'Heshan Qu','HSY'),(2252,'430921','南县',226,0,0,'Nan Xian','NXN'),(2253,'430922','桃江县',226,0,0,'Taojiang Xian','TJG'),(2254,'430923','安化县',226,0,0,'Anhua Xian','ANH'),(2255,'430981','沅江市',226,0,0,'Yuanjiang Shi','YJS'),(2256,'431001','市辖区',227,0,0,'Shixiaqu','2'),(2257,'431002','北湖区',227,0,0,'Beihu Qu','BHQ'),(2258,'431003','苏仙区',227,0,0,'Suxian Qu','2'),(2259,'431021','桂阳县',227,0,0,'Guiyang Xian','GYX'),(2260,'431022','宜章县',227,0,0,'yizhang Xian','YZA'),(2261,'431023','永兴县',227,0,0,'Yongxing Xian','YXX'),(2262,'431024','嘉禾县',227,0,0,'Jiahe Xian','JAH'),(2263,'431025','临武县',227,0,0,'Linwu Xian','LWX'),(2264,'431026','汝城县',227,0,0,'Rucheng Xian','RCE'),(2265,'431027','桂东县',227,0,0,'Guidong Xian','GDO'),(2266,'431028','安仁县',227,0,0,'Anren Xian','ARN'),(2267,'431081','资兴市',227,0,0,'Zixing Shi','ZXG'),(2268,'431101','市辖区',228,0,0,'Shixiaqu','2'),(2270,'431103','冷水滩区',228,0,0,'Lengshuitan Qu','LST'),(2271,'431121','祁阳县',228,0,0,'Qiyang Xian','QJY'),(2272,'431122','东安县',228,0,0,'Dong,an Xian','DOA'),(2273,'431123','双牌县',228,0,0,'Shuangpai Xian','SPA'),(2274,'431124','道县',228,0,0,'Dao Xian','DAO'),(2275,'431125','江永县',228,0,0,'Jiangyong Xian','JYD'),(2276,'431126','宁远县',228,0,0,'Ningyuan Xian','NYN'),(2277,'431127','蓝山县',228,0,0,'Lanshan Xian','LNS'),(2278,'431128','新田县',228,0,0,'Xintian Xian','XTN'),(2279,'431129','江华瑶族自治县',228,0,0,'Jianghua Yaozu Zizhixian','JHX'),(2280,'431201','市辖区',229,0,0,'Shixiaqu','2'),(2281,'431202','鹤城区',229,0,0,'Hecheng Qu','HCG'),(2282,'431221','中方县',229,0,0,'Zhongfang Xian','ZFX'),(2283,'431222','沅陵县',229,0,0,'Yuanling Xian','YNL'),(2284,'431223','辰溪县',229,0,0,'Chenxi Xian','CXX'),(2285,'431224','溆浦县',229,0,0,'Xupu Xian','XUP'),(2286,'431225','会同县',229,0,0,'Huitong Xian','HTG'),(2287,'431226','麻阳苗族自治县',229,0,0,'Mayang Miaozu Zizhixian','MYX'),(2288,'431227','新晃侗族自治县',229,0,0,'Xinhuang Dongzu Zizhixian','XHD'),(2289,'431228','芷江侗族自治县',229,0,0,'Zhijiang Dongzu Zizhixian','ZJX'),(2290,'431229','靖州苗族侗族自治县',229,0,0,'Jingzhou Miaozu Dongzu Zizhixian','JZO'),(2291,'431230','通道侗族自治县',229,0,0,'Tongdao Dongzu Zizhixian','TDD'),(2292,'431281','洪江市',229,0,0,'Hongjiang Shi','HGJ'),(2293,'431301','市辖区',230,0,0,'1','2'),(2294,'431302','娄星区',230,0,0,'Louxing Qu','2'),(2295,'431321','双峰县',230,0,0,'Shuangfeng Xian','2'),(2296,'431322','新化县',230,0,0,'Xinhua Xian','2'),(2297,'431381','冷水江市',230,0,0,'Lengshuijiang Shi','2'),(2298,'431382','涟源市',230,0,0,'Lianyuan Shi','2'),(2299,'433101','吉首市',231,0,0,'Jishou Shi','JSO'),(2300,'433122','泸溪县',231,0,0,'Luxi Xian','LXW'),(2301,'433123','凤凰县',231,0,0,'Fenghuang Xian','FHX'),(2302,'433124','花垣县',231,0,0,'Huayuan Xian','HYH'),(2303,'433125','保靖县',231,0,0,'Baojing Xian','BJG'),(2304,'433126','古丈县',231,0,0,'Guzhang Xian','GZG'),(2305,'433127','永顺县',231,0,0,'Yongshun Xian','YSF'),(2306,'433130','龙山县',231,0,0,'Longshan Xian','LSR'),(2307,'440101','市辖区',232,0,0,'Shixiaqu','2'),(2308,'440115','南沙区',232,0,0,'Nansha Qu','2'),(2309,'440103','荔湾区',232,0,0,'Liwan Qu','LWQ'),(2310,'440104','越秀区',232,0,0,'Yuexiu Qu','YXU'),(2311,'440105','海珠区',232,0,0,'Haizhu Qu','HZU'),(2312,'440106','天河区',232,0,0,'Tianhe Qu','THQ'),(2313,'440116','萝岗区',232,0,0,'Luogang Qu','2'),(2314,'440111','白云区',232,0,0,'Baiyun Qu','BYN'),(2315,'440112','黄埔区',232,0,0,'Huangpu Qu','HPU'),(2316,'440113','番禺区',232,0,0,'Panyu Qu','PNY'),(2317,'440114','花都区',232,0,0,'Huadu Qu','HDU'),(2318,'440183','增城市',232,0,0,'Zengcheng Shi','ZEC'),(2319,'440184','从化市',232,0,0,'Conghua Shi','CNH'),(2320,'440201','市辖区',233,0,0,'Shixiaqu','2'),(2321,'440203','武江区',233,0,0,'Wujiang Qu','WJQ'),(2322,'440204','浈江区',233,0,0,'Zhenjiang Qu','ZJQ'),(2323,'440205','曲江区',233,0,0,'Qujiang Qu','2'),(2324,'440222','始兴县',233,0,0,'Shixing Xian','SXX'),(2325,'440224','仁化县',233,0,0,'Renhua Xian','RHA'),(2326,'440229','翁源县',233,0,0,'Wengyuan Xian','WYN'),(2327,'440232','乳源瑶族自治县',233,0,0,'Ruyuan Yaozu Zizhixian','RYN'),(2328,'440233','新丰县',233,0,0,'Xinfeng Xian','XFY'),(2329,'440281','乐昌市',233,0,0,'Lechang Shi','LEC'),(2330,'440282','南雄市',233,0,0,'Nanxiong Shi','NXS'),(2331,'440301','市辖区',234,0,0,'Shixiaqu','2'),(2332,'440303','罗湖区',234,0,0,'Luohu Qu','LHQ'),(2333,'440304','福田区',234,0,0,'Futian Qu','FTN'),(2334,'440305','南山区',234,0,0,'Nanshan Qu','NSN'),(2335,'440306','宝安区',234,0,0,'Bao,an Qu','BAQ'),(2336,'440307','龙岗区',234,0,0,'Longgang Qu','LGG'),(2337,'440308','盐田区',234,0,0,'Yan Tian Qu','YTQ'),(2338,'440401','市辖区',235,0,0,'Shixiaqu','2'),(2339,'440402','香洲区',235,0,0,'Xiangzhou Qu','XZQ'),(2340,'440403','斗门区',235,0,0,'Doumen Qu','DOU'),(2341,'440404','金湾区',235,0,0,'Jinwan Qu','JW Q'),(2342,'440501','市辖区',236,0,0,'Shixiaqu','2'),(2343,'440507','龙湖区',236,0,0,'Longhu Qu','LHH'),(2344,'440511','金平区',236,0,0,'Jinping Qu','JPQ'),(2345,'440512','濠江区',236,0,0,'Haojiang Qu','HJ Q'),(2346,'440513','潮阳区',236,0,0,'Chaoyang  Qu','CHY'),(2347,'440514','潮南区',236,0,0,'Chaonan Qu','CN Q'),(2348,'440515','澄海区',236,0,0,'Chenghai QU','CHS'),(2349,'440523','南澳县',236,0,0,'Nan,ao Xian','NAN'),(2350,'440601','市辖区',237,0,0,'Shixiaqu','2'),(2351,'440604','禅城区',237,0,0,'Chancheng Qu','CC Q'),(2352,'440605','南海区',237,0,0,'Nanhai Shi','NAH'),(2353,'440606','顺德区',237,0,0,'Shunde Shi','SUD'),(2354,'440607','三水区',237,0,0,'Sanshui Shi','SJQ'),(2355,'440608','高明区',237,0,0,'Gaoming Shi','GOM'),(2356,'440701','市辖区',238,0,0,'Shixiaqu','2'),(2357,'440703','蓬江区',238,0,0,'Pengjiang Qu','PJJ'),(2358,'440704','江海区',238,0,0,'Jianghai Qu','JHI'),(2359,'440705','新会区',238,0,0,'Xinhui Shi','XIN'),(2360,'440781','台山市',238,0,0,'Taishan Shi','TSS'),(2361,'440783','开平市',238,0,0,'Kaiping Shi','KPS'),(2362,'440784','鹤山市',238,0,0,'Heshan Shi','HES'),(2363,'440785','恩平市',238,0,0,'Enping Shi','ENP'),(2364,'440801','市辖区',239,0,0,'Shixiaqu','2'),(2365,'440802','赤坎区',239,0,0,'Chikan Qu','CKQ'),(2366,'440803','霞山区',239,0,0,'Xiashan Qu','XAS'),(2367,'440804','坡头区',239,0,0,'Potou Qu','PTU'),(2368,'440811','麻章区',239,0,0,'Mazhang Qu','MZQ'),(2369,'440823','遂溪县',239,0,0,'Suixi Xian','SXI'),(2370,'440825','徐闻县',239,0,0,'Xuwen Xian','XWN'),(2371,'440881','廉江市',239,0,0,'Lianjiang Shi','LJS'),(2372,'440882','雷州市',239,0,0,'Leizhou Shi','LEZ'),(2373,'440883','吴川市',239,0,0,'Wuchuan Shi','WCS'),(2374,'440901','市辖区',240,0,0,'Shixiaqu','2'),(2375,'440902','茂南区',240,0,0,'Maonan Qu','MNQ'),(2376,'440903','茂港区',240,0,0,'Maogang Qu','MGQ'),(2377,'440923','电白县',240,0,0,'Dianbai Xian','DBI'),(2378,'440981','高州市',240,0,0,'Gaozhou Shi','GZO'),(2379,'440982','化州市',240,0,0,'Huazhou Shi','HZY'),(2380,'440983','信宜市',240,0,0,'Xinyi Shi','XYY'),(2381,'441201','市辖区',241,0,0,'Shixiaqu','2'),(2382,'441202','端州区',241,0,0,'Duanzhou Qu','DZQ'),(2383,'441203','鼎湖区',241,0,0,'Dinghu Qu','DGH'),(2384,'441223','广宁县',241,0,0,'Guangning Xian','GNG'),(2385,'441224','怀集县',241,0,0,'Huaiji Xian','HJX'),(2386,'441225','封开县',241,0,0,'Fengkai Xian','FKX'),(2387,'441226','德庆县',241,0,0,'Deqing Xian','DQY'),(2388,'441283','高要市',241,0,0,'Gaoyao Xian','GYY'),(2389,'441284','四会市',241,0,0,'Sihui Shi','SHI'),(2390,'441301','市辖区',242,0,0,'Shixiaqu','2'),(2391,'441302','惠城区',242,0,0,'Huicheng Qu','HCQ'),(2392,'441303','惠阳区',242,0,0,'Huiyang Shi','HUY'),(2393,'441322','博罗县',242,0,0,'Boluo Xian','BOL'),(2394,'441323','惠东县',242,0,0,'Huidong Xian','HID'),(2395,'441324','龙门县',242,0,0,'Longmen Xian','LMN'),(2396,'441401','市辖区',243,0,0,'Shixiaqu','2'),(2397,'441402','梅江区',243,0,0,'Meijiang Qu','MJQ'),(2398,'441421','梅县',243,0,0,'Mei Xian','MEX'),(2399,'441422','大埔县',243,0,0,'Dabu Xian','DBX'),(2400,'441423','丰顺县',243,0,0,'Fengshun Xian','FES'),(2401,'441424','五华县',243,0,0,'Wuhua Xian','WHY'),(2402,'441426','平远县',243,0,0,'Pingyuan Xian','PYY'),(2403,'441427','蕉岭县',243,0,0,'Jiaoling Xian','JOL'),(2404,'441481','兴宁市',243,0,0,'Xingning Shi','XNG'),(2405,'441501','市辖区',244,0,0,'Shixiaqu','2'),(2406,'441502','城区',244,0,0,'Chengqu','CQS'),(2407,'441521','海丰县',244,0,0,'Haifeng Xian','HIF'),(2408,'441523','陆河县',244,0,0,'Luhe Xian','LHY'),(2409,'441581','陆丰市',244,0,0,'Lufeng Shi','LUF'),(2410,'441601','市辖区',245,0,0,'Shixiaqu','2'),(2411,'441602','源城区',245,0,0,'Yuancheng Qu','YCQ'),(2412,'441621','紫金县',245,0,0,'Zijin Xian','ZJY'),(2413,'441622','龙川县',245,0,0,'Longchuan Xian','LCY'),(2414,'441623','连平县',245,0,0,'Lianping Xian','LNP'),(2415,'441624','和平县',245,0,0,'Heping Xian','HPY'),(2416,'441625','东源县',245,0,0,'Dongyuan Xian','DYN'),(2417,'441701','市辖区',246,0,0,'Shixiaqu','2'),(2418,'441702','江城区',246,0,0,'Jiangcheng Qu','JCQ'),(2419,'441721','阳西县',246,0,0,'Yangxi Xian','YXY'),(2420,'441723','阳东县',246,0,0,'Yangdong Xian','YGD'),(2421,'441781','阳春市',246,0,0,'Yangchun Shi','YCU'),(2422,'441801','市辖区',247,0,0,'Shixiaqu','2'),(2423,'441802','清城区',247,0,0,'Qingcheng Qu','QCQ'),(2424,'441821','佛冈县',247,0,0,'Fogang Xian','FGY'),(2425,'441823','阳山县',247,0,0,'Yangshan Xian','YSN'),(2426,'441825','连山壮族瑶族自治县',247,0,0,'Lianshan Zhuangzu Yaozu Zizhixian','LSZ'),(2427,'441826','连南瑶族自治县',247,0,0,'Liannanyaozuzizhi Qu','2'),(2428,'441827','清新县',247,0,0,'Qingxin Xian','QGX'),(2429,'441881','英德市',247,0,0,'Yingde Shi','YDS'),(2430,'441882','连州市',247,0,0,'Lianzhou Shi','LZO'),(2431,'445101','市辖区',250,0,0,'Shixiaqu','2'),(2432,'445102','湘桥区',250,0,0,'Xiangqiao Qu','XQO'),(2433,'445121','潮安县',250,0,0,'Chao,an Xian','CAY'),(2434,'445122','饶平县',250,0,0,'Raoping Xian','RPG'),(2435,'445201','市辖区',251,0,0,'Shixiaqu','2'),(2436,'445202','榕城区',251,0,0,'Rongcheng Qu','RCH'),(2437,'445221','揭东县',251,0,0,'Jiedong Xian','JDX'),(2438,'445222','揭西县',251,0,0,'Jiexi Xian','JEX'),(2439,'445224','惠来县',251,0,0,'Huilai Xian','HLY'),(2440,'445281','普宁市',251,0,0,'Puning Shi','PNG'),(2441,'445301','市辖区',252,0,0,'Shixiaqu','2'),(2442,'445302','云城区',252,0,0,'Yuncheng Qu','YYF'),(2443,'445321','新兴县',252,0,0,'Xinxing Xian','XNX'),(2444,'445322','郁南县',252,0,0,'Yunan Xian','YNK'),(2445,'445323','云安县',252,0,0,'Yun,an Xian','YUA'),(2446,'445381','罗定市',252,0,0,'Luoding Shi','LUO'),(2447,'450101','市辖区',253,0,0,'Shixiaqu','2'),(2448,'450102','兴宁区',253,0,0,'Xingning Qu','XNE'),(2449,'450103','青秀区',253,0,0,'Qingxiu Qu','2'),(2450,'450105','江南区',253,0,0,'Jiangnan Qu','JNA'),(2451,'450107','西乡塘区',253,0,0,'Xixiangtang Qu','2'),(2452,'450108','良庆区',253,0,0,'Liangqing Qu','2'),(2453,'450109','邕宁区',253,0,0,'Yongning Qu','2'),(2454,'450122','武鸣县',253,0,0,'Wuming Xian','WMG'),(2455,'450123','隆安县',253,0,0,'Long,an Xian','2'),(2456,'450124','马山县',253,0,0,'Mashan Xian','2'),(2457,'450125','上林县',253,0,0,'Shanglin Xian','2'),(2458,'450126','宾阳县',253,0,0,'Binyang Xian','2'),(2459,'450127','横县',253,0,0,'Heng Xian','2'),(2460,'450201','市辖区',254,0,0,'Shixiaqu','2'),(2461,'450202','城中区',254,0,0,'Chengzhong Qu','CZG'),(2462,'450203','鱼峰区',254,0,0,'Yufeng Qu','YFQ'),(2463,'450204','柳南区',254,0,0,'Liunan Qu','LNU'),(2464,'450205','柳北区',254,0,0,'Liubei Qu','LBE'),(2465,'450221','柳江县',254,0,0,'Liujiang Xian','LUJ'),(2466,'450222','柳城县',254,0,0,'Liucheng Xian','LCB'),(2467,'450223','鹿寨县',254,0,0,'Luzhai Xian','2'),(2468,'450224','融安县',254,0,0,'Rong,an Xian','2'),(2469,'450225','融水苗族自治县',254,0,0,'Rongshui Miaozu Zizhixian','2'),(2470,'450226','三江侗族自治县',254,0,0,'Sanjiang Dongzu Zizhixian','2'),(2471,'450301','市辖区',255,0,0,'Shixiaqu','2'),(2472,'450302','秀峰区',255,0,0,'Xiufeng Qu','XUF'),(2473,'450303','叠彩区',255,0,0,'Diecai Qu','DCA'),(2474,'450304','象山区',255,0,0,'Xiangshan Qu','XSK'),(2475,'450305','七星区',255,0,0,'Qixing Qu','QXG'),(2476,'450311','雁山区',255,0,0,'Yanshan Qu','YSA'),(2477,'450321','阳朔县',255,0,0,'Yangshuo Xian','YSO'),(2478,'450322','临桂县',255,0,0,'Lingui Xian','LGI'),(2479,'450323','灵川县',255,0,0,'Lingchuan Xian','LCU'),(2480,'450324','全州县',255,0,0,'Quanzhou Xian','QZO'),(2481,'450325','兴安县',255,0,0,'Xing,an Xian','XAG'),(2482,'450326','永福县',255,0,0,'Yongfu Xian','YFU'),(2483,'450327','灌阳县',255,0,0,'Guanyang Xian','GNY'),(2484,'450328','龙胜各族自治县',255,0,0,'Longsheng Gezu Zizhixian','LSG'),(2485,'450329','资源县',255,0,0,'Ziyuan Xian','ZYU'),(2486,'450330','平乐县',255,0,0,'Pingle Xian','PLE'),(2487,'450331','荔蒲县',255,0,0,'Lipu Xian','2'),(2488,'450332','恭城瑶族自治县',255,0,0,'Gongcheng Yaozu Zizhixian','GGC'),(2489,'450401','市辖区',256,0,0,'Shixiaqu','2'),(2490,'450403','万秀区',256,0,0,'Wanxiu Qu','WXQ'),(2491,'450404','蝶山区',256,0,0,'Dieshan Qu','DES'),(2492,'450405','长洲区',256,0,0,'Changzhou Qu','2'),(2493,'450421','苍梧县',256,0,0,'Cangwu Xian','CAW'),(2494,'450422','藤县',256,0,0,'Teng Xian','2'),(2495,'450423','蒙山县',256,0,0,'Mengshan Xian','MSA'),(2496,'450481','岑溪市',256,0,0,'Cenxi Shi','CEX'),(2497,'450501','市辖区',257,0,0,'Shixiaqu','2'),(2498,'450502','海城区',257,0,0,'Haicheng Qu','HCB'),(2499,'450503','银海区',257,0,0,'Yinhai Qu','YHB'),(2500,'450512','铁山港区',257,0,0,'Tieshangangqu ','TSG'),(2501,'450521','合浦县',257,0,0,'Hepu Xian','HPX'),(2502,'450601','市辖区',258,0,0,'Shixiaqu','2'),(2503,'450602','港口区',258,0,0,'Gangkou Qu','GKQ'),(2504,'450603','防城区',258,0,0,'Fangcheng Qu','FCQ'),(2505,'450621','上思县',258,0,0,'Shangsi Xian','SGS'),(2506,'450681','东兴市',258,0,0,'Dongxing Shi','DOX'),(2507,'450701','市辖区',259,0,0,'Shixiaqu','2'),(2508,'450702','钦南区',259,0,0,'Qinnan Qu','QNQ'),(2509,'450703','钦北区',259,0,0,'Qinbei Qu','QBQ'),(2510,'450721','灵山县',259,0,0,'Lingshan Xian','LSB'),(2511,'450722','浦北县',259,0,0,'Pubei Xian','PBE'),(2512,'450801','市辖区',260,0,0,'Shixiaqu','2'),(2513,'450802','港北区',260,0,0,'Gangbei Qu','GBE'),(2514,'450803','港南区',260,0,0,'Gangnan Qu','GNQ'),(2515,'450804','覃塘区',260,0,0,'Tantang Qu','2'),(2516,'450821','平南县',260,0,0,'Pingnan Xian','PNN'),(2517,'450881','桂平市',260,0,0,'Guiping Shi','GPS'),(2518,'450901','市辖区',261,0,0,'Shixiaqu','2'),(2519,'450902','玉州区',261,0,0,'Yuzhou Qu','YZO'),(2520,'450921','容县',261,0,0,'Rong Xian','ROG'),(2521,'450922','陆川县',261,0,0,'Luchuan Xian','LCJ'),(2522,'450923','博白县',261,0,0,'Bobai Xian','BBA'),(2523,'450924','兴业县',261,0,0,'Xingye Xian','XGY'),(2524,'450981','北流市',261,0,0,'Beiliu Shi','BLS'),(2525,'451001','市辖区',262,0,0,'1','2'),(2526,'451002','右江区',262,0,0,'Youjiang Qu','2'),(2527,'451021','田阳县',262,0,0,'Tianyang Xian','2'),(2528,'451022','田东县',262,0,0,'Tiandong Xian','2'),(2529,'451023','平果县',262,0,0,'Pingguo Xian','2'),(2530,'451024','德保县',262,0,0,'Debao Xian','2'),(2531,'451025','靖西县',262,0,0,'Jingxi Xian','2'),(2532,'451026','那坡县',262,0,0,'Napo Xian','2'),(2533,'451027','凌云县',262,0,0,'Lingyun Xian','2'),(2534,'451028','乐业县',262,0,0,'Leye Xian','2'),(2535,'451029','田林县',262,0,0,'Tianlin Xian','2'),(2536,'451030','西林县',262,0,0,'Xilin Xian','2'),(2537,'451031','隆林各族自治县',262,0,0,'Longlin Gezu Zizhixian','2'),(2538,'451101','市辖区',263,0,0,'1','2'),(2539,'451102','八步区',263,0,0,'Babu Qu','2'),(2540,'451121','昭平县',263,0,0,'Zhaoping Xian','2'),(2541,'451122','钟山县',263,0,0,'Zhongshan Xian','2'),(2542,'451123','富川瑶族自治县',263,0,0,'Fuchuan Yaozu Zizhixian','2'),(2543,'451201','市辖区',264,0,0,'1','2'),(2544,'451202','金城江区',264,0,0,'Jinchengjiang Qu','2'),(2545,'451221','南丹县',264,0,0,'Nandan Xian','2'),(2546,'451222','天峨县',264,0,0,'Tian,e Xian','2'),(2547,'451223','凤山县',264,0,0,'Fengshan Xian','2'),(2548,'451224','东兰县',264,0,0,'Donglan Xian','2'),(2549,'451225','罗城仫佬族自治县',264,0,0,'Luocheng Mulaozu Zizhixian','2'),(2550,'451226','环江毛南族自治县',264,0,0,'Huanjiang Maonanzu Zizhixian','2'),(2551,'451227','巴马瑶族自治县',264,0,0,'Bama Yaozu Zizhixian','2'),(2552,'451228','都安瑶族自治县',264,0,0,'Du,an Yaozu Zizhixian','2'),(2553,'451229','大化瑶族自治县',264,0,0,'Dahua Yaozu Zizhixian','2'),(2554,'451281','宜州市',264,0,0,'Yizhou Shi','2'),(2555,'451301','市辖区',265,0,0,'1','2'),(2556,'451302','兴宾区',265,0,0,'Xingbin Qu','2'),(2557,'451321','忻城县',265,0,0,'Xincheng Xian','2'),(2558,'451322','象州县',265,0,0,'Xiangzhou Xian','2'),(2559,'451323','武宣县',265,0,0,'Wuxuan Xian','2'),(2560,'451324','金秀瑶族自治县',265,0,0,'Jinxiu Yaozu Zizhixian','2'),(2561,'451381','合山市',265,0,0,'Heshan Shi','2'),(2562,'451401','市辖区',266,0,0,'1','2'),(2563,'451402','江洲区',266,0,0,'Jiangzhou Qu','2'),(2564,'451421','扶绥县',266,0,0,'Fusui Xian','2'),(2565,'451422','宁明县',266,0,0,'Ningming Xian','2'),(2566,'451423','龙州县',266,0,0,'Longzhou Xian','2'),(2567,'451424','大新县',266,0,0,'Daxin Xian','2'),(2568,'451425','天等县',266,0,0,'Tiandeng Xian','2'),(2569,'451481','凭祥市',266,0,0,'Pingxiang Shi','2'),(2570,'460101','市辖区',267,0,0,'Shixiaqu','2'),(2571,'460105','秀英区',267,0,0,'Xiuying Qu','XYH'),(2572,'460106','龙华区',267,0,0,'LongHua Qu','LH'),(2573,'460107','琼山区',267,0,0,'QiongShan Qu','QS'),(2574,'460108','美兰区',267,0,0,'MeiLan Qu','ML'),(2575,'460201','市辖区',268,0,0,'Shixiaqu','2'),(2576,'469001','五指山市',269,0,0,'Wuzhishan Qu','2'),(2577,'469002','琼海市',269,0,0,'Qionghai Shi','2'),(2578,'469003','儋州市',269,0,0,'Danzhou Shi','2'),(2579,'469005','文昌市',269,0,0,'Wenchang Shi','2'),(2580,'469006','万宁市',269,0,0,'Wanning Shi','2'),(2581,'469007','东方市',269,0,0,'Dongfang Shi','2'),(2582,'469021','定安县',269,0,0,'Ding,an Xian','2'),(2583,'469022','屯昌县',269,0,0,'Tunchang Xian','2'),(2584,'469023','澄迈县',269,0,0,'Chengmai Xian','2'),(2585,'469024','临高县',269,0,0,'Lingao Xian','2'),(2586,'469025','白沙黎族自治县',269,0,0,'Baisha Lizu Zizhixian','2'),(2587,'469026','昌江黎族自治县',269,0,0,'Changjiang Lizu Zizhixian','2'),(2588,'469027','乐东黎族自治县',269,0,0,'Ledong Lizu Zizhixian','2'),(2589,'469028','陵水黎族自治县',269,0,0,'Lingshui Lizu Zizhixian','2'),(2590,'469029','保亭黎族苗族自治县',269,0,0,'Baoting Lizu Miaozu Zizhixian','2'),(2591,'469030','琼中黎族苗族自治县',269,0,0,'Qiongzhong Lizu Miaozu Zizhixian','2'),(2592,'469031','西沙群岛',269,0,0,'Xisha Qundao','2'),(2593,'469032','南沙群岛',269,0,0,'Nansha Qundao','2'),(2594,'469033','中沙群岛的岛礁及其海域',269,0,0,'Zhongsha Qundao de Daojiao Jiqi Haiyu','2'),(2595,'500101','万州区',270,0,0,'Wanzhou Qu','WZO '),(2596,'500102','涪陵区',270,0,0,'Fuling Qu','FLG'),(2597,'500103','渝中区',270,0,0,'Yuzhong Qu','YZQ'),(2598,'500104','大渡口区',270,0,0,'Dadukou Qu','DDK'),(2599,'500105','江北区',270,0,0,'Jiangbei Qu','JBE'),(2600,'500106','沙坪坝区',270,0,0,'Shapingba Qu','SPB'),(2601,'500107','九龙坡区',270,0,0,'Jiulongpo Qu','JLP'),(2602,'500108','南岸区',270,0,0,'Nan,an Qu','NAQ'),(2603,'500109','北碚区',270,0,0,'Beibei Qu','BBE'),(2604,'500110','万盛区',270,0,0,'Wansheng Qu','WSQ'),(2605,'500111','双桥区',270,0,0,'Shuangqiao Qu','SQQ'),(2606,'500112','渝北区',270,0,0,'Yubei Qu','YBE'),(2607,'500113','巴南区',270,0,0,'Banan Qu','BNN'),(2608,'500114','黔江区',270,0,0,'Qianjiang Qu','2'),(2609,'500115','长寿区',270,0,0,'Changshou Qu','2'),(2610,'500222','綦江县',271,0,0,'Qijiang Xian','QJG'),(2611,'500223','潼南县',271,0,0,'Tongnan Xian','TNN'),(2612,'500224','铜梁县',271,0,0,'Tongliang Xian','TGL'),(2613,'500225','大足县',271,0,0,'Dazu Xian','DZX'),(2614,'500226','荣昌县',271,0,0,'Rongchang Xian','RGC'),(2615,'500227','璧山县',271,0,0,'Bishan Xian','BSY'),(2616,'500228','梁平县',271,0,0,'Liangping Xian','LGP'),(2617,'500229','城口县',271,0,0,'Chengkou Xian','CKO'),(2618,'500230','丰都县',271,0,0,'Fengdu Xian','FDU'),(2619,'500231','垫江县',271,0,0,'Dianjiang Xian','DJG'),(2620,'500232','武隆县',271,0,0,'Wulong Xian','WLG'),(2621,'500233','忠县',271,0,0,'Zhong Xian','ZHX'),(2622,'500234','开县',271,0,0,'Kai Xian','KAI'),(2623,'500235','云阳县',271,0,0,'Yunyang Xian','YNY'),(2624,'500236','奉节县',271,0,0,'Fengjie Xian','FJE'),(2625,'500237','巫山县',271,0,0,'Wushan Xian','WSN'),(2626,'500238','巫溪县',271,0,0,'Wuxi Xian','WXX'),(2627,'500240','石柱土家族自治县',271,0,0,'Shizhu Tujiazu Zizhixian','SZY'),(2628,'500241','秀山土家族苗族自治县',271,0,0,'Xiushan Tujiazu Miaozu Zizhixian','XUS'),(2629,'500242','酉阳土家族苗族自治县',271,0,0,'Youyang Tujiazu Miaozu Zizhixian','YUY'),(2630,'500243','彭水苗族土家族自治县',271,0,0,'Pengshui Miaozu Tujiazu Zizhixian','PSU'),(2631,'500116','江津区',272,0,0,'Jiangjin Shi','2'),(2632,'500117','合川区',272,0,0,'Hechuan Shi','2'),(2633,'500118','永川区',272,0,0,'Yongchuan Shi','2'),(2634,'500119','南川区',272,0,0,'Nanchuan Shi','2'),(2635,'510101','市辖区',273,0,0,'Shixiaqu','2'),(2636,'510104','锦江区',273,0,0,'Jinjiang Qu','JJQ'),(2637,'510105','青羊区',273,0,0,'Qingyang Qu','QYQ'),(2638,'510106','金牛区',273,0,0,'Jinniu Qu','JNU'),(2639,'510107','武侯区',273,0,0,'Wuhou Qu','WHQ'),(2640,'510108','成华区',273,0,0,'Chenghua Qu','CHQ'),(2641,'510112','龙泉驿区',273,0,0,'Longquanyi Qu','LQY'),(2642,'510113','青白江区',273,0,0,'Qingbaijiang Qu','QBJ'),(2643,'510114','新都区',273,0,0,'Xindu Qu','2'),(2644,'510115','温江区',273,0,0,'Wenjiang Qu','2'),(2645,'510121','金堂县',273,0,0,'Jintang Xian','JNT'),(2646,'510122','双流县',273,0,0,'Shuangliu Xian','SLU'),(2647,'510124','郫县',273,0,0,'Pi Xian','PIX'),(2648,'510129','大邑县',273,0,0,'Dayi Xian','DYI'),(2649,'510131','蒲江县',273,0,0,'Pujiang Xian','PJX'),(2650,'510132','新津县',273,0,0,'Xinjin Xian','XJC'),(2651,'510181','都江堰市',273,0,0,'Dujiangyan Shi','DJY'),(2652,'510182','彭州市',273,0,0,'Pengzhou Shi','PZS'),(2653,'510183','邛崃市',273,0,0,'Qionglai Shi','QLA'),(2654,'510184','崇州市',273,0,0,'Chongzhou Shi','CZO'),(2655,'510301','市辖区',274,0,0,'Shixiaqu','2'),(2656,'510302','自流井区',274,0,0,'Ziliujing Qu','ZLJ'),(2657,'510303','贡井区',274,0,0,'Gongjing Qu','2'),(2658,'510304','大安区',274,0,0,'Da,an Qu','DAQ'),(2659,'510311','沿滩区',274,0,0,'Yantan Qu','YTN'),(2660,'510321','荣县',274,0,0,'Rong Xian','RGX'),(2661,'510322','富顺县',274,0,0,'Fushun Xian','FSH'),(2662,'510401','市辖区',275,0,0,'Shixiaqu','2'),(2663,'510402','东区',275,0,0,'Dong Qu','DQP'),(2664,'510403','西区',275,0,0,'Xi Qu','XIQ'),(2665,'510411','仁和区',275,0,0,'Renhe Qu','RHQ'),(2666,'510421','米易县',275,0,0,'Miyi Xian','MIY'),(2667,'510422','盐边县',275,0,0,'Yanbian Xian','YBN'),(2668,'510501','市辖区',276,0,0,'Shixiaqu','2'),(2669,'510502','江阳区',276,0,0,'Jiangyang Qu','JYB'),(2670,'510503','纳溪区',276,0,0,'Naxi Qu','NXI'),(2671,'510504','龙马潭区',276,0,0,'Longmatan Qu','LMT'),(2672,'510521','泸县',276,0,0,'Lu Xian','LUX'),(2673,'510522','合江县',276,0,0,'Hejiang Xian','HEJ'),(2674,'510524','叙永县',276,0,0,'Xuyong Xian','XYO'),(2675,'510525','古蔺县',276,0,0,'Gulin Xian','GUL'),(2676,'510601','市辖区',277,0,0,'Shixiaqu','2'),(2677,'510603','旌阳区',277,0,0,'Jingyang Qu','JYF'),(2678,'510623','中江县',277,0,0,'Zhongjiang Xian','ZGJ'),(2679,'510626','罗江县',277,0,0,'Luojiang Xian','LOJ'),(2680,'510681','广汉市',277,0,0,'Guanghan Shi','GHN'),(2681,'510682','什邡市',277,0,0,'Shifang Shi','SFS'),(2682,'510683','绵竹市',277,0,0,'Jinzhou Shi','MZU'),(2683,'510701','市辖区',278,0,0,'Shixiaqu','2'),(2684,'510703','涪城区',278,0,0,'Fucheng Qu','FCM'),(2685,'510704','游仙区',278,0,0,'Youxian Qu','YXM'),(2686,'510722','三台县',278,0,0,'Santai Xian','SNT'),(2687,'510723','盐亭县',278,0,0,'Yanting Xian','YTC'),(2688,'510724','安县',278,0,0,'An Xian','AXN'),(2689,'510725','梓潼县',278,0,0,'Zitong Xian','ZTG'),(2690,'510726','北川羌族自治县',278,0,0,'Beichuanqiangzuzizhi Qu','2'),(2691,'510727','平武县',278,0,0,'Pingwu Xian','PWU'),(2692,'510781','江油市',278,0,0,'Jiangyou Shi','JYO'),(2693,'510801','市辖区',279,0,0,'Shixiaqu','2'),(2694,'511002','市中区',279,0,0,'Shizhong Qu','SZM'),(2695,'510811','元坝区',279,0,0,'Yuanba Qu','YBQ'),(2696,'510812','朝天区',279,0,0,'Chaotian Qu','CTN'),(2697,'510821','旺苍县',279,0,0,'Wangcang Xian','WGC'),(2698,'510822','青川县',279,0,0,'Qingchuan Xian','QCX'),(2699,'510823','剑阁县',279,0,0,'Jiange Xian','JGE'),(2700,'510824','苍溪县',279,0,0,'Cangxi Xian','CXC'),(2701,'510901','市辖区',280,0,0,'Shixiaqu','2'),(2702,'510903','船山区',280,0,0,'Chuanshan Qu','2'),(2703,'510904','安居区',280,0,0,'Anju Qu','2'),(2704,'510921','蓬溪县',280,0,0,'Pengxi Xian','PXI'),(2705,'510922','射洪县',280,0,0,'Shehong Xian','SHE'),(2706,'510923','大英县',280,0,0,'Daying Xian','DAY'),(2707,'511001','市辖区',281,0,0,'Shixiaqu','2'),(2708,'511002','市中区',281,0,0,'Shizhong Qu','SZM'),(2709,'511011','东兴区',281,0,0,'Dongxing Qu','DXQ'),(2710,'511024','威远县',281,0,0,'Weiyuan Xian','WYU'),(2711,'511025','资中县',281,0,0,'Zizhong Xian','ZZC'),(2712,'511028','隆昌县',281,0,0,'Longchang Xian','LCC'),(2713,'511101','市辖区',282,0,0,'Shixiaqu','2'),(2714,'511102','市中区',282,0,0,'Shizhong Qu','SZP'),(2715,'511111','沙湾区',282,0,0,'Shawan Qu','SWN'),(2716,'511112','五通桥区',282,0,0,'Wutongqiao Qu','WTQ'),(2717,'511113','金口河区',282,0,0,'Jinkouhe Qu','JKH'),(2718,'511123','犍为县',282,0,0,'Qianwei Xian','QWE'),(2719,'511124','井研县',282,0,0,'Jingyan Xian','JYA'),(2720,'511126','夹江县',282,0,0,'Jiajiang Xian','JJC'),(2721,'511129','沐川县',282,0,0,'Muchuan Xian','MCH'),(2722,'511132','峨边彝族自治县',282,0,0,'Ebian Yizu Zizhixian','EBN'),(2723,'511133','马边彝族自治县',282,0,0,'Mabian Yizu Zizhixian','MBN'),(2724,'511181','峨眉山市',282,0,0,'Emeishan Shi','EMS'),(2725,'511301','市辖区',283,0,0,'Shixiaqu','2'),(2726,'511302','顺庆区',283,0,0,'Shunqing Xian','SQG'),(2727,'511303','高坪区',283,0,0,'Gaoping Qu','GPQ'),(2728,'511304','嘉陵区',283,0,0,'Jialing Qu','JLG'),(2729,'511321','南部县',283,0,0,'Nanbu Xian','NBU'),(2730,'511322','营山县',283,0,0,'Yingshan Xian','YGS'),(2731,'511323','蓬安县',283,0,0,'Peng,an Xian','PGA'),(2732,'511324','仪陇县',283,0,0,'Yilong Xian','YLC'),(2733,'511325','西充县',283,0,0,'Xichong Xian','XCO'),(2734,'511381','阆中市',283,0,0,'Langzhong Shi','LZJ'),(2735,'511401','市辖区',284,0,0,'1','2'),(2736,'511402','东坡区',284,0,0,'Dongpo Qu','2'),(2737,'511421','仁寿县',284,0,0,'Renshou Xian','2'),(2738,'511422','彭山县',284,0,0,'Pengshan Xian','2'),(2739,'511423','洪雅县',284,0,0,'Hongya Xian','2'),(2740,'511424','丹棱县',284,0,0,'Danling Xian','2'),(2741,'511425','青神县',284,0,0,'Qingshen Xian','2'),(2742,'511501','市辖区',285,0,0,'Shixiaqu','2'),(2743,'511502','翠屏区',285,0,0,'Cuiping Qu','CPQ'),(2744,'511521','宜宾县',285,0,0,'Yibin Xian','YBX'),(2745,'511522','南溪县',285,0,0,'Nanxi Xian','NNX'),(2746,'511523','江安县',285,0,0,'Jiang,an Xian','JAC'),(2747,'511524','长宁县',285,0,0,'Changning Xian','CNX'),(2748,'511525','高县',285,0,0,'Gao Xian','GAO'),(2749,'511526','珙县',285,0,0,'Gong Xian','GOG'),(2750,'511527','筠连县',285,0,0,'Junlian Xian','JNL'),(2751,'511528','兴文县',285,0,0,'Xingwen Xian','XWC'),(2752,'511529','屏山县',285,0,0,'Pingshan Xian','PSC'),(2753,'511601','市辖区',286,0,0,'Shixiaqu','2'),(2754,'511602','广安区',286,0,0,'Guang,an Qu','GAQ'),(2755,'511621','岳池县',286,0,0,'Yuechi Xian','YCC'),(2756,'511622','武胜县',286,0,0,'Wusheng Xian','WSG'),(2757,'511623','邻水县',286,0,0,'Linshui Xian','LSH'),(2759,'511701','市辖区',287,0,0,'1','2'),(2760,'511702','通川区',287,0,0,'Tongchuan Qu','2'),(2761,'511721','达县',287,0,0,'Da Xian','2'),(2762,'511722','宣汉县',287,0,0,'Xuanhan Xian','2'),(2763,'511723','开江县',287,0,0,'Kaijiang Xian','2'),(2764,'511724','大竹县',287,0,0,'Dazhu Xian','2'),(2765,'511725','渠县',287,0,0,'Qu Xian','2'),(2766,'511781','万源市',287,0,0,'Wanyuan Shi','2'),(2767,'511801','市辖区',288,0,0,'1','2'),(2768,'511802','雨城区',288,0,0,'Yucheg Qu','2'),(2769,'511821','名山县',288,0,0,'Mingshan Xian','2'),(2770,'511822','荥经县',288,0,0,'Yingjing Xian','2'),(2771,'511823','汉源县',288,0,0,'Hanyuan Xian','2'),(2772,'511824','石棉县',288,0,0,'Shimian Xian','2'),(2773,'511825','天全县',288,0,0,'Tianquan Xian','2'),(2774,'511826','芦山县',288,0,0,'Lushan Xian','2'),(2775,'511827','宝兴县',288,0,0,'Baoxing Xian','2'),(2776,'511901','市辖区',289,0,0,'1','2'),(2777,'511902','巴州区',289,0,0,'Bazhou Qu','2'),(2778,'511921','通江县',289,0,0,'Tongjiang Xian','2'),(2779,'511922','南江县',289,0,0,'Nanjiang Xian','2'),(2780,'511923','平昌县',289,0,0,'Pingchang Xian','2'),(2781,'512001','市辖区',290,0,0,'1','2'),(2782,'512002','雁江区',290,0,0,'Yanjiang Qu','2'),(2783,'512021','安岳县',290,0,0,'Anyue Xian','2'),(2784,'512022','乐至县',290,0,0,'Lezhi Xian','2'),(2785,'512081','简阳市',290,0,0,'Jianyang Shi','2'),(2786,'513221','汶川县',291,0,0,'Wenchuan Xian','WNC'),(2787,'513222','理县',291,0,0,'Li Xian','LXC'),(2788,'513223','茂县',291,0,0,'Mao Xian','MAO'),(2789,'513224','松潘县',291,0,0,'Songpan Xian','SOP'),(2790,'513225','九寨沟县',291,0,0,'Jiuzhaigou Xian','JZG'),(2791,'513226','金川县',291,0,0,'Jinchuan Xian','JCH'),(2792,'513227','小金县',291,0,0,'Xiaojin Xian','XJX'),(2793,'513228','黑水县',291,0,0,'Heishui Xian','HIS'),(2794,'513229','马尔康县',291,0,0,'Barkam Xian','BAK'),(2795,'513230','壤塘县',291,0,0,'Zamtang Xian','ZAM'),(2796,'513231','阿坝县',291,0,0,'Aba(Ngawa) Xian','ABX'),(2797,'513232','若尔盖县',291,0,0,'ZoigeXian','ZOI'),(2798,'513233','红原县',291,0,0,'Hongyuan Xian','HOY'),(2799,'513321','康定县',292,0,0,'Kangding(Dardo) Xian','KDX'),(2800,'513322','泸定县',292,0,0,'Luding(Jagsamka) Xian','LUD'),(2801,'513323','丹巴县',292,0,0,'Danba(Rongzhag) Xian','DBA'),(2802,'513324','九龙县',292,0,0,'Jiulong(Gyaisi) Xian','JLC'),(2803,'513325','雅江县',292,0,0,'Yajiang(Nyagquka) Xian','YAJ'),(2804,'513326','道孚县',292,0,0,'Dawu Xian','DAW'),(2805,'513327','炉霍县',292,0,0,'Luhuo(Zhaggo) Xian','LUH'),(2806,'513328','甘孜县',292,0,0,'Garze Xian','GRZ'),(2807,'513329','新龙县',292,0,0,'Xinlong(Nyagrong) Xian','XLG'),(2808,'513330','德格县',292,0,0,'DegeXian','DEG'),(2809,'513331','白玉县',292,0,0,'Baiyu Xian','BYC'),(2810,'513332','石渠县',292,0,0,'Serxv Xian','SER'),(2811,'513333','色达县',292,0,0,'Sertar Xian','STX'),(2812,'513334','理塘县',292,0,0,'Litang Xian','LIT'),(2813,'513335','巴塘县',292,0,0,'Batang Xian','BTC'),(2814,'513336','乡城县',292,0,0,'Xiangcheng(Qagcheng) Xian','XCC'),(2815,'513337','稻城县',292,0,0,'Daocheng(Dabba) Xian','DCX'),(2816,'513338','得荣县',292,0,0,'Derong Xian','DER'),(2817,'513401','西昌市',293,0,0,'Xichang Shi','XCA'),(2818,'513422','木里藏族自治县',293,0,0,'Muli Zangzu Zizhixian','MLI'),(2819,'513423','盐源县',293,0,0,'Yanyuan Xian','YYU'),(2820,'513424','德昌县',293,0,0,'Dechang Xian','DEC'),(2821,'513425','会理县',293,0,0,'Huili Xian','HLI'),(2822,'513426','会东县',293,0,0,'Huidong Xian','HDG'),(2823,'513427','宁南县',293,0,0,'Ningnan Xian','NIN'),(2824,'513428','普格县',293,0,0,'Puge Xian','PGE'),(2825,'513429','布拖县',293,0,0,'Butuo Xian','BTO'),(2826,'513430','金阳县',293,0,0,'Jinyang Xian','JYW'),(2827,'513431','昭觉县',293,0,0,'Zhaojue Xian','ZJE'),(2828,'513432','喜德县',293,0,0,'Xide Xian','XDE'),(2829,'513433','冕宁县',293,0,0,'Mianning Xian','MNG'),(2830,'513434','越西县',293,0,0,'Yuexi Xian','YXC'),(2831,'513435','甘洛县',293,0,0,'Ganluo Xian','GLO'),(2832,'513436','美姑县',293,0,0,'Meigu Xian','MEG'),(2833,'513437','雷波县',293,0,0,'Leibo Xian','LBX'),(2834,'520101','市辖区',294,0,0,'Shixiaqu','2'),(2835,'520102','南明区',294,0,0,'Nanming Qu','NMQ'),(2836,'520103','云岩区',294,0,0,'Yunyan Qu','YYQ'),(2837,'520111','花溪区',294,0,0,'Huaxi Qu','HXI'),(2838,'520112','乌当区',294,0,0,'Wudang Qu','WDQ'),(2839,'520113','白云区',294,0,0,'Baiyun Qu','BYU'),(2840,'520114','小河区',294,0,0,'Xiaohe Qu','2'),(2841,'520121','开阳县',294,0,0,'Kaiyang Xian','KYG'),(2842,'520122','息烽县',294,0,0,'Xifeng Xian','XFX'),(2843,'520123','修文县',294,0,0,'Xiuwen Xian','XWX'),(2844,'520181','清镇市',294,0,0,'Qingzhen Shi','QZN'),(2845,'520201','钟山区',295,0,0,'Zhongshan Qu','ZSQ'),(2846,'520203','六枝特区',295,0,0,'Liuzhi Tequ','LZT'),(2847,'520221','水城县',295,0,0,'Shuicheng Xian','SUC'),(2848,'520222','盘县',295,0,0,'Pan Xian','2'),(2849,'520301','市辖区',296,0,0,'Shixiaqu','2'),(2850,'520302','红花岗区',296,0,0,'Honghuagang Qu','HHG'),(2851,'520303','汇川区',296,0,0,'Huichuan Qu','2'),(2852,'520321','遵义县',296,0,0,'Zunyi Xian','ZYI'),(2853,'520322','桐梓县',296,0,0,'Tongzi Xian','TZI'),(2854,'520323','绥阳县',296,0,0,'Suiyang Xian','SUY'),(2855,'520324','正安县',296,0,0,'Zhengan Xan','2'),(2856,'520325','道真仡佬族苗族自治县',296,0,0,'Daozhen Gelaozu Miaozu Zizhixian','DZN'),(2857,'520326','务川仡佬族苗族自治县',296,0,0,'Wuchuan Gelaozu Miaozu Zizhixian','WCU'),(2858,'520327','凤冈县',296,0,0,'Fenggang Xian','FGG'),(2859,'520328','湄潭县',296,0,0,'Meitan Xian','MTN'),(2860,'520329','余庆县',296,0,0,'Yuqing Xian','YUQ'),(2861,'520330','习水县',296,0,0,'Xishui Xian','XSI'),(2862,'520381','赤水市',296,0,0,'Chishui Shi','CSS'),(2863,'520382','仁怀市',296,0,0,'Renhuai Shi','RHS'),(2864,'520401','市辖区',297,0,0,'1','2'),(2865,'520402','西秀区',297,0,0,'Xixiu Qu','2'),(2866,'520421','平坝县',297,0,0,'Pingba Xian','2'),(2867,'520422','普定县',297,0,0,'Puding Xian','2'),(2868,'520423','镇宁布依族苗族自治县',297,0,0,'Zhenning Buyeizu Miaozu Zizhixian','2'),(2869,'520424','关岭布依族苗族自治县',297,0,0,'Guanling Buyeizu Miaozu Zizhixian','2'),(2870,'520425','紫云苗族布依族自治县',297,0,0,'Ziyun Miaozu Buyeizu Zizhixian','2'),(2871,'522201','铜仁市',298,0,0,'Tongren Shi','TRS'),(2872,'522222','江口县',298,0,0,'Jiangkou Xian','JGK'),(2873,'522223','玉屏侗族自治县',298,0,0,'Yuping Dongzu Zizhixian','YPG'),(2874,'522224','石阡县',298,0,0,'Shiqian Xian','SQI'),(2875,'522225','思南县',298,0,0,'Sinan Xian','SNA'),(2876,'522226','印江土家族苗族自治县',298,0,0,'Yinjiang Tujiazu Miaozu Zizhixian','YJY'),(2877,'522227','德江县',298,0,0,'Dejiang Xian','DEJ'),(2878,'522228','沿河土家族自治县',298,0,0,'Yanhe Tujiazu Zizhixian','YHE'),(2879,'522229','松桃苗族自治县',298,0,0,'Songtao Miaozu Zizhixian','STM'),(2880,'522230','万山特区',298,0,0,'Wanshan Tequ','WAS'),(2881,'522301','兴义市',299,0,0,'Xingyi Shi','XYI'),(2882,'522322','兴仁县',299,0,0,'Xingren Xian','XRN'),(2883,'522323','普安县',299,0,0,'Pu,an Xian','PUA'),(2884,'522324','晴隆县',299,0,0,'Qinglong Xian','QLG'),(2885,'522325','贞丰县',299,0,0,'Zhenfeng Xian','ZFG'),(2886,'522326','望谟县',299,0,0,'Wangmo Xian','WMO'),(2887,'522327','册亨县',299,0,0,'Ceheng Xian','CEH'),(2888,'522328','安龙县',299,0,0,'Anlong Xian','ALG'),(2889,'522401','毕节市',300,0,0,'Bijie Shi','BJE'),(2890,'522422','大方县',300,0,0,'Dafang Xian','DAF'),(2891,'522423','黔西县',300,0,0,'Qianxi Xian','QNX'),(2892,'522424','金沙县',300,0,0,'Jinsha Xian','JSX'),(2893,'522425','织金县',300,0,0,'Zhijin Xian','ZJN'),(2894,'522426','纳雍县',300,0,0,'Nayong Xian','NYG'),(2895,'522427','威宁彝族回族苗族自治县',300,0,0,'Weining Yizu Huizu Miaozu Zizhixian','WNG'),(2896,'522428','赫章县',300,0,0,'Hezhang Xian','HZA'),(2897,'522601','凯里市',301,0,0,'Kaili Shi','KLS'),(2898,'522622','黄平县',301,0,0,'Huangping Xian','HPN'),(2899,'522623','施秉县',301,0,0,'Shibing Xian','SBG'),(2900,'522624','三穗县',301,0,0,'Sansui Xian','SAS'),(2901,'522625','镇远县',301,0,0,'Zhenyuan Xian','ZYX'),(2902,'522626','岑巩县',301,0,0,'Cengong Xian','CGX'),(2903,'522627','天柱县',301,0,0,'Tianzhu Xian','TZU'),(2904,'522628','锦屏县',301,0,0,'Jinping Xian','JPX'),(2905,'522629','剑河县',301,0,0,'Jianhe Xian','JHE'),(2906,'522630','台江县',301,0,0,'Taijiang Xian','TJX'),(2907,'522631','黎平县',301,0,0,'Liping Xian','LIP'),(2908,'522632','榕江县',301,0,0,'Rongjiang Xian','RJG'),(2909,'522633','从江县',301,0,0,'Congjiang Xian','COJ'),(2910,'522634','雷山县',301,0,0,'Leishan Xian','LSA'),(2911,'522635','麻江县',301,0,0,'Majiang Xian','MAJ'),(2912,'522636','丹寨县',301,0,0,'Danzhai Xian','DZH'),(2913,'522701','都匀市',302,0,0,'Duyun Shi','DUY'),(2914,'522702','福泉市',302,0,0,'Fuquan Shi','FQN'),(2915,'522722','荔波县',302,0,0,'Libo Xian','LBO'),(2916,'522723','贵定县',302,0,0,'Guiding Xian','GDG'),(2917,'522725','瓮安县',302,0,0,'Weng,an Xian','WGA'),(2918,'522726','独山县',302,0,0,'Dushan Xian','DSX'),(2919,'522727','平塘县',302,0,0,'Pingtang Xian','PTG'),(2920,'522728','罗甸县',302,0,0,'Luodian Xian','LOD'),(2921,'522729','长顺县',302,0,0,'Changshun Xian','CSU'),(2922,'522730','龙里县',302,0,0,'Longli Xian','LLI'),(2923,'522731','惠水县',302,0,0,'Huishui Xian','HUS'),(2924,'522732','三都水族自治县',302,0,0,'Sandu Suizu Zizhixian','SDU'),(2925,'530101','市辖区',303,0,0,'Shixiaqu','2'),(2926,'530102','五华区',303,0,0,'Wuhua Qu','WHA'),(2927,'530103','盘龙区',303,0,0,'Panlong Qu','PLQ'),(2928,'530111','官渡区',303,0,0,'Guandu Qu','GDU'),(2929,'530112','西山区',303,0,0,'Xishan Qu','XSN'),(2930,'530113','东川区',303,0,0,'Dongchuan Qu','DCU'),(2931,'530121','呈贡县',303,0,0,'Chenggong Xian','CGD'),(2932,'530122','晋宁县',303,0,0,'Jinning Xian','JND'),(2933,'530124','富民县',303,0,0,'Fumin Xian','FMN'),(2934,'530125','宜良县',303,0,0,'Yiliang Xian','YIL'),(2935,'530126','石林彝族自治县',303,0,0,'Shilin Yizu Zizhixian','SLY'),(2936,'530127','嵩明县',303,0,0,'Songming Xian','SMI'),(2937,'530128','禄劝彝族苗族自治县',303,0,0,'Luchuan Yizu Miaozu Zizhixian','LUC'),(2938,'530129','寻甸回族彝族自治县',303,0,0,'Xundian Huizu Yizu Zizhixian','XDN'),(2939,'530181','安宁市',303,0,0,'Anning Shi','ANG'),(2940,'530301','市辖区',304,0,0,'Shixiaqu','2'),(2941,'530302','麒麟区',304,0,0,'Qilin Xian','QLQ'),(2942,'530321','马龙县',304,0,0,'Malong Xian','MLO'),(2943,'530322','陆良县',304,0,0,'Luliang Xian','LLX'),(2944,'530323','师宗县',304,0,0,'Shizong Xian','SZD'),(2945,'530324','罗平县',304,0,0,'Luoping Xian','LPX'),(2946,'530325','富源县',304,0,0,'Fuyuan Xian','FYD'),(2947,'530326','会泽县',304,0,0,'Huize Xian','HUZ'),(2948,'530328','沾益县',304,0,0,'Zhanyi Xian','ZYD'),(2949,'530381','宣威市',304,0,0,'Xuanwei Shi','XWS'),(2950,'530401','市辖区',305,0,0,'Shixiaqu','2'),(2951,'530402','红塔区',305,0,0,'Hongta Qu','HTA'),(2952,'530421','江川县',305,0,0,'Jiangchuan Xian','JGC'),(2953,'530422','澄江县',305,0,0,'Chengjiang Xian','CGJ'),(2954,'530423','通海县',305,0,0,'Tonghai Xian','THI'),(2955,'530424','华宁县',305,0,0,'Huaning Xian','HND'),(2956,'530425','易门县',305,0,0,'Yimen Xian','YMD'),(2957,'530426','峨山彝族自治县',305,0,0,'Eshan Yizu Zizhixian','ESN'),(2958,'530427','新平彝族傣族自治县',305,0,0,'Xinping Yizu Daizu Zizhixian','XNP'),(2959,'530428','元江哈尼族彝族傣族自治县',305,0,0,'Yuanjiang Hanizu Yizu Daizu Zizhixian','YJA'),(2960,'530501','市辖区',306,0,0,'1','2'),(2961,'530502','隆阳区',306,0,0,'Longyang Qu','2'),(2962,'530521','施甸县',306,0,0,'Shidian Xian','2'),(2963,'530522','腾冲县',306,0,0,'Tengchong Xian','2'),(2964,'530523','龙陵县',306,0,0,'Longling Xian','2'),(2965,'530524','昌宁县',306,0,0,'Changning Xian','2'),(2966,'530601','市辖区',307,0,0,'1','2'),(2967,'530602','昭阳区',307,0,0,'Zhaoyang Qu','2'),(2968,'530621','鲁甸县',307,0,0,'Ludian Xian','2'),(2969,'530622','巧家县',307,0,0,'Qiaojia Xian','2'),(2970,'530623','盐津县',307,0,0,'Yanjin Xian','2'),(2971,'530624','大关县',307,0,0,'Daguan Xian','2'),(2972,'530625','永善县',307,0,0,'Yongshan Xian','2'),(2973,'530626','绥江县',307,0,0,'Suijiang Xian','2'),(2974,'530627','镇雄县',307,0,0,'Zhenxiong Xian','2'),(2975,'530628','彝良县',307,0,0,'Yiliang Xian','2'),(2976,'530629','威信县',307,0,0,'Weixin Xian','2'),(2977,'530630','水富县',307,0,0,'Shuifu Xian ','2'),(2978,'530701','市辖区',308,0,0,'1','2'),(2979,'530702','古城区',308,0,0,'Gucheng Qu','2'),(2980,'530721','玉龙纳西族自治县',308,0,0,'Yulongnaxizuzizhi Xian','2'),(2981,'530722','永胜县',308,0,0,'Yongsheng Xian','2'),(2982,'530723','华坪县',308,0,0,'Huaping Xian','2'),(2983,'530724','宁蒗彝族自治县',308,0,0,'Ninglang Yizu Zizhixian','2'),(2984,'530801','市辖区',309,0,0,'1','2'),(2985,'530802','思茅区',309,0,0,'Simao Qu','2'),(2986,'530821','宁洱哈尼族彝族自治县',309,0,0,'Pu,er Hanizu Yizu Zizhixian','2'),(2987,'530822','墨江哈尼族自治县',309,0,0,'Mojiang Hanizu Zizhixian','2'),(2988,'530823','景东彝族自治县',309,0,0,'Jingdong Yizu Zizhixian','2'),(2989,'530824','景谷傣族彝族自治县',309,0,0,'Jinggu Daizu Yizu Zizhixian','2'),(2990,'530825','镇沅彝族哈尼族拉祜族自治县',309,0,0,'Zhenyuan Yizu Hanizu Lahuzu Zizhixian','2'),(2991,'530826','江城哈尼族彝族自治县',309,0,0,'Jiangcheng Hanizu Yizu Zizhixian','2'),(2992,'530827','孟连傣族拉祜族佤族自治县',309,0,0,'Menglian Daizu Lahuzu Vazu Zizixian','2'),(2993,'530828','澜沧拉祜族自治县',309,0,0,'Lancang Lahuzu Zizhixian','2'),(2994,'530829','西盟佤族自治县',309,0,0,'Ximeng Vazu Zizhixian','2'),(2995,'530901','市辖区',310,0,0,'1','2'),(2996,'530902','临翔区',310,0,0,'Linxiang Qu','2'),(2997,'530921','凤庆县',310,0,0,'Fengqing Xian','2'),(2998,'530922','云县',310,0,0,'Yun Xian','2'),(2999,'530923','永德县',310,0,0,'Yongde Xian','2'),(3000,'530924','镇康县',310,0,0,'Zhenkang Xian','2'),(3001,'530925','双江拉祜族佤族布朗族傣族自治县',310,0,0,'Shuangjiang Lahuzu Vazu Bulangzu Daizu Zizhixian','2'),(3002,'530926','耿马傣族佤族自治县',310,0,0,'Gengma Daizu Vazu Zizhixian','2'),(3003,'530927','沧源佤族自治县',310,0,0,'Cangyuan Vazu Zizhixian','2'),(3004,'532301','楚雄市',311,0,0,'Chuxiong Shi','CXS'),(3005,'532322','双柏县',311,0,0,'Shuangbai Xian','SBA'),(3006,'532323','牟定县',311,0,0,'Mouding Xian','MDI'),(3007,'532324','南华县',311,0,0,'Nanhua Xian','NHA'),(3008,'532325','姚安县',311,0,0,'Yao,an Xian','YOA'),(3009,'532326','大姚县',311,0,0,'Dayao Xian','DYO'),(3010,'532327','永仁县',311,0,0,'Yongren Xian','YRN'),(3011,'532328','元谋县',311,0,0,'Yuanmou Xian','YMO'),(3012,'532329','武定县',311,0,0,'Wuding Xian','WDX'),(3013,'532331','禄丰县',311,0,0,'Lufeng Xian','LFX'),(3014,'532501','个旧市',312,0,0,'Gejiu Shi','GJU'),(3015,'532502','开远市',312,0,0,'Kaiyuan Shi','KYD'),(3016,'532503','蒙自市',312,0,0,'Mengzi Xian','2'),(3017,'532523','屏边苗族自治县',312,0,0,'Pingbian Miaozu Zizhixian','PBN'),(3018,'532524','建水县',312,0,0,'Jianshui Xian','JSD'),(3019,'532525','石屏县',312,0,0,'Shiping Xian','SPG'),(3020,'532526','弥勒县',312,0,0,'Mile Xian','MIL'),(3021,'532527','泸西县',312,0,0,'Luxi Xian','LXD'),(3022,'532528','元阳县',312,0,0,'Yuanyang Xian','YYD'),(3023,'532529','红河县',312,0,0,'Honghe Xian','HHX'),(3024,'532530','金平苗族瑶族傣族自治县',312,0,0,'Jinping Miaozu Yaozu Daizu Zizhixian','JNP'),(3025,'532531','绿春县',312,0,0,'Lvchun Xian','LCX'),(3026,'532532','河口瑶族自治县',312,0,0,'Hekou Yaozu Zizhixian','HKM'),(3027,'532621','文山县',313,0,0,'Wenshan Xian','WES'),(3028,'532622','砚山县',313,0,0,'Yanshan Xian','YSD'),(3029,'532623','西畴县',313,0,0,'Xichou Xian','XIC'),(3030,'532624','麻栗坡县',313,0,0,'Malipo Xian','MLP'),(3031,'532625','马关县',313,0,0,'Maguan Xian','MGN'),(3032,'532626','丘北县',313,0,0,'Qiubei Xian','QBE'),(3033,'532627','广南县',313,0,0,'Guangnan Xian','GGN'),(3034,'532628','富宁县',313,0,0,'Funing Xian','FND'),(3035,'532801','景洪市',314,0,0,'Jinghong Shi','JHG'),(3036,'532822','勐海县',314,0,0,'Menghai Xian','MHI'),(3037,'532823','勐腊县',314,0,0,'Mengla Xian','MLA'),(3038,'532901','大理市',315,0,0,'Dali Shi','DLS'),(3039,'532922','漾濞彝族自治县',315,0,0,'Yangbi Yizu Zizhixian','YGB'),(3040,'532923','祥云县',315,0,0,'Xiangyun Xian','XYD'),(3041,'532924','宾川县',315,0,0,'Binchuan Xian','BCD'),(3042,'532925','弥渡县',315,0,0,'Midu Xian','MDU'),(3043,'532926','南涧彝族自治县',315,0,0,'Nanjian Yizu Zizhixian','NNJ'),(3044,'532927','巍山彝族回族自治县',315,0,0,'Weishan Yizu Huizu Zizhixian','WSY'),(3045,'532928','永平县',315,0,0,'Yongping Xian','YPX'),(3046,'532929','云龙县',315,0,0,'Yunlong Xian','YLO'),(3047,'532930','洱源县',315,0,0,'Eryuan Xian','EYN'),(3048,'532931','剑川县',315,0,0,'Jianchuan Xian','JIC'),(3049,'532932','鹤庆县',315,0,0,'Heqing Xian','HQG'),(3050,'533102','瑞丽市',316,0,0,'Ruili Shi','RUI'),(3051,'533103','芒市',316,0,0,'Luxi Shi','2'),(3052,'533122','梁河县',316,0,0,'Lianghe Xian','LHD'),(3053,'533123','盈江县',316,0,0,'Yingjiang Xian','YGJ'),(3054,'533124','陇川县',316,0,0,'Longchuan Xian','LCN'),(3055,'533321','泸水县',317,0,0,'Lushui Xian','LSX'),(3056,'533323','福贡县',317,0,0,'Fugong Xian','FGO'),(3057,'533324','贡山独龙族怒族自治县',317,0,0,'Gongshan Dulongzu Nuzu Zizhixian','GSN'),(3058,'533325','兰坪白族普米族自治县',317,0,0,'Lanping Baizu Pumizu Zizhixian','LPG'),(3059,'533421','香格里拉县',318,0,0,'Xianggelila Xian','2'),(3060,'533422','德钦县',318,0,0,'Deqen Xian','DQN'),(3061,'533423','维西傈僳族自治县',318,0,0,'Weixi Lisuzu Zizhixian','WXI'),(3062,'540101','市辖区',319,0,0,'Shixiaqu','2'),(3063,'540102','城关区',319,0,0,'Chengguang Qu','CGN'),(3064,'540121','林周县',319,0,0,'Lhvnzhub Xian','LZB'),(3065,'540122','当雄县',319,0,0,'Damxung Xian','DAM'),(3066,'540123','尼木县',319,0,0,'Nyemo Xian','NYE'),(3067,'540124','曲水县',319,0,0,'Qvxv Xian','QUX'),(3068,'540125','堆龙德庆县',319,0,0,'Doilungdeqen Xian','DOI'),(3069,'540126','达孜县',319,0,0,'Dagze Xian','DAG'),(3070,'540127','墨竹工卡县',319,0,0,'Maizhokunggar Xian','MAI'),(3071,'542121','昌都县',320,0,0,'Qamdo Xian','QAX'),(3072,'542122','江达县',320,0,0,'Jomda Xian','JOM'),(3073,'542123','贡觉县',320,0,0,'Konjo Xian','KON'),(3074,'542124','类乌齐县',320,0,0,'Riwoqe Xian','RIW'),(3075,'542125','丁青县',320,0,0,'Dengqen Xian','DEN'),(3076,'542126','察雅县',320,0,0,'Chagyab Xian','CHA'),(3077,'542127','八宿县',320,0,0,'Baxoi Xian','BAX'),(3078,'542128','左贡县',320,0,0,'Zogang Xian','ZOX'),(3079,'542129','芒康县',320,0,0,'Mangkam Xian','MAN'),(3080,'542132','洛隆县',320,0,0,'Lhorong Xian','LHO'),(3081,'542133','边坝县',320,0,0,'Banbar Xian','BAN'),(3082,'542221','乃东县',321,0,0,'Nedong Xian','NED'),(3083,'542222','扎囊县',321,0,0,'Chanang(Chatang) Xian','CNG'),(3084,'542223','贡嘎县',321,0,0,'Gonggar Xian','GON'),(3085,'542224','桑日县',321,0,0,'Sangri Xian','SRI'),(3086,'542225','琼结县',321,0,0,'Qonggyai Xian','QON'),(3087,'542226','曲松县',321,0,0,'Qusum Xian','QUS'),(3088,'542227','措美县',321,0,0,'Comai Xian','COM'),(3089,'542228','洛扎县',321,0,0,'Lhozhag Xian','LHX'),(3090,'542229','加查县',321,0,0,'Gyaca Xian','GYA'),(3091,'542231','隆子县',321,0,0,'Lhvnze Xian','LHZ'),(3092,'542232','错那县',321,0,0,'Cona Xian','CON'),(3093,'542233','浪卡子县',321,0,0,'Nagarze Xian','NAX'),(3094,'542301','日喀则市',322,0,0,'Xigaze Shi','XIG'),(3095,'542322','南木林县',322,0,0,'Namling Xian','NAM'),(3096,'542323','江孜县',322,0,0,'Gyangze Xian','GYZ'),(3097,'542324','定日县',322,0,0,'Tingri Xian','TIN'),(3098,'542325','萨迦县',322,0,0,'Sa,gya Xian','SGX'),(3099,'542326','拉孜县',322,0,0,'Lhaze Xian','LAZ'),(3100,'542327','昂仁县',322,0,0,'Ngamring Xian','NGA'),(3101,'542328','谢通门县',322,0,0,'Xaitongmoin Xian','XTM'),(3102,'542329','白朗县',322,0,0,'Bainang Xian','BAI'),(3103,'542330','仁布县',322,0,0,'Rinbung Xian','RIN'),(3104,'542331','康马县',322,0,0,'Kangmar Xian','KAN'),(3105,'542332','定结县',322,0,0,'Dinggye Xian','DIN'),(3106,'542333','仲巴县',322,0,0,'Zhongba Xian','ZHB'),(3107,'542334','亚东县',322,0,0,'Yadong(Chomo) Xian','YDZ'),(3108,'542335','吉隆县',322,0,0,'Gyirong Xian','GIR'),(3109,'542336','聂拉木县',322,0,0,'Nyalam Xian','NYA'),(3110,'542337','萨嘎县',322,0,0,'Saga Xian','SAG'),(3111,'542338','岗巴县',322,0,0,'Gamba Xian','GAM'),(3112,'542421','那曲县',323,0,0,'Nagqu Xian','NAG'),(3113,'542422','嘉黎县',323,0,0,'Lhari Xian','LHR'),(3114,'542423','比如县',323,0,0,'Biru Xian','BRU'),(3115,'542424','聂荣县',323,0,0,'Nyainrong Xian','NRO'),(3116,'542425','安多县',323,0,0,'Amdo Xian','AMD'),(3117,'542426','申扎县',323,0,0,'Xainza Xian','XZX'),(3118,'542427','索县',323,0,0,'Sog Xian','SOG'),(3119,'542428','班戈县',323,0,0,'Bangoin Xian','BGX'),(3120,'542429','巴青县',323,0,0,'Baqen Xian','BQE'),(3121,'542430','尼玛县',323,0,0,'Nyima Xian','NYX'),(3122,'542521','普兰县',324,0,0,'Burang Xian','BUR'),(3123,'542522','札达县',324,0,0,'Zanda Xian','ZAN'),(3124,'542523','噶尔县',324,0,0,'Gar Xian','GAR'),(3125,'542524','日土县',324,0,0,'Rutog Xian','RUT'),(3126,'542525','革吉县',324,0,0,'Ge,gyai Xian','GEG'),(3127,'542526','改则县',324,0,0,'Gerze Xian','GER'),(3128,'542527','措勤县',324,0,0,'Coqen Xian','COQ'),(3129,'542621','林芝县',325,0,0,'Nyingchi Xian','NYI'),(3130,'542622','工布江达县',325,0,0,'Gongbo,gyamda Xian','GOX'),(3131,'542623','米林县',325,0,0,'Mainling Xian','MAX'),(3132,'542624','墨脱县',325,0,0,'Metog Xian','MET'),(3133,'542625','波密县',325,0,0,'Bomi(Bowo) Xian','BMI'),(3134,'542626','察隅县',325,0,0,'Zayv Xian','ZAY'),(3135,'542627','朗县',325,0,0,'Nang Xian','NGX'),(3136,'610101','市辖区',326,0,0,'Shixiaqu','2'),(3137,'610102','新城区',326,0,0,'Xincheng Qu','XCK'),(3138,'610103','碑林区',326,0,0,'Beilin Qu','BLQ'),(3139,'610104','莲湖区',326,0,0,'Lianhu Qu','LHU'),(3140,'610111','灞桥区',326,0,0,'Baqiao Qu','BQQ'),(3141,'610112','未央区',326,0,0,'Weiyang Qu','2'),(3142,'610113','雁塔区',326,0,0,'Yanta Qu','YTA'),(3143,'610114','阎良区',326,0,0,'Yanliang Qu','YLQ'),(3144,'610115','临潼区',326,0,0,'Lintong Qu','LTG'),(3145,'610116','长安区',326,0,0,'Changan Qu','2'),(3146,'610122','蓝田县',326,0,0,'Lantian Xian','LNT'),(3147,'610124','周至县',326,0,0,'Zhouzhi Xian','ZOZ'),(3148,'610125','户县',326,0,0,'Hu Xian','HUX'),(3149,'610126','高陵县',326,0,0,'Gaoling Xian','GLS'),(3150,'610201','市辖区',327,0,0,'Shixiaqu','2'),(3151,'610202','王益区',327,0,0,'Wangyi Qu','2'),(3152,'610203','印台区',327,0,0,'Yintai Qu','2'),(3153,'610204','耀州区',327,0,0,'Yaozhou Qu','2'),(3154,'610222','宜君县',327,0,0,'Yijun Xian','YJU'),(3155,'610301','市辖区',328,0,0,'Shixiaqu','2'),(3156,'610302','渭滨区',328,0,0,'Weibin Qu','WBQ'),(3157,'610303','金台区',328,0,0,'Jintai Qu','JTQ'),(3158,'610304','陈仓区',328,0,0,'Chencang Qu','2'),(3159,'610322','凤翔县',328,0,0,'Fengxiang Xian','FXG'),(3160,'610323','岐山县',328,0,0,'Qishan Xian','QIS'),(3161,'610324','扶风县',328,0,0,'Fufeng Xian','FFG'),(3162,'610326','眉县',328,0,0,'Mei Xian','MEI'),(3163,'610327','陇县',328,0,0,'Long Xian','LON'),(3164,'610328','千阳县',328,0,0,'Qianyang Xian','QNY'),(3165,'610329','麟游县',328,0,0,'Linyou Xian','LYP'),(3166,'610330','凤县',328,0,0,'Feng Xian','FEG'),(3167,'610331','太白县',328,0,0,'Taibai Xian','TBA'),(3168,'610401','市辖区',329,0,0,'Shixiaqu','2'),(3169,'610402','秦都区',329,0,0,'Qindu Qu','QDU'),(3170,'610403','杨陵区',329,0,0,'Yangling Qu','YGL'),(3171,'610404','渭城区',329,0,0,'Weicheng Qu','WIC'),(3172,'610422','三原县',329,0,0,'Sanyuan Xian','SYN'),(3173,'610423','泾阳县',329,0,0,'Jingyang Xian','JGY'),(3174,'610424','乾县',329,0,0,'Qian Xian','QIA'),(3175,'610425','礼泉县',329,0,0,'Liquan Xian','LIQ'),(3176,'610426','永寿县',329,0,0,'Yongshou Xian','YSH'),(3177,'610427','彬县',329,0,0,'Bin Xian','BIX'),(3178,'610428','长武县',329,0,0,'Changwu Xian','CWU'),(3179,'610429','旬邑县',329,0,0,'Xunyi Xian','XNY'),(3180,'610430','淳化县',329,0,0,'Chunhua Xian','CHU'),(3181,'610431','武功县',329,0,0,'Wugong Xian','WGG'),(3182,'610481','兴平市',329,0,0,'Xingping Shi','XPG'),(3183,'610501','市辖区',330,0,0,'Shixiaqu','2'),(3184,'610502','临渭区',330,0,0,'Linwei Qu','LWE'),(3185,'610521','华县',330,0,0,'Hua Xian','HXN'),(3186,'610522','潼关县',330,0,0,'Tongguan Xian','TGN'),(3187,'610523','大荔县',330,0,0,'Dali Xian','DAL'),(3188,'610524','合阳县',330,0,0,'Heyang Xian','HYK'),(3189,'610525','澄城县',330,0,0,'Chengcheng Xian','CCG'),(3190,'610526','蒲城县',330,0,0,'Pucheng Xian','PUC'),(3191,'610527','白水县',330,0,0,'Baishui Xian','BSU'),(3192,'610528','富平县',330,0,0,'Fuping Xian','FPX'),(3193,'610581','韩城市',330,0,0,'Hancheng Shi','HCE'),(3194,'610582','华阴市',330,0,0,'Huayin Shi','HYI'),(3195,'610601','市辖区',331,0,0,'Shixiaqu','2'),(3196,'610602','宝塔区',331,0,0,'Baota Qu','BTA'),(3197,'610621','延长县',331,0,0,'Yanchang Xian','YCA'),(3198,'610622','延川县',331,0,0,'Yanchuan Xian','YCT'),(3199,'610623','子长县',331,0,0,'Zichang Xian','ZCA'),(3200,'610624','安塞县',331,0,0,'Ansai Xian','ANS'),(3201,'610625','志丹县',331,0,0,'Zhidan Xian','ZDN'),(3202,'610626','吴起县',331,0,0,'Wuqi Xian','2'),(3203,'610627','甘泉县',331,0,0,'Ganquan Xian','GQN'),(3204,'610628','富县',331,0,0,'Fu Xian','FUX'),(3205,'610629','洛川县',331,0,0,'Luochuan Xian','LCW'),(3206,'610630','宜川县',331,0,0,'Yichuan Xian','YIC'),(3207,'610631','黄龙县',331,0,0,'Huanglong Xian','HGL'),(3208,'610632','黄陵县',331,0,0,'Huangling Xian','HLG'),(3209,'610701','市辖区',332,0,0,'Shixiaqu','2'),(3210,'610702','汉台区',332,0,0,'Hantai Qu','HTQ'),(3211,'610721','南郑县',332,0,0,'Nanzheng Xian','NZG'),(3212,'610722','城固县',332,0,0,'Chenggu Xian','CGU'),(3213,'610723','洋县',332,0,0,'Yang Xian','YGX'),(3214,'610724','西乡县',332,0,0,'Xixiang Xian','XXA'),(3215,'610725','勉县',332,0,0,'Mian Xian','MIA'),(3216,'610726','宁强县',332,0,0,'Ningqiang Xian','NQG'),(3217,'610727','略阳县',332,0,0,'Lueyang Xian','LYC'),(3218,'610728','镇巴县',332,0,0,'Zhenba Xian','ZBA'),(3219,'610729','留坝县',332,0,0,'Liuba Xian','LBA'),(3220,'610730','佛坪县',332,0,0,'Foping Xian','FPG'),(3221,'610801','市辖区',333,0,0,'1','2'),(3222,'610802','榆阳区',333,0,0,'Yuyang Qu','2'),(3223,'610821','神木县',333,0,0,'Shenmu Xian','2'),(3224,'610822','府谷县',333,0,0,'Fugu Xian','2'),(3225,'610823','横山县',333,0,0,'Hengshan Xian','2'),(3226,'610824','靖边县',333,0,0,'Jingbian Xian','2'),(3227,'610825','定边县',333,0,0,'Dingbian Xian','2'),(3228,'610826','绥德县',333,0,0,'Suide Xian','2'),(3229,'610827','米脂县',333,0,0,'Mizhi Xian','2'),(3230,'610828','佳县',333,0,0,'Jia Xian','2'),(3231,'610829','吴堡县',333,0,0,'Wubu Xian','2'),(3232,'610830','清涧县',333,0,0,'Qingjian Xian','2'),(3233,'610831','子洲县',333,0,0,'Zizhou Xian','2'),(3234,'610901','市辖区',334,0,0,'1','2'),(3235,'610902','汉滨区',334,0,0,'Hanbin Qu','2'),(3236,'610921','汉阴县',334,0,0,'Hanyin Xian','2'),(3237,'610922','石泉县',334,0,0,'Shiquan Xian','2'),(3238,'610923','宁陕县',334,0,0,'Ningshan Xian','2'),(3239,'610924','紫阳县',334,0,0,'Ziyang Xian','2'),(3240,'610925','岚皋县',334,0,0,'Langao Xian','2'),(3241,'610926','平利县',334,0,0,'Pingli Xian','2'),(3242,'610927','镇坪县',334,0,0,'Zhenping Xian','2'),(3243,'610928','旬阳县',334,0,0,'Xunyang Xian','2'),(3244,'610929','白河县',334,0,0,'Baihe Xian','2'),(3245,'611001','市辖区',335,0,0,'1','2'),(3246,'611002','商州区',335,0,0,'Shangzhou Qu','2'),(3247,'611021','洛南县',335,0,0,'Luonan Xian','2'),(3248,'611022','丹凤县',335,0,0,'Danfeng Xian','2'),(3249,'611023','商南县',335,0,0,'Shangnan Xian','2'),(3250,'611024','山阳县',335,0,0,'Shanyang Xian','2'),(3251,'611025','镇安县',335,0,0,'Zhen,an Xian','2'),(3252,'611026','柞水县',335,0,0,'Zhashui Xian','2'),(3253,'620101','市辖区',336,0,0,'Shixiaqu','2'),(3254,'620102','城关区',336,0,0,'Chengguan Qu','CLZ'),(3255,'620103','七里河区',336,0,0,'Qilihe Qu','QLH'),(3256,'620104','西固区',336,0,0,'Xigu Qu','XGU'),(3257,'620105','安宁区',336,0,0,'Anning Qu','ANQ'),(3258,'620111','红古区',336,0,0,'Honggu Qu','HOG'),(3259,'620121','永登县',336,0,0,'Yongdeng Xian','YDG'),(3260,'620122','皋兰县',336,0,0,'Gaolan Xian','GAL'),(3261,'620123','榆中县',336,0,0,'Yuzhong Xian','YZX'),(3262,'620201','市辖区',337,0,0,'Shixiaqu','2'),(3263,'620301','市辖区',338,0,0,'Shixiaqu','2'),(3264,'620302','金川区',338,0,0,'Jinchuan Qu','JCU'),(3265,'620321','永昌县',338,0,0,'Yongchang Xian','YCF'),(3266,'620401','市辖区',339,0,0,'Shixiaqu','2'),(3267,'620402','白银区',339,0,0,'Baiyin Qu','BYB'),(3268,'620403','平川区',339,0,0,'Pingchuan Qu','PCQ'),(3269,'620421','靖远县',339,0,0,'Jingyuan Xian','JYH'),(3270,'620422','会宁县',339,0,0,'Huining xian','HNI'),(3271,'620423','景泰县',339,0,0,'Jingtai Xian','JGT'),(3272,'620501','市辖区',340,0,0,'Shixiaqu','2'),(3274,'620502','秦州区',340,0,0,'Beidao Qu','2'),(3275,'620521','清水县',340,0,0,'Qingshui Xian','QSG'),(3276,'620522','秦安县',340,0,0,'Qin,an Xian','QNA'),(3277,'620523','甘谷县',340,0,0,'Gangu Xian','GGU'),(3278,'620524','武山县',340,0,0,'Wushan Xian','WSX'),(3279,'620525','张家川回族自治县',340,0,0,'Zhangjiachuan Huizu Zizhixian','ZJC'),(3280,'620601','市辖区',341,0,0,'1','2'),(3281,'620602','凉州区',341,0,0,'Liangzhou Qu','2'),(3282,'620621','民勤县',341,0,0,'Minqin Xian','2'),(3283,'620622','古浪县',341,0,0,'Gulang Xian','2'),(3284,'620623','天祝藏族自治县',341,0,0,'Tianzhu Zangzu Zizhixian','2'),(3285,'620701','市辖区',342,0,0,'1','2'),(3286,'620702','甘州区',342,0,0,'Ganzhou Qu','2'),(3287,'620721','肃南裕固族自治县',342,0,0,'Sunan Yugurzu Zizhixian','2'),(3288,'620722','民乐县',342,0,0,'Minle Xian','2'),(3289,'620723','临泽县',342,0,0,'Linze Xian','2'),(3290,'620724','高台县',342,0,0,'Gaotai Xian','2'),(3291,'620725','山丹县',342,0,0,'Shandan Xian','2'),(3292,'620801','市辖区',343,0,0,'1','2'),(3293,'620802','崆峒区',343,0,0,'Kongdong Qu','2'),(3294,'620821','泾川县',343,0,0,'Jingchuan Xian','2'),(3295,'620822','灵台县',343,0,0,'Lingtai Xian','2'),(3296,'620823','崇信县',343,0,0,'Chongxin Xian','2'),(3297,'620824','华亭县',343,0,0,'Huating Xian','2'),(3298,'620825','庄浪县',343,0,0,'Zhuanglang Xian','2'),(3299,'620826','静宁县',343,0,0,'Jingning Xian','2'),(3300,'620901','市辖区',344,0,0,'1','2'),(3301,'620902','肃州区',344,0,0,'Suzhou Qu','2'),(3302,'620921','金塔县',344,0,0,'Jinta Xian','2'),(3304,'620923','肃北蒙古族自治县',344,0,0,'Subei Monguzu Zizhixian','2'),(3305,'620924','阿克塞哈萨克族自治县',344,0,0,'Aksay Kazakzu Zizhixian','2'),(3306,'620981','玉门市',344,0,0,'Yumen Shi','2'),(3307,'620982','敦煌市',344,0,0,'Dunhuang Shi','2'),(3308,'621001','市辖区',345,0,0,'1','2'),(3309,'621002','西峰区',345,0,0,'Xifeng Qu','2'),(3310,'621021','庆城县',345,0,0,'Qingcheng Xian','2'),(3311,'621022','环县',345,0,0,'Huan Xian','2'),(3312,'621023','华池县',345,0,0,'Huachi Xian','2'),(3313,'621024','合水县',345,0,0,'Heshui Xian','2'),(3314,'621025','正宁县',345,0,0,'Zhengning Xian','2'),(3315,'621026','宁县',345,0,0,'Ning Xian','2'),(3316,'621027','镇原县',345,0,0,'Zhenyuan Xian','2'),(3317,'621101','市辖区',346,0,0,'1','2'),(3318,'621102','安定区',346,0,0,'Anding Qu','2'),(3319,'621121','通渭县',346,0,0,'Tongwei Xian','2'),(3320,'621122','陇西县',346,0,0,'Longxi Xian','2'),(3321,'621123','渭源县',346,0,0,'Weiyuan Xian','2'),(3322,'621124','临洮县',346,0,0,'Lintao Xian','2'),(3323,'621125','漳县',346,0,0,'Zhang Xian','2'),(3324,'621126','岷县',346,0,0,'Min Xian','2'),(3325,'621201','市辖区',347,0,0,'1','2'),(3326,'621202','武都区',347,0,0,'Wudu Qu','2'),(3327,'621221','成县',347,0,0,'Cheng Xian','2'),(3328,'621222','文县',347,0,0,'Wen Xian','2'),(3329,'621223','宕昌县',347,0,0,'Dangchang Xian','2'),(3330,'621224','康县',347,0,0,'Kang Xian','2'),(3331,'621225','西和县',347,0,0,'Xihe Xian','2'),(3332,'621226','礼县',347,0,0,'Li Xian','2'),(3333,'621227','徽县',347,0,0,'Hui Xian','2'),(3334,'621228','两当县',347,0,0,'Liangdang Xian','2'),(3335,'622901','临夏市',348,0,0,'Linxia Shi','LXR'),(3336,'622921','临夏县',348,0,0,'Linxia Xian','LXF'),(3337,'622922','康乐县',348,0,0,'Kangle Xian','KLE'),(3338,'622923','永靖县',348,0,0,'Yongjing Xian','YJG'),(3339,'622924','广河县',348,0,0,'Guanghe Xian','GHX'),(3340,'622925','和政县',348,0,0,'Hezheng Xian','HZG'),(3341,'622926','东乡族自治县',348,0,0,'Dongxiangzu Zizhixian','DXZ'),(3342,'622927','积石山保安族东乡族撒拉族自治县',348,0,0,'Jishishan Bonanzu Dongxiangzu Salarzu Zizhixian','JSN'),(3343,'623001','合作市',349,0,0,'Hezuo Shi','HEZ'),(3344,'623021','临潭县',349,0,0,'Lintan Xian','LTN'),(3345,'623022','卓尼县',349,0,0,'Jone','JON'),(3346,'623023','舟曲县',349,0,0,'Zhugqu Xian','ZQU'),(3347,'623024','迭部县',349,0,0,'Tewo Xian','TEW'),(3348,'623025','玛曲县',349,0,0,'Maqu Xian','MQU'),(3349,'623026','碌曲县',349,0,0,'Luqu Xian','LQU'),(3350,'623027','夏河县',349,0,0,'Xiahe Xian','XHN'),(3351,'630101','市辖区',350,0,0,'Shixiaqu','2'),(3352,'630102','城东区',350,0,0,'Chengdong Qu','CDQ'),(3353,'630103','城中区',350,0,0,'Chengzhong Qu','CZQ'),(3354,'630104','城西区',350,0,0,'Chengxi Qu','CXQ'),(3355,'630105','城北区',350,0,0,'Chengbei Qu','CBE'),(3356,'630121','大通回族土族自治县',350,0,0,'Datong Huizu Tuzu Zizhixian','DAT'),(3357,'630122','湟中县',350,0,0,'Huangzhong Xian','2'),(3358,'630123','湟源县',350,0,0,'Huangyuan Xian','2'),(3359,'632121','平安县',351,0,0,'Ping,an Xian','PAN'),(3360,'632122','民和回族土族自治县',351,0,0,'Minhe Huizu Tuzu Zizhixian','MHE'),(3361,'632123','乐都县',351,0,0,'Ledu Xian','LDU'),(3362,'632126','互助土族自治县',351,0,0,'Huzhu Tuzu Zizhixian','HZT'),(3363,'632127','化隆回族自治县',351,0,0,'Hualong Huizu Zizhixian','HLO'),(3364,'632128','循化撒拉族自治县',351,0,0,'Xunhua Salazu Zizhixian','XUH'),(3365,'632221','门源回族自治县',352,0,0,'Menyuan Huizu Zizhixian','MYU'),(3366,'632222','祁连县',352,0,0,'Qilian Xian','QLN'),(3367,'632223','海晏县',352,0,0,'Haiyan Xian','HIY'),(3368,'632224','刚察县',352,0,0,'Gangca Xian','GAN'),(3369,'632321','同仁县',353,0,0,'Tongren Xian','TRN'),(3370,'632322','尖扎县',353,0,0,'Jainca Xian','JAI'),(3371,'632323','泽库县',353,0,0,'Zekog Xian','ZEK'),(3372,'632324','河南蒙古族自治县',353,0,0,'Henan Mongolzu Zizhixian','HNM'),(3373,'632521','共和县',354,0,0,'Gonghe Xian','GHE'),(3374,'632522','同德县',354,0,0,'Tongde Xian','TDX'),(3375,'632523','贵德县',354,0,0,'Guide Xian','GID'),(3376,'632524','兴海县',354,0,0,'Xinghai Xian','XHA'),(3377,'632525','贵南县',354,0,0,'Guinan Xian','GNN'),(3378,'632621','玛沁县',355,0,0,'Maqen Xian','MAQ'),(3379,'632622','班玛县',355,0,0,'Baima Xian','BMX'),(3380,'632623','甘德县',355,0,0,'Gade Xian','GAD'),(3381,'632624','达日县',355,0,0,'Tarlag Xian','TAR'),(3382,'632625','久治县',355,0,0,'Jigzhi Xian','JUZ'),(3383,'632626','玛多县',355,0,0,'Madoi Xian','MAD'),(3384,'632721','玉树县',356,0,0,'Yushu Xian','YSK'),(3385,'632722','杂多县',356,0,0,'Zadoi Xian','ZAD'),(3386,'632723','称多县',356,0,0,'Chindu Xian','CHI'),(3387,'632724','治多县',356,0,0,'Zhidoi Xian','ZHI'),(3388,'632725','囊谦县',356,0,0,'Nangqen Xian','NQN'),(3389,'632726','曲麻莱县',356,0,0,'Qumarleb Xian','QUM'),(3390,'632801','格尔木市',357,0,0,'Golmud Shi','GOS'),(3391,'632802','德令哈市',357,0,0,'Delhi Shi','DEL'),(3392,'632821','乌兰县',357,0,0,'Ulan Xian','ULA'),(3393,'632822','都兰县',357,0,0,'Dulan Xian','DUL'),(3394,'632823','天峻县',357,0,0,'Tianjun Xian','TJN'),(3395,'640101','市辖区',358,0,0,'Shixiaqu','2'),(3396,'640104','兴庆区',358,0,0,'Xingqing Qu','2'),(3397,'640105','西夏区',358,0,0,'Xixia Qu','2'),(3398,'640106','金凤区',358,0,0,'Jinfeng Qu','2'),(3399,'640121','永宁县',358,0,0,'Yongning Xian','YGN'),(3400,'640122','贺兰县',358,0,0,'Helan Xian','HLN'),(3401,'640181','灵武市',358,0,0,'Lingwu Shi','2'),(3402,'640201','市辖区',359,0,0,'Shixiaqu','2'),(3403,'640202','大武口区',359,0,0,'Dawukou Qu','DWK'),(3404,'640205','惠农区',359,0,0,'Huinong Qu','2'),(3405,'640221','平罗县',359,0,0,'Pingluo Xian','PLO'),(3406,'640301','市辖区',360,0,0,'Shixiaqu','2'),(3407,'640302','利通区',360,0,0,'Litong Qu','LTW'),(3408,'640323','盐池县',360,0,0,'Yanchi Xian','YCY'),(3409,'640324','同心县',360,0,0,'Tongxin Xian','TGX'),(3410,'640381','青铜峡市',360,0,0,'Qingtongxia Xian','QTX'),(3411,'640401','市辖区',361,0,0,'1','2'),(3412,'640402','原州区',361,0,0,'Yuanzhou Qu','2'),(3413,'640422','西吉县',361,0,0,'Xiji Xian','2'),(3414,'640423','隆德县',361,0,0,'Longde Xian','2'),(3415,'640424','泾源县',361,0,0,'Jingyuan Xian','2'),(3416,'640425','彭阳县',361,0,0,'Pengyang Xian','2'),(3417,'640501','市辖区',362,0,0,'1','2'),(3418,'640502','沙坡头区',362,0,0,'Shapotou Qu','2'),(3419,'640521','中宁县',362,0,0,'Zhongning Xian','2'),(3420,'640522','海原县',362,0,0,'Haiyuan Xian','2'),(3421,'650101','市辖区',363,0,0,'Shixiaqu','2'),(3422,'650102','天山区',363,0,0,'Tianshan Qu','TSL'),(3423,'650103','沙依巴克区',363,0,0,'Saybag Qu','SAY'),(3424,'650104','新市区',363,0,0,'Xinshi Qu','XSU'),(3425,'650105','水磨沟区',363,0,0,'Shuimogou Qu','SMG'),(3426,'650106','头屯河区',363,0,0,'Toutunhe Qu','TTH'),(3427,'650107','达坂城区',363,0,0,'Dabancheng Qu','2'),(3428,'650109','米东区',363,0,0,'Midong Qu','2'),(3429,'650121','乌鲁木齐县',363,0,0,'Urumqi Xian','URX'),(3430,'650201','市辖区',364,0,0,'Shixiaqu','2'),(3431,'650202','独山子区',364,0,0,'Dushanzi Qu','DSZ'),(3432,'650203','克拉玛依区',364,0,0,'Karamay Qu','KRQ'),(3433,'650204','白碱滩区',364,0,0,'Baijiantan Qu','BJT'),(3434,'650205','乌尔禾区',364,0,0,'Orku Qu','ORK'),(3435,'652101','吐鲁番市',365,0,0,'Turpan Shi','TUR'),(3436,'652122','鄯善县',365,0,0,'Shanshan(piqan) Xian','SSX'),(3437,'652123','托克逊县',365,0,0,'Toksun Xian','TOK'),(3438,'652201','哈密市',366,0,0,'Hami(kumul) Shi','HAM'),(3439,'652222','巴里坤哈萨克自治县',366,0,0,'Barkol Kazak Zizhixian','BAR'),(3440,'652223','伊吾县',366,0,0,'Yiwu(Araturuk) Xian','YWX'),(3441,'652301','昌吉市',367,0,0,'Changji Shi','CJS'),(3442,'652302','阜康市',367,0,0,'Fukang Shi','FKG'),(3444,'652323','呼图壁县',367,0,0,'Hutubi Xian','HTB'),(3445,'652324','玛纳斯县',367,0,0,'Manas Xian','MAS'),(3446,'652325','奇台县',367,0,0,'Qitai Xian','QTA'),(3447,'652327','吉木萨尔县',367,0,0,'Jimsar Xian','JIM'),(3448,'652328','木垒哈萨克自治县',367,0,0,'Mori Kazak Zizhixian','MOR'),(3449,'652701','博乐市',368,0,0,'Bole(Bortala) Shi','BLE'),(3450,'652722','精河县',368,0,0,'Jinghe(Jing) Xian','JGH'),(3451,'652723','温泉县',368,0,0,'Wenquan(Arixang) Xian','WNQ'),(3452,'652801','库尔勒市',369,0,0,'Korla Shi','KOR'),(3453,'652822','轮台县',369,0,0,'Luntai(Bugur) Xian','LTX'),(3454,'652823','尉犁县',369,0,0,'Yuli(Lopnur) Xian','YLI'),(3455,'652824','若羌县',369,0,0,'Ruoqiang(Qakilik) Xian','RQG'),(3456,'652825','且末县',369,0,0,'Qiemo(Qarqan) Xian','QMO'),(3457,'652826','焉耆回族自治县',369,0,0,'Yanqi Huizu Zizhixian','YQI'),(3458,'652827','和静县',369,0,0,'Hejing Xian','HJG'),(3459,'652828','和硕县',369,0,0,'Hoxud Xian','HOX'),(3460,'652829','博湖县',369,0,0,'Bohu(Bagrax) Xian','BHU'),(3461,'652901','阿克苏市',370,0,0,'Aksu Shi','AKS'),(3462,'652922','温宿县',370,0,0,'Wensu Xian','WSU'),(3463,'652923','库车县',370,0,0,'Kuqa Xian','KUQ'),(3464,'652924','沙雅县',370,0,0,'Xayar Xian','XYR'),(3465,'652925','新和县',370,0,0,'Xinhe(Toksu) Xian','XHT'),(3466,'652926','拜城县',370,0,0,'Baicheng(Bay) Xian','BCG'),(3467,'652927','乌什县',370,0,0,'Wushi(Uqturpan) Xian','WSH'),(3468,'652928','阿瓦提县',370,0,0,'Awat Xian','AWA'),(3469,'652929','柯坪县',370,0,0,'Kalpin Xian','KAL'),(3470,'653001','阿图什市',371,0,0,'Artux Shi','ART'),(3471,'653022','阿克陶县',371,0,0,'Akto Xian','AKT'),(3472,'653023','阿合奇县',371,0,0,'Akqi Xian','AKQ'),(3473,'653024','乌恰县',371,0,0,'Wuqia(Ulugqat) Xian','WQA'),(3474,'653101','喀什市',372,0,0,'Kashi (Kaxgar) Shi','KHG'),(3475,'653121','疏附县',372,0,0,'Shufu Xian','SFU'),(3476,'653122','疏勒县',372,0,0,'Shule Xian','SHL'),(3477,'653123','英吉沙县',372,0,0,'Yengisar Xian','YEN'),(3478,'653124','泽普县',372,0,0,'Zepu(Poskam) Xian','ZEP'),(3479,'653125','莎车县',372,0,0,'Shache(Yarkant) Xian','SHC'),(3480,'653126','叶城县',372,0,0,'Yecheng(Kargilik) Xian','YEC'),(3481,'653127','麦盖提县',372,0,0,'Markit Xian','MAR'),(3482,'653128','岳普湖县',372,0,0,'Yopurga Xian','YOP'),(3483,'653129','伽师县',372,0,0,'Jiashi(Payzawat) Xian','JSI'),(3484,'653130','巴楚县',372,0,0,'Bachu(Maralbexi) Xian','BCX'),(3485,'653131','塔什库尔干塔吉克自治县',372,0,0,'Taxkorgan Tajik Zizhixian','TXK'),(3486,'653201','和田市',373,0,0,'Hotan Shi','HTS'),(3487,'653221','和田县',373,0,0,'Hotan Xian','HOT'),(3488,'653222','墨玉县',373,0,0,'Moyu(Karakax) Xian','MOY'),(3489,'653223','皮山县',373,0,0,'Pishan(Guma) Xian','PSA'),(3490,'653224','洛浦县',373,0,0,'Lop Xian','LOP'),(3491,'653225','策勒县',373,0,0,'Qira Xian','QIR'),(3492,'653226','于田县',373,0,0,'Yutian(Keriya) Xian','YUT'),(3493,'653227','民丰县',373,0,0,'Minfeng(Niya) Xian','MFG'),(3494,'654002','伊宁市',374,0,0,'Yining(Gulja) Shi','2'),(3495,'654003','奎屯市',374,0,0,'Kuytun Shi','2'),(3496,'654021','伊宁县',374,0,0,'Yining(Gulja) Xian','2'),(3497,'654022','察布查尔锡伯自治县',374,0,0,'Qapqal Xibe Zizhixian','2'),(3498,'654023','霍城县',374,0,0,'Huocheng Xin','2'),(3499,'654024','巩留县',374,0,0,'Gongliu(Tokkuztara) Xian','2'),(3500,'654025','新源县',374,0,0,'Xinyuan(Kunes) Xian','2'),(3501,'654026','昭苏县',374,0,0,'Zhaosu(Mongolkure) Xian','2'),(3502,'654027','特克斯县',374,0,0,'Tekes Xian','2'),(3503,'654028','尼勒克县',374,0,0,'Nilka Xian','2'),(3504,'654201','塔城市',375,0,0,'Tacheng(Qoqek) Shi','TCS'),(3505,'654202','乌苏市',375,0,0,'Usu Shi','USU'),(3506,'654221','额敏县',375,0,0,'Emin(Dorbiljin) Xian','EMN'),(3507,'654223','沙湾县',375,0,0,'Shawan Xian','SWX'),(3508,'654224','托里县',375,0,0,'Toli Xian','TLI'),(3509,'654225','裕民县',375,0,0,'Yumin(Qagantokay) Xian','YMN'),(3510,'654226','和布克赛尔蒙古自治县',375,0,0,'Hebukesaiermengguzizhi Xian','2'),(3511,'654301','阿勒泰市',376,0,0,'Altay Shi','ALT'),(3512,'654321','布尔津县',376,0,0,'Burqin Xian','BUX'),(3513,'654322','富蕴县',376,0,0,'Fuyun(Koktokay) Xian','FYN'),(3514,'654323','福海县',376,0,0,'Fuhai(Burultokay) Xian','FHI'),(3515,'654324','哈巴河县',376,0,0,'Habahe(Kaba) Xian','HBH'),(3516,'654325','青河县',376,0,0,'Qinghe(Qinggil) Xian','QHX'),(3517,'654326','吉木乃县',376,0,0,'Jeminay Xian','JEM'),(3518,'659001','石河子市',377,0,0,'Shihezi Shi','SHZ'),(3519,'659002','阿拉尔市',377,0,0,'Alaer Shi','2'),(3520,'659003','图木舒克市',377,0,0,'Tumushuke Shi','2'),(3521,'659004','五家渠市',377,0,0,'Wujiaqu Shi','2'),(4000,'620503','麦积区',340,0,0,'Maiji Qu','2'),(4001,'500116','江津区',270,0,0,'Jiangjin Qu','2'),(4002,'500117','合川区',270,0,0,'Hechuan Qu','2'),(4003,'500118','永川区',270,0,0,'Yongchuan Qu','2'),(4004,'500119','南川区',270,0,0,'Nanchuan Qu','2'),(4006,'340221','芜湖县',1412,0,0,'Wuhu Xian','WHX'),(4100,'232701','加格达奇区',106,0,0,'Jiagedaqi Qu','2'),(4101,'232702','松岭区',106,0,0,'Songling Qu','2'),(4102,'232703','新林区',106,0,0,'Xinlin Qu','2'),(4103,'232704','呼中区',106,0,0,'Huzhong Qu','2'),(4200,'330402','南湖区',125,0,0,'Nanhu Qu','2'),(4300,'360482','共青城市',162,0,0,'Gongqingcheng Shi','2'),(4400,'640303','红寺堡区',360,0,0,'Hongsibao Qu','2'),(4500,'620922','瓜州县',344,0,0,'Guazhou Xian','2'),(4600,'421321','随县',215,0,0,'Sui Xian','2'),(4700,'431102','零陵区',228,0,0,'Lingling Qu','2'),(4800,'451119','平桂管理区',263,0,0,'Pingguiguanli Qu','2'),(4900,'510802','利州区',279,0,0,'Lizhou Qu','2'),(5000,'511681','华蓥市',286,0,0,'Huaying Shi','HYC');

/*Table structure for table `wlyy_advert` */

DROP TABLE IF EXISTS `wlyy_advert`;

CREATE TABLE `wlyy_advert` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `title` varchar(100) DEFAULT NULL COMMENT '广告标题',
  `from` varchar(100) DEFAULT NULL COMMENT '广告来源',
  `photo` varchar(100) DEFAULT NULL COMMENT '广告图片',
  `url` varchar(100) DEFAULT NULL COMMENT '广告链接地址',
  `seq` int(11) DEFAULT NULL COMMENT '广告显示顺序',
  `type` int(11) DEFAULT NULL COMMENT '广告类型（如主页广告）',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '发布时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  `czy` varchar(20) NOT NULL COMMENT '操作员，关联wlyy_user表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='系统广告表';

/*Data for the table `wlyy_advert` */

/*Table structure for table `wlyy_chat_log` */

DROP TABLE IF EXISTS `wlyy_chat_log`;

CREATE TABLE `wlyy_chat_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `msgid` varchar(50) DEFAULT NULL COMMENT '消息ID',
  `sender` varchar(50) DEFAULT NULL COMMENT '发送人',
  `receiver` varchar(50) DEFAULT NULL COMMENT '接收人',
  `msg_type` int(11) DEFAULT NULL COMMENT '消息类型（1文本，2图片、3语音）',
  `chat_type` int(11) DEFAULT NULL COMMENT '聊天类型（1单聊，2群聊）',
  `content` varchar(1000) DEFAULT NULL COMMENT '消息内容',
  `state` int(11) DEFAULT NULL COMMENT '消息状态（1已发送，2已接收，3已读）',
  `platform` int(11) DEFAULT NULL COMMENT '消息平台，1微信，2医生APP',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '发送时间',
  `del` varchar(1) DEFAULT NULL COMMENT '是否已作废（1正常，0已作废）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='聊天记录表';

/*Data for the table `wlyy_chat_log` */

/*Table structure for table `wlyy_complaint_doctor` */

DROP TABLE IF EXISTS `wlyy_complaint_doctor`;

CREATE TABLE `wlyy_complaint_doctor` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '投诉标识',
  `user` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `content` varchar(3000) DEFAULT NULL COMMENT '投诉内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '投诉时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='投诉医生表';

/*Data for the table `wlyy_complaint_doctor` */

/*Table structure for table `wlyy_consult` */

DROP TABLE IF EXISTS `wlyy_consult`;

CREATE TABLE `wlyy_consult` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '咨询标识',
  `patient` varchar(50) NOT NULL COMMENT '咨询患者标识',
  `type` int(11) NOT NULL COMMENT '咨询类型：1三师咨询，2视频咨询，3图文咨询，4公共咨询，5病友圈',
  `title` varchar(300) DEFAULT NULL COMMENT '咨询标题',
  `symptoms` varchar(500) DEFAULT NULL COMMENT '主诉',
  `images` varchar(3000) DEFAULT NULL COMMENT '咨询图片URL，多图以逗号分隔',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '咨询时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_consult_1` (`patient`,`type`)
) ENGINE=InnoDB AUTO_INCREMENT=58 DEFAULT CHARSET=utf8mb4 COMMENT='患者视频、三师、公共、病友等咨询记录表';

/*Data for the table `wlyy_consult` */

insert  into `wlyy_consult`(`id`,`code`,`patient`,`type`,`title`,`symptoms`,`images`,`czrq`,`del`) values (1,'647e1753eb1d477cbdc1bab392191a8e','U20160322000001',4,'this is question title','this is queston content','','2016-05-19 14:50:22','1'),(2,'eaf5f669c720403bb35966f6ae1d3680','U20160322000001',1,NULL,'咳嗽','','2016-05-19 14:52:09','1'),(3,'3b7cc158bdb942dab55f5ed2913f5652','U20160322000001',5,'this is question title','this is question content','','2016-05-19 15:06:38','1'),(4,'484bcbf413b24002b86627eb2b182c60','U20160322000001',4,'咳嗽','特别是晚上','','2016-05-19 19:46:19','1'),(5,'f8ae771460d24ad6b95d5403d7964a11','U20160322000001',1,NULL,'咳嗽咳嗽，头晕难受的','','2016-05-25 08:50:40','1'),(6,'a2adbea1eecb40508f837ac5030bd022','U20160322000003',1,NULL,'sdfsdfsdfsd','','2016-05-31 06:07:25','1'),(7,'2a234400ab5147c9b8fb4a083bcad063','U20160322000003',4,'sdfsdfdgfdg','dfgdfgdfgdf','','2016-06-01 01:10:15','1'),(8,'3549b82a65cc4fd886ef9a545789b2e5','U20160322000003',4,'sdfsdfsdfsdfsd','fsdfsdfsdfsd','','2016-06-01 01:19:46','1'),(9,'64e2286583fe4098bd1a97b11cb812fb','U20160322000003',4,'dfsdfsdfs','dgdfgdfgdf','','2016-06-01 01:21:33','1'),(10,'44ffc8c295094b358f2b6b02eded79d2','U20160322000003',4,'dfsdfsdfs','dgdfgdfgdf','','2016-06-01 01:25:09','1'),(11,'1eb6e1bce3cc463880d66b51b9e552e0','U20160322000003',4,'sdfsdf','aadfsdfsdfsdfdf','','2016-06-01 01:26:56','1'),(12,'52edf47291484bcd977a23cd19189567','U20160322000003',5,'sdfsdfsdfsdfsdfsdf','sdfsdfsdfsdfdsf','','2016-06-01 01:42:16','1'),(13,'5694c85a066941cfb906779c0d9ea0f4','U20160322000003',5,'testtesttest','aaaaaaaaaaaaaaaaaaaaaaaa','','2016-06-01 01:43:06','1'),(14,'e24844b1fff145cb9223a6059822eef1','U20160322000003',4,'teststwsssdfsdfsdfsdf','aaaaaasdfsdfsdfsd','','2016-06-01 01:44:04','1'),(15,'2c752ce1faef48b2acc1492d4880e514','U20160322000003',4,'sdfsdfsdfdsdgs','sdfsdfsdfsdf','','2016-06-01 01:45:52','1'),(16,'e9d56a61565c44fe98af9a85277b9871','U20160322000003',4,'fsdfsdfsdgdgsgda','gsdgsdgsdgfdgd','','2016-06-01 01:47:11','1'),(17,'96126447705c481d9aaae751fe056515','U20160322000003',4,'sdfsdfsadfassd','fsdfsdfsdfsdfsdfs','','2016-06-01 01:48:57','1'),(18,'b0dec98ee6e14d9b89cbc56a5e4ee1c1','U20160322000003',4,'aaaaaaaa','aaaaaaaaaaaaaa','','2016-06-01 01:52:45','1'),(19,'97aaf2113e8648929b5a90d66e9f3796','U20160322000003',4,'111112221','1111111111','','2016-06-01 01:58:40','1'),(20,'0f5bb688f5ca465ca070d1a72037e6bf','U20160322000003',4,'00000000000000000','111111111111111111111111111','','2016-06-01 02:01:23','1'),(21,'3e7f3a5a250545268c50b2674f6a20cc','U20160322000003',4,'00000000000000000','111111111111111111111111111','','2016-06-01 02:07:47','1'),(22,'a0829f9a84374f07934dbe465fc599d4','U20160322000003',4,'7777777777777777777777777777','7777777777777777777777777777777','','2016-06-01 02:11:49','1'),(23,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001',5,'我的测试我的测试士大夫士大夫','士大夫士大夫士大夫似的','','2016-06-01 05:37:33','1'),(32,'6521abc096424ce68a33ae88905492d8','U20160322000001',4,'惊讶于iyouiofhghhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh','发士大夫士大夫撒大锅饭该管管','','2016-06-01 06:08:24','1'),(33,'dea69050f0ec42d1afe6f78503664dbf','U20160322000002',4,'发烧感冒流鼻涕','发烧发烧法华寺撒恐辐女啊数据开发卡死','','2016-06-01 07:50:06','1'),(34,'f05ba96c5b784ec8b101ee7221586600','U20160322000002',4,'咯Hey1红你定定','空位子定额1为您忒您','','2016-06-01 07:57:13','1'),(35,'be279a617d7f40cc9f90aa311991ff0f','U20160322000002',4,'13232dsdsadsadsadsada','13212323ddddddddddddd','','2016-06-01 10:56:46','1'),(36,'533778533efa47e6a3014b0e80431b4e','U20160322000002',5,'111111111111111111111','222222222222222222','','2016-06-02 01:11:48','1'),(37,'7ed92f3f63a64839a5da16b3f735a84a','U20160322000001',5,'11123的十大十大多少','133213达到多少的的多少啊','','2016-06-02 02:06:15','1'),(38,'f719821bae6b4fa4a0fb853d3adfea65','U20160322000004',5,'123233323233232131232','323123123123231231231','','2016-06-02 05:37:47','1'),(39,'e864c4f39b7742f0969bcfb6245c4988','U20160322000004',4,'23132131233232','332312dsadadsadsadsadad','','2016-06-02 13:03:47','1'),(40,'36fbd94c9eb841b6844d027ac991d741','U20160322000004',4,'23132131233232','332312dsadadsadsadsadadsdad','','2016-06-02 13:06:12','1'),(41,'9265bf0f00154497bbdd7accd4daa557','U20160322000004',4,'23132131233232','111111111qwdqwdwqdsad','','2016-06-02 13:06:45','1'),(42,'c61a4b166e9e49c882ae851cec7b3f1c','U20160322000004',4,'12332312312321313','2323131231321','','2016-06-03 02:41:36','1'),(43,'37206ac4955040ef81e4a135ca244e77','U20160322000004',4,'111111111111111111111111111','11111111111111111111111111111','','2016-06-03 02:42:00','1'),(44,'96c381487d4f4db7ad497b45f86fb7ff','U20160322000004',4,'22222222222222222222222222','2222222222222222','','2016-06-03 02:42:18','1'),(45,'7add9f0372134c95abeca4636f2c28a5','U20160322000004',4,'22222222222222222222222222','2222222222222222','','2016-06-03 02:42:28','1'),(46,'7963d4b88cc640fc809b50d2f6c8dd73','U20160322000004',4,'3333333333333333333333333','333333333333333333333333','','2016-06-03 02:43:22','1'),(47,'7e6ec67ffdd74d768c85f86ac70d6acb','U20160322000004',4,'33333333333333333333','213323123132','','2016-06-03 02:44:02','1'),(48,'bb269725677f4e718e4ea184d07555c4','U20160322000004',4,'33333333333333333333','2133231231321','','2016-06-03 02:45:05','1'),(49,'f1726917fdfe47c6881a59507da409c2','U20160322000004',4,'111111111111111111111','32313313131231','','2016-06-03 07:00:44','1'),(50,'d45ba09008f84c5791609c7384a0c52d','U20160322000004',4,'3123333333333333333333','111333333333333333333','','2016-06-03 07:02:26','1'),(51,'456090ffc94c42d98c005a3a1e349329','U20160322000004',5,'111111111111111111111111111','111111111111111111111','','2016-06-03 07:02:42','1'),(52,'f2b8ea5984dc4df0b894225b2ebedc52','U20160322000004',4,'111111111111111111111111','11111111111111111111','','2016-06-03 07:03:01','1'),(53,'e00214ef3704435b8639a76eb86ae820','U20160322000004',4,'2222222222222','33333333333333','','2016-06-03 07:08:14','1'),(54,'ae24efd6c3cd4305a4bb86bd1a3c1747','U20160322000004',4,'11111111111111111','2222222222222222','','2016-06-03 07:09:01','1'),(55,'1e618fc268a04a3a8e2ac507f2922ca3','U20160322000004',4,'111111111111111','1111111111111','','2016-06-03 07:30:40','1'),(56,'920d543363fc4bcb9de38cc3c94c1e4a','U20160322000004',4,'32321321321321312312','32321321312312312','','2016-06-03 07:35:57','1'),(57,'b61e51ea081447f680700513f10aad70','U20160322000004',4,'111111111111111111111111111111111','222222222222222222222222','','2016-06-03 07:36:18','1');

/*Table structure for table `wlyy_consult_communication` */

DROP TABLE IF EXISTS `wlyy_consult_communication`;

CREATE TABLE `wlyy_consult_communication` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) DEFAULT NULL COMMENT '咨询标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '咨询患者标识',
  `name` varchar(50) DEFAULT NULL COMMENT '患者姓名',
  `photo` varchar(300) DEFAULT NULL COMMENT '患者头像',
  `title` varchar(300) DEFAULT NULL COMMENT '问题标题',
  `content` varchar(1000) DEFAULT NULL COMMENT '问题描述',
  `images` varchar(3000) DEFAULT NULL COMMENT '图片URL，多图以逗号分隔',
  `amount` int(11) DEFAULT NULL COMMENT '回复数量',
  `unread` int(11) DEFAULT NULL COMMENT '未读数量',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '咨询时间',
  `del` varchar(1) DEFAULT NULL COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_consult_text_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4 COMMENT='病友圈表';

/*Data for the table `wlyy_consult_communication` */

insert  into `wlyy_consult_communication`(`id`,`consult`,`patient`,`name`,`photo`,`title`,`content`,`images`,`amount`,`unread`,`czrq`,`del`) values (1,'3b7cc158bdb942dab55f5ed2913f5652','U20160322000001','李碧玉','','this is question title','this is question content','',1,0,'2016-05-19 08:54:31','1'),(2,'52edf47291484bcd977a23cd19189567','U20160322000003','窦怡宁','','sdfsdfsdfsdfsdfsdf','sdfsdfsdfsdfdsf','',2,0,'2016-06-01 03:11:51','1'),(3,'5694c85a066941cfb906779c0d9ea0f4','U20160322000003','窦怡宁','','testtesttest','aaaaaaaaaaaaaaaaaaaaaaaa','',6,0,'2016-06-01 03:20:45','1'),(4,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','我的测试我的测试士大夫士大夫','士大夫士大夫士大夫似的','',9,0,'2016-06-01 05:49:17','1'),(5,'533778533efa47e6a3014b0e80431b4e','U20160322000002','黄晓明','2016/06/01/20160601102451_820.jpg','111111111111111111111','222222222222222222','',0,0,'2016-06-02 01:11:48','1'),(6,'7ed92f3f63a64839a5da16b3f735a84a','U20160322000001','李碧玉','2016/06/01/20160601140418_38.jpg','11123的十大十大多少','133213达到多少的的多少啊','',1,1,'2016-06-02 03:56:39','1'),(7,'f719821bae6b4fa4a0fb853d3adfea65','U20160322000004','赖小娜','','123233323233232131232','323123123123231231231','',1,0,'2016-06-02 13:02:24','1'),(8,'456090ffc94c42d98c005a3a1e349329','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','111111111111111111111111111','111111111111111111111','',0,0,'2016-06-03 07:02:42','1');

/*Table structure for table `wlyy_consult_communication_reply` */

DROP TABLE IF EXISTS `wlyy_consult_communication_reply`;

CREATE TABLE `wlyy_consult_communication_reply` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) NOT NULL COMMENT '咨询标识',
  `patient` varchar(50) NOT NULL COMMENT '回复患者标识',
  `name` varchar(50) DEFAULT NULL COMMENT '回复者姓名',
  `photo` varchar(300) DEFAULT NULL COMMENT '回复者头像',
  `content` varchar(3000) NOT NULL COMMENT '回复内容',
  `images` varchar(1000) DEFAULT NULL COMMENT '回复图片URL地址，多图以逗号分隔',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '回复时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_consult_text_reply_1` (`consult`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8mb4 COMMENT='病友圈回复记录表';

/*Data for the table `wlyy_consult_communication_reply` */

insert  into `wlyy_consult_communication_reply`(`id`,`consult`,`patient`,`name`,`photo`,`content`,`images`,`czrq`,`del`) values (1,'3b7cc158bdb942dab55f5ed2913f5652','U20160322000001','李碧玉','http://172.19.103.77:8080/wlyy/uploadFiles/images/2016/05/17/20160517005825_389.jpg','this is reply content',NULL,'2016-05-19 15:08:28','1'),(2,'5694c85a066941cfb906779c0d9ea0f4','U20160322000003','窦怡宁','','sdfsdfsdf','','2016-06-01 02:20:35','1'),(3,'5694c85a066941cfb906779c0d9ea0f4','U20160322000003','窦怡宁','','sdf','','2016-06-01 02:20:55','1'),(4,'5694c85a066941cfb906779c0d9ea0f4','U20160322000003','窦怡宁','','999999999999999999999','','2016-06-01 02:35:07','1'),(5,'5694c85a066941cfb906779c0d9ea0f4','U20160322000003','窦怡宁','','aewrwerwerwerwer','','2016-06-01 02:35:53','1'),(6,'5694c85a066941cfb906779c0d9ea0f4','U20160322000003','窦怡宁','2016/06/01/20160601030004_249.jpg','dsfsdfsdf','','2016-06-01 03:06:33','1'),(7,'52edf47291484bcd977a23cd19189567','U20160322000003','窦怡宁','2016/06/01/20160601030004_249.jpg','aaaaaaaaaaaaaaaaaaaaaaaaaaaa','','2016-06-01 03:06:57','1'),(8,'52edf47291484bcd977a23cd19189567','U20160322000003','窦怡宁','2016/06/01/20160601030922_687.jpg','7777777777777777777777777','','2016-06-01 03:11:51','1'),(9,'5694c85a066941cfb906779c0d9ea0f4','U20160322000003','窦怡宁','2016/06/01/20160601031535_437.jpg','sdfsdfsdgfdgfdg','','2016-06-01 03:20:45','1'),(10,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','士大夫士大夫士大夫','','2016-06-01 05:37:58','1'),(11,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','发士大夫士大夫士大夫撒 发士大夫','','2016-06-01 05:44:27','1'),(12,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','发士大夫士大夫士大夫撒 发士大夫','','2016-06-01 05:44:32','1'),(13,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','发士大夫士大夫士大夫撒 发士大夫','','2016-06-01 05:44:36','1'),(14,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','发士大夫士大夫士大夫撒 发士大夫','','2016-06-01 05:44:43','1'),(15,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','发士大夫士大夫士大夫撒 发士大夫','','2016-06-01 05:44:47','1'),(16,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','发士大夫士大夫士大夫撒 发士大夫地方电饭锅电饭锅电饭锅','','2016-06-01 05:44:54','1'),(17,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','梵蒂冈地方个人格瑞特瑞特人','','2016-06-01 05:48:49','1'),(18,'6e9a66cafc6d4c59be53b58be8807da2','U20160322000001','李碧玉','','发士大夫大锅饭的规范电饭锅电饭锅大锅饭电饭锅大富大贵个电饭锅','','2016-06-01 05:49:17','1'),(19,'7ed92f3f63a64839a5da16b3f735a84a','U20160322000004','赖小娜','','大','','2016-06-02 03:56:39','1'),(20,'f719821bae6b4fa4a0fb853d3adfea65','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','dsadsadas dsa ','','2016-06-02 13:02:24','1');

/*Table structure for table `wlyy_consult_movi` */

DROP TABLE IF EXISTS `wlyy_consult_movi`;

CREATE TABLE `wlyy_consult_movi` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) DEFAULT NULL COMMENT '咨询标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `doctor_name` varchar(100) DEFAULT NULL COMMENT '医生姓名',
  `team` varchar(50) DEFAULT NULL COMMENT '三师团队标识',
  `team_name` varchar(100) DEFAULT NULL COMMENT '三师团队名称',
  `target` int(11) DEFAULT NULL COMMENT '预约类型：1指定医生，2三师预约',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `family` varchar(50) DEFAULT NULL COMMENT '家人标识',
  `name` varchar(100) DEFAULT NULL COMMENT '姓名',
  `sex` int(11) DEFAULT NULL COMMENT '性别',
  `photo` varchar(300) DEFAULT NULL COMMENT '头像',
  `birthday` date DEFAULT NULL COMMENT '头像',
  `type` int(11) DEFAULT NULL COMMENT '咨询类型，1电话咨询，2视频咨询',
  `content` varchar(3000) DEFAULT NULL COMMENT '咨询内容说明',
  `scheduling` varchar(50) DEFAULT NULL COMMENT '排班标识',
  `appo_date` datetime DEFAULT NULL COMMENT '预约日期',
  `appo_week` int(11) DEFAULT NULL COMMENT '预约星期',
  `hour_begin` time DEFAULT NULL COMMENT '预约开始时间',
  `hour_end` time DEFAULT NULL COMMENT '预约结束时间',
  `images` varchar(3000) DEFAULT NULL COMMENT '图片URL，多图逗号分隔',
  `status` int(11) DEFAULT NULL COMMENT '咨询状态：0待医生同意，-1医生拒绝，1医生同意，2咨询完成',
  `comment` varchar(50) DEFAULT NULL COMMENT '评论标识',
  `czrq` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '咨询时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_consult_movi_1` (`consult`),
  KEY `idx_wlyy_consult_movi_2` (`doctor`),
  KEY `idx_wlyy_consult_movi_3` (`patient`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='电话、视频咨询表';

/*Data for the table `wlyy_consult_movi` */

/*Table structure for table `wlyy_consult_movi_referral` */

DROP TABLE IF EXISTS `wlyy_consult_movi_referral`;

CREATE TABLE `wlyy_consult_movi_referral` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) NOT NULL COMMENT '视频咨询标识',
  `form_doctor` varchar(50) DEFAULT NULL COMMENT '转出医生标识',
  `form_doctor_name` varchar(100) NOT NULL COMMENT '转出医生姓名',
  `to_doctor` varchar(50) NOT NULL COMMENT '转入医生标识',
  `scheduling` varchar(50) DEFAULT NULL COMMENT '排班标识',
  `appo_date` date DEFAULT NULL COMMENT '预约日期',
  `appo_week` int(11) DEFAULT NULL COMMENT '预约星期',
  `hour_begin` time DEFAULT NULL COMMENT '预约开始时间',
  `hour_end` time DEFAULT NULL COMMENT '预约结束时间',
  `talk_time` int(11) DEFAULT '0' COMMENT '通话时长：分钟',
  `content` varchar(500) DEFAULT NULL COMMENT '转诊说明',
  `flag` int(11) DEFAULT '0' COMMENT '是否已转诊：1是，0否',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '转诊时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_consult_movi_referral_2` (`consult`,`to_doctor`),
  KEY `idx_wlyy_consult_movi_referral_1` (`consult`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='视频咨询转诊记录表';

/*Data for the table `wlyy_consult_movi_referral` */

/*Table structure for table `wlyy_consult_public` */

DROP TABLE IF EXISTS `wlyy_consult_public`;

CREATE TABLE `wlyy_consult_public` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) DEFAULT NULL COMMENT '咨询标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '咨询患者标识',
  `name` varchar(50) DEFAULT NULL COMMENT '患者姓名',
  `photo` varchar(300) DEFAULT NULL COMMENT '患者头像',
  `fbsj` varchar(50) DEFAULT NULL COMMENT '发病时间（如：1小时前）',
  `title` varchar(300) DEFAULT NULL COMMENT '问题标题',
  `content` varchar(1000) DEFAULT NULL COMMENT '问题描述',
  `images` varchar(3000) DEFAULT NULL COMMENT '图片URL，多图以逗号分隔',
  `amount` int(11) DEFAULT NULL COMMENT '回复数量',
  `unread` int(11) DEFAULT NULL COMMENT '未读数量',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '咨询时间',
  `del` varchar(1) DEFAULT NULL COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_consult_public_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=39 DEFAULT CHARSET=utf8mb4 COMMENT='公共咨询记录表';

/*Data for the table `wlyy_consult_public` */

insert  into `wlyy_consult_public`(`id`,`consult`,`patient`,`name`,`photo`,`fbsj`,`title`,`content`,`images`,`amount`,`unread`,`czrq`,`del`) values (1,'647e1753eb1d477cbdc1bab392191a8e','U20160322000001','李碧玉','','one week ago','this is question title','this is queston content','',4,3,'2016-05-25 09:19:16','1'),(2,'484bcbf413b24002b86627eb2b182c60','U20160322000001','李碧玉','','最近24小时','咳嗽','特别是晚上','http://120.41.251.85:8080/wlyy/uploadFiles\\wx_images\\2016\\05\\19\\20160519195820_148.png',4,4,'2016-05-25 09:21:52','1'),(3,'2a234400ab5147c9b8fb4a083bcad063','U20160322000003','窦怡宁','','最近24小时','sdfsdfdgfdg','dfgdfgdfgdf','',0,0,'2016-06-01 01:10:15','1'),(4,'3549b82a65cc4fd886ef9a545789b2e5','U20160322000003','窦怡宁','','最近24小时','sdfsdfsdfsdfsd','fsdfsdfsdfsd','',0,0,'2016-06-01 01:19:46','1'),(5,'64e2286583fe4098bd1a97b11cb812fb','U20160322000003','窦怡宁','','最近24小时','dfsdfsdfs','dgdfgdfgdf','',0,0,'2016-06-01 01:21:33','1'),(6,'44ffc8c295094b358f2b6b02eded79d2','U20160322000003','窦怡宁','','最近24小时','dfsdfsdfs','dgdfgdfgdf','',0,0,'2016-06-01 01:25:09','1'),(7,'1eb6e1bce3cc463880d66b51b9e552e0','U20160322000003','窦怡宁','','最近24小时','sdfsdf','aadfsdfsdfsdfdf','',0,0,'2016-06-01 01:26:56','1'),(8,'e24844b1fff145cb9223a6059822eef1','U20160322000003','窦怡宁','','最近三个月','teststwsssdfsdfsdfsdf','aaaaaasdfsdfsdfsd','',0,0,'2016-06-01 01:44:04','1'),(9,'2c752ce1faef48b2acc1492d4880e514','U20160322000003','窦怡宁','','最近24小时','sdfsdfsdfdsdgs','sdfsdfsdfsdf','',0,0,'2016-06-01 01:45:52','1'),(10,'e9d56a61565c44fe98af9a85277b9871','U20160322000003','窦怡宁','','最近24小时','fsdfsdfsdgdgsgda','gsdgsdgsdgfdgd','',0,0,'2016-06-01 01:47:11','1'),(11,'96126447705c481d9aaae751fe056515','U20160322000003','窦怡宁','','最近24小时','sdfsdfsadfassd','fsdfsdfsdfsdfsdfs','',0,0,'2016-06-01 01:48:57','1'),(12,'b0dec98ee6e14d9b89cbc56a5e4ee1c1','U20160322000003','窦怡宁','','最近24小时','aaaaaaaa','aaaaaaaaaaaaaa','',0,0,'2016-06-01 01:52:45','1'),(13,'97aaf2113e8648929b5a90d66e9f3796','U20160322000003','窦怡宁','','最近24小时','111112221','1111111111','',0,0,'2016-06-01 01:58:40','1'),(14,'0f5bb688f5ca465ca070d1a72037e6bf','U20160322000003','窦怡宁','','最近24小时','00000000000000000','111111111111111111111111111','',0,0,'2016-06-01 02:01:23','1'),(15,'3e7f3a5a250545268c50b2674f6a20cc','U20160322000003','窦怡宁','','最近24小时','00000000000000000','111111111111111111111111111','',0,0,'2016-06-01 02:07:47','1'),(16,'a0829f9a84374f07934dbe465fc599d4','U20160322000003','窦怡宁','','最近24小时','7777777777777777777777777777','7777777777777777777777777777777','',0,0,'2016-06-01 02:11:49','1'),(17,'6521abc096424ce68a33ae88905492d8','U20160322000001','李碧玉','','最近24小时','惊讶于iyouiofhghhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh','发士大夫士大夫撒大锅饭该管管','',0,0,'2016-06-01 06:08:24','1'),(18,'dea69050f0ec42d1afe6f78503664dbf','U20160322000002','张华','','最近24小时','发烧感冒流鼻涕','发烧发烧法华寺撒恐辐女啊数据开发卡死','',0,0,'2016-06-01 07:50:06','1'),(19,'f05ba96c5b784ec8b101ee7221586600','U20160322000002','张华','','最近24小时','咯Hey1红你定定','空位子定额1为您忒您','',0,0,'2016-06-01 07:57:13','1'),(20,'be279a617d7f40cc9f90aa311991ff0f','U20160322000002','黄晓明','2016/06/01/20160601102451_820.jpg','最近24小时','13232dsdsadsadsadsada','13212323ddddddddddddd','',1,1,'2016-06-02 15:20:02','1'),(21,'e864c4f39b7742f0969bcfb6245c4988','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','23132131233232','332312dsadadsadsadsadad','',0,0,'2016-06-02 13:03:47','1'),(22,'36fbd94c9eb841b6844d027ac991d741','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','23132131233232','332312dsadadsadsadsadadsdad','',0,0,'2016-06-02 13:06:12','1'),(23,'9265bf0f00154497bbdd7accd4daa557','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','23132131233232','111111111qwdqwdwqdsad','',0,0,'2016-06-02 13:06:45','1'),(24,'c61a4b166e9e49c882ae851cec7b3f1c','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','12332312312321313','2323131231321','',0,0,'2016-06-03 02:41:36','1'),(25,'37206ac4955040ef81e4a135ca244e77','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','111111111111111111111111111','11111111111111111111111111111','',0,0,'2016-06-03 02:42:00','1'),(26,'96c381487d4f4db7ad497b45f86fb7ff','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','22222222222222222222222222','2222222222222222','',0,0,'2016-06-03 02:42:18','1'),(27,'7add9f0372134c95abeca4636f2c28a5','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','22222222222222222222222222','2222222222222222','',0,0,'2016-06-03 02:42:28','1'),(28,'7963d4b88cc640fc809b50d2f6c8dd73','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','3333333333333333333333333','333333333333333333333333','',0,0,'2016-06-03 02:43:22','1'),(29,'7e6ec67ffdd74d768c85f86ac70d6acb','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','33333333333333333333','213323123132','',0,0,'2016-06-03 02:44:02','1'),(30,'bb269725677f4e718e4ea184d07555c4','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','33333333333333333333','2133231231321','',0,0,'2016-06-03 02:45:05','1'),(31,'f1726917fdfe47c6881a59507da409c2','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','111111111111111111111','32313313131231','',0,0,'2016-06-03 07:00:44','1'),(32,'d45ba09008f84c5791609c7384a0c52d','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','3123333333333333333333','111333333333333333333','',0,0,'2016-06-03 07:02:26','1'),(33,'f2b8ea5984dc4df0b894225b2ebedc52','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','111111111111111111111111','11111111111111111111','',0,0,'2016-06-03 07:03:01','1'),(34,'e00214ef3704435b8639a76eb86ae820','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','2222222222222','33333333333333','',0,0,'2016-06-03 07:08:14','1'),(35,'ae24efd6c3cd4305a4bb86bd1a3c1747','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','11111111111111111','2222222222222222','',1,1,'2016-06-14 02:34:13','1'),(36,'1e618fc268a04a3a8e2ac507f2922ca3','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','111111111111111','1111111111111','',0,0,'2016-06-03 07:30:40','1'),(37,'920d543363fc4bcb9de38cc3c94c1e4a','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','32321321321321312312','32321321312312312','',8,8,'2016-06-14 02:45:29','1'),(38,'b61e51ea081447f680700513f10aad70','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg','最近24小时','111111111111111111111111111111111','222222222222222222222222','',53,53,'2016-06-14 03:00:58','1');

/*Table structure for table `wlyy_consult_public_reply` */

DROP TABLE IF EXISTS `wlyy_consult_public_reply`;

CREATE TABLE `wlyy_consult_public_reply` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) NOT NULL COMMENT '交流标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '回复患者标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '回复医生标识',
  `name` varchar(50) DEFAULT NULL COMMENT '回复者姓名',
  `photo` varchar(300) DEFAULT NULL COMMENT '回复者头像',
  `content` varchar(3000) NOT NULL COMMENT '回复内容',
  `images` varchar(1000) DEFAULT NULL COMMENT '回复图片URL地址，多图以逗号分隔',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '回复时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_consult_public_reply_1` (`consult`)
) ENGINE=InnoDB AUTO_INCREMENT=72 DEFAULT CHARSET=utf8mb4 COMMENT='图文咨询、公共咨询、病友圈咨询回复记录表';

/*Data for the table `wlyy_consult_public_reply` */

insert  into `wlyy_consult_public_reply`(`id`,`consult`,`patient`,`doctor`,`name`,`photo`,`content`,`images`,`czrq`,`del`) values (1,'647e1753eb1d477cbdc1bab392191a8e',NULL,'D20160322000002','聂青\r\n','','this is reply content',NULL,'2016-05-19 08:52:04','1'),(2,'647e1753eb1d477cbdc1bab392191a8e',NULL,'D20160322000002','聂青\r\n','http://192.168.3.128/res/images/2016\\05\\20\\20160520085011_970.jpg','哈哈哈','http://172.19.103.77/res/images/2016/05/25/20160525005034_123.jpg','2016-05-25 00:50:34','1'),(3,'484bcbf413b24002b86627eb2b182c60',NULL,'D20160322000002','聂青\r\n','','发到啊啊','','2016-05-25 06:33:09','1'),(4,'647e1753eb1d477cbdc1bab392191a8e',NULL,'D20160322000002','聂青\r\n','','发疯','http://172.19.103.77/res/images/2016/05/25/20160525064326_352.jpg','2016-05-25 06:43:26','1'),(5,'647e1753eb1d477cbdc1bab392191a8e',NULL,'D20160322000002','聂青\r\n','','测试刷新数','http://172.19.103.77/res/images/2016/05/25/20160525091916_962.jpg','2016-05-25 09:19:16','1'),(6,'484bcbf413b24002b86627eb2b182c60',NULL,'D20160322000002','聂青\r\n','','天天爱测试','http://172.19.103.77/res/images/2016/05/25/20160525092024_953.jpg','2016-05-25 09:20:24','1'),(7,'484bcbf413b24002b86627eb2b182c60',NULL,'D20160322000002','聂青\r\n','','哎测试1','','2016-05-25 09:21:09','1'),(8,'484bcbf413b24002b86627eb2b182c60',NULL,'D20160322000002','聂青\r\n','','发疯','','2016-05-25 09:21:52','1'),(9,'be279a617d7f40cc9f90aa311991ff0f',NULL,'D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','其二','http://172.19.103.77/res/images/2016/06/02/20160602152002_447.jpg,http://172.19.103.77/res/images/2016/06/02/20160602152002_118.jpg','2016-06-02 15:20:02','1'),(10,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','我来测试多张图片','http://172.19.103.77/res/images/2016/06/07/20160607093751_142.jpg,http://172.19.103.77/res/images/2016/06/07/20160607093752_284.jpg,http://172.19.103.77/res/images/2016/06/07/20160607093752_137.jpg','2016-06-07 09:37:52','1'),(11,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','测试多张图片','http://172.19.103.77/res/images/2016/06/07/20160607094438_898.jpg,http://172.19.103.77/res/images/2016/06/07/20160607094438_816.jpg,http://172.19.103.77/res/images/2016/06/07/20160607094438_959.jpg','2016-06-07 09:44:38','1'),(12,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','测试多张图片','http://172.19.103.77/res/images/2016/06/08/20160608013859_128.jpg,http://172.19.103.77/res/images/2016/06/08/20160608013859_201.jpg,http://172.19.103.77/res/images/2016/06/08/20160608013859_74.jpg','2016-06-08 01:38:59','1'),(13,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','回复','','2016-06-14 01:29:39','1'),(14,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','22','','2016-06-14 01:31:01','1'),(15,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','22','','2016-06-14 01:31:47','1'),(16,'920d543363fc4bcb9de38cc3c94c1e4a',NULL,'D20160322000002','聂青\r\n','','33','','2016-06-14 01:37:55','1'),(17,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','33','','2016-06-14 01:41:30','1'),(18,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','44','','2016-06-14 01:42:17','1'),(19,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','55','','2016-06-14 01:42:31','1'),(20,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','66','','2016-06-14 01:43:05','1'),(21,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','77','','2016-06-14 01:43:23','1'),(22,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','哈哈哈','','2016-06-14 01:43:43','1'),(23,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','哈哈','','2016-06-14 01:44:07','1'),(24,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','77','','2016-06-14 01:45:55','1'),(25,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','233','','2016-06-14 01:48:23','1'),(26,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','55','','2016-06-14 01:49:27','1'),(27,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','66','','2016-06-14 01:50:01','1'),(28,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','22','http://172.19.103.77/res/images/2016/06/14/20160614015212_331.jpg','2016-06-14 01:52:13','1'),(29,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','22','','2016-06-14 01:53:24','1'),(30,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','99','','2016-06-14 01:53:45','1'),(31,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','33','','2016-06-14 01:54:21','1'),(32,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','33','','2016-06-14 01:54:22','1'),(33,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','66','','2016-06-14 01:54:39','1'),(34,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','77','','2016-06-14 01:59:30','1'),(35,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','88','','2016-06-14 02:00:05','1'),(36,'920d543363fc4bcb9de38cc3c94c1e4a',NULL,'D20160322000002','聂青\r\n','','44','','2016-06-14 02:02:06','1'),(37,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','123','','2016-06-14 02:03:22','1'),(38,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','111','','2016-06-14 02:04:10','1'),(39,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','222','','2016-06-14 02:05:35','1'),(40,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','333','','2016-06-14 02:05:54','1'),(41,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','33','','2016-06-14 02:07:17','1'),(42,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','222','','2016-06-14 02:08:01','1'),(43,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','333','','2016-06-14 02:08:47','1'),(44,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','44','','2016-06-14 02:09:33','1'),(45,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','44','','2016-06-14 02:10:36','1'),(46,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','44','','2016-06-14 02:12:18','1'),(47,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','6666','','2016-06-14 02:13:07','1'),(48,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','777','','2016-06-14 02:15:07','1'),(49,'920d543363fc4bcb9de38cc3c94c1e4a',NULL,'D20160322000002','聂青\r\n','','55','','2016-06-14 02:16:14','1'),(50,'920d543363fc4bcb9de38cc3c94c1e4a',NULL,'D20160322000002','聂青\r\n','','55','','2016-06-14 02:17:18','1'),(51,'920d543363fc4bcb9de38cc3c94c1e4a',NULL,'D20160322000002','聂青\r\n','','55\n','','2016-06-14 02:23:08','1'),(52,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','6667','','2016-06-14 02:24:03','1'),(53,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','7777','','2016-06-14 02:24:25','1'),(54,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','88','','2016-06-14 02:29:51','1'),(55,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','999','','2016-06-14 02:30:59','1'),(56,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','100','','2016-06-14 02:31:45','1'),(57,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','啊打发士大夫啊','','2016-06-14 02:32:39','1'),(58,'920d543363fc4bcb9de38cc3c94c1e4a',NULL,'D20160322000002','聂青\r\n','','阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬啊树','','2016-06-14 02:32:59','1'),(59,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','99','','2016-06-14 02:32:59','1'),(60,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','45','','2016-06-14 02:33:20','1'),(61,'ae24efd6c3cd4305a4bb86bd1a3c1747',NULL,'D20160322000002','聂青\r\n','','100','','2016-06-14 02:34:13','1'),(62,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','888','','2016-06-14 02:34:55','1'),(63,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','西海水世界是','','2016-06-14 02:35:49','1'),(64,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','接电话事实是','','2016-06-14 02:36:19','1'),(65,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','大概多少不打电话','','2016-06-14 02:36:38','1'),(66,'920d543363fc4bcb9de38cc3c94c1e4a',NULL,'D20160322000002','聂青\r\n','','对比吧BS','','2016-06-14 02:36:58','1'),(67,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','666','','2016-06-14 02:41:33','1'),(68,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','666','','2016-06-14 02:42:49','1'),(69,'920d543363fc4bcb9de38cc3c94c1e4a',NULL,'D20160322000002','聂青\r\n','','工作关系花王','','2016-06-14 02:45:29','1'),(70,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','阿德asda不能','','2016-06-14 02:48:49','1'),(71,'b61e51ea081447f680700513f10aad70',NULL,'D20160322000002','聂青\r\n','','66666','','2016-06-14 03:00:58','1');

/*Table structure for table `wlyy_consult_team` */

DROP TABLE IF EXISTS `wlyy_consult_team`;

CREATE TABLE `wlyy_consult_team` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) NOT NULL COMMENT '咨询标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '健康管理师标识',
  `team` varchar(50) DEFAULT NULL COMMENT '三师团队标识',
  `type` int(11) DEFAULT '2' COMMENT '1指定医生，2三师咨询',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `name` varchar(50) DEFAULT NULL COMMENT '患者姓名',
  `birthday` date DEFAULT NULL COMMENT '患者生日',
  `photo` varchar(300) DEFAULT NULL COMMENT '患者头像',
  `fbsj` varchar(30) DEFAULT NULL COMMENT '发病时间（如：最近3个月）',
  `symptoms` varchar(500) DEFAULT NULL COMMENT '主要症状',
  `status` int(11) DEFAULT NULL COMMENT '咨询状态（0进行中，1已完成，-1患者取消）',
  `images` varchar(3000) DEFAULT NULL COMMENT '咨询图片URL，多图以逗号分隔',
  `voice` varchar(300) DEFAULT NULL COMMENT '咨询语音URL',
  `comment` varchar(50) DEFAULT NULL COMMENT '用户评价标识',
  `comment_content` varchar(500) DEFAULT NULL COMMENT '用户评价内容',
  `comment_star` int(11) DEFAULT NULL COMMENT '用户评价星级',
  `doctor_read` int(11) DEFAULT NULL COMMENT '医生未读数量',
  `patient_read` int(11) DEFAULT NULL COMMENT '患者未读数量',
  `del` varchar(1) DEFAULT NULL COMMENT '作废标识，1正常，0作废',
  `czrq` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '咨询时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_consult_team_1` (`doctor`),
  KEY `idx_wlyy_consult_team_2` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='三师咨询';

/*Data for the table `wlyy_consult_team` */

insert  into `wlyy_consult_team`(`id`,`consult`,`doctor`,`team`,`type`,`patient`,`name`,`birthday`,`photo`,`fbsj`,`symptoms`,`status`,`images`,`voice`,`comment`,`comment_content`,`comment_star`,`doctor_read`,`patient_read`,`del`,`czrq`) values (1,'eaf5f669c720403bb35966f6ae1d3680','D20160322000002','2',2,'U20160322000001','李碧玉','1982-06-11','http://172.19.103.77:8080/wlyy/uploadFiles/images/2016/05/17/20160517005825_389.jpg','最近24小时','咳嗽',1,'','',NULL,NULL,0,7,0,'1','2016-05-19 07:26:28'),(2,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','2',2,'U20160322000001','李碧玉','1982-06-11','','最近24小时','咳嗽咳嗽，头晕难受的',1,'','',NULL,NULL,0,0,46,'1','2016-06-13 11:49:15'),(3,'a2adbea1eecb40508f837ac5030bd022','D20160322000002','1',2,'U20160322000003','窦怡宁','1971-09-23','','最近24小时','sdfsdfsdfsd',1,'','',NULL,NULL,0,0,6,'1','2016-06-13 11:38:30');

/*Table structure for table `wlyy_consult_team_doctor` */

DROP TABLE IF EXISTS `wlyy_consult_team_doctor`;

CREATE TABLE `wlyy_consult_team_doctor` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) DEFAULT NULL COMMENT '图文咨询标识',
  `form_doctor` varchar(50) DEFAULT NULL COMMENT '转出医生标识',
  `form_doctor_name` varchar(100) DEFAULT NULL COMMENT '转出医生姓名',
  `to_doctor` varchar(50) DEFAULT NULL COMMENT '接收医生标识',
  `reply` int(11) DEFAULT NULL COMMENT '是否有回复过',
  `czrq` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '转接时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='三师咨询转接给的医生记录';

/*Data for the table `wlyy_consult_team_doctor` */

insert  into `wlyy_consult_team_doctor`(`id`,`consult`,`form_doctor`,`form_doctor_name`,`to_doctor`,`reply`,`czrq`,`del`) values (1,'eaf5f669c720403bb35966f6ae1d3680',NULL,NULL,'D20160322000002',0,'2016-05-19 14:52:09','1'),(2,'f8ae771460d24ad6b95d5403d7964a11',NULL,NULL,'D20160322000002',1,'2016-05-25 05:36:45','1'),(3,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n',NULL,0,'2016-05-30 08:04:53','1'),(4,'a2adbea1eecb40508f837ac5030bd022',NULL,NULL,'D20160322000002',1,'2016-06-02 15:07:14','1');

/*Table structure for table `wlyy_consult_team_log` */

DROP TABLE IF EXISTS `wlyy_consult_team_log`;

CREATE TABLE `wlyy_consult_team_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `consult` varchar(50) DEFAULT NULL COMMENT '咨询标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '回复医生标识',
  `doctor_name` varchar(50) DEFAULT NULL COMMENT '回复医生姓名',
  `photo` varchar(300) DEFAULT NULL COMMENT '回复人头像',
  `content` varchar(3000) DEFAULT NULL COMMENT '回复内容/追问内容',
  `type` int(11) DEFAULT NULL COMMENT '类型，0问，1回复，2追问，3评价',
  `chat_type` int(11) DEFAULT '1' COMMENT '记录类型：1文字，2图片，3语音',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '操作时间',
  `del` varchar(1) DEFAULT NULL COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_consult_team_log_1` (`consult`)
) ENGINE=InnoDB AUTO_INCREMENT=75 DEFAULT CHARSET=utf8mb4 COMMENT='三师咨询日志表';

/*Data for the table `wlyy_consult_team_log` */

insert  into `wlyy_consult_team_log`(`id`,`consult`,`doctor`,`doctor_name`,`photo`,`content`,`type`,`chat_type`,`czrq`,`del`) values (1,'eaf5f669c720403bb35966f6ae1d3680',NULL,NULL,NULL,'发病时间：最近24小时<br>主要症状：咳嗽',0,1,'2016-05-19 06:52:06','1'),(2,'eaf5f669c720403bb35966f6ae1d3680',NULL,NULL,NULL,'咳嗽',2,1,'2016-05-19 14:52:49','1'),(3,'eaf5f669c720403bb35966f6ae1d3680',NULL,NULL,NULL,'咳嗽',2,1,'2016-05-19 14:52:58','1'),(4,'eaf5f669c720403bb35966f6ae1d3680',NULL,NULL,NULL,'咳嗽',2,1,'2016-05-19 14:53:05','1'),(5,'eaf5f669c720403bb35966f6ae1d3680',NULL,NULL,NULL,'咳嗽',2,1,'2016-05-19 14:53:14','1'),(6,'eaf5f669c720403bb35966f6ae1d3680',NULL,NULL,NULL,'咳嗽',2,1,'2016-05-19 14:53:21','1'),(7,'eaf5f669c720403bb35966f6ae1d3680',NULL,NULL,NULL,'咳嗽',2,1,'2016-05-19 14:53:32','1'),(8,NULL,NULL,NULL,NULL,'d\'d',2,1,'2016-05-21 11:26:47','1'),(9,NULL,NULL,NULL,NULL,'ddd',2,1,'2016-05-21 11:36:45','1'),(10,NULL,NULL,NULL,NULL,'ddd',2,1,'2016-05-21 11:37:32','1'),(11,'f8ae771460d24ad6b95d5403d7964a11',NULL,NULL,NULL,'发病时间：最近24小时<br>主要症状：咳嗽咳嗽，头晕难受的',0,1,'2016-05-25 00:50:33','1'),(12,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','file:///mnt/sdcard/haimawan/download/advert.jpg',1,2,'2016-05-25 05:36:45','1'),(13,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','_doc/audio/1464154633228.amr',1,3,'2016-05-25 05:37:05','1'),(14,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','好的',1,1,'2016-05-25 05:37:20','1'),(15,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','恩恩额',1,1,'2016-05-25 05:37:32','1'),(16,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','_doc/audio/1464160054157.amr',1,3,'2016-05-25 07:07:28','1'),(17,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','_doc/audio/1464160069214.amr',1,3,'2016-05-25 07:07:41','1'),(18,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','file:///mnt/sdcard/haimawan/download/advert.jpg',1,2,'2016-05-25 07:07:51','1'),(19,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','file:///mnt/sdcard/haimawan/download/advert.jpg',1,2,'2016-05-25 07:10:34','1'),(20,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','啊打发',1,1,'2016-05-25 07:11:18','1'),(21,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','file:///mnt/sdcard/haimawan/download/advert.jpg',1,2,'2016-05-25 07:12:34','1'),(22,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','_doc/audio/1464160376966.amr',1,3,'2016-05-25 07:12:49','1'),(23,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','file:///mnt/sdcard/haimawan/download/advert.jpg',1,2,'2016-05-25 08:48:40','1'),(24,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','file:///mnt/sdcard/haimawan/download/advert.jpg',1,2,'2016-05-25 08:48:56','1'),(25,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','file:///mnt/sdcard/haimawan/download/advert.jpg',1,2,'2016-05-25 08:49:45','1'),(26,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','啊啊的身份阿斯顿阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬额发士大夫阿斯蒂芬',1,1,'2016-05-27 06:59:35','1'),(27,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','士大夫阿斯蒂芬阿斯蒂芬阿斯顿',1,1,'2016-05-27 07:01:04','1'),(28,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','地方爱的色放',1,1,'2016-05-27 07:01:18','1'),(29,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','啊啊对方啊',1,1,'2016-05-27 07:39:53','1'),(30,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','第三方',1,1,'2016-05-30 01:19:11','1'),(31,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','阿凡达',1,1,'2016-05-30 01:19:24','1'),(32,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','啊',1,1,'2016-05-30 01:20:20','1'),(33,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','大大',1,1,'2016-05-30 01:20:25','1'),(34,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','阿德',1,1,'2016-05-30 01:20:58','1'),(35,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','file:///storage/emulated/0/Android/data/io.dcloud.HBuilder/.HBuilder/apps/HBuilder/doc/1464571381173.jpg',1,2,'2016-05-30 01:22:52','1'),(36,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','_doc/audio/1464571406022.amr',1,3,'2016-05-30 01:23:15','1'),(37,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','天天',1,1,'2016-05-30 01:25:55','1'),(38,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','谔谔阿道夫阿斯顿发士大夫阿斯蒂芬阿斯蒂芬阿瑟瑞发阿斯蒂芬阿斯蒂芬阿斯蒂芬啊俄方',1,1,'2016-05-30 01:26:02','1'),(39,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','啊啊啊',1,1,'2016-05-30 01:31:01','1'),(40,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','微软犬瘟热犬瘟热请问对方爱的色放',1,1,'2016-05-30 01:31:06','1'),(41,'undefined','D20160322000002','聂青\r\n','','阿道夫',1,1,'2016-05-30 01:44:39','1'),(42,'undefined','D20160322000002','聂青\r\n','','谔谔',1,1,'2016-05-30 01:44:42','1'),(43,'undefined','D20160322000002','聂青\r\n','','阿德阿德啊',1,1,'2016-05-30 01:44:47','1'),(44,'undefined','D20160322000002','聂青\r\n','','爱的色放阿',1,1,'2016-05-30 01:47:59','1'),(45,'undefined','D20160322000002','聂青\r\n','','谔谔 额',1,1,'2016-05-30 01:48:02','1'),(46,'undefined','D20160322000002','聂青\r\n','','额阿德啊',1,1,'2016-05-30 01:48:04','1'),(47,'undefined','D20160322000002','聂青\r\n','','地方阿道夫爱的色放阿斯蒂芬阿斯蒂芬爱的色放',1,1,'2016-05-30 01:48:30','1'),(48,'undefined','D20160322000002','聂青\r\n','','阿爱的色放阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬爱的色放士大夫分为发射点发射点发阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬啊沙发沙发',1,1,'2016-05-30 01:48:39','1'),(49,'undefined','D20160322000002','聂青\r\n','','file:///storage/emulated/0/Android/data/io.dcloud.HBuilder/.HBuilder/apps/HBuilder/doc/1464572960231.jpg',1,2,'2016-05-30 01:49:13','1'),(50,'undefined','D20160322000002','聂青\r\n','','啊',1,1,'2016-05-30 01:59:02','1'),(51,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','',1,2,'2016-05-30 07:50:51','1'),(52,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','',1,2,'2016-05-30 07:52:55','1'),(53,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','',1,2,'2016-05-30 07:53:27','1'),(54,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','',1,2,'2016-05-30 07:54:29','1'),(55,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','',1,3,'2016-05-30 07:55:49','1'),(56,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','哈哈哈',1,1,'2016-05-30 07:56:09','1'),(57,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','',1,2,'2016-05-30 08:10:32','1'),(58,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','就',1,1,'2016-05-30 08:24:49','1'),(59,'a2adbea1eecb40508f837ac5030bd022',NULL,NULL,NULL,'发病时间：最近24小时<br>主要症状：sdfsdfsdfsd',0,1,'2016-05-31 06:07:25','1'),(60,'a2adbea1eecb40508f837ac5030bd022','D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','发啊',1,1,'2016-06-02 15:07:14','1'),(61,'a2adbea1eecb40508f837ac5030bd022','D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','',1,2,'2016-06-02 15:09:25','1'),(62,'a2adbea1eecb40508f837ac5030bd022','D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','',1,2,'2016-06-02 15:14:07','1'),(63,'a2adbea1eecb40508f837ac5030bd022','D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','http://172.19.103.77/res/images/2016/06/02/20160602151537_603.jpg',1,2,'2016-06-02 15:15:38','1'),(64,'a2adbea1eecb40508f837ac5030bd022','D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','http://172.19.103.77/res/images/2016/06/02/20160602151908_496.jpg',1,2,'2016-06-02 15:19:08','1'),(65,'a2adbea1eecb40508f837ac5030bd022','D20160322000002','聂青\r\n','http://172.19.103.77/res/images/2016/06/02/20160602150608_745.jpg','2016/06/02/20160602151921_979.amr',1,3,'2016-06-02 15:19:21','1'),(66,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','http://172.19.103.77/res/images/2016/06/13/20160613075920_951.jpg',1,2,'2016-06-13 07:59:20','1'),(67,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','2016/06/13/20160613075929_774.amr',1,3,'2016-06-13 07:59:29','1'),(68,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','http://172.19.103.77/res/images/2016/06/13/20160613075938_708.jpg',1,2,'2016-06-13 07:59:38','1'),(69,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','http://172.19.103.77/res/images/2016/06/13/20160613080310_258.jpg',1,2,'2016-06-13 08:03:10','1'),(70,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','http://172.19.103.77/res/images/2016/06/13/20160613081006_248.jpg',1,2,'2016-06-13 08:10:06','1'),(71,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','2016/06/13/20160613081020_198.amr',1,3,'2016-06-13 08:10:20','1'),(72,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','天天啊测试',1,1,'2016-06-13 08:11:59','1'),(73,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','阿凡达',1,1,'2016-06-13 08:12:53','1'),(74,'f8ae771460d24ad6b95d5403d7964a11','D20160322000002','聂青\r\n','','http://172.19.103.77/res/images/2016/06/13/20160613081257_325.jpg',1,2,'2016-06-13 08:12:57','1');

/*Table structure for table `wlyy_doctor` */

DROP TABLE IF EXISTS `wlyy_doctor`;

CREATE TABLE `wlyy_doctor` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '医生标识',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `sex` int(11) DEFAULT NULL COMMENT '性别（1男，2女）',
  `birthday` date DEFAULT NULL COMMENT '生日',
  `photo` varchar(100) DEFAULT NULL COMMENT '头像http地址',
  `mobile` varchar(20) NOT NULL COMMENT '手机号',
  `password` varchar(50) NOT NULL COMMENT '密码',
  `salt` varchar(50) DEFAULT NULL,
  `status` int(11) NOT NULL DEFAULT '1' COMMENT '状态（1正常，0禁用）',
  `province` varchar(50) DEFAULT NULL COMMENT '省',
  `city` varchar(50) DEFAULT NULL COMMENT '市',
  `hospital` varchar(50) DEFAULT NULL COMMENT '医院标识',
  `dept` varchar(50) DEFAULT NULL COMMENT '科室标识',
  `job` varchar(50) DEFAULT NULL COMMENT '职称',
  `expertise` varchar(300) DEFAULT NULL COMMENT '医生专长',
  `introduce` varchar(3000) DEFAULT NULL COMMENT '医生介绍',
  `level` int(11) DEFAULT '0' COMMENT '类型：1专科医生，2全科医生，3健康管理师',
  `czrq` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `iscertified` int(11) NOT NULL DEFAULT '0' COMMENT '资格是否认证通过，1是，0否',
  `qrcode` varchar(30) DEFAULT NULL COMMENT '二维码',
  `province_name` varchar(50) DEFAULT NULL COMMENT '省名称',
  `city_name` varchar(50) DEFAULT NULL COMMENT '市名称',
  `hospital_name` varchar(50) DEFAULT NULL COMMENT '医院名称',
  `dept_name` varchar(50) DEFAULT NULL COMMENT '科室名称',
  `job_name` varchar(50) DEFAULT NULL COMMENT '职称名称',
  `town` varchar(50) DEFAULT NULL COMMENT '区县标识',
  `town_name` varchar(50) DEFAULT NULL COMMENT '区县名称',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_doctor_info_uid` (`code`),
  UNIQUE KEY `idx_wlyy_doctor_info_2` (`mobile`,`password`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='医生信息表';

/*Data for the table `wlyy_doctor` */

insert  into `wlyy_doctor`(`id`,`code`,`name`,`sex`,`birthday`,`photo`,`mobile`,`password`,`salt`,`status`,`province`,`city`,`hospital`,`dept`,`job`,`expertise`,`introduce`,`level`,`czrq`,`iscertified`,`qrcode`,`province_name`,`city_name`,`hospital_name`,`dept_name`,`job_name`,`town`,`town_name`) values (1,'D20160322000001','徐小鹏',1,'1955-07-15','','13693066634','6e335b853b1ed99622d2cbdaed37d3424f36f6fe','e17354680a03a774',1,'350000','350200','3502030400\r\n','','','在高血压、冠心病、风心、心肌炎等领域具有较深造诣，尤其在高血压和冠心病的介入诊疗技术形成了自己的专业技术特色。\r\n','能熟练内科操作，对常见的心脏病的超声特点和诊断较熟悉。近来担任\"诊断学\"及\"内科学\"的教学工作，取得较好成绩。已发表\"上海市部分居民高血压的调查\"、\"老年收缩期高血压患者超声心动图特点\"、\"西拉普利的降压疗效\"、\"24小时动态血压监测评估硝苯啶缓释片降压效果\"等学术论文。',1,'2016-06-15 02:39:17',0,'1','福建省','厦门市','莲前第一社区医疗服务中心\r\n','心血管内科','主任医师','350203','思明区'),(2,'D20160322000002','聂青\r\n',1,'1955-07-15','http://172.19.103.77/res/images/2016/06/14/20160614094729_996.jpg','18512345678','6e335b853b1ed99622d2cbdaed37d3424f36f6fe','e17354680a03a774',1,'350000','350200','3502060400','','','呼吸系统的常见病、多发病如上呼吸道感染、支气管哮喘、慢性阻塞性肺疾病、支气管扩张等能够较为熟练地结合中医辨证与西医辨病两套方法进行诊治','从事呼吸病临床及实验研究工作十年余，先后参加国家级、省部级多项课题的研究，在科室积极开展的中医特色疗法如穴位注射和敷贴、中药雾化等，疗效显著，对疑难疾病的诊治能坚持自己的观点，和科室同仁一道成功抢救许多肺心病、肺性脑病和呼吸衰竭等危重患者。',1,'2016-06-15 02:40:34',0,NULL,'福建省','厦门市','金山社区医疗服务中心\r\n','呼吸内科','主任医师','350206','湖里区'),(3,'D20160322000003','江燕\r\n',1,'1955-07-15','','13245678978','6e335b853b1ed99622d2cbdaed37d3424f36f6fe','e17354680a03a774',1,'350000','350200','3502030500','','','多胎妊娠。高危产科。胎儿异常。母胎血型不合。优生咨询及孕期用药咨询。产前筛查、产前诊断、胎儿宫内健康评估、宫内治疗（宫内输血，激光手术，减胎，羊水减量，羊水灌注，胎儿引流，胎儿活检等）。\r\n','英国胎儿医学基金会评审专家及培训专家。中华围产医学会胎儿学组委员，广东省围产医学会产前诊断学组副组长。国内第一位赴英国接受规范化胎儿医学培训的专家。\r\n',1,'2016-06-15 02:44:05',0,NULL,'福建省','厦门市','嘉莲社区医疗服务中心\r\n','产科门诊','主任医师','350203','思明区');

/*Table structure for table `wlyy_doctor_address` */

DROP TABLE IF EXISTS `wlyy_doctor_address`;

CREATE TABLE `wlyy_doctor_address` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '地址标识',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识，关联wlyy_doctor表',
  `dept` varchar(50) NOT NULL COMMENT '所在科室',
  `province` varchar(50) DEFAULT NULL COMMENT '省标识',
  `city` varchar(50) DEFAULT NULL COMMENT '市标识',
  `town` varchar(50) DEFAULT NULL COMMENT '区县标识',
  `address` varchar(100) NOT NULL COMMENT '地址',
  `state` int(11) DEFAULT NULL COMMENT '当前所在位置，1是，0否',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_doctor_address_uid` (`doctor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医生工作地址';

/*Data for the table `wlyy_doctor_address` */

/*Table structure for table `wlyy_doctor_comment` */

DROP TABLE IF EXISTS `wlyy_doctor_comment`;

CREATE TABLE `wlyy_doctor_comment` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '评价标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识，关联wlyy_doctor表',
  `dname` varchar(100) DEFAULT NULL COMMENT '医生姓名',
  `user` varchar(50) DEFAULT NULL COMMENT '用户标识，关联wlyy_patient表',
  `uname` varchar(50) DEFAULT NULL COMMENT '评价人姓名',
  `content` varchar(300) DEFAULT NULL COMMENT '评价内容',
  `star` int(11) DEFAULT NULL COMMENT '星级',
  `type` int(11) DEFAULT NULL COMMENT '评价类型：1视频咨询评价、2图文咨询评价',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '评价时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_doctor_comment_doctor` (`doctor`),
  KEY `wlyy_doctor_comment_user` (`user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医生评价表';

/*Data for the table `wlyy_doctor_comment` */

/*Table structure for table `wlyy_doctor_medical_records_part` */

DROP TABLE IF EXISTS `wlyy_doctor_medical_records_part`;

CREATE TABLE `wlyy_doctor_medical_records_part` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '片段标识',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识，空表示是系统片段',
  `name` varchar(100) NOT NULL COMMENT '片段名称',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) NOT NULL DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_doctor_medical_records_part_1` (`doctor`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8mb4 COMMENT='医生病历片段类型表';

/*Data for the table `wlyy_doctor_medical_records_part` */

insert  into `wlyy_doctor_medical_records_part`(`id`,`code`,`doctor`,`name`,`czrq`,`del`) values (1,'1','D20160322000002','高血压','2016-05-14 06:31:18','1'),(2,'4a131dbc9f4f4ab5af55482f7df4cf32','D20160322000002','糖尿病','2016-05-17 10:58:22','1'),(3,'8338f8d680cb408780a01ee84dee0080','D20160322000002','糖尿病','2016-05-17 10:58:40','1'),(4,'cde05335f82143e8afebb1f29724cd29','D20160322000002','糖尿病','2016-05-17 11:01:42','1'),(5,'329bf10449704b3296840aed0f94b017','D20160322000002','糖尿病','2016-05-17 11:02:11','1'),(6,'c55c0322137b4d209a82045dabd74556','D20160322000002','糖尿病','2016-05-17 11:12:15','1'),(7,'988eee2d07ec4779aa7b86fcb1b980d6','D20160322000002','aa','2016-05-17 11:14:43','1'),(8,'224649589e72473ebe2c7d1b5fe47c30','D20160322000002','tangniaobing','2016-05-17 11:15:53','1'),(9,'e2cf5dcf687843ea8c0f7cec069cf153','D20160322000002','tangniaobing','2016-05-17 11:17:38','1'),(10,'c9b41b71d6f345d8bdd7d94e3066a2ac','D20160322000002','xue','2016-05-17 11:22:16','1'),(11,'c8adba69ed434627bce7f332933d60ff','D20160322000002','xue','2016-05-17 11:23:04','1'),(12,'c8f6a00cce924df59448a47e94f4221e','D20160322000002','糖尿病','2016-05-17 13:27:20','1'),(13,'a8ccfbcc606f4c9390f27da34040f687','D20160322000002','糖尿病','2016-05-17 13:29:12','1'),(14,'9f8da2229da9421b9f4939f653b2640c','D20160322000002','糖尿病','2016-05-18 01:38:42','1'),(15,'c6a42cac50a84a1ebd9294c50ee97baa','D20160322000002','糖尿病','2016-05-18 01:38:50','1'),(24,'832baad956064a2684b70b27282fc06e','D20160322000002','天天爱测试','2016-05-24 12:53:23','1'),(25,'45d89ea7ac8445c0b427cbebd129c8a9','D20160322000002','天天斗地主','2016-05-24 13:00:13','1'),(26,'46ce036ca487427381f950a68a197c22','D20160322000002','我的命发发发大地方阿斯蒂芬阿斯啊的说法阿','2016-05-25 09:34:02','1');

/*Table structure for table `wlyy_doctor_medical_records_part_item` */

DROP TABLE IF EXISTS `wlyy_doctor_medical_records_part_item`;

CREATE TABLE `wlyy_doctor_medical_records_part_item` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识,为空为系统定义',
  `part` varchar(50) NOT NULL COMMENT '片段标识',
  `part_name` varchar(100) NOT NULL COMMENT '片段名称',
  `content` varchar(500) NOT NULL COMMENT '片段内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) NOT NULL DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_doctor_medical_records_part_item_1` (`part`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COMMENT='医生病历片段明细表';

/*Data for the table `wlyy_doctor_medical_records_part_item` */

insert  into `wlyy_doctor_medical_records_part_item`(`id`,`doctor`,`part`,`part_name`,`content`,`czrq`,`del`) values (1,'D20160322000002','1','高血压','保持良好心态！','2016-05-14 06:31:46','1'),(2,'D20160322000002','12eae0d0dabb4d0395c79279051be167','tan','faf','2016-05-18 01:48:58','1'),(3,'D20160322000002','343ebfd2eb2c47818703c9a616cff2e2','tang','a糖尿病','2016-05-18 01:50:43','1'),(4,'D20160322000002','15309e9f32d24ec79268069d1226c356','20160517片段记录','糖尿病患者应以低糖或无糖为主，平时多运动锻炼','2016-05-18 02:28:37','1'),(5,'D20160322000002','15309e9f32d24ec79268069d1226c356','20160517片段记录','糖尿病患者应以低糖或无糖为主，平时多运动锻炼','2016-05-18 02:31:30','1'),(6,'D20160322000002','15309e9f32d24ec79268069d1226c356','20160517片段记录','糖尿病患者应以低糖或无糖为主，平时多运动锻炼','2016-05-18 02:44:52','1'),(7,'D20160322000002','15309e9f32d24ec79268069d1226c356','20160517片段记录','糖尿病患者应以低糖或无糖为主，平时多运动锻炼','2016-05-18 02:46:19','1'),(8,'D20160322000002','08de64e31b6848bb8154185ec08629e5','片段记录1','片段记录内容：糖尿病的注意内容是。。。','2016-05-19 09:56:47','1'),(9,'D20160322000002','46ce036ca487427381f950a68a197c22','我的命发发发大地方阿斯蒂芬阿斯啊的说法阿','啊打发发到阿道夫大大','2016-05-25 09:44:53','1'),(10,'D20160322000002','9f8da2229da9421b9f4939f653b2640c','糖尿病','糖尿病','2016-05-25 09:50:57','1'),(11,'D20160322000002','9f8da2229da9421b9f4939f653b2640c','糖尿病','糖尿病','2016-05-25 09:55:09','1'),(12,'D20160322000002','224649589e72473ebe2c7d1b5fe47c30','tangniaobing','天天糖尿病','2016-05-25 09:55:29','1');

/*Table structure for table `wlyy_doctor_patient_group` */

DROP TABLE IF EXISTS `wlyy_doctor_patient_group`;

CREATE TABLE `wlyy_doctor_patient_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '业务主键',
  `name` varchar(50) NOT NULL COMMENT '组名',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `status` int(11) DEFAULT '1' COMMENT '状态（1正常，0删除）',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_doctor_patient_group_1` (`doctor`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=61 DEFAULT CHARSET=utf8mb4 COMMENT='患者分组表';

/*Data for the table `wlyy_doctor_patient_group` */

insert  into `wlyy_doctor_patient_group`(`id`,`code`,`name`,`doctor`,`czrq`,`status`) values (1,'1','高血压',NULL,'2016-05-05 11:38:18',1),(2,'2','糖尿病',NULL,'2016-05-05 11:39:17',1),(3,'other','我的患者',NULL,'2016-05-05 11:40:17',1),(18,'85702905d1674b3889ed00789ad8a674','分组1','D20160322000002','2016-05-13 01:23:44',0),(19,'f5107689a6814b45b734a9d767078094','把','D20160322000002','2016-05-17 12:23:16',0),(20,'31d7cf0ddef04ea98e42a68fe246aa05','高压1','D20160322000002','2016-05-18 01:25:03',0),(21,'f40890172a3f40d493ed926dc9e4a7cd','*********','D20160322000002','2016-05-17 12:40:32',0),(22,'7a8e25b05fdd46f3b5feb2d11a323eea','放寒假火凤凰哼哼唧唧姐姐姐夫法国红酒枋湖计划经济句u','D20160322000002','2016-05-17 12:40:27',0),(23,'9018b9418d2743c2ac781a84dfcedbae','~哼哼唧唧计划经济喝牛奶你扭扭捏捏扭扭捏捏扭扭捏捏','D20160322000002','2016-05-17 12:40:30',0),(24,'ebca055600c24c65970b757e6895705e','收拾收拾','D20160322000002','2016-05-18 01:24:56',0),(25,'7a3d922b24924ad1842f4ba728901871','泪流满面了泪流满面','D20160322000002','2016-05-18 01:24:06',0),(26,'071e9cfaa0de4f6991976bdb287fb8f1','123456789012345678901234567890','D20160322000002','2016-05-17 13:50:41',0),(27,'9cb23649a7db4b1b880ff6a6647c0b85','1234567890123456789012345678901','D20160322000002','2016-05-17 13:50:55',0),(28,'10a036c38839491bac5acddecf9f2995','12345678901234567890123456789012345','D20160322000002','2016-05-17 13:45:55',0),(29,'7e7e5d97016b4195938e7f8ac422eaff','还是上班不会好好说说宿舍睡觉斤哈哈哈事实','D20160322000002','2016-05-18 01:25:00',0),(30,'155cbd7f750a442abeac5df4ae7a5e8f','寿司君的店记得记得舅舅家看额呵呵呵斤是手','D20160322000002','2016-05-18 01:24:09',0),(31,'3ccd403823954aafa16445863f6dee00','事实是家电家具','D20160322000002','2016-05-19 08:45:41',0),(32,'9744332a6dd345d2a6148b5320635470','是手机','D20160322000002','2016-05-18 00:38:02',0),(33,'6992a8b2c4134691884bee21e79cb09e','faa','D20160322000002','2016-05-18 00:37:58',0),(34,'0c59840dfc63495bb89c6e5839023a89','467%','D20160322000002','2016-05-18 01:19:28',0),(35,'0867503b4b9b48da8d758d0454f2f24c','$#','D20160322000002','2016-05-18 01:19:33',0),(36,'2b4e03c7c91a47f495d9221a077e32d4','^','D20160322000002','2016-05-18 01:20:01',0),(37,'9e226d10181d456c83c4a0eab22d638e','223@','D20160322000002','2016-05-18 01:22:03',0),(38,'827ccefdf2264129b5274150f106fa6f','fadsfasdf','D20160322000002','2016-05-18 01:24:46',0),(39,'1d6ba756aa384513ac08885df9e869b3','df','D20160322000002','2016-05-18 01:19:57',0),(40,'d2afff3cc9024d1ab2e314f216d391da','aa','D20160322000002','2016-05-18 01:24:15',0),(41,'e32ca87dc91d4efd9dd43f4a30d9a043','aa','D20160322000002','2016-05-18 01:31:53',0),(42,'2281e72ab9bc4049912bbf615562385d','afa','D20160322000002','2016-05-18 01:31:56',0),(43,'6e931e25865642bebd308547123bfa28','dfa','D20160322000002','2016-05-18 01:31:44',0),(44,'ffbc81087ec84e46a054ee3330ff45b2','高压1组','D20160322000002','2016-06-13 15:43:03',0),(45,'80bf143ef574465caf73dc7558724f32','高压2组','D20160322000002','2016-06-13 15:43:06',0),(46,'5731b2c81a014209a0ce8daaec1dcd6e','1','D20160322000002','2016-05-18 02:27:40',0),(47,'033fa94c18f64ca98375e21970b4e1c7','2','D20160322000002','2016-05-18 02:27:42',0),(48,'cd9e0e58352d49f8beccd516205e26bf','3','D20160322000002','2016-05-18 02:27:44',0),(49,'d7006fc548094a20b4714a4c14535035','4','D20160322000002','2016-05-18 02:27:46',0),(50,'df7d318c133d44e38a150ff441f80245','5','D20160322000002','2016-05-18 02:27:48',0),(51,'b3b4cece181243a0b989d15fa23434a9','5','D20160322000002','2016-05-18 02:27:51',0),(52,'7352a7a4eb434b02b42debb9becf5140','高崎','D20160322000002','2016-05-18 11:25:28',0),(53,'4df2b52d817f47b1b2bf59fea7b14410','高崎','D20160322000002','2016-05-18 11:25:24',0),(54,'8b5a76c3f1b644b5984eb47cbe55cc23','高崎','D20160322000002','2016-05-18 11:25:21',0),(55,'1badb13d23dd4cd89896ff32b2cddb71','高崎','D20160322000002','2016-05-18 11:25:18',0),(56,'346748d499db43ea832adb056bff52e2','高糖','D20160322000002','2016-05-18 11:25:15',0),(57,'fab2857753ac4f4ca84dc1f315670abc','分组1','D20160322000002','2016-05-18 11:26:06',0),(58,'c56a56132dbd4184a5a033665bd37758','zazaza','D20160322000002','2016-05-19 08:44:36',0),(59,'17f127dd2f2e4a25b3a63015449bc848','fadf','D20160322000002','2016-05-19 08:45:36',0),(60,'ed1cd8422e984533a2717960e80da424','“”','D20160322000002','2016-05-19 08:45:57',0);

/*Table structure for table `wlyy_doctor_patient_group_info` */

DROP TABLE IF EXISTS `wlyy_doctor_patient_group_info`;

CREATE TABLE `wlyy_doctor_patient_group_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `pname` varchar(100) DEFAULT NULL COMMENT '患者姓名',
  `group_code` varchar(50) DEFAULT NULL COMMENT '组编号（wlyy_doctor_patient_group的业务主键code）',
  `record_amount` int(11) DEFAULT '0' COMMENT '病历记录数',
  `part_amount` int(11) DEFAULT '0' COMMENT '病历片段数',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `status` int(11) DEFAULT '1' COMMENT '状态（1正常，0删除）',
  `dqrq` date DEFAULT NULL COMMENT '到期时间',
  `qyrq` date DEFAULT NULL COMMENT '签约日期/已诊日期',
  `sign_type` varchar(1) DEFAULT NULL COMMENT '签约类型（1表示三师签约，2表示家庭签约）',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_doctor_patient_group_info_1` (`doctor`,`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8mb4 COMMENT='患者分组明细表';

/*Data for the table `wlyy_doctor_patient_group_info` */

insert  into `wlyy_doctor_patient_group_info`(`id`,`doctor`,`patient`,`pname`,`group_code`,`record_amount`,`part_amount`,`czrq`,`status`,`dqrq`,`qyrq`,`sign_type`) values (1,'D20160322000002','U20160322000001','李碧玉','other',0,16,'2016-06-08 10:00:16',1,NULL,'2016-04-27','1'),(2,'D20160322000002','U20160322000002','张华','other',0,0,'2016-06-08 10:00:17',1,NULL,'2016-04-27','1'),(4,'D20160322000002','U20160322000004','赖小娜','other',0,0,'2016-06-08 10:00:15',1,NULL,'2016-04-27','1');

/*Table structure for table `wlyy_doctor_scheduling` */

DROP TABLE IF EXISTS `wlyy_doctor_scheduling`;

CREATE TABLE `wlyy_doctor_scheduling` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '排班标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识/团队标识',
  `week` int(11) DEFAULT NULL COMMENT '星期几（1~7）',
  `hour_begin` time DEFAULT NULL COMMENT '排班开始时间',
  `hour_end` time DEFAULT NULL COMMENT '排班结束时间',
  `times` int(11) DEFAULT '-1' COMMENT '可预约次数',
  `type` int(11) DEFAULT NULL COMMENT '排班类型：1视频预约',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '排班操作时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_doctor_scheduling_2` (`code`),
  KEY `idx_wlyy_doctor_scheduling_1` (`doctor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医生排班表';

/*Data for the table `wlyy_doctor_scheduling` */

/*Table structure for table `wlyy_doctor_scheduling_times` */

DROP TABLE IF EXISTS `wlyy_doctor_scheduling_times`;

CREATE TABLE `wlyy_doctor_scheduling_times` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `scheduling` varchar(50) DEFAULT NULL COMMENT '排班标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `appo_date` date DEFAULT NULL COMMENT '预约日期：如2016-04-23',
  `times` int(11) DEFAULT NULL COMMENT '预约次数',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '操作时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_doctor_scheduling_times_1` (`scheduling`,`appo_date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医生排班预约次数表';

/*Data for the table `wlyy_doctor_scheduling_times` */

/*Table structure for table `wlyy_doctor_service` */

DROP TABLE IF EXISTS `wlyy_doctor_service`;

CREATE TABLE `wlyy_doctor_service` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `service` varchar(50) NOT NULL COMMENT '服务标识（关联dm_service的code）',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识',
  `logo` varchar(300) NOT NULL COMMENT '服务LOGO http url',
  `title` varchar(100) NOT NULL COMMENT '服务标题',
  `content` varchar(200) NOT NULL COMMENT '服务介绍',
  `url` varchar(300) NOT NULL COMMENT '服务访问地址',
  `czrq` datetime NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_doctor_service_1` (`doctor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医生服务';

/*Data for the table `wlyy_doctor_service` */

/*Table structure for table `wlyy_doctor_statistics_comment` */

DROP TABLE IF EXISTS `wlyy_doctor_statistics_comment`;

CREATE TABLE `wlyy_doctor_statistics_comment` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识',
  `date` int(11) NOT NULL COMMENT '年月，如201601',
  `type` int(11) NOT NULL COMMENT '类型：1三师咨询（指定咨询），2视频咨询',
  `one_star` int(11) DEFAULT '0' COMMENT '1星总数',
  `two_star` int(11) DEFAULT '0' COMMENT '2星总数',
  `three_star` int(11) DEFAULT '0' COMMENT '3星总数',
  `four_star` int(11) DEFAULT '0' COMMENT '4星总数',
  `five_star` int(11) DEFAULT '0' COMMENT '5星总数',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_doctor_statistics_comment_1` (`doctor`,`date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医生评价统计表';

/*Data for the table `wlyy_doctor_statistics_comment` */

/*Table structure for table `wlyy_doctor_statistics_consult` */

DROP TABLE IF EXISTS `wlyy_doctor_statistics_consult`;

CREATE TABLE `wlyy_doctor_statistics_consult` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识',
  `date` int(11) NOT NULL COMMENT '年月，如201601',
  `type_team` int(11) DEFAULT '0' COMMENT '指定咨询/三师咨询总数',
  `type_movi` int(11) DEFAULT '0' COMMENT '视频咨询总数',
  `users_team` int(11) DEFAULT '0' COMMENT '指定咨询/三师咨询咨询总人数',
  `users_movi` int(11) DEFAULT '0' COMMENT '视频咨询总人数',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_doctor_statistics_consult_1` (`doctor`,`date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医生咨询量统计表';

/*Data for the table `wlyy_doctor_statistics_consult` */

/*Table structure for table `wlyy_doctor_team` */

DROP TABLE IF EXISTS `wlyy_doctor_team`;

CREATE TABLE `wlyy_doctor_team` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '团队编码，业务主键',
  `name` varchar(50) NOT NULL COMMENT '团队名称',
  `icon` varchar(100) DEFAULT NULL COMMENT '团队LOGO',
  `members` int(11) DEFAULT '0' COMMENT '团队人员数',
  `doctor` varchar(50) NOT NULL COMMENT '创建人，关联wlyy_doctor表',
  `doctor_name` varchar(100) DEFAULT NULL COMMENT '创建人姓名',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='三师团队表';

/*Data for the table `wlyy_doctor_team` */

insert  into `wlyy_doctor_team`(`id`,`code`,`name`,`icon`,`members`,`doctor`,`doctor_name`,`czrq`,`del`) values (2,'1','糖尿病专家组','../images/face.png',3,'D20160322000001','徐小鹏','2016-05-12 13:25:37','1'),(3,'2','高血压专家组','../images/face.png',3,'D20160322000001','徐小鹏','2016-05-13 00:25:39','1');

/*Table structure for table `wlyy_doctor_team_info` */

DROP TABLE IF EXISTS `wlyy_doctor_team_info`;

CREATE TABLE `wlyy_doctor_team_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `team` varchar(50) NOT NULL COMMENT '团队编码，关联wlyy_doctor_team表',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识，关联wlyy_doctor表',
  `name` varchar(50) DEFAULT NULL COMMENT '医生姓名',
  `type` int(11) NOT NULL COMMENT '医生类型：1专科医生，2全科医生，3健康管理师，4营养师',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_doctor_team_info_uid` (`doctor`),
  KEY `idx_wlyy_doctor_team_info_team` (`team`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4 COMMENT='医生团队详情表';

/*Data for the table `wlyy_doctor_team_info` */

insert  into `wlyy_doctor_team_info`(`id`,`team`,`doctor`,`name`,`type`,`czrq`,`del`) values (1,'2','D20160322000001','徐小鹏',1,'2016-05-10 07:36:11','1'),(3,'2','D20160322000003','江燕',2,'2016-05-10 07:37:28','1'),(5,'1','D20160322000002','聂青',3,'2016-05-10 07:37:55','1');

/*Table structure for table `wlyy_followup_item_record` */

DROP TABLE IF EXISTS `wlyy_followup_item_record`;

CREATE TABLE `wlyy_followup_item_record` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '随访项记录标识',
  `plan` varchar(50) NOT NULL COMMENT '随访计划标识',
  `stage` varchar(50) NOT NULL COMMENT '随访计划阶段标识',
  `item` varchar(50) NOT NULL COMMENT '随访计划阶段随访项标识',
  `type` int(11) NOT NULL COMMENT '类型：1问卷，2体测',
  `title` varchar(200) NOT NULL COMMENT '标题',
  `status` int(11) NOT NULL COMMENT '状态：0未作答，1已作答，2已完成',
  `czrq` date NOT NULL COMMENT '生成日期',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_item_record_1` (`stage`)
) ENGINE=InnoDB AUTO_INCREMENT=51 DEFAULT CHARSET=utf8mb4 COMMENT='生成的随访项记录';

/*Data for the table `wlyy_followup_item_record` */

insert  into `wlyy_followup_item_record`(`id`,`code`,`plan`,`stage`,`item`,`type`,`title`,`status`,`czrq`) values (1,'record00001','plan00001','stage00001','item00001',1,'问卷随访1',1,'2016-05-28'),(3,'record00003','plan00001','stage00001','item00001',1,'问卷随访2',1,'2016-05-30'),(4,'record00004','plan00001','stage00001','item00002',2,'体测随访2',0,'2016-05-30'),(6,'record00006','plan00001','stage00001','item00001',1,'问卷随访',2,'2016-05-30'),(45,'15ff3a4039794b1aaf152ca3c6ed4eb3','222222222','000000101','00000010101',1,'随访计划推送测试1阶段1随访项1',0,'2016-05-31'),(46,'78dbb2cf3f5f47c8b2d162717f6142b7','0000001','000000101','00000010102',2,'随访计划推送测试1阶段1随访项2',0,'2016-05-31'),(47,'f786b7079c984680a155b8757d97009a','0000001','000000101','00000010101',1,'随访计划推送测试1阶段1随访项1',0,'2016-06-21'),(48,'4d939ee286f5419ab4d54cf2833ec110','0000001','000000102','00000010201',1,'随访计划推送测试1阶段2随访项1',0,'2016-06-21'),(49,'f3395cb9b5c24133b2913af9206dd71d','0000001','000000102','00000010201',1,'随访计划推送测试1阶段2随访项1',0,'2016-07-21'),(50,'c340e264b77540d8844a2a689a78ac81','plan00001','stage00001','item00001',1,'糖尿病随访问卷',2,'2016-06-01');

/*Table structure for table `wlyy_followup_item_record_answer` */

DROP TABLE IF EXISTS `wlyy_followup_item_record_answer`;

CREATE TABLE `wlyy_followup_item_record_answer` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `plan` varchar(50) NOT NULL COMMENT '随访计划标识',
  `stage` varchar(50) NOT NULL COMMENT '随访计划阶段标识',
  `item` varchar(50) NOT NULL COMMENT '随访计划阶段随访项标识',
  `record` varchar(50) NOT NULL COMMENT '记录标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '代填写医生标识',
  `doctor_name` varchar(50) DEFAULT NULL COMMENT '代填写医生姓名',
  `type` int(11) NOT NULL COMMENT '问题类型：1问卷，2体测',
  `tc_index` int(11) DEFAULT NULL COMMENT '体测指标类型：1血糖，2血压，3体重，4腰围',
  `question` varchar(50) NOT NULL COMMENT '问题标识',
  `option_code` varchar(50) DEFAULT NULL COMMENT '选项标识',
  `answer` varchar(300) NOT NULL COMMENT '回答内容',
  `czrq` datetime DEFAULT NULL COMMENT '回答时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_plan_stage_item_answer_1` (`record`)
) ENGINE=InnoDB AUTO_INCREMENT=244 DEFAULT CHARSET=utf8mb4 COMMENT='随访患者回答记录表';

/*Data for the table `wlyy_followup_item_record_answer` */

insert  into `wlyy_followup_item_record_answer`(`id`,`plan`,`stage`,`item`,`record`,`doctor`,`doctor_name`,`type`,`tc_index`,`question`,`option_code`,`answer`,`czrq`) values (226,'plan00001','stage00001','item00001','c340e264b77540d8844a2a689a78ac81','D20160322000002','聂青\r\n',1,0,'question00001','option00002','没吃','2016-06-02 11:27:35'),(227,'plan00001','stage00001','item00001','c340e264b77540d8844a2a689a78ac81','D20160322000002','聂青\r\n',2,0,'question00003','option00003','喇叭丸','2016-06-02 11:27:35'),(228,'plan00001','stage00001','item00001','c340e264b77540d8844a2a689a78ac81','D20160322000002','聂青\r\n',3,0,'question00002','','阿发阿道夫爱的色放阿飞啊','2016-06-02 11:27:35'),(236,'plan00001','stage00001','item00001','record00003','D20160322000002','聂青\r\n',1,0,'question00001','option00001','吃了','2016-06-02 11:55:04'),(237,'plan00001','stage00001','item00001','record00003','D20160322000002','聂青\r\n',2,0,'question00003','option00003','喇叭丸','2016-06-02 11:55:04'),(238,'plan00001','stage00001','item00001','record00003','D20160322000002','聂青\r\n',3,0,'question00002','','发测试文件我2打发','2016-06-02 11:55:04'),(239,'plan00001','stage00001','item00001','record00006','D20160322000002','聂青\r\n',1,0,'question00001','option00002','没吃','2016-06-02 11:55:25'),(240,'plan00001','stage00001','item00001','record00006','D20160322000002','聂青\r\n',2,0,'question00003','option00003','喇叭丸','2016-06-02 11:55:25'),(241,'plan00001','stage00001','item00001','record00006','D20160322000002','聂青\r\n',3,0,'question00002','','地方阿德发到付阿道夫阿水分昂问放假啊','2016-06-02 11:55:25'),(242,'plan00001','stage00001','item00001','record00001','D20160322000002','聂青\r\n',1,0,'question00001','option00002','没吃','2016-06-02 16:18:41'),(243,'plan00001','stage00001','item00001','record00001','D20160322000002','聂青\r\n',2,0,'question00003','option00004','胃散','2016-06-02 16:18:41');

/*Table structure for table `wlyy_followup_item_record_question` */

DROP TABLE IF EXISTS `wlyy_followup_item_record_question`;

CREATE TABLE `wlyy_followup_item_record_question` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `code` varchar(50) NOT NULL COMMENT '问题标识(关联wlyy_followup_plan_stage_item_question表的code)',
  `plan` varchar(50) NOT NULL COMMENT '随访计划标识',
  `stage` varchar(50) NOT NULL COMMENT '随访计划阶段标识',
  `item` varchar(50) NOT NULL COMMENT '随访计划阶段随访项标识',
  `record` varchar(50) NOT NULL COMMENT '随访记录标识',
  `title` varchar(200) NOT NULL COMMENT '问题标题',
  `type` int(11) NOT NULL COMMENT '问题类型：1单选，2多选，3问答',
  `tc_index` int(11) DEFAULT NULL COMMENT '体测指标类型：1血糖，2血压，3体重，4腰围',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_item_record_question_1` (`record`),
  KEY `idx_wlyy_followup_item_record_question_2` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=53 DEFAULT CHARSET=utf8mb4 COMMENT='随访项记录随访问题表';

/*Data for the table `wlyy_followup_item_record_question` */

insert  into `wlyy_followup_item_record_question`(`id`,`code`,`plan`,`stage`,`item`,`record`,`title`,`type`,`tc_index`) values (1,'question00001','plan00001','stage00001','item00001','record00003','是否吃药了',1,2),(3,'question00003','plan00001','stage00001','item00001','record00003','吃了什么药',2,2),(5,'question00004','plan00001','stage00001','item00001','record00001','是否吃药了',1,2),(6,'question00006','plan00001','stage00001','item00001','record00001','吃了什么药',2,2),(7,'1111','plan00001','stage00001','item00002','record00004','血糖检测',0,1),(8,'2222','plan00001','stage00001','item00002','record00004','血压监测',0,2),(16,'question00016','plan00001','stage00001','item00001','record00006','是否吃药了',1,1),(17,'question00017','plan00001','stage00001','item00001','record00006','吃了什么药',2,1),(18,'question00018','plan00001','stage00001','item00001','record00006','感觉怎么样？',3,1),(45,'0000001010101','0000001','000000101','00000010101','15ff3a4039794b1aaf152ca3c6ed4eb3','随访计划推送测试1阶段1随访项1问题1',3,1),(46,'0000001010201','0000001','000000101','00000010102','78dbb2cf3f5f47c8b2d162717f6142b7','随访计划推送测试1阶段1随访项2问题1',3,0),(47,'0000001010101','0000001','000000101','00000010101','f786b7079c984680a155b8757d97009a','随访计划推送测试1阶段1随访项1问题1',3,1),(48,'0000001020101','0000001','000000102','00000010201','4d939ee286f5419ab4d54cf2833ec110','随访计划推送测试1阶段2随访项1问题1',3,0),(49,'0000001020101','0000001','000000102','00000010201','f3395cb9b5c24133b2913af9206dd71d','随访计划推送测试1阶段2随访项1问题1',3,0),(50,'question00001','plan00001','stage00001','item00001','c340e264b77540d8844a2a689a78ac81','是否吃药了',1,2),(52,'question00003','plan00001','stage00001','item00001','c340e264b77540d8844a2a689a78ac81','吃了什么药',2,2);

/*Table structure for table `wlyy_followup_item_record_question_option` */

DROP TABLE IF EXISTS `wlyy_followup_item_record_question_option`;

CREATE TABLE `wlyy_followup_item_record_question_option` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `code` varchar(50) NOT NULL COMMENT '选项标识',
  `plan` varchar(50) NOT NULL COMMENT '随访计划标识',
  `stage` varchar(50) NOT NULL COMMENT '随访计划阶段标识',
  `item` varchar(50) NOT NULL COMMENT '随访计划阶段随访项标识',
  `record` varchar(50) NOT NULL COMMENT '随访记录标识',
  `question` varchar(50) NOT NULL COMMENT '问题标识(关联wlyy_followup_item_record_question表的code)',
  `des` varchar(500) NOT NULL COMMENT '选项描述',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_item_record_question_option_1` (`question`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8mb4 COMMENT='随访项记录随访问题选项表';

/*Data for the table `wlyy_followup_item_record_question_option` */

insert  into `wlyy_followup_item_record_question_option`(`id`,`code`,`plan`,`stage`,`item`,`record`,`question`,`des`) values (1,'option00001','plan00001','stage00001','item00001','record00003','question00001','吃了'),(2,'option00002','plan00001','stage00001','item00001','record00003','question00001','没吃'),(3,'option00003','plan00001','stage00001','item00001','record00003','question00003','喇叭丸'),(4,'option00004','plan00001','stage00001','item00001','record00003','question00003','胃散'),(5,'option00005','plan00001','stage00001','item00001','record00003','question00003','泻立停'),(6,'option00006','plan00001','stage00001','item00001','record00001','question00004','吃了'),(7,'option00007','plan00001','stage00001','item00001','record00001','question00004','没吃'),(8,'option00008','plan00001','stage00001','item00001','record00001','question00006','喇叭丸'),(9,'option00009','plan00001','stage00001','item00001','record00001','question00006','胃散'),(10,'option00010','plan00001','stage00001','item00001','record00001','question00006','123'),(11,'option00011','plan00001','stage00001','item00002','record00004','1111','血糖（早餐前）'),(13,'option00013','plan00001','stage00001','item00002','record00004','2222','舒张压'),(14,'option00014','plan00001','stage00001','item00002','record00004','2222','收缩压'),(17,'option00017','plan00001','stage00001','item00001','record00006','question00016','吃了'),(18,'option00018','plan00001','stage00001','item00001','record00006','question00016','没吃'),(19,'option00019','plan00001','stage00001','item00001','record00006','question00017','维生素A'),(20,'option00020','plan00001','stage00001','item00001','record00006','question00017','维生素c');

/*Table structure for table `wlyy_followup_plan` */

DROP TABLE IF EXISTS `wlyy_followup_plan`;

CREATE TABLE `wlyy_followup_plan` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '与业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '计划标识',
  `title` varchar(100) NOT NULL COMMENT '标题/随访计划名称',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识',
  `doctor_name` varchar(50) NOT NULL COMMENT '医生姓名',
  `team` varchar(50) DEFAULT NULL COMMENT '三师团队标识',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `patient_name` varchar(50) NOT NULL COMMENT '患者姓名',
  `status` int(11) NOT NULL COMMENT '计划状态：-1暂停，0进行中，1已结束',
  `wj_amount` int(11) DEFAULT '0' COMMENT '总问卷随访数',
  `wj_finish_amount` int(11) DEFAULT '0' COMMENT '已完成问卷随访数',
  `tc_amount` int(11) DEFAULT '0' COMMENT '总体测随访数',
  `tc_finish_amount` int(11) DEFAULT '0' COMMENT '已完成体测随访数',
  `czrq` datetime NOT NULL COMMENT '制定日期',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_plan_1` (`doctor`),
  KEY `idx_wlyy_followup_plan_2` (`patient`),
  KEY `idx_wlyy_followup_plan_3` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='随访计划表';

/*Data for the table `wlyy_followup_plan` */

insert  into `wlyy_followup_plan`(`id`,`code`,`title`,`doctor`,`doctor_name`,`team`,`patient`,`patient_name`,`status`,`wj_amount`,`wj_finish_amount`,`tc_amount`,`tc_finish_amount`,`czrq`) values (1,'plan00001','随访计划1','D20160322000002','聂青','2','U20160322000001','李碧玉',0,2,19,1,1,'2016-05-26 14:38:09'),(2,'plan00002','随访计划2','D20160322000002','聂青','2','U20160322000002','张华',0,0,0,0,0,'2016-05-26 14:41:46'),(3,'222222222','随访计划推送测试1','D20160322000002','聂青','2','U20160322000001','李碧玉',1,4,0,1,0,'2016-05-31 14:48:33');

/*Table structure for table `wlyy_followup_plan_doctor` */

DROP TABLE IF EXISTS `wlyy_followup_plan_doctor`;

CREATE TABLE `wlyy_followup_plan_doctor` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `plan` varchar(50) DEFAULT NULL COMMENT '随访计划标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='医生相关的随访计划表';

/*Data for the table `wlyy_followup_plan_doctor` */

insert  into `wlyy_followup_plan_doctor`(`id`,`plan`,`doctor`) values (1,'plan00001','D20160322000002'),(2,'plan00002','D20160322000002'),(3,'0000001','D20160322000002');

/*Table structure for table `wlyy_followup_plan_stage` */

DROP TABLE IF EXISTS `wlyy_followup_plan_stage`;

CREATE TABLE `wlyy_followup_plan_stage` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '阶段标识',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识',
  `doctor_name` varchar(50) NOT NULL COMMENT '医生姓名',
  `plan` varchar(50) NOT NULL COMMENT '计划标识',
  `seq` int(11) NOT NULL COMMENT '阶段序号',
  `type` int(11) NOT NULL COMMENT '类型：1定时，2不定时',
  `end_date` date DEFAULT NULL COMMENT '结束日期',
  `target` varchar(200) NOT NULL COMMENT '目标',
  `status` int(11) DEFAULT NULL COMMENT '执行状态：-1暂停，0未开始，1进行中，2已结束',
  `czrq` datetime DEFAULT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_plan_stage_1` (`plan`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='随访计划阶段表';

/*Data for the table `wlyy_followup_plan_stage` */

insert  into `wlyy_followup_plan_stage`(`id`,`code`,`doctor`,`doctor_name`,`plan`,`seq`,`type`,`end_date`,`target`,`status`,`czrq`) values (1,'stage00001','D20160322000002','聂青','plan00001',1,2,'2016-05-31','控制血糖',1,'2016-05-26 14:39:20'),(2,'000000101','D20160322000002','聂青','0000001',1,1,'2016-06-30','随访计划推送测试1阶段1',2,'2016-05-31 14:49:57'),(3,'000000102','D20160322000002','聂青','0000001',2,2,'2016-06-30','随访计划推送测试1阶段2',2,'2016-05-31 14:56:10'),(4,'stage00002','D20160322000002','聂青','plan00001',2,1,'2016-06-23','继续控制血糖',0,'2016-06-02 20:43:12');

/*Table structure for table `wlyy_followup_plan_stage_item` */

DROP TABLE IF EXISTS `wlyy_followup_plan_stage_item`;

CREATE TABLE `wlyy_followup_plan_stage_item` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '随访项标识',
  `plan` varchar(50) NOT NULL COMMENT '随访计划标识',
  `stage` varchar(50) NOT NULL COMMENT '随访计划阶段标识',
  `type` int(11) NOT NULL COMMENT '随访项类型：1问卷，2体测',
  `title` varchar(200) NOT NULL COMMENT '标题',
  `push_type` int(11) NOT NULL COMMENT '推送类型：1按时间，2按次数',
  `push_times` int(11) DEFAULT NULL COMMENT '推送次数',
  `push_cycle` int(11) DEFAULT NULL COMMENT '推送周期',
  `push_cycle_unit` int(11) DEFAULT NULL COMMENT '推送周期单位：1天，2周，3月',
  `next_push_date` date DEFAULT NULL COMMENT '下一次推送日期',
  `push_begin` date DEFAULT NULL COMMENT '推送开始日期',
  `push_end` date DEFAULT NULL COMMENT '推送结束日期',
  `times` int(11) DEFAULT '0' COMMENT '已推送次数',
  `status` int(11) NOT NULL COMMENT '执行状态：-1暂停，0未开始，1进行中，2已结束',
  `czrq` datetime NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_plan_stage_item_1` (`stage`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COMMENT='随访计划随访阶段随访项';

/*Data for the table `wlyy_followup_plan_stage_item` */

insert  into `wlyy_followup_plan_stage_item`(`id`,`code`,`plan`,`stage`,`type`,`title`,`push_type`,`push_times`,`push_cycle`,`push_cycle_unit`,`next_push_date`,`push_begin`,`push_end`,`times`,`status`,`czrq`) values (1,'item00001','plan00001','stage00001',1,'糖尿病随访问卷',1,0,8,1,'2016-07-02','2016-07-02','2016-07-05',0,1,'2016-05-30 19:01:49'),(2,'item00002','plan00001','stage00001',2,'糖尿病随访体测',1,0,3,2,'2016-06-21','2016-06-02','2016-05-18',1,0,'2016-05-30 20:07:51'),(3,'00000010101','0000001','000000101',1,'随访计划推送测试1阶段1随访项1',1,0,3,2,'2016-07-12','2016-05-31','2016-06-30',2,2,'2016-05-31 14:51:24'),(4,'00000010102','0000001','000000101',2,'随访计划推送测试1阶段1随访项2',2,3,1,3,'2016-06-30','2016-05-31','2016-06-30',1,2,'2016-05-31 14:54:28'),(5,'00000010201','0000001','000000102',1,'随访计划推送测试1阶段2随访项1',1,0,1,3,'2016-08-21','2016-06-15','2016-07-31',2,2,'2016-05-31 14:57:28'),(6,'d7bfb473642a4171894dde45a035c925','plan00001','stage00001',1,'编辑测试',1,0,1,1,NULL,'2016-06-01','2016-06-05',2,2,'2016-05-31 15:17:51');

/*Table structure for table `wlyy_followup_plan_stage_item_question` */

DROP TABLE IF EXISTS `wlyy_followup_plan_stage_item_question`;

CREATE TABLE `wlyy_followup_plan_stage_item_question` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `code` varchar(50) NOT NULL COMMENT '问题标识',
  `plan` varchar(50) NOT NULL COMMENT '随访计划标识',
  `stage` varchar(50) NOT NULL COMMENT '随访计划阶段标识',
  `item` varchar(50) NOT NULL COMMENT '随访计划阶段随访项标识',
  `title` varchar(200) NOT NULL COMMENT '问题标题',
  `type` int(11) NOT NULL COMMENT '问题类型：1单选，2多选，3问答',
  `tc_index` int(11) DEFAULT NULL COMMENT '体测指标类型：1血糖，2血压，3体重，4腰围',
  `options` varchar(3000) DEFAULT NULL COMMENT '问题选项jsonarray串,格式为：[{code:"",des:""}]',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_plan_stage_item_question_1` (`item`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4 COMMENT='随访计划随访阶段随访项随访问题表';

/*Data for the table `wlyy_followup_plan_stage_item_question` */

insert  into `wlyy_followup_plan_stage_item_question`(`id`,`code`,`plan`,`stage`,`item`,`title`,`type`,`tc_index`,`options`) values (1,'question00001','plan00001','stage00001','item00001','是否吃药了',1,2,NULL),(2,'1111','plan00001','stage00001','item00002','血糖检查',0,1,NULL),(3,'question00003','plan00001','stage00001','item00001','吃了什么药',2,2,NULL),(4,'0000001010101','0000001','000000101','00000010101','随访计划推送测试1阶段1随访项1问题1',3,1,NULL),(5,'0000001010201','0000001','000000101','00000010102','随访计划推送测试1阶段1随访项2问题1',3,0,NULL),(6,'0000001020101','0000001','000000102','00000010201','随访计划推送测试1阶段2随访项1问题1',3,0,NULL),(7,'2911f7bb86d449b7bb797839492b2170','plan00001','stage00001','d7bfb473642a4171894dde45a035c925','测试题目',1,0,'[{\"code\":\"34f2f0dffaf44af3b765bb1e3fcaa555\",\"des\":\"测试一\"},{\"code\":\"dee8c491ee0746b59847cf49cbaec90b\",\"des\":\"测试二\"}]'),(8,'2222','plan00001','stage00001','item00002','血压监测',0,2,NULL);

/*Table structure for table `wlyy_followup_plan_stage_item_question_option` */

DROP TABLE IF EXISTS `wlyy_followup_plan_stage_item_question_option`;

CREATE TABLE `wlyy_followup_plan_stage_item_question_option` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `code` varchar(50) NOT NULL COMMENT '选项标识',
  `plan` varchar(50) NOT NULL COMMENT '随访计划标识',
  `stage` varchar(50) NOT NULL COMMENT '随访计划阶段标识',
  `item` varchar(50) NOT NULL COMMENT '随访计划阶段随访项标识',
  `question` varchar(50) NOT NULL COMMENT '问题标识',
  `des` varchar(500) NOT NULL COMMENT '选项描述',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_plan_stage_item_question_option_1` (`item`)
) ENGINE=InnoDB AUTO_INCREMENT=112 DEFAULT CHARSET=utf8mb4 COMMENT='随访计划随访阶段随访项随访问题选项表';

/*Data for the table `wlyy_followup_plan_stage_item_question_option` */

insert  into `wlyy_followup_plan_stage_item_question_option`(`id`,`code`,`plan`,`stage`,`item`,`question`,`des`) values (1,'option00001','plan00001','stage00001','item00001','question00001','吃了'),(2,'option00002','plan00001','stage00001','item00001','question00001','没吃'),(3,'option00003','plan00001','stage00001','item00001','question00003','喇叭丸'),(4,'option00004','plan00001','stage00001','item00001','question00003','胃散'),(5,'option00005','plan00001','stage00001','item00001','question00003','泻立停'),(6,'34f2f0dffaf44af3b765bb1e3fcaa555','plan00001','stage00001','d7bfb473642a4171894dde45a035c925','2911f7bb86d449b7bb797839492b2170','测试一'),(7,'dee8c491ee0746b59847cf49cbaec90b','plan00001','stage00001','d7bfb473642a4171894dde45a035c925','2911f7bb86d449b7bb797839492b2170','测试二'),(8,'1111','plan00001','stage00001','item00002','1111','早餐前血糖值'),(9,'opiton00008','plan00001','stage00001','item00001','question00008','血压值'),(10,'2222','plan00001','stage00001','item00002','2222','收缩压'),(111,'333','plan00001','stage00001','item00002','2222','舒张压');

/*Table structure for table `wlyy_followup_plan_stage_target` */

DROP TABLE IF EXISTS `wlyy_followup_plan_stage_target`;

CREATE TABLE `wlyy_followup_plan_stage_target` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `content` varchar(200) NOT NULL COMMENT '目标内容',
  `czrq` datetime NOT NULL COMMENT '添加时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='随访计划阶段目标定义表';

/*Data for the table `wlyy_followup_plan_stage_target` */

insert  into `wlyy_followup_plan_stage_target`(`id`,`content`,`czrq`) values (1,'控制血压','2016-05-28 10:16:48'),(2,'控制血糖','2016-05-28 10:16:50');

/*Table structure for table `wlyy_followup_question` */

DROP TABLE IF EXISTS `wlyy_followup_question`;

CREATE TABLE `wlyy_followup_question` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '问题标识',
  `doctor` varchar(50) DEFAULT '0' COMMENT '医生标识，0代表为系统随访项',
  `title` varchar(200) NOT NULL COMMENT '标题',
  `type` int(11) NOT NULL COMMENT '随访项类型：1单选，2多选，3问答',
  `content` varchar(3000) DEFAULT NULL COMMENT '选项json串用于查询',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_question_1` (`doctor`),
  KEY `idx_wlyy_followup_question_2` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='问卷随访问题定义表';

/*Data for the table `wlyy_followup_question` */

insert  into `wlyy_followup_question`(`id`,`code`,`doctor`,`title`,`type`,`content`,`czrq`,`del`) values (1,'111','0','是否按医生要求的次数服药？',1,'','2016-05-31 08:33:11','1'),(2,'222','0','测试复选题',2,'','2016-05-31 08:35:37','1'),(3,'333','0','测试内容',3,'','2016-05-31 08:36:18','1');

/*Table structure for table `wlyy_followup_question_option` */

DROP TABLE IF EXISTS `wlyy_followup_question_option`;

CREATE TABLE `wlyy_followup_question_option` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `question` varchar(50) NOT NULL COMMENT '问题标识',
  `des` varchar(500) NOT NULL COMMENT '选项描述',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_question_1` (`question`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COMMENT='问卷随访问题选项定义表';

/*Data for the table `wlyy_followup_question_option` */

insert  into `wlyy_followup_question_option`(`id`,`question`,`des`,`czrq`,`del`) values (1,'111','单选内容1','2016-05-30 09:33:47','1'),(2,'111','单选内容2','2016-05-30 09:33:49','1'),(3,'111','单选内容3','2016-05-30 09:33:51','1'),(4,'111','单选内容4','2016-05-30 09:33:57','1'),(5,'222','复选内容1','2016-05-30 09:34:02','1'),(6,'222','复选内容2','2016-05-30 09:34:04','1'),(7,'222','复选内容3','2016-05-30 09:34:15','1'),(8,'222','复选内容4','2016-05-30 09:34:09','1'),(9,'333','文本框内容','2016-05-31 16:34:15','1');

/*Table structure for table `wlyy_followup_summary` */

DROP TABLE IF EXISTS `wlyy_followup_summary`;

CREATE TABLE `wlyy_followup_summary` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `plan` varchar(50) DEFAULT NULL COMMENT '计划标识（计划总结）',
  `stage` varchar(50) DEFAULT NULL COMMENT '阶段标识（阶段总结）',
  `item` varchar(50) DEFAULT NULL COMMENT '随访项标识（随访项小结）',
  `record` varchar(50) DEFAULT NULL COMMENT '纪录标识(随访纪录总结)',
  `type` int(11) DEFAULT NULL COMMENT '小结类型：(1、计划  2、阶段 3、随访项 4、随访纪录)',
  `result` varchar(200) DEFAULT NULL COMMENT '控制结果',
  `summary` varchar(1000) NOT NULL COMMENT '总结内容',
  `doctor` varchar(50) NOT NULL COMMENT '总结医生标识',
  `doctor_name` varchar(50) NOT NULL COMMENT '总结医生姓名',
  `czrq` datetime NOT NULL COMMENT '总结时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COMMENT='随访总结';

/*Data for the table `wlyy_followup_summary` */

insert  into `wlyy_followup_summary`(`id`,`plan`,`stage`,`item`,`record`,`type`,`result`,`summary`,`doctor`,`doctor_name`,`czrq`) values (2,'plan00001','stage00001','item00001','',3,'测试','情况良好，暂停计划','D20160322000002','聂青','2016-05-30 10:18:18'),(3,'plan00001','stage00001','','',2,'测试','情况良好，暂停计划','D20160322000002','聂青','2016-05-30 10:16:58'),(4,'plan00001','','','',1,'测试','情况良好，暂停计划','D20160322000002','聂青','2016-05-30 10:16:58'),(5,'plan00001','stage00001','item00001','record00003',4,'控制满意','测试小结','D20160322000002','聂青\r\n','2016-05-31 08:56:10'),(6,'plan00001','stage00001','item00001','c340e264b77540d8844a2a689a78ac81',4,'不满意','烦烦烦','D20160322000002','聂青\r\n','2016-06-02 06:07:41'),(12,'plan00001','stage00001','item00001','record00006',4,'不满意','发','D20160322000002','聂青\r\n','2016-06-02 11:37:28');

/*Table structure for table `wlyy_followup_tc` */

DROP TABLE IF EXISTS `wlyy_followup_tc`;

CREATE TABLE `wlyy_followup_tc` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '体测类型标识',
  `doctor` varchar(50) DEFAULT '0' COMMENT '医生标识，0代表为系统随访项',
  `tc_index` int(11) NOT NULL COMMENT '体测指标类型（1血糖，2血压，3体重，4腰围）',
  `title` varchar(200) NOT NULL COMMENT '标题',
  `content` varchar(200) NOT NULL COMMENT '选项json串用于查询',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_tc_1` (`doctor`),
  KEY `idx_wlyy_followup_tc_2` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='体测随访体测类型定义表';

/*Data for the table `wlyy_followup_tc` */

insert  into `wlyy_followup_tc`(`id`,`code`,`doctor`,`tc_index`,`title`,`content`,`czrq`,`del`) values (1,'1','0',1,'血糖测量','[{code:7,des:\"早餐前血糖\"}]','2016-05-30 09:48:50','1'),(2,'2','0',2,'血压测量','[{code:8,des:\"收缩压\"},{code:9,des:\"舒张压\"}]','2016-05-30 09:48:49','1');

/*Table structure for table `wlyy_followup_tc_option` */

DROP TABLE IF EXISTS `wlyy_followup_tc_option`;

CREATE TABLE `wlyy_followup_tc_option` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `tc` varchar(50) NOT NULL COMMENT '体测类型标识',
  `des` varchar(500) NOT NULL COMMENT '选项描述',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_tc_option_1` (`tc`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='体测随访体测选项定义表';

/*Data for the table `wlyy_followup_tc_option` */

insert  into `wlyy_followup_tc_option`(`id`,`tc`,`des`,`czrq`,`del`) values (1,'1','早餐前血糖','2016-05-30 09:31:55','1'),(2,'2','收缩压','2016-05-30 09:31:56','1'),(3,'2','舒张压','2016-05-30 09:31:57','1');

/*Table structure for table `wlyy_followup_template` */

DROP TABLE IF EXISTS `wlyy_followup_template`;

CREATE TABLE `wlyy_followup_template` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '模板标识',
  `doctor` varchar(50) DEFAULT '0' COMMENT '医生标识，0表示为系统模板',
  `title` varchar(200) NOT NULL COMMENT '模板标题',
  `type` int(11) NOT NULL COMMENT '模板类型：1问卷模板，2体测模板',
  `push_type` int(11) NOT NULL COMMENT '推送类型：1按时间，2按次数',
  `push_times` int(11) NOT NULL COMMENT '推送次数',
  `push_cycle` int(11) NOT NULL COMMENT '推送周期',
  `push_cycle_unit` int(11) NOT NULL COMMENT '推送周期单位：1天，2周，3月',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '创建日期',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_template_tc_1` (`doctor`),
  KEY `idx_wlyy_followup_template_tc_2` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='体测随访模板表';

/*Data for the table `wlyy_followup_template` */

insert  into `wlyy_followup_template`(`id`,`code`,`doctor`,`title`,`type`,`push_type`,`push_times`,`push_cycle`,`push_cycle_unit`,`czrq`) values (1,'1','0','问卷模板1',1,1,0,3,1,'2016-05-30 09:50:16'),(2,'2','0','体测模板1',2,1,0,3,1,'2016-05-30 09:50:17');

/*Table structure for table `wlyy_followup_template_plan` */

DROP TABLE IF EXISTS `wlyy_followup_template_plan`;

CREATE TABLE `wlyy_followup_template_plan` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '与业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '计划标识',
  `title` varchar(100) NOT NULL COMMENT '标题/随访计划名称',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识',
  `stages` text NOT NULL COMMENT '随访模板阶段内容',
  `czrq` datetime NOT NULL COMMENT '生成日期',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_template_plan_1` (`doctor`),
  KEY `idx_wlyy_followup_template_plan_2` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8mb4 COMMENT='随访计划模板表';

/*Data for the table `wlyy_followup_template_plan` */

insert  into `wlyy_followup_template_plan`(`id`,`code`,`title`,`doctor`,`stages`,`czrq`) values (18,'ee9c777264244d3c92121037341eb98f','test','D20160322000002','[{\"type\":2,\"target\":\"控制血压\",\"end_date\":\"\",\"items\":[{\"tmplCode\":\"1\",\"title\":\"问卷模板1\",\"type\":1,\"push_type\":2,\"push_cycle\":3,\"push_cycle_unit\":1,\"push_times\":\"1\",\"push_begin\":\"2016-06-07\",\"push_end\":\"\",\"questions\":[{\"code\":\"1\",\"options\":[{\"code\":1,\"des\":\"选项1\"},{\"code\":2,\"des\":\"选项2\"},{\"code\":3,\"des\":\"选项3\"}],\"index\":1,\"title\":\"问题1：单选\",\"type\":1},{\"code\":\"2\",\"options\":[{\"code\":4,\"des\":\"选项4\"},{\"code\":5,\"des\":\"选项5\"},{\"code\":6,\"des\":\"选项6\"}],\"index\":2,\"title\":\"问题2：多选\",\"type\":2},{\"code\":\"3\",\"index\":3,\"title\":\"问题3：今天星期几\",\"type\":3},{\"code\":\"333\",\"id\":3,\"title\":\"测试内容\",\"type\":3,\"child\":[],\"options\":[]},{\"code\":\"222\",\"id\":2,\"title\":\"测试复选题\",\"type\":2,\"child\":[],\"options\":[]},{\"code\":\"111\",\"id\":1,\"title\":\"是否按医生要求的次数服药？\",\"type\":1,\"child\":[],\"options\":[]}]}],\"overTime\":\"\"}]','1970-01-01 00:00:00');

/*Table structure for table `wlyy_followup_template_question` */

DROP TABLE IF EXISTS `wlyy_followup_template_question`;

CREATE TABLE `wlyy_followup_template_question` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '问题标识',
  `template` varchar(50) NOT NULL COMMENT '模板标识',
  `title` varchar(200) NOT NULL COMMENT '问题标题',
  `type` int(11) NOT NULL COMMENT '问题类型：1单选，2多选，3问答',
  `tc_index` int(11) DEFAULT NULL COMMENT '体测指标类型：1血糖，2血压，3体重，4腰围',
  `options` varchar(3000) DEFAULT NULL COMMENT '问题选项jsonarray串,格式为：[{code:"",des:""}]',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_followup_wj_template_item_1` (`template`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COMMENT='随访模板问题表';

/*Data for the table `wlyy_followup_template_question` */

insert  into `wlyy_followup_template_question`(`id`,`code`,`template`,`title`,`type`,`tc_index`,`options`) values (1,'1','1','问题1：单选',1,1,'[{code:1,des:\"选项1\"},{code:2,des:\"选项2\"},{code:3,des:\"选项3\"}]'),(2,'2','1','问题2：多选',2,2,'[{code:4,des:\"选项4\"},{code:5,des:\"选项5\"},{code:6,des:\"选项6\"}]'),(3,'3','1','问题3：今天星期几',3,3,NULL),(4,'4','2','血糖测量',3,1,'[{code:7,des:\"早餐前血糖\"}]'),(5,'5','2','血压测量',3,2,'[{code:8,des:\"收缩压\"},{code:9,des:\"舒张压\"}]');

/*Table structure for table `wlyy_followup_template_question_option` */

DROP TABLE IF EXISTS `wlyy_followup_template_question_option`;

CREATE TABLE `wlyy_followup_template_question_option` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `template` varchar(50) NOT NULL COMMENT '模板标识',
  `question` varchar(50) NOT NULL COMMENT '问题标识',
  `des` varchar(500) NOT NULL COMMENT '选项描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COMMENT='随访模板问题选项表';

/*Data for the table `wlyy_followup_template_question_option` */

insert  into `wlyy_followup_template_question_option`(`id`,`template`,`question`,`des`) values (1,'1','1','选项1'),(2,'1','1','选项2'),(3,'1','1','选项3'),(4,'1','2','选项4'),(5,'1','2','选项5'),(6,'1','2','选项6'),(7,'2','4','早餐前血糖'),(8,'2','5','收缩压'),(9,'2','5','舒张压');

/*Table structure for table `wlyy_friends_log` */

DROP TABLE IF EXISTS `wlyy_friends_log`;

CREATE TABLE `wlyy_friends_log` (
  `n_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `applicant` varchar(50) NOT NULL COMMENT '申请人标识',
  `target` varchar(50) NOT NULL COMMENT '申请对象标识',
  `state` int(11) NOT NULL COMMENT '状态：0待处理，1同意，-1拒绝',
  `platform` int(11) NOT NULL COMMENT '消息平台：1微信端，2医生端',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '申请时间',
  PRIMARY KEY (`n_id`),
  KEY `idx_wlyy_friends_log_1` (`target`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='添加好友记录';

/*Data for the table `wlyy_friends_log` */

/*Table structure for table `wlyy_group_chat_log` */

DROP TABLE IF EXISTS `wlyy_group_chat_log`;

CREATE TABLE `wlyy_group_chat_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `msgid` varchar(50) NOT NULL COMMENT '消息ID',
  `group` varchar(50) NOT NULL COMMENT '群组标识',
  `receiver` varchar(50) NOT NULL COMMENT '接收人',
  `state` int(11) DEFAULT NULL COMMENT '消息状态（1已发送，2已接收，3已读）',
  `platform` int(11) DEFAULT NULL COMMENT '消息平台，1微信，2医生APP',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='群聊天记录状态表';

/*Data for the table `wlyy_group_chat_log` */

/*Table structure for table `wlyy_health_edu_article` */

DROP TABLE IF EXISTS `wlyy_health_edu_article`;

CREATE TABLE `wlyy_health_edu_article` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '文章标识',
  `title` varchar(200) DEFAULT NULL COMMENT '标题',
  `url` varchar(300) DEFAULT NULL COMMENT '访问URL',
  `content` varchar(300) DEFAULT NULL COMMENT '文章内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_health_edu_article_1` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='健康教育文章';

/*Data for the table `wlyy_health_edu_article` */

insert  into `wlyy_health_edu_article`(`id`,`code`,`title`,`url`,`content`,`czrq`) values (1,'1','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来','2016-05-14 09:17:33'),(2,'2','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。','2016-05-14 09:17:48'),(3,'3','30个省市购房难度排名：北京最难','http://news.sohu.com/20160513/n449180597.shtml','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。','2016-05-14 09:19:22');

/*Table structure for table `wlyy_health_edu_article_patient` */

DROP TABLE IF EXISTS `wlyy_health_edu_article_patient`;

CREATE TABLE `wlyy_health_edu_article_patient` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `article` varchar(50) DEFAULT NULL COMMENT '文章标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `doctor_name` varchar(50) DEFAULT NULL COMMENT '医生姓名',
  `url` varchar(300) DEFAULT NULL COMMENT '文章访问URL',
  `title` varchar(200) DEFAULT NULL COMMENT '文章标识',
  `content` varchar(300) DEFAULT NULL COMMENT '文章简介',
  `is_read` int(11) DEFAULT '1' COMMENT '是否已读：0已读，1未读',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_health_edu_article_patient_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=53 DEFAULT CHARSET=utf8mb4 COMMENT='患者健康教育文章';

/*Data for the table `wlyy_health_edu_article_patient` */

insert  into `wlyy_health_edu_article_patient`(`id`,`patient`,`article`,`doctor`,`doctor_name`,`url`,`title`,`content`,`is_read`,`czrq`) values (1,'U20160322000001','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','文章1文章1文章1文章1文章1文章1文章1文章1文章1文章1文章1',0,'2016-05-13 02:55:21'),(2,'U20160322000001','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','文章2文章2文章2文章2文章2文章2文章2',1,'2016-05-13 02:55:25'),(3,'U20160322000001','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','文章3文章3文章3文章3文章3文章3文章3文章3',1,'2016-05-13 02:55:33'),(4,'U20160322000002','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','文章1文章1文章1文章1文章1文章1文章1文章1文章1文章1文章1',1,'2016-05-17 04:35:01'),(5,'U20160322000002','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','文章2文章2文章2文章2文章2文章2文章2',1,'2016-05-13 02:55:58'),(6,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','文章3文章3文章3文章3文章3文章3文章3文章3',1,'2016-05-17 08:37:40'),(7,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-17 08:32:17'),(8,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-16 03:22:25'),(9,'U20160322000004','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-16 03:22:25'),(10,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-17 08:32:13'),(11,'U20160322000003','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-16 03:22:49'),(12,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-17 04:35:07'),(13,'U20160322000002','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-17 08:32:09'),(14,'U20160322000003','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-16 03:26:01'),(15,'U20160322000003','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-16 03:26:01'),(16,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-16 03:29:01'),(17,'U20160322000002','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-16 03:29:01'),(18,'U20160322000002','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-16 03:29:01'),(19,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-17 08:32:07'),(20,'U20160322000004','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-16 03:29:01'),(21,'U20160322000004','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-16 03:29:01'),(22,'U20160322000001','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-18 06:21:35'),(23,'U20160322000001','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-18 06:30:02'),(24,'U20160322000002','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-18 06:30:02'),(25,'U20160322000003','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-18 06:30:02'),(26,'U20160322000004','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-18 06:30:02'),(27,'U20160322000001','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-18 12:07:27'),(28,'U20160322000004','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-19 02:34:43'),(29,'U20160322000001','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-20 01:47:27'),(30,'U20160322000001','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-20 01:47:27'),(31,'U20160322000001','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-20 01:47:28'),(32,'U20160322000001','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-20 01:51:27'),(33,'U20160322000001','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-21 03:22:01'),(34,'U20160322000003','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-21 03:25:19'),(35,'U20160322000002','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-21 03:25:33'),(36,'U20160322000004','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-21 03:25:33'),(37,'U20160322000001','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-25 02:59:27'),(38,'U20160322000001','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-25 02:59:27'),(39,'U20160322000002','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-25 03:16:21'),(40,'U20160322000002','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-25 03:16:39'),(41,'U20160322000003','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-25 03:16:39'),(42,'U20160322000004','1','D20160322000002','聂青\r\n','http://news.sina.com.cn/o/2016-05-12/doc-ifxsehvu8800022.shtml','美国“黑寡妇”蜘蛛入侵伊拉克 农夫向政府求救','我们都知道，冠心病是心血管疾病中比较常见的一种，常常发生于中老年人群，当然随着近年来生活水平的提高，人们生活结构方式的改变，冠心病疾病已经慢慢年轻化，很多年轻人也渐渐加入了冠心病这个队伍中来',0,'2016-05-25 03:16:39'),(43,'U20160322000004','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-25 10:59:03'),(44,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-25 11:03:24'),(45,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-25 11:06:53'),(46,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-27 08:30:37'),(47,'U20160322000002','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-27 08:30:58'),(48,'U20160322000002','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-27 08:30:58'),(49,'U20160322000003','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-27 08:30:58'),(50,'U20160322000003','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-27 08:30:58'),(51,'U20160322000003','3','D20160322000002','聂青\r\n','http://news.sohu.com/20160513/n449180597.shtml','30个省市购房难度排名：北京最难','低血糖常见于糖尿病患者治疗过程中,是最常见的不良反应，它会直接导致心脑血管意外，以致危及生命。国外学者曾指出：“一次严重的医源性低血糖或由此诱发的心血管事件可能会抵消一生维持血糖在正常范围所带来的益处”。根据国际标准，只要血糖值≤3．9mmol／L就应按低血糖处理。',0,'2016-05-27 08:31:26'),(52,'U20160322000003','2','D20160322000002','聂青\r\n','http://cnews.chinadaily.com.cn/2016-05/13/content_25249255.htm','美国考古惊现神秘海怪 1.6亿年前神秘生物曝光','诺如病毒(Norovirus)是一组杯状病毒属病毒，1968年在美国诺瓦克市被分离发现。诺如病毒主要存活于受污染的水源，容易造成人类感染性腹泻。',0,'2016-05-27 08:31:26');

/*Table structure for table `wlyy_health_news` */

DROP TABLE IF EXISTS `wlyy_health_news`;

CREATE TABLE `wlyy_health_news` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `photo` varchar(50) DEFAULT NULL COMMENT '资讯图片',
  `title` varchar(150) NOT NULL COMMENT '标题',
  `summary` varchar(300) NOT NULL COMMENT '概述',
  `url` varchar(300) NOT NULL COMMENT '查看URL',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='健康资讯';

/*Data for the table `wlyy_health_news` */

/*Table structure for table `wlyy_inspect` */

DROP TABLE IF EXISTS `wlyy_inspect`;

CREATE TABLE `wlyy_inspect` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '检验检查标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='患者检查检验记录表';

/*Data for the table `wlyy_inspect` */

insert  into `wlyy_inspect`(`id`,`code`,`doctor`,`patient`,`czrq`,`del`) values (1,'INS2016032600000001','20160322000001','20160322000001','2016-03-26 16:16:28','1');

/*Table structure for table `wlyy_inspect_info` */

DROP TABLE IF EXISTS `wlyy_inspect_info`;

CREATE TABLE `wlyy_inspect_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '检查项标识',
  `inspect` varchar(50) DEFAULT NULL COMMENT '检查检验标识',
  `kind` varchar(100) DEFAULT NULL COMMENT '类别',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `times` int(11) DEFAULT NULL COMMENT '次数',
  `unit` varchar(100) DEFAULT NULL COMMENT '单位',
  `part` varchar(100) DEFAULT NULL COMMENT '检查部位',
  `specimen` varchar(100) DEFAULT NULL COMMENT '检验标本',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '0' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_swlyy_inspect_info_1` (`inspect`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='患者检查检验细项表';

/*Data for the table `wlyy_inspect_info` */

insert  into `wlyy_inspect_info`(`id`,`code`,`inspect`,`kind`,`name`,`times`,`unit`,`part`,`specimen`,`czrq`,`del`) values (1,'INSI2016032600000001','INS2016032600000001','â1111â','â1111â',1,'â1111â','â1111â','â1111â','2016-03-26 16:16:28','1'),(2,'INSI2016032600000002','INS2016032600000001','â2222â','â2222â',1,'â2222â','â2222â','â2222â','2016-03-26 16:16:28','1');

/*Table structure for table `wlyy_intervene` */

DROP TABLE IF EXISTS `wlyy_intervene`;

CREATE TABLE `wlyy_intervene` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务有关主键',
  `code` varchar(50) NOT NULL COMMENT '干预标识',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `title` varchar(20) NOT NULL COMMENT '干预标题',
  `cycle` int(11) NOT NULL COMMENT '执行周期(1每周，2每半个月，3每个月)',
  `begin_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '干预开始时间',
  `end_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT '干预结束时间',
  `bg` varchar(300) DEFAULT NULL COMMENT '血糖计划（json数组字符串，对应dm_intervene_item_type表的code，如：["001","002"]）',
  `bg_des` varchar(200) DEFAULT NULL COMMENT '血糖计划说明文字',
  `nibp` varchar(300) DEFAULT NULL COMMENT '血压计划（json数组字符串，对应dm_intervene_item_type表的code，如：["001","002"]）',
  `nibp_des` varchar(200) DEFAULT NULL COMMENT '血压计划文字说明',
  `weight` varchar(300) DEFAULT NULL COMMENT '体重计划（json数组字符串，对应dm_intervene_item_type表的code，如：["001","002"]）',
  `weight_des` varchar(200) DEFAULT NULL COMMENT '体重计划文字说明',
  `waistline` varchar(300) DEFAULT NULL COMMENT '腰围计划（json数组字符串，对应dm_intervene_item_type表的code，如：["001","002"]）',
  `waistline_des` varchar(200) DEFAULT NULL COMMENT '腰围计划文字说明',
  `sport` varchar(300) DEFAULT NULL COMMENT '运动计划（json数组字符串，对应dm_intervene_item_type表的code，如：["001","002"]）',
  `sport_des` varchar(200) DEFAULT NULL COMMENT '运动计划文字说明',
  `medicine` varchar(300) DEFAULT NULL COMMENT '用药计划（json数组字符串，对应dm_intervene_item_type表的code，如：["001","002"]）',
  `medicine_des` varchar(200) DEFAULT NULL COMMENT '用药计划文字说明',
  `diet` varchar(300) DEFAULT NULL COMMENT '饮食建议',
  `suggest` varchar(500) DEFAULT NULL COMMENT '健康指导建议',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '创建日期',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_intervene_1` (`doctor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='干预记录表';

/*Data for the table `wlyy_intervene` */

/*Table structure for table `wlyy_medical_edu_article` */

DROP TABLE IF EXISTS `wlyy_medical_edu_article`;

CREATE TABLE `wlyy_medical_edu_article` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '与业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '文章标识',
  `category` varchar(50) DEFAULT NULL COMMENT '医学教育分类标识',
  `title` varchar(100) DEFAULT NULL COMMENT '文章标题',
  `logo` varchar(100) DEFAULT NULL COMMENT '文章LOGO',
  `url` varchar(100) DEFAULT NULL COMMENT '文章HTTP地址',
  `content` text COMMENT '文章内容',
  `oper` varchar(50) DEFAULT NULL COMMENT '操作员',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '操作时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_medical_edu_article_1` (`category`),
  KEY `idx_wlyy_medical_edu_article_2` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医学教育文章信息表';

/*Data for the table `wlyy_medical_edu_article` */

/*Table structure for table `wlyy_medical_edu_article_read` */

DROP TABLE IF EXISTS `wlyy_medical_edu_article_read`;

CREATE TABLE `wlyy_medical_edu_article_read` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `article` varchar(50) DEFAULT NULL COMMENT '文章标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '查看时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_medical_edu_article_read_1` (`article`),
  KEY `idx_wlyy_medical_edu_article_read_2` (`doctor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

/*Data for the table `wlyy_medical_edu_article_read` */

/*Table structure for table `wlyy_medical_edu_category` */

DROP TABLE IF EXISTS `wlyy_medical_edu_category`;

CREATE TABLE `wlyy_medical_edu_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '分类标识',
  `name` varchar(50) DEFAULT NULL COMMENT '分类名称',
  `default` int(11) DEFAULT '0' COMMENT '是否为推荐类型,1是，0否',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT NULL COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医学教育分类表';

/*Data for the table `wlyy_medical_edu_category` */

/*Table structure for table `wlyy_medical_edu_setting` */

DROP TABLE IF EXISTS `wlyy_medical_edu_setting`;

CREATE TABLE `wlyy_medical_edu_setting` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `med_edu` varchar(50) DEFAULT NULL COMMENT '医学教育分类标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '设置时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_medical_edu_setting_1` (`med_edu`),
  KEY `idx_wlyy_medical_edu_setting_2` (`doctor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='医学教育设置表';

/*Data for the table `wlyy_medical_edu_setting` */

/*Table structure for table `wlyy_message` */

DROP TABLE IF EXISTS `wlyy_message`;

CREATE TABLE `wlyy_message` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '与业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '消息标识',
  `receiver` varchar(50) NOT NULL COMMENT '消息接收人（微信平台为患者标识，医生APP平台为医生标识）',
  `sender` varchar(50) DEFAULT NULL COMMENT '消息发送人标识',
  `data` varchar(100) DEFAULT NULL COMMENT '群组标识\\网络咨询标识\\问卷随访标识',
  `title` varchar(50) NOT NULL COMMENT '消息标题',
  `content` varchar(200) NOT NULL COMMENT '消息内容',
  `type` int(11) DEFAULT NULL COMMENT '消息类型（101患者申请取消签约、102患者同意取消签约、103患者拒绝取消签约、104患者填写了血糖记录、105患者填写了血压记录、106患者填写了体重记录、107患者填写了腰围记录、108患者填写了运动记录、109患者填写了用药记录、110患者填写了饮食记录、111患者提交了问卷随访、112请求添加好友消息、113入群消息、114群解散消息、115踢出群消息、116新的网络咨询、117网络咨询追问、201医生拒绝签约、202医生同意签约、203医生申请取消签约、204医生同意取消签约、205医生拒绝取消签约、206新的问卷随访、207新的健康干预、208请求添加好友消息、209入群消息、210群解散消息、211踢出群消息、212聊天消息提醒、213群聊天消息、214医生回复了网络咨询、215请求添加为家人、216电话随访，217、上门随访）',
  `platform` int(11) DEFAULT NULL COMMENT '消息平台，1微信端/患者端，2医生APP端',
  `state` int(11) DEFAULT '0' COMMENT '消息状态，1已发送，0待发送，-1发送失败',
  `has_read` int(11) DEFAULT '1' COMMENT '查看状态，1未读，0已读',
  `readonly` int(11) DEFAULT NULL COMMENT '只读消息：1否，0是',
  `czrq` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '消息时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_message_uid` (`receiver`)
) ENGINE=InnoDB AUTO_INCREMENT=42 DEFAULT CHARSET=utf8mb4 COMMENT='消息表';

/*Data for the table `wlyy_message` */

insert  into `wlyy_message`(`id`,`code`,`receiver`,`sender`,`data`,`title`,`content`,`type`,`platform`,`state`,`has_read`,`readonly`,`czrq`,`del`) values (1,'MSG2016032300000003','20160322000001','20160322000001','FUP2016032300000003','系统消息','您有新的问卷随访！',206,1,0,1,1,NULL,'1'),(2,'b16905e679904ee2a6c2d6eb55de9812','D20160322000002','U20160322000001','37199c9f15604160ad8abe041c4c22c8','图文咨询','您有新的图文咨询消息',116,1,0,0,0,NULL,'1'),(3,'7082abe8a3f1479ea7ad6a516939689c','D20160322000002','U20160322000001','78c979c18b9e42748f6237ef381e4002','图文咨询','您有新的图文咨询消息',116,1,0,0,0,NULL,'1'),(4,'f0c054cdd38a432d8f9ee898c6f8e618','D20160322000002','U20160322000001','456d48323a2641d08fd97a76c9ae0d95','图文咨询','您有新的图文咨询消息',116,1,0,0,0,NULL,'1'),(5,'91563a5ada974445879d8f399263f1b0','D20160322000002','U20160322000001','ab6b30ed1b6c4c61b8e9a74835a6a539','图文咨询','您有新的图文咨询消息',116,1,0,0,0,NULL,'1'),(6,'0f56b89ad40f4ce4807ad83a52e527e2','D20160322000002','U20160322000001','0a11e4000a6949d2b8b8486499592b2d','图文咨询','您有新的图文咨询消息',116,1,0,0,0,NULL,'1'),(7,'a5ffae395dcb40c08827ba48b9d18a29','D20160322000002','U20160322000001','0a11e4000a6949d2b8b8486499592b2d','图文咨询','您有新的图文咨询消息',116,1,0,0,0,NULL,'1'),(8,'60450c0353774a84b6563c3f85794845','D20160322000002','U20160322000001','0a11e4000a6949d2b8b8486499592b2d','图文咨询','您有新的图文咨询消息',116,1,0,0,0,NULL,'1'),(9,'7df318b4e75e4f1f95d280da250eb03c','U20160322000001','D20160322000002','0a11e4000a6949d2b8b8486499592b2d','图文咨询','聂青\r\n回复了您的咨询',214,1,0,0,0,NULL,'1'),(10,'0b60a9a273b140d1999176af2222fe51','D20160322000002','U20160322000001','0fcb8905d7dd47c7a5bdd5b619e39aca','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(11,'e93f369c3e4541f9afce6051f2eb599d','D20160322000002','U20160322000001','2d39e6d9393a450e999a023cbe02f460','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(12,'b7e0672166ac4b63a1fc0ab5647358bc','D20160322000002','U20160322000001','d125adf7d52d495da1251d2768634747','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(13,'8dc8081c88f54750811de1f4f0dce708','D20160322000002','U20160322000001','bc60196007c748d39fc905bca196760b','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(14,'490cfb8a55ff4794859acb2928508d6f','D20160322000002','U20160322000001','26a57cea0e424a9482e6f2bc7c1612f1','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(15,'88a148f41adb4a84be80fe2e6e976987','D20160322000002','U20160322000001','d51b824cad094742ac913a1894c2e3fe','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(16,'90a19a86141d4e7f9819eb6001cab7ab','D20160322000002','U20160322000001','664f4e4bd25d49e38d016976c75cce7d','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(17,'6884f2fa03e5411992609590abd7daa9','D20160322000002','U20160322000001','a2fb7952d22040efba7fbf407a9058b3','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(18,'bb2bbc747d844801a6136f8ec5cdbff4','D20160322000002','U20160322000001','3078fbecb4b445d7b7cbd20ee78620ca','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(19,'37155a9eaa49463aa4a52ffc90c3ab41','D20160322000002','U20160322000001','61eab1dda828412c88982caca0001d1d','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(20,'d8ccd37d8b7c41db9cd08e95b26d44c9','D20160322000002','U20160322000001','65170fff4c6e45f8b564c4a07a50f59b','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(21,'09c35fc6ca954621850dc5d12b07a5b6','D20160322000002','U20160322000001','c8f1c88b65e7476bbf71de300b47e97c','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(22,'1c52c1ebb4a74e0cbfe5b36d4286503a','D20160322000002','U20160322000001','c5348f47058a42b097256aa5d9c81f02','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(23,'509c8dc4d90043b4bfadb9c727648adf','D20160322000002','U20160322000001','72e41862bf974f2c99f2589f25c3f552','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(24,'15a9deff8f0643219e42e3b62dec9ea4','D20160322000002','U20160322000001','131fcb311d2e449d8871c200056c8785','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(25,'07d489b691124e41b951ce17ee4edc31','D20160322000002','U20160322000001','d7f0c000ad9d4c568580c55badda4bb7','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(26,'46c1f438073c44a7997fc8101113cd5a','D20160322000002','U20160322000001','6c3d723395d741e18d5aec0314870e1c','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(27,'9a7b09c66a844e8badb480d6620215a3','D20160322000002','U20160322000001','5a6949f8d060488782c6d657586f0ca6','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(28,'940fbb9f36d9408f88ed864338e52212','D20160322000002','U20160322000001','848bb7f0fcb946bba8af3b39e4ae53d5','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(29,'d784dfc9e13a4824bc65c3b4ca679c28','D20160322000002','U20160322000001','848bb7f0fcb946bba8af3b39e4ae53d5','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(30,'89f4cc98a1cb4a5b8535642a7986c321','D20160322000002','U20160322000001','848bb7f0fcb946bba8af3b39e4ae53d5','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(31,'877a2534233b40849804024ebdd9f929','D20160322000002','U20160322000001','848bb7f0fcb946bba8af3b39e4ae53d5','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(32,'d85346eea236463196aabc01f0eb2d5b','D20160322000002','U20160322000001','848bb7f0fcb946bba8af3b39e4ae53d5','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(33,'f5af14f0b61d45f29ab4ead812ef84ce','D20160322000002','U20160322000001','848bb7f0fcb946bba8af3b39e4ae53d5','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(34,'d58cd999562b4c5e8c9b4c0b02adbb0c','D20160322000002','U20160322000001','848bb7f0fcb946bba8af3b39e4ae53d5','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(35,'e54e4ce42f944034a3e77dd6496912ba','D20160322000002','U20160322000001','eaf5f669c720403bb35966f6ae1d3680','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(36,'89d5b3cd60864edfac97b408a96488ac','D20160322000002','U20160322000001','eaf5f669c720403bb35966f6ae1d3680','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(37,'0b846b5513344428aff4b36b7f745264','D20160322000002','U20160322000001','eaf5f669c720403bb35966f6ae1d3680','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(38,'abc6833fff92475b83aa8930fb428372','D20160322000002','U20160322000001','eaf5f669c720403bb35966f6ae1d3680','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(39,'62af310907be44e9a01798253e2ab2d0','D20160322000002','U20160322000001','eaf5f669c720403bb35966f6ae1d3680','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(40,'717a57a753344c2faa23208a4217ea16','D20160322000002','U20160322000001','eaf5f669c720403bb35966f6ae1d3680','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1'),(41,'b45e2aa256604a8a9407ac1d128cfc40','D20160322000002','U20160322000001','eaf5f669c720403bb35966f6ae1d3680','三师咨询','您有新的三师咨询消息',116,1,0,0,0,NULL,'1');

/*Table structure for table `wlyy_message_family_contract` */

DROP TABLE IF EXISTS `wlyy_message_family_contract`;

CREATE TABLE `wlyy_message_family_contract` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `receiver` varchar(50) NOT NULL COMMENT '接收者标识',
  `sender` varchar(50) NOT NULL COMMENT '发送者标识',
  `sender_name` varchar(50) NOT NULL COMMENT '发送者姓名',
  `sender_photo` varchar(300) DEFAULT NULL COMMENT '发送者头像',
  `title` varchar(50) NOT NULL COMMENT '消息标题',
  `message` varchar(50) NOT NULL COMMENT '消息内容',
  `type` int(11) NOT NULL COMMENT '消息类型：1新的签约，2签约成功，3签约失败，4解约申请，5解约成功，6解约失败，7签约到期',
  `data` varchar(1000) DEFAULT NULL COMMENT '消息数据',
  `is_read` int(11) NOT NULL COMMENT '是否已读：1未读，0已读',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT '是否已处理，1为未处理，0为已处理',
  `czrq` datetime NOT NULL COMMENT '消息发送时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_message_family_contract_1` (`receiver`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='家庭签约消息表';

/*Data for the table `wlyy_message_family_contract` */

insert  into `wlyy_message_family_contract`(`id`,`receiver`,`sender`,`sender_name`,`sender_photo`,`title`,`message`,`type`,`data`,`is_read`,`status`,`czrq`) values (2,'D20160322000001','59c61a2b5cde4c5ebb2d5bd64d23f920','肖红星','http://img5.duitang.com/uploads/item/201507/31/20150731164206_BXMvm.jpeg','家庭签约申请','您有一条新的家庭签约申请！',1,'',1,0,'2016-06-12 10:25:48'),(3,'D20160322000001','59c61a2b5cde4c5ebb2d5bd64d23f920','肖红星',NULL,'解除家庭签约申请','肖红星 申请解除与您的家族签约！',4,'',0,0,'2016-06-12 10:44:47'),(4,'59c61a2b5cde4c5ebb2d5bd64d23f920','D20160322000001','徐小鹏',NULL,'解除申请通知','您好，您的签约医生已同意您的解约申请，解约已生效！',5,'',1,0,'2016-06-12 14:06:31');

/*Table structure for table `wlyy_message_health_index` */

DROP TABLE IF EXISTS `wlyy_message_health_index`;

CREATE TABLE `wlyy_message_health_index` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `receiver` varchar(50) NOT NULL COMMENT '接收者标识',
  `sender` varchar(50) NOT NULL COMMENT '发送者标识',
  `sender_name` varchar(50) NOT NULL COMMENT '发送者姓名',
  `sender_photo` varchar(300) DEFAULT NULL COMMENT '发送者头像',
  `type` int(11) NOT NULL COMMENT '消息类型：1血糖，2血压',
  `value1` double NOT NULL COMMENT '当前值/收缩压，正数为高，负数为低',
  `value2` double NOT NULL COMMENT '上次值/舒张压，正数为高，负数为低',
  `is_read` int(11) NOT NULL COMMENT '是否已读：1未读，0已读',
  `czrq` datetime NOT NULL COMMENT '消息发送时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_message_health_index_1` (`receiver`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COMMENT='体征消息表';

/*Data for the table `wlyy_message_health_index` */

insert  into `wlyy_message_health_index`(`id`,`receiver`,`sender`,`sender_name`,`sender_photo`,`type`,`value1`,`value2`,`is_read`,`czrq`) values (5,'doctor','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg',1,83,4.5,1,'2016-06-13 16:52:12'),(6,'D20160322000002','U20160322000004','赖小娜','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg',2,135,117,0,'2016-06-13 16:52:12'),(7,'D20160322000002','U20160322000001','李晓毅','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg',1,83,4.5,1,'2016-06-13 23:28:04');

/*Table structure for table `wlyy_orders` */

DROP TABLE IF EXISTS `wlyy_orders`;

CREATE TABLE `wlyy_orders` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '订单标识',
  `pay_way` varchar(30) DEFAULT NULL COMMENT '支付方式 1 预交金 2支付宝 3微信 4其他',
  `status` int(2) NOT NULL COMMENT '支付状态 0未支付 1已支付 2已配药 3已复审 4已发货 5已接收 -1订单取消',
  `store` varchar(30) DEFAULT NULL COMMENT '店铺名称',
  `payable` varchar(20) DEFAULT NULL COMMENT '应付款',
  `czrq` timestamp NULL DEFAULT NULL COMMENT '下单时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `prescription` varchar(50) NOT NULL COMMENT '处方',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=43 DEFAULT CHARSET=utf8mb4 COMMENT='订单表';

/*Data for the table `wlyy_orders` */

insert  into `wlyy_orders`(`id`,`code`,`pay_way`,`status`,`store`,`payable`,`czrq`,`del`,`patient`,`prescription`) values (1,'20160322000004','1',1,'厦门','24','2016-03-28 20:11:23','1','20160322000001',''),(3,'ORD2016033000000003','1',2,'HOS2016032600000001','36.6','2016-03-30 20:19:35','1','20160322000001','PRE2016032600000001'),(7,'ORD2016033100000002','1',4,'HOS2016032600000001','36.6','2016-03-31 18:06:48','1','20160322000001','PRE2016033100000002'),(8,'ORD2016033100000003','1',4,'HOS2016032600000001','36.6','2016-04-01 00:35:56','1','20160322000001','PRE2016040100000003'),(9,'ORD2016033100000004','1',5,'HOS2016032600000001','36.6','2016-04-01 11:24:29','1','20160322000001','PRE2016040100000004'),(15,'ORD2016040600000006','1',5,'HOS2016032600000001','36.6','2016-04-06 17:05:57','1','20160322000001','PRE2016040100000002'),(19,'ORD2016040700000001','1',3,'HOS2016032600000001','36.6','2016-04-07 17:11:41','1','20160322000001','PRE2016040100000002'),(20,'ORD2016040700000002','1',3,'HOS2016032600000001','36.6','2016-04-07 19:09:31','1','20160322000001','PRE2016040100000003'),(21,'ORD2016040700000003','1',5,'HOS2016032600000001','36.6','2016-04-07 19:09:39','1','20160322000001','PRE2016040100000003'),(24,'ORD2016040700000006','1',5,'HOS2016032600000001','36.6','2016-04-07 19:16:59','1','20160322000001','PRE2016040100000003'),(25,'ORD2016040700000007','1',2,'HOS2016032600000001','36.6','2016-04-07 19:17:33','1','20160322000001','PRE2016040100000002'),(26,'ORD2016040700000008','1',1,'HOS2016032600000001','36.6','2016-04-07 19:33:31','1','20160322000001','PRE2016040100000002'),(31,'ORD2016040700000015','1',0,'HOS2016032600000001','36.6','2016-04-07 22:59:31','1','20160322000001','PRE2016040100000003'),(32,'ORD2016040800000001','1',0,'HOS2016032600000001','36.6','2016-04-12 13:45:57','1','20160322000001','PRE2016040100000003'),(33,'ORD2016040800000002','1',0,'HOS2016032600000001','36.6','2016-04-12 14:07:26','1','20160322000001','PRE2016040100000003'),(34,'ORD2016040800000003','1',0,'HOS2016032600000001','36.6','2016-04-12 14:09:35','1','20160322000001','PRE2016040100000003'),(35,'ORD2016040800000004','1',0,'HOS2016032600000001','36.6','2016-04-12 14:09:37','1','20160322000001','PRE2016040100000003'),(36,'ORD2016040800000005','1',0,'HOS2016032600000001','32.3','2016-04-12 14:11:45','1','20160322000001','PRE2016040100000003'),(37,'ORD2016040800000006','1',0,'HOS2016032600000001','32.3','2016-04-12 14:11:47','1','20160322000001','PRE2016040100000003'),(38,'ORD2016040800000007','1',0,'HOS2016032600000001','32.3','2016-04-12 14:13:20','1','20160322000001','PRE2016040100000003'),(39,'ORD2016040800000008','1',0,'HOS2016032600000001','32.3','2016-04-12 14:17:56','1','20160322000001','PRE2016040100000003'),(40,'ORD2016040800000009','1',1,'HOS2016032600000001','32.3','2016-04-12 14:20:03','1','20160322000001','PRE2016040100000003'),(41,'ORD2016040800000010','1',1,'HOS2016032600000001','32.3','2016-04-12 14:20:31','1','20160322000001','PRE2016040100000003'),(42,'ORD2016040800000011','1',1,'HOS2016032600000001','32.3','2016-04-12 14:22:53','1','20160322000001','PRE2016040100000003');

/*Table structure for table `wlyy_orders_detail` */

DROP TABLE IF EXISTS `wlyy_orders_detail`;

CREATE TABLE `wlyy_orders_detail` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `orders` varchar(50) NOT NULL COMMENT '订单标识',
  `medicines` varchar(50) NOT NULL COMMENT '商品名称',
  `number` int(10) DEFAULT NULL COMMENT '数量',
  `price` varchar(20) DEFAULT NULL COMMENT '单价',
  `czrq` timestamp NULL DEFAULT NULL COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=61 DEFAULT CHARSET=utf8mb4;

/*Data for the table `wlyy_orders_detail` */

insert  into `wlyy_orders_detail`(`id`,`orders`,`medicines`,`number`,`price`,`czrq`,`del`) values (2,'ORD2016033000000003','[江中]复方草珊瑚含片',3,'12.2','2016-03-30 20:19:35','1'),(6,'ORD2016033100000002','[江中]复方草珊瑚含片',3,'12.2','2016-03-31 18:06:48','1'),(7,'ORD2016033100000003','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-01 00:35:56','1'),(8,'ORD2016033100000004','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-01 11:24:29','1'),(25,'ORD2016040600000001','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-06 14:14:15','1'),(26,'ORD2016040600000002','[江中]复方草珊瑚含片',3,'12.2','2016-04-06 16:22:58','1'),(28,'ORD2016040600000004','[江中]复方草珊瑚含片',3,'12.2','2016-04-06 16:49:34','1'),(29,'ORD2016040600000005','[江中]复方草珊瑚含片',3,'12.2','2016-04-06 16:56:36','1'),(30,'ORD2016040600000006','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-06 16:58:48','1'),(31,'ORD2016040600000006','[江中]复方草珊瑚含片',3,'12.2','2016-04-06 17:05:57','1'),(32,'ORD2016040600000007','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 13:51:44','1'),(33,'ORD2016040600000008','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 16:03:57','1'),(34,'ORD2016040600000009','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 16:04:07','1'),(35,'ORD2016040700000001','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 17:11:41','1'),(36,'ORD2016040700000002','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 19:09:31','1'),(37,'ORD2016040700000003','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 19:09:39','1'),(38,'ORD2016040700000004','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 19:13:34','1'),(39,'ORD2016040700000005','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 19:16:14','1'),(40,'ORD2016040700000006','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 19:16:59','1'),(41,'ORD2016040700000007','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 19:17:33','1'),(42,'ORD2016040700000008','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 19:33:31','1'),(43,'ORD2016040700000009','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 20:12:34','1'),(45,'ORD2016040700000011','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 21:45:14','1'),(46,'ORD2016040700000012','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 21:45:38','1'),(47,'ORD2016040700000013','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 21:45:42','1'),(49,'ORD2016040700000015','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-07 22:59:31','1'),(50,'ORD2016040800000001','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-12 13:45:57','1'),(51,'ORD2016040800000002','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-12 14:07:26','1'),(52,'ORD2016040800000003','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-12 14:09:35','1'),(53,'ORD2016040800000004','[æ±ä¸­]å¤æ¹èççå«ç',3,'12.2','2016-04-12 14:09:37','1'),(54,'ORD2016040800000005','å¡ææ®å©ç',3,'12.2','2016-04-12 14:11:45','1'),(55,'ORD2016040800000006','å¡ææ®å©ç',3,'12.2','2016-04-12 14:11:47','1'),(56,'ORD2016040800000007','å¡ææ®å©ç',3,'12.2','2016-04-12 14:13:20','1'),(57,'ORD2016040800000008','å¡ææ®å©ç',3,'12.2','2016-04-12 14:17:56','1'),(58,'ORD2016040800000009','å¡ææ®å©ç',3,'12.2','2016-04-12 14:20:03','1'),(59,'ORD2016040800000010','å¡ææ®å©ç',3,'12.2','2016-04-12 14:20:31','1'),(60,'ORD2016040800000011','å¡ææ®å©ç',3,'12.2','2016-04-12 14:22:53','1');

/*Table structure for table `wlyy_patient` */

DROP TABLE IF EXISTS `wlyy_patient`;

CREATE TABLE `wlyy_patient` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '业务主键',
  `idcard` varchar(20) NOT NULL COMMENT '身份证号',
  `password` varchar(50) DEFAULT NULL COMMENT '登录密码',
  `salt` varchar(50) DEFAULT NULL,
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `birthday` date DEFAULT NULL COMMENT '生日',
  `sex` int(11) DEFAULT NULL COMMENT '性别，1男，2女',
  `mobile` varchar(20) DEFAULT NULL COMMENT '手机号',
  `phone` varchar(20) DEFAULT NULL COMMENT '联系电话',
  `ssc` varchar(50) DEFAULT NULL COMMENT '社保卡号',
  `photo` varchar(100) DEFAULT NULL COMMENT '头像http地址',
  `province` varchar(50) DEFAULT NULL COMMENT '省编码',
  `city` varchar(50) DEFAULT NULL COMMENT '市编码',
  `town` varchar(50) DEFAULT NULL COMMENT '区县编码',
  `street` varchar(10) DEFAULT NULL COMMENT '街道',
  `province_name` varchar(50) DEFAULT NULL COMMENT '省名称',
  `city_name` varchar(50) DEFAULT NULL COMMENT '城市名称',
  `town_name` varchar(50) DEFAULT NULL COMMENT '区县名称',
  `address` varchar(100) DEFAULT NULL COMMENT '详细地址',
  `disease` int(11) DEFAULT '0' COMMENT '疾病类型，0健康，1高血压，2糖尿病，3高血压+糖尿病',
  `disease_condition` int(11) DEFAULT NULL COMMENT '病情：0绿标，1黄标，2红标',
  `points` int(11) DEFAULT NULL COMMENT '总积分',
  `record_amount` int(11) DEFAULT NULL COMMENT '病历总数',
  `czrq` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `openid` varchar(50) DEFAULT NULL COMMENT '微信编号',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_patient_1` (`idcard`)
) ENGINE=InnoDB AUTO_INCREMENT=42 DEFAULT CHARSET=utf8mb4 COMMENT='患者信息表';

/*Data for the table `wlyy_patient` */

insert  into `wlyy_patient`(`id`,`code`,`idcard`,`password`,`salt`,`name`,`birthday`,`sex`,`mobile`,`phone`,`ssc`,`photo`,`province`,`city`,`town`,`street`,`province_name`,`city_name`,`town_name`,`address`,`disease`,`disease_condition`,`points`,`record_amount`,`czrq`,`openid`) values (1,'U20160322000001','U20160322000001','6e335b853b1ed99622d2cbdaed37d3424f36f6fe','e17354680a03a774','李碧玉','1982-06-11',2,'12345678901','0592-5982816\r\n','350204163650','2016/06/01/20160601140418_38.jpg','1','01','0101',NULL,'福建省','湖里区','新店镇','禾祥西路185号\r\n',0,0,0,3,'2016-06-15 12:18:48',''),(4,'U20160322000004','2','6e335b853b1ed99622d2cbdaed37d3424f36f6fe','e17354680a03a774','赖小娜','1989-10-25',2,'18256233705','0592-5635633','D87408301','http://172.19.103.77/res/images/2016/06/02/20160602094450_253.jpg',NULL,NULL,NULL,NULL,'福建省','厦门市','湖里区','殿前街道120号',2,2,0,0,'2016-06-07 07:28:55','oULM4xOTgIyh2-425VHbAkuTWZ6Y'),(9,'U20160322000002','33','838448e686e2a71738065b8fb6d67efce05a4366','9c4baa5881338355','张华','1965-07-04',1,'15859242576','0592-5982112','D87408301','2016/06/01/20160601102451_820.jpg',NULL,NULL,NULL,'航空商务广场','福建省','厦门市','湖里区','健康之路9层',0,0,0,0,'2016-06-15 12:14:07','oULM4xALliKJeDKcLrdxxLprEGTU'),(38,'d32a338511ac475c91861b2dc99cef07','350600198906041511','feeb692b9d44de3b120ed5e76f1dad8a2d8c1b95','d024f6224fb506a8','测试','1989-06-04',1,'18259633296','0592-1234567','D12345678','2016/06/01/20160601102451_820.jpg',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0,0,0,'2016-06-08 06:20:24',''),(41,'59c61a2b5cde4c5ebb2d5bd64d23f920','620621198309190874',NULL,NULL,'肖红星','1983-09-19',1,'13693066634','0592-1234567','D12345678',NULL,'001','001001','6',NULL,'福建省','厦门市','翔安区','新店镇祥福二里',0,0,0,0,'2016-06-15 12:15:58','123456');

/*Table structure for table `wlyy_patient_course` */

DROP TABLE IF EXISTS `wlyy_patient_course`;

CREATE TABLE `wlyy_patient_course` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '历程标识',
  `user` varchar(50) NOT NULL COMMENT '患者标识',
  `title` varchar(100) NOT NULL COMMENT '健康历程标题',
  `content` varchar(500) DEFAULT NULL COMMENT '内容',
  `table` varchar(50) NOT NULL COMMENT '对应的表',
  `tid` varchar(20) NOT NULL COMMENT '对应的表的code字段值',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_course_1` (`user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='健康历程表';

/*Data for the table `wlyy_patient_course` */

/*Table structure for table `wlyy_patient_device` */

DROP TABLE IF EXISTS `wlyy_patient_device`;

CREATE TABLE `wlyy_patient_device` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关键',
  `code` varchar(50) NOT NULL COMMENT '设备标识',
  `user` varchar(50) NOT NULL COMMENT '患者标识',
  `category` varchar(50) DEFAULT NULL COMMENT '设备类型标识',
  `category_name` varchar(100) DEFAULT NULL COMMENT '设备类型名称',
  `device_name` varchar(50) DEFAULT NULL COMMENT '设备名称',
  `sn` varchar(50) NOT NULL COMMENT '设备SN码',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_device_1` (`user`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8mb4 COMMENT='患者设备表';

/*Data for the table `wlyy_patient_device` */

insert  into `wlyy_patient_device`(`id`,`code`,`user`,`category`,`category_name`,`device_name`,`sn`,`czrq`,`del`) values (1,'1','U20160322000001','1','血糖仪','血糖仪01','sn11111','2016-05-18 02:02:15','0'),(2,'2','U20160322000001','1','血糖仪','血糖仪02128','sn222299128','2016-05-18 02:37:48','0'),(3,'3','U20160322000001','2','血压仪','血压仪0011','sn3333333341','2016-05-18 02:37:43','0'),(4,'5','U20160322000001','1','血糖仪','device031','6543211','2016-05-18 02:37:40','0'),(5,'7d9826ed56f4403093b0efca02c5308f','U20160322000001','1',NULL,'血糖仪5','sn555556777','2016-05-18 02:37:37','0'),(6,'4b718f44776a47c1a9180989a0c01f1f','U20160322000001','2',NULL,'血压仪6','sn66666','2016-05-17 09:36:07','0'),(7,'008a79bbec354a7f8bee233cbe0a7e6a','U20160322000001','2',NULL,'血压计123','SN12312323','2016-05-18 02:37:34','0'),(8,'cf48f8568c8a4bb79cb776b050f71ac0','U20160322000001','2',NULL,'血压计129','sn777777779','2016-05-18 02:09:37','0'),(9,'44e331a6e6ee4488b3b48ff87d77470d','U20160322000001','1',NULL,'血糖仪817','6817','2016-05-18 02:37:31','0'),(10,'ce2df9130190492c97280dad2677e9eb','U20160322000001','2',NULL,'血压计08','0000000000001','2016-05-11 08:16:13','0'),(11,'42951cfa706b4156b60aea6507b25c7f','U20160322000001','2',NULL,'血压计2228911','2228911','2016-05-18 02:37:29','0'),(12,'2b9b958384914aedaff499ffbc2ca78c','U20160322000001','2',NULL,'血压计33','33333333333333','2016-05-11 11:02:41','0'),(13,'81cdc79a05b7450398ff29409ee4e5ad','U20160322000001','1',NULL,'血糖仪44','44444444444','2016-05-11 08:21:35','0'),(14,'5d09e4cde162412eb526172d02b9b664','U20160322000001','1','血糖仪','ghj','rghjj','2016-05-13 09:38:22','0'),(15,'d2b5b72f38f44906aa9f3dace91669aa','U20160322000001','1','血糖仪','血糖仪a1','aaaaaa1','2016-05-18 02:36:46','0'),(16,'0e2406e68966434b8f28315b53904900','U20160322000001','1','血糖仪','血糖仪41','41414141','2016-05-18 02:09:33','0'),(17,'6a8fea920161468c932ab6214873c7ea','U20160322000001','2','血压仪','血压器11','11111111','2016-05-18 02:09:29','0'),(18,'ac7ab0c8791f4de1947625fbebf92d3f','U20160322000001','1','血糖仪','血糖仪1','111111111111','2016-05-18 02:41:48','0'),(19,'86b5e79752414163af5f6e6f7e8e1a03','U20160322000001','1','血糖仪','血糖仪1','111111111111','2016-05-18 03:04:10','1'),(20,'ede199ac61194cd2b2b1cf5d6a6e2763','U20160322000001','1','血糖仪','11111','11111111','2016-05-18 03:07:43','1'),(21,'52ad53e5ad414b70bd438c9eda596b37','U20160322000001','1','血糖仪','222211','22211','2016-05-18 03:09:44','1'),(22,'724431c3a40c4b3dbe25079c9b5c4f46','U20160322000003','1','血糖仪','11','11111','2016-05-31 08:06:34','1'),(23,'9bb2bedc4dc04ce08238676087a1e356','U20160322000003','1','血糖仪','11','11111','2016-05-31 08:06:36','1'),(24,'b636fa2c42564a77b3a96eae6ba5b0a7','U20160322000004','2','血压仪','达到','打打  ','2016-06-02 05:58:30','1'),(25,'2e2b2ee461974652b794cfad6d76082e','U20160322000004','1','血糖仪','的撒大十大','打算是','2016-06-02 07:48:04','1'),(26,'f31f71e5a2f742e3a9b7587e4c89d88b','U20160322000004','1','血糖仪','的撒旦都是','都是','2016-06-02 07:48:50','1'),(27,'dc2edd06086d48b781d4bee0273d9eb6','U20160322000001','1','血糖仪','1112','3231231','2016-06-02 07:49:49','1'),(28,'0450242555d84be2b73333fe6c7a1fdd','U20160322000004','1','血糖仪','131231313213','232321321312312','2016-06-02 08:42:05','1');

/*Table structure for table `wlyy_patient_family` */

DROP TABLE IF EXISTS `wlyy_patient_family`;

CREATE TABLE `wlyy_patient_family` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '与业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '家人标识',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `name` varchar(100) DEFAULT NULL COMMENT '患者姓名',
  `relationship` varchar(50) NOT NULL COMMENT '关系标识',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_family_1` (`patient`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='患者家人信息表';

/*Data for the table `wlyy_patient_family` */

/*Table structure for table `wlyy_patient_friend` */

DROP TABLE IF EXISTS `wlyy_patient_friend`;

CREATE TABLE `wlyy_patient_friend` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '与业务无关主键',
  `user1` varchar(50) NOT NULL COMMENT '患者标识，与wlyy_patient表关联',
  `user2` varchar(50) NOT NULL COMMENT '患者标识，与wlyy_patient表关联',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_friend_1` (`user1`),
  KEY `idx_wlyy_patient_friend_2` (`user2`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='患者好友表';

/*Data for the table `wlyy_patient_friend` */

/*Table structure for table `wlyy_patient_gift` */

DROP TABLE IF EXISTS `wlyy_patient_gift`;

CREATE TABLE `wlyy_patient_gift` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `user` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `gift` varchar(50) DEFAULT NULL COMMENT '礼品标识',
  `posints` int(11) DEFAULT NULL COMMENT '消费的积分数',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '兑换时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='患者兑换的礼品记录表';

/*Data for the table `wlyy_patient_gift` */

/*Table structure for table `wlyy_patient_group` */

DROP TABLE IF EXISTS `wlyy_patient_group`;

CREATE TABLE `wlyy_patient_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '与业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '业务主键',
  `creater` varchar(50) NOT NULL COMMENT '创建人，与wlyy_patient表关联',
  `name` varchar(50) NOT NULL COMMENT '群名称',
  `icon` varchar(100) DEFAULT NULL COMMENT '群LOGO',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT '是否作废，1正常，0解散',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_group_1` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='患者群组信息';

/*Data for the table `wlyy_patient_group` */

/*Table structure for table `wlyy_patient_group_info` */

DROP TABLE IF EXISTS `wlyy_patient_group_info`;

CREATE TABLE `wlyy_patient_group_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `team` varchar(50) NOT NULL COMMENT '群组标识，与wlyy_patient_group表关联',
  `user` varchar(50) NOT NULL COMMENT '患者标识，与wlyy_patient表关联',
  `admin` int(11) DEFAULT '0' COMMENT '管理员标识，1管理员，0普通组员',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_group_info_team` (`team`),
  KEY `idx_wlyy_patient_group_info_uid` (`user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='患者群组详情表';

/*Data for the table `wlyy_patient_group_info` */

/*Table structure for table `wlyy_patient_health_guidance` */

DROP TABLE IF EXISTS `wlyy_patient_health_guidance`;

CREATE TABLE `wlyy_patient_health_guidance` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `content` varchar(500) DEFAULT NULL COMMENT '指导内容',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `images` varchar(3000) DEFAULT NULL COMMENT '健康指导图片URL，多图以逗号分隔',
  `voice` varchar(300) DEFAULT NULL COMMENT '健康指导语音URL',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_health_guidance_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=37 DEFAULT CHARSET=utf8mb4 COMMENT='患者健康指导';

/*Data for the table `wlyy_patient_health_guidance` */

insert  into `wlyy_patient_health_guidance`(`id`,`patient`,`doctor`,`content`,`del`,`czrq`,`images`,`voice`) values (1,'U20160322000001','D20160322000002','guidance content','1','2016-05-12 15:42:47',NULL,NULL),(6,'U20160322000001','D20160322000002','请多运动运动','1','2016-05-16 11:33:55',NULL,NULL),(7,'U20160322000001','D20160322000002','提高心理调节能力,不要过度兴奋，激动或发怒。避免情绪激动、过度紧张、焦虑及各种不良刺激，多听音乐，陶冶情操。','1','2016-05-16 11:34:28',NULL,NULL),(8,'U20160322000001','D20160322000002','您好您的运动量比较低，建议您每天进行一些体育锻炼，比如慢跑，跳绳，游泳，登山。但是不要做一些危险性的运动如攀岩，蹦极','1','2016-05-16 11:34:48',NULL,NULL),(9,'U20160322000001','D20160322000002','以低盐、低脂肪饮食为宜，适当限制胆固醇，少吃或避免含饱和脂肪酸的动物脂肪，宜多食含维生素的食物。','1','2016-05-16 11:35:00',NULL,NULL),(10,'U20160322000004','D20160322000002','请至少填写','1','2016-05-18 02:48:07',NULL,NULL),(11,'U20160322000001','D20160322000002','清淡饮食！','1','2016-05-18 06:07:41',NULL,NULL),(12,'U20160322000002','D20160322000002','请注意多运动','1','2016-05-20 05:23:09',NULL,NULL),(13,'U20160322000002','D20160322000002','请您多喝水','1','2016-05-20 05:25:45',NULL,NULL),(14,'U20160322000002','D20160322000002','请多进行轻度运动','1','2016-05-20 05:41:13',NULL,NULL),(15,'U20160322000001','D20160322000002','请节制饮食','1','2016-05-20 05:57:32',NULL,NULL),(16,'U20160322000001','D20160322000002','发士大夫','1','2016-05-20 10:06:54',NULL,NULL),(17,'U20160322000001','D20160322000002','aafa','1','2016-05-21 03:14:39',NULL,NULL),(18,'U20160322000002','D20160322000002','要以低糖食物，清淡，少吃油腻的东西','1','2016-05-25 05:41:54',NULL,NULL),(19,'U20160322000003','D20160322000002','天天爱测血压','1','2016-05-25 06:09:58',NULL,NULL),(20,'U20160322000002','D20160322000002','啦啦啦，我是快乐的小行家，灭天测测血压，吃吃药，快乐又逍遥','1','2016-05-25 06:19:45',NULL,NULL),(21,'U20160322000002','D20160322000002','啦啦啦，我是快乐的小行家，每天测测血药，吃吃药，快乐又逍遥','1','2016-05-25 06:20:31',NULL,NULL),(22,'U20160322000004','D20160322000002','南岸娜娜娜娜难1难拿','1','2016-05-25 06:23:17',NULL,NULL),(23,'U20160322000004','D20160322000002','啦啦啦阿拉 啊阿道夫阿三阿发阿道夫阿斯顿发顺丰的','1','2016-05-25 06:23:39',NULL,NULL),(24,'U20160322000003','D20160322000002','塔塔啊啊分啊阿发阿斯蒂芬违法阿斯蒂芬阿斯弗去啊俄方asda杀死对方阿斯蒂芬阿斯蒂芬啊额发','1','2016-05-25 06:31:13',NULL,NULL),(25,'U20160322000001','D20160322000002','发到','1','2016-05-27 08:19:13',NULL,NULL),(26,'U20160322000001','D20160322000002','测试翻译你','1','2016-05-27 08:20:31',NULL,NULL),(27,'U20160322000003','D20160322000002','发射点','1','2016-05-27 08:21:12',NULL,NULL),(28,'U20160322000001','D20160322000002','阿道夫阿','1','2016-05-27 08:27:22',NULL,NULL),(29,'U20160322000001','D20160322000002','发啊发到发到','1','2016-05-27 08:28:02',NULL,NULL),(30,'U20160322000004','D20160322000002','吞吞吐吐','1','2016-05-27 08:28:19',NULL,NULL),(32,'123','D20160322000002',NULL,'1','2016-06-14 03:41:15','',''),(33,'','D20160322000002',NULL,'1','2016-06-14 03:41:30','',''),(34,'','D20160322000002',NULL,'1','2016-06-14 03:55:30','',''),(35,'','D20160322000002',NULL,'1','2016-06-14 03:55:44','',''),(36,'1234','D20160322000002',NULL,'1','2016-06-14 03:55:49','','');

/*Table structure for table `wlyy_patient_health_index` */

DROP TABLE IF EXISTS `wlyy_patient_health_index`;

CREATE TABLE `wlyy_patient_health_index` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `user` varchar(50) DEFAULT NULL COMMENT '患者标识，与wlyy_patient关联',
  `intervene` varchar(50) DEFAULT NULL COMMENT '干预标识',
  `value1` decimal(6,2) DEFAULT NULL COMMENT '血糖/收缩压/体重/腰围/早餐前空腹',
  `value2` decimal(6,2) DEFAULT NULL COMMENT '舒张压/早餐后空腹',
  `value3` decimal(6,2) DEFAULT NULL COMMENT '午餐空腹',
  `value4` decimal(6,2) DEFAULT NULL COMMENT '午餐后',
  `value5` decimal(6,2) DEFAULT NULL COMMENT '晚餐空腹',
  `value6` decimal(6,2) DEFAULT NULL COMMENT '晚餐后',
  `value7` decimal(6,2) DEFAULT NULL COMMENT '睡前',
  `type` int(1) DEFAULT NULL COMMENT '健康指标类型（1血糖，2血压，3体重，4腰围）',
  `record_date` date DEFAULT NULL COMMENT '记录时间',
  `sort_date` datetime DEFAULT NULL COMMENT '用于查询排序的时间',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_health_index_1` (`user`),
  KEY `idx_wlyy_patient_health_index_2` (`user`,`type`,`record_date`)
) ENGINE=InnoDB AUTO_INCREMENT=81 DEFAULT CHARSET=utf8mb4 COMMENT='患者健康指标表';

/*Data for the table `wlyy_patient_health_index` */

insert  into `wlyy_patient_health_index`(`id`,`user`,`intervene`,`value1`,`value2`,`value3`,`value4`,`value5`,`value6`,`value7`,`type`,`record_date`,`sort_date`,`czrq`,`del`) values (1,'U20160322000001','',NULL,'6.00',NULL,NULL,NULL,NULL,NULL,1,'2016-04-13',NULL,'2016-05-14 03:42:25','1'),(3,'U20160322000001','','5.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-15','2016-05-15 06:27:24','2016-05-16 06:27:24','1'),(4,'U20160322000001','','6.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-16','2016-05-16 06:56:03','2016-05-16 06:56:03','1'),(5,'U20160322000001','','6.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-14','2016-05-14 06:28:24','2016-05-16 06:28:24','1'),(6,'U20160322000001','','90.00','60.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-16','2016-05-16 06:31:50','2016-05-16 06:31:50','1'),(7,'U20160322000001',NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-14','2016-05-14 11:23:57','2016-05-18 11:23:57','1'),(8,'U20160322000001','','110.00',NULL,NULL,NULL,NULL,NULL,NULL,3,'2016-05-16','2016-05-16 06:35:49','2016-05-16 06:35:49','1'),(9,'U20160322000001',NULL,'83.00',NULL,NULL,NULL,NULL,NULL,NULL,4,'2016-05-16','2016-05-16 12:40:02','2016-05-18 12:40:02','1'),(10,'U20160322000001','','90.00',NULL,NULL,NULL,NULL,NULL,NULL,4,'2016-04-16','2016-04-16 06:36:33','2016-05-16 06:36:33','1'),(11,'U20160322000001','','87.00',NULL,NULL,NULL,NULL,NULL,NULL,4,'2016-05-15','2016-05-15 06:36:53','2016-05-16 06:36:53','1'),(16,'U20160322000001','','89.00','78.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-15','2016-05-15 06:59:05','2016-05-16 06:59:05','1'),(17,'U20160322000001',NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-18','2016-05-18 11:26:45','2016-05-18 11:26:45','1'),(18,'U20160322000001','','111.00',NULL,NULL,NULL,NULL,NULL,NULL,3,'2016-05-14','2016-05-14 06:59:58','2016-05-16 06:59:58','1'),(19,'U20160322000001','','90.00',NULL,NULL,NULL,NULL,NULL,NULL,4,'2016-05-14','2016-05-14 07:00:15','2016-05-16 07:00:15','1'),(20,'U20160322000001','','81.00',NULL,NULL,NULL,NULL,NULL,NULL,4,'2016-05-18','2016-05-18 07:11:50','2016-05-16 07:11:50','1'),(21,'U20160322000001','','82.00',NULL,NULL,NULL,NULL,NULL,NULL,4,'2016-05-19','2016-05-19 07:12:43','2016-05-16 07:12:43','1'),(23,'U20160322000001','','100.00','100.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-20','2016-05-20 07:22:39','2016-05-16 07:22:39','1'),(26,'U20160322000001','','7.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-13','2016-05-13 07:27:26','2016-05-16 07:27:26','1'),(27,'U20160322000001','','8.10',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-12','2016-05-12 07:30:08','2016-05-16 07:30:08','1'),(31,'U20160322000001',NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-11','2016-05-11 11:23:13','2016-05-18 11:23:13','1'),(32,'U20160322000001','','86.00','86.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-10','2016-05-10 07:51:05','2016-05-16 07:51:05','1'),(33,'U20160322000001','','6.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-11','2016-05-11 07:55:24','2016-05-16 07:55:24','1'),(34,'U20160322000001','','89.90','88.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-09','2016-05-09 07:57:08','2016-05-16 07:57:08','1'),(35,'U20160322000001',NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-12','2016-05-12 11:23:53','2016-05-18 11:23:53','1'),(36,'U20160322000001','','140.00',NULL,NULL,NULL,NULL,NULL,NULL,3,'2016-05-15','2016-05-15 08:00:01','2016-05-16 08:00:01','1'),(37,'U20160322000001','','87.00',NULL,NULL,NULL,NULL,NULL,NULL,4,'2016-05-13','2016-05-13 08:00:29','2016-05-16 08:00:29','1'),(38,'U20160322000001','','90.00',NULL,NULL,NULL,NULL,NULL,NULL,3,'2016-05-13','2016-05-13 08:08:56','2016-05-16 08:08:56','1'),(40,'U20160322000001','','97.00',NULL,NULL,NULL,NULL,NULL,NULL,4,'2016-05-12','2016-05-12 08:10:54','2016-05-16 08:10:54','1'),(41,'U20160322000001','',NULL,'12.00',NULL,NULL,NULL,NULL,NULL,1,'2016-05-18','2016-05-18 04:38:12','2016-05-18 04:38:12','1'),(43,'U20160322000001',NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-06','2016-05-06 11:08:52','2016-05-18 11:08:52','1'),(45,NULL,NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-11','2016-05-11 11:11:13','2016-05-18 11:11:13','1'),(49,NULL,NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-11','2016-05-11 11:23:26','2016-05-18 11:23:26','1'),(50,'U20160322000001',NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-17','2016-05-17 11:26:40','2016-05-18 11:26:40','1'),(51,NULL,'','111.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-31','2016-05-31 07:20:32','2016-05-31 07:20:32','1'),(52,NULL,'','4.40',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-31','2016-05-31 07:20:54','2016-05-31 07:20:54','1'),(53,NULL,'','7.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-31','2016-05-31 07:21:16','2016-05-31 07:21:16','1'),(54,'U20160322000003','','4.60',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-31','2016-05-31 07:51:33','2016-05-31 07:51:33','1'),(55,'U20160322000003','','1.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-01','2016-06-01 03:31:58','2016-06-01 03:31:58','1'),(56,'U20160322000004','','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 12:31:54','2016-06-02 12:31:54','1'),(57,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 10:31:56','2016-06-02 10:31:56','1'),(58,NULL,'','4.40',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 10:34:20','2016-06-02 10:34:20','1'),(59,NULL,'','1231.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 10:34:42','2016-06-02 10:34:42','1'),(60,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:29:29','2016-06-02 11:29:29','1'),(61,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:29:29','2016-06-02 11:29:29','1'),(62,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:30:25','2016-06-02 11:30:25','1'),(63,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:30:25','2016-06-02 11:30:25','1'),(64,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:30:45','2016-06-02 11:30:45','1'),(65,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:30:45','2016-06-02 11:30:45','1'),(66,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:31:22','2016-06-02 11:31:22','1'),(67,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:31:22','2016-06-02 11:31:22','1'),(68,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:33:46','2016-06-02 11:33:46','1'),(69,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:33:46','2016-06-02 11:33:46','1'),(70,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:34:26','2016-06-02 11:34:26','1'),(71,NULL,'','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-02','2016-06-02 11:34:26','2016-06-02 11:34:26','1'),(72,'U20160322000004','','91.00','61.00',NULL,NULL,NULL,NULL,NULL,2,'2016-06-02','2016-06-02 12:38:43','2016-06-02 12:38:43','1'),(73,NULL,'','90.00','60.00',NULL,NULL,NULL,NULL,NULL,2,'2016-06-02','2016-06-02 12:36:56','2016-06-02 12:36:56','1'),(74,NULL,'','100.00','61.00',NULL,NULL,NULL,NULL,NULL,2,'2016-06-02','2016-06-02 12:37:17','2016-06-02 12:37:17','1'),(75,'U20160322000004','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,3,'2016-06-02','2016-06-02 12:39:49','2016-06-02 12:39:49','1'),(76,'U20160322000004','','4.50',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-06-03','2016-06-03 08:11:28','2016-06-03 08:11:28','1'),(79,'U20160322000004',NULL,'83.00','93.00',NULL,NULL,NULL,NULL,NULL,2,'2016-05-11','2016-05-11 16:45:57','2016-06-13 16:45:57','1'),(80,'U20160322000004',NULL,'83.00',NULL,NULL,NULL,NULL,NULL,NULL,1,'2016-05-11','2016-05-11 16:51:58','2016-06-13 16:51:58','1');

/*Table structure for table `wlyy_patient_health_record_diet` */

DROP TABLE IF EXISTS `wlyy_patient_health_record_diet`;

CREATE TABLE `wlyy_patient_health_record_diet` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '记录标识',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `record_date` date DEFAULT NULL COMMENT '记录时间',
  `content` varchar(500) DEFAULT NULL COMMENT '饮食内容',
  `images` varchar(3000) DEFAULT NULL COMMENT '图片HTTP地址，多图以逗号分隔',
  `sort_date` datetime DEFAULT NULL COMMENT '用于查询排序的时间',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_health_record_diet_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=87 DEFAULT CHARSET=utf8mb4 COMMENT='患者健康记录(饮食)表';

/*Data for the table `wlyy_patient_health_record_diet` */

insert  into `wlyy_patient_health_record_diet`(`id`,`code`,`patient`,`record_date`,`content`,`images`,`sort_date`,`czrq`,`del`) values (63,'15679fd0ef064ed2bf4eecafbbeb3a3c','U20160322000001','2016-05-17','面条','http://172.19.103.77:8080/wlyy/uploadFiles/images/2016/05/18/20160518061120_176.jpg','2016-05-17 06:11:20','2016-05-18 06:11:20','1'),(64,'da0aa4110f1d4c798e9863cf0a9d1dc9','U20160322000001','2016-05-16','米饭','http://172.19.103.77:8080/wlyy/uploadFiles/images/2016/05/18/20160518061135_175.jpg','2016-05-16 06:11:35','2016-05-18 06:11:36','1'),(65,'e8017cec408949e9b98a7cd06393426d','U20160322000003','2016-06-01','7图','','2016-06-01 05:34:31','2016-06-01 05:34:31','1'),(66,'c6f4e4d1d0634c8b9a8ce1ab10bae4da','U20160322000001','2016-06-01','1111','','2016-06-01 05:40:58','2016-06-01 05:40:58','1'),(67,'af5a59bbd0fe4801b5fb5d338095d803','U20160322000001','2016-06-01','432','','2016-06-01 05:41:40','2016-06-01 05:41:40','1'),(68,'8be8f7a3cb7b41eb9485a4b6cefd471e','U20160322000001','2016-06-01','111111','','2016-06-01 05:42:21','2016-06-01 05:42:21','1'),(69,'26dff49d765e4d26a3baa32766df2f3f','U20160322000001','2016-06-01','的速度速度速度速度','','2016-06-01 05:48:06','2016-06-01 05:48:06','1'),(70,'32256949740b4eedb0e521e75e93c427','U20160322000001','2016-06-01','的十大','','2016-06-01 05:48:52','2016-06-01 05:48:52','1'),(71,'f04cc4ec00d844318e0946ffdbb10203','U20160322000001','2016-06-01','1','','2016-06-01 05:53:07','2016-06-01 05:53:07','1'),(72,'a6d9572046934da0b182d4f58a107a1a','U20160322000001','2016-06-01','1','','2016-06-01 05:54:03','2016-06-01 05:54:03','1'),(73,'5a0d2fb085994b939bac50d72852c52d','U20160322000001','2016-06-01','1231','','2016-06-01 05:55:27','2016-06-01 05:55:27','1'),(74,'7fc9439990434e68b61a8ab7a5dac461','U20160322000001','2016-06-01','1','','2016-06-01 05:57:33','2016-06-01 05:57:33','1'),(75,'c444e00da7524bd18315dec5ff7d90c8','U20160322000001','2016-06-01','13212','','2016-06-01 05:58:05','2016-06-01 05:58:05','1'),(76,'90cc3e9668044df58704787b1e89f0f3','U20160322000001','2016-06-01','dsdsd','','2016-06-01 05:58:50','2016-06-01 05:58:50','1'),(77,'6570ba4f34924e0bb14ce132eb8a46d7','U20160322000001','2016-06-01','2','','2016-06-01 05:59:59','2016-06-01 05:59:59','1'),(78,'e7a3fb6a5c2b421d8048faa9f0530a53','U20160322000001','2016-06-01','1','','2016-06-01 06:00:41','2016-06-01 06:00:41','1'),(79,'570b90a732bf43e8b588aa189b4b2b0d','U20160322000002','2016-06-01','dsadsa','','2016-06-01 10:26:02','2016-06-01 10:26:02','1'),(80,'a21960fc9dec450589ddff3a3c5e2040','U20160322000002','2016-06-01','ggggg','','2016-06-01 10:41:48','2016-06-01 10:41:48','1'),(81,'99f49b0cadee4a8a8ba7225eb644d135','U20160322000002','2016-06-01','hhhhh','','2016-06-01 10:45:59','2016-06-01 10:45:59','1'),(82,'a05fdbf2fdca42ee96fd7bdc4964fe06','U20160322000002','2016-06-01','55555','','2016-06-01 10:50:56','2016-06-01 10:50:56','1'),(83,'0495189dd2e04ce0b5e2586fcd75c44d','U20160322000002','2016-06-01','tttttt','','2016-06-01 10:52:09','2016-06-01 10:52:09','1'),(84,'721d9da25d40465b8e842ba213a8f105','U20160322000002','2016-06-01','dffdfdf','','2016-06-01 10:53:22','2016-06-01 10:53:22','1'),(85,'78c1bcab2953472195724333f0f3a63f','U20160322000002','2016-06-01','dffdf','','2016-06-01 10:53:55','2016-06-01 10:53:55','1'),(86,'2da58c2fd1354404b3b013be72c00391','U20160322000004','2016-06-02','31','','2016-06-02 12:44:42','2016-06-02 12:44:42','1');

/*Table structure for table `wlyy_patient_health_record_medication` */

DROP TABLE IF EXISTS `wlyy_patient_health_record_medication`;

CREATE TABLE `wlyy_patient_health_record_medication` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '记录标识',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `record_date` date DEFAULT NULL COMMENT '记录时间',
  `medicines` varchar(50) DEFAULT NULL COMMENT '药品标识',
  `medicines_name` varchar(100) DEFAULT NULL COMMENT '药品名称',
  `sort_date` datetime DEFAULT NULL COMMENT '用于查询排序的时间',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_health_record_medication_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4 COMMENT='患者健康记录(用药)表';

/*Data for the table `wlyy_patient_health_record_medication` */

insert  into `wlyy_patient_health_record_medication`(`id`,`code`,`patient`,`record_date`,`medicines`,`medicines_name`,`sort_date`,`czrq`,`del`) values (4,'70548dd416a14efe86e431db9a829891','U20160322000001','2016-05-13','1','基础胰岛素','2016-05-13 06:54:22','2016-05-14 06:54:22','1'),(5,'f02da48638da47f3af9657cc9f1bcf87','U20160322000001','2016-05-13','1','基础胰岛素','2016-05-13 06:55:17','2016-05-14 06:55:17','1'),(6,'fe8afaffd7224a34b344d4db3f7347c9','U20160322000001','2016-05-11','3','阿司匹林','2016-05-11 07:15:03','2016-05-14 07:15:03','1'),(7,'21a0935a02c24cf3a89beb81b4b88d20','U20160322000003','2016-05-31','1','基础胰岛素','2016-05-31 07:47:02','2016-05-31 07:47:02','1'),(8,'a33f866a5f3f49ef94d952e550ea38b3','U20160322000003','2016-05-31','1','基础胰岛素','2016-05-31 08:05:55','2016-05-31 08:05:55','1');

/*Table structure for table `wlyy_patient_health_record_sports` */

DROP TABLE IF EXISTS `wlyy_patient_health_record_sports`;

CREATE TABLE `wlyy_patient_health_record_sports` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '记录标识',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `record_date` date DEFAULT NULL COMMENT '记录时间',
  `sports_time` int(11) DEFAULT NULL COMMENT '运动时长（分）',
  `sports_type` varchar(50) DEFAULT NULL COMMENT '运动强度',
  `sports_type_name` varchar(100) DEFAULT NULL COMMENT '运动强度名称',
  `sports` varchar(50) DEFAULT NULL COMMENT '运动类型',
  `sports_name` varchar(100) DEFAULT NULL COMMENT '运动类型名称',
  `sort_date` datetime DEFAULT NULL COMMENT '用于查询排序的时间',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_health_record_sports_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb4 COMMENT='患者健康(运动)记录表';

/*Data for the table `wlyy_patient_health_record_sports` */

insert  into `wlyy_patient_health_record_sports`(`id`,`code`,`patient`,`record_date`,`sports_time`,`sports_type`,`sports_type_name`,`sports`,`sports_name`,`sort_date`,`czrq`,`del`) values (7,'aa48faba827d4ee4a98eaf8e21b9f896','U20160322000001','2016-04-15',5,'4','强度运动','2','散步','2016-04-15 04:29:25','2016-05-14 04:29:25','1'),(8,'01b51db007244620990592cfe6149bf5','U20160322000001','2016-05-13',15,'3','稍强运动','2','散步','2016-05-13 04:31:36','2016-05-14 04:31:36','1'),(9,'cec942d8e9f24ce98277813f8997bbca','U20160322000001','2016-04-12',5,'4','强度运动','2','散步','2016-04-12 04:43:51','2016-05-14 06:00:47','1'),(10,'fa9b7d64881e457392a3f866728daf5f','U20160322000001','2016-04-12',5,'4','强度运动','2','散步','2016-04-12 04:43:55','2016-05-14 06:00:48','1'),(11,'f72c1a4fb3f7437aa33a0c913762cb4b','U20160322000001','2016-04-19',5,'4','强度运动','2','散步','2016-04-19 04:44:07','2016-05-14 06:00:49','1'),(12,'a24062f1ee8b476f8760ad3fa4d9be49','U20160322000001','2016-05-14',15,'2','中度运动','4','太极拳','2016-05-14 06:01:58','2016-05-14 06:01:58','1'),(13,'958634ad961b4676b767bec586322f7b','U20160322000001','2016-05-13',30,'1','轻度运动','6','跑步','2016-05-13 06:04:25','2016-05-14 06:04:25','1'),(14,'3ecd8443075e4382ae01eec7592a38fe','U20160322000001','2016-05-13',5,'4','强度运动','3','做操','2016-05-13 06:08:02','2016-05-14 06:08:02','1'),(15,'23677673557942209886571e75cc9cdd','U20160322000001','2016-05-13',5,'1','轻度运动','1','购物','2016-05-13 06:09:46','2016-05-14 06:09:46','1'),(16,'de6678f7cc5d456bafde2cbb8ed0eeb3','U20160322000001','2016-05-15',60,'1','轻度运动','1','购物','2016-05-15 06:11:55','2016-05-14 06:11:55','1'),(17,'a9e99e508a1c458db398fdfa44f7d8eb','U20160322000001','2016-05-12',30,'2','中度运动','1','购物','2016-05-12 06:12:47','2016-05-14 06:12:47','1'),(18,'f1fcf1ca93394c23a6c70c0c410ca3fa','U20160322000001','2016-05-12',5,'1','轻度运动','1','购物','2016-05-12 06:14:35','2016-05-14 06:14:35','1'),(19,'8bf34f26872346efa4d70fcf758e0bf5','U20160322000003','2016-05-31',5,'1','轻度运动','1','购物','2016-05-31 07:44:42','2016-05-31 07:44:42','1'),(20,'43d3f3843c1440caa26185b95ea15689','U20160322000003','2016-05-31',5,'1','轻度运动','2','散步','2016-05-31 08:05:41','2016-05-31 08:05:41','1'),(21,'ff1d1313ccd2418980df9819d0d88a04','U20160322000003','2016-06-01',5,'1','轻度运动','1','购物','2016-06-01 02:23:38','2016-06-01 02:23:38','1'),(22,'81909606b51a414faaf9f6219f6414f2','U20160322000003','2016-06-01',5,'1','轻度运动','1','购物','2016-06-01 02:23:40','2016-06-01 02:23:40','1'),(23,'add9802ec3594600aa9f3edeb9d7cf95','U20160322000004','2016-06-02',5,'1','轻度运动','1','购物','2016-06-02 12:40:50','2016-06-02 12:40:50','1'),(24,'6e18d5b33a6148fab5c8a1bd14cf3fe7','U20160322000004','2016-06-02',5,'1','轻度运动','1','购物','2016-06-02 12:42:58','2016-06-02 12:42:58','1');

/*Table structure for table `wlyy_patient_health_standard` */

DROP TABLE IF EXISTS `wlyy_patient_health_standard`;

CREATE TABLE `wlyy_patient_health_standard` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `type` int(11) NOT NULL COMMENT '健康指标类型：1血糖，2血压，3体重，4腰围',
  `min_value_1` double DEFAULT NULL COMMENT '最低安全值(血糖餐前\\收缩压\\体重\\腰围)',
  `max_value_1` double DEFAULT NULL COMMENT '最高安全值(血糖餐前\\收缩压\\体重\\腰围)',
  `min_value_2` double DEFAULT NULL COMMENT '最低安全值(血糖餐后\\舒张压)',
  `max_value_2` double DEFAULT NULL COMMENT '最高安全值(血糖餐后\\舒张压)',
  `doctor` varchar(50) NOT NULL COMMENT '设置医生',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '设置时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_patient_health_standard_1` (`patient`,`type`)
) ENGINE=InnoDB AUTO_INCREMENT=103 DEFAULT CHARSET=utf8mb4 COMMENT='患者健康指标预警值';

/*Data for the table `wlyy_patient_health_standard` */

insert  into `wlyy_patient_health_standard`(`id`,`patient`,`type`,`min_value_1`,`max_value_1`,`min_value_2`,`max_value_2`,`doctor`,`czrq`) values (1,'system',1,3.9,6.1,4.4,7.8,'system','2016-06-13 03:11:07'),(2,'system',2,90,139,60,89,'system','2016-06-13 03:11:28'),(45,'U20160322000002',1,3.9,6.1,4.4,7.8,'D20160322000002','2016-05-20 05:21:31'),(46,'U20160322000002',2,90,139,60,89,'D20160322000002','2016-05-20 05:21:31'),(47,'U20160322000002',3,80,100,0,0,'D20160322000002','2016-05-20 05:21:31'),(48,'U20160322000002',4,80,90,0,0,'D20160322000002','2016-05-20 05:21:31'),(95,'U20160322000001',1,0,0,0,0,'D20160322000002','2016-06-13 16:27:27'),(96,'U20160322000001',2,0,0,0,0,'D20160322000002','2016-06-13 16:27:27'),(97,'U20160322000001',3,0,0,0,0,'D20160322000002','2016-06-13 16:27:27'),(98,'U20160322000001',4,0,0,0,0,'D20160322000002','2016-06-13 16:27:27'),(99,'U20160322000004',1,0,0,0,0,'D20160322000002','2016-06-14 09:51:23'),(100,'U20160322000004',2,0,0,0,0,'D20160322000002','2016-06-14 09:51:23'),(101,'U20160322000004',3,0,0,0,0,'D20160322000002','2016-06-14 09:51:23'),(102,'U20160322000004',4,0,0,0,0,'D20160322000002','2016-06-14 09:51:23');

/*Table structure for table `wlyy_patient_inspection_suggest` */

DROP TABLE IF EXISTS `wlyy_patient_inspection_suggest`;

CREATE TABLE `wlyy_patient_inspection_suggest` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `doctor_name` varchar(100) DEFAULT NULL COMMENT '医生姓名',
  `consult` varchar(50) DEFAULT NULL COMMENT '咨询标识',
  `type` int(11) DEFAULT NULL COMMENT '咨询类型：1三师咨询（即时咨询），2视频咨询',
  `content` varchar(1000) DEFAULT NULL COMMENT '建议内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_inspection_suggest_1` (`patient`),
  KEY `idx_wlyy_patient_inspection_suggest_2` (`consult`,`type`),
  KEY `idx_wlyy_patient_inspection_suggest_3` (`doctor`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='患者检查建议表';

/*Data for the table `wlyy_patient_inspection_suggest` */

insert  into `wlyy_patient_inspection_suggest`(`id`,`patient`,`doctor`,`doctor_name`,`consult`,`type`,`content`,`czrq`,`del`) values (1,'U20160322000001','D20160322000002','聂青\r\n','eaf5f669c720403bb35966f6ae1d3680',1,'CT、骨密度检查','2016-05-20 01:37:46','1'),(2,'U20160322000001','D20160322000002','聂青\r\n','eaf5f669c720403bb35966f6ae1d3680',1,'及时到医院进行心电图检查项目','2016-05-25 05:38:43','1');

/*Table structure for table `wlyy_patient_medical_records` */

DROP TABLE IF EXISTS `wlyy_patient_medical_records`;

CREATE TABLE `wlyy_patient_medical_records` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '病历标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `doctor_name` varchar(50) DEFAULT NULL COMMENT '医生姓名',
  `type` int(11) DEFAULT NULL COMMENT '类型：1记录，2随手记',
  `title` varchar(200) DEFAULT NULL COMMENT '病历标题',
  `symptoms` varchar(500) DEFAULT NULL COMMENT '主诉',
  `images` varchar(3000) DEFAULT NULL COMMENT '咨询图片，多图以逗号分隔',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_medical_records_1` (`code`),
  KEY `idx_wlyy_patient_medical_records_2` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=30 DEFAULT CHARSET=utf8mb4 COMMENT='患者病历记录表';

/*Data for the table `wlyy_patient_medical_records` */

insert  into `wlyy_patient_medical_records`(`id`,`code`,`patient`,`doctor`,`doctor_name`,`type`,`title`,`symptoms`,`images`,`czrq`,`del`) values (16,'43b9457b12844971805ad737eb8e6047','U20160322000001','D20160322000002','聂青\r\n',2,'片段记录1',NULL,NULL,'2016-05-19 11:06:15','1'),(17,'55c5b73d2aa9429483233c724ee715d2','U20160322000001','D20160322000002','聂青\r\n',1,'2016-05-19-三师咨询-病例记录','咳嗽','','2016-05-19 11:06:37','1'),(18,'77956ddd34f84a91a3a696a04392cbb6','U20160322000001','D20160322000002','聂青\r\n',2,'20160517片段记录',NULL,NULL,'2016-05-24 13:48:31','0'),(19,'2a56c57bd78a407da6f7589c61b0124e','U20160322000001','D20160322000002','聂青\r\n',2,'天天爱测试',NULL,NULL,'2016-05-24 13:49:21','0'),(20,'f1133a87276741ec95c6f2705706289f','U20160322000001','D20160322000002','聂青\r\n',2,'糖尿病',NULL,NULL,'2016-05-24 13:48:46','0'),(21,'48cfd9306b4f48909eecf13f51bbf18e','U20160322000001','D20160322000002','聂青\r\n',2,'天天斗地主',NULL,NULL,'2016-05-24 13:50:59','0'),(22,'d19258e740ee40df9179681cd17d05eb','U20160322000001','D20160322000002','聂青\r\n',2,'糖尿病',NULL,NULL,'2016-05-24 13:00:32','1'),(23,'d35dbf3422e44aa4a4f8d813bc17ca58','U20160322000001','D20160322000002','聂青\r\n',2,'天天斗地主',NULL,NULL,'2016-05-24 13:48:09','0'),(24,'7e14fb7e1ba0438381ca63f9eabdb24c','U20160322000001','D20160322000002','聂青\r\n',2,'我的命发发发大地方阿斯蒂芬阿斯啊的说法阿',NULL,NULL,'2016-05-25 09:34:37','1'),(25,'967d5fb62c5d44b09e3667e6ddf9636a','U20160322000001','D20160322000002','聂青\r\n',2,'我的命发发发大地方阿斯蒂芬阿斯啊的说法阿',NULL,NULL,'2016-05-25 09:35:17','1'),(26,'b4470fd192514b94ac67b45a2adc87d9','U20160322000001','D20160322000002','聂青\r\n',2,'我的命发发发大地方阿斯蒂芬阿斯啊的说法阿',NULL,NULL,'2016-05-25 09:44:54','1'),(27,'c5d21f1298064428b93a6442c205fea8','U20160322000001','D20160322000002','聂青\r\n',2,'糖尿病',NULL,NULL,'2016-05-25 09:50:57','1'),(28,'77e47eab35cf4062808a8ebc6acb8698','U20160322000001','D20160322000002','聂青\r\n',2,'糖尿病',NULL,NULL,'2016-05-25 09:55:09','1'),(29,'e839f5ea94f04700a2565d8dbd9131be','U20160322000001','D20160322000002','聂青\r\n',2,'tangniaobing',NULL,NULL,'2016-05-25 09:55:29','1');

/*Table structure for table `wlyy_patient_medical_records_item` */

DROP TABLE IF EXISTS `wlyy_patient_medical_records_item`;

CREATE TABLE `wlyy_patient_medical_records_item` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `record` varchar(50) NOT NULL COMMENT '病历记录标识',
  `part` varchar(50) NOT NULL COMMENT '片段标识',
  `part_name` varchar(100) NOT NULL COMMENT '片段名称',
  `content` varchar(1000) NOT NULL COMMENT '片段内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_medical_records_item_1` (`record`)
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8mb4 COMMENT='患者病历片断记录表';

/*Data for the table `wlyy_patient_medical_records_item` */

insert  into `wlyy_patient_medical_records_item`(`id`,`record`,`part`,`part_name`,`content`,`czrq`) values (18,'43b9457b12844971805ad737eb8e6047','08de64e31b6848bb8154185ec08629e5','片段记录1','newTestConetent','2016-05-19 11:06:15'),(19,'55c5b73d2aa9429483233c724ee715d2','15309e9f32d24ec79268069d1226c356','20160517片段记录','糖尿病患者应以低糖或无糖为主，平时多运动锻炼','2016-05-19 11:06:37'),(20,'55c5b73d2aa9429483233c724ee715d2','1','高血压','保持良好心态！','2016-05-19 11:06:37'),(21,'77956ddd34f84a91a3a696a04392cbb6','15309e9f32d24ec79268069d1226c356','20160517片段记录','糖尿病患者应以低糖或无糖为主，平时多运动锻炼','2016-05-19 11:14:53'),(22,'2a56c57bd78a407da6f7589c61b0124e','832baad956064a2684b70b27282fc06e','天天爱测试','天天测试的测试天天','2016-05-24 12:53:41'),(23,'f1133a87276741ec95c6f2705706289f','a8ccfbcc606f4c9390f27da34040f687','糖尿病','天天糖尿病','2016-05-24 12:59:43'),(24,'48cfd9306b4f48909eecf13f51bbf18e','45d89ea7ac8445c0b427cbebd129c8a9','天天斗地主','发','2016-05-24 13:00:18'),(25,'d19258e740ee40df9179681cd17d05eb','9f8da2229da9421b9f4939f653b2640c','糖尿病','哈哈','2016-05-24 13:00:32'),(26,'d35dbf3422e44aa4a4f8d813bc17ca58','45d89ea7ac8445c0b427cbebd129c8a9','天天斗地主','天天','2016-05-24 13:00:52'),(27,'7e14fb7e1ba0438381ca63f9eabdb24c','46ce036ca487427381f950a68a197c22','我的命发发发大地方阿斯蒂芬阿斯啊的说法阿','纠结啊楼上的房间阿斯蒂芬就啊撒旦解放拉萨的理解阿斯蒂芬嚼蜡说句地方了家啊手动阀手动阀手动阀手动阀手动','2016-05-25 09:34:37'),(28,'967d5fb62c5d44b09e3667e6ddf9636a','46ce036ca487427381f950a68a197c22','我的命发发发大地方阿斯蒂芬阿斯啊的说法阿','打发士大夫阿德','2016-05-25 09:35:17'),(29,'b4470fd192514b94ac67b45a2adc87d9','46ce036ca487427381f950a68a197c22','我的命发发发大地方阿斯蒂芬阿斯啊的说法阿','啊打发发到阿道夫大大','2016-05-25 09:44:54'),(30,'c5d21f1298064428b93a6442c205fea8','9f8da2229da9421b9f4939f653b2640c','糖尿病','糖尿病','2016-05-25 09:50:57'),(31,'77e47eab35cf4062808a8ebc6acb8698','9f8da2229da9421b9f4939f653b2640c','糖尿病','糖尿病','2016-05-25 09:55:09'),(32,'e839f5ea94f04700a2565d8dbd9131be','224649589e72473ebe2c7d1b5fe47c30','tangniaobing','天天糖尿病','2016-05-25 09:55:29');

/*Table structure for table `wlyy_patient_orders` */

DROP TABLE IF EXISTS `wlyy_patient_orders`;

CREATE TABLE `wlyy_patient_orders` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '医嘱标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `treatment` varchar(50) DEFAULT NULL COMMENT '就诊标识',
  `content` varchar(500) DEFAULT NULL COMMENT '医嘱内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_orders_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='医嘱信息表';

/*Data for the table `wlyy_patient_orders` */

insert  into `wlyy_patient_orders`(`id`,`code`,`patient`,`doctor`,`treatment`,`content`,`czrq`,`del`) values (1,'1','20160322000001',NULL,'1','肌肉注射 头孢氨卞 一天一次 每次5mg','2016-04-08 12:50:43','1'),(2,'2','20160322000001',NULL,'2','口服 科素亚 氯沙坦钾片 一天二次 每次 50mg','2016-04-08 12:53:07','1'),(3,'POS2016032800000001','20160322000001','20160322000001','1','口服 头孢呋辛酯片 一天三次 每次2片 饭后服用','2016-04-07 23:57:31','1');

/*Table structure for table `wlyy_patient_remind` */

DROP TABLE IF EXISTS `wlyy_patient_remind`;

CREATE TABLE `wlyy_patient_remind` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '提醒标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `visit_code` varchar(50) DEFAULT NULL COMMENT '就诊记录标识',
  `type` int(11) DEFAULT NULL COMMENT '提醒类型，1用药，2复诊',
  `content` varchar(1000) DEFAULT NULL COMMENT '提醒内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_remind_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=45 DEFAULT CHARSET=utf8mb4 COMMENT='患者提醒表';

/*Data for the table `wlyy_patient_remind` */

insert  into `wlyy_patient_remind`(`id`,`code`,`doctor`,`patient`,`visit_code`,`type`,`content`,`czrq`,`del`) values (17,'PAR2016040500000003','20160322000001','20160322000001',NULL,1,'记得每天饭后才能吃药','2016-04-05 16:59:09','1'),(18,'PAR2016040500000004','20160322000001','20160322000001',NULL,1,'低盐，远离辛辣食物','2016-04-05 16:59:45','1'),(19,'PAR2016040500000005','20160322000001','20160322000001',NULL,1,'每天起床测量血压','2016-04-05 17:00:06','1'),(22,'PAR2016040600000003','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/04/06到我处进行复诊，请准时过来。','2016-04-08 01:06:46','1'),(24,'PAR2016040600000005','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/03/20到我处进行复诊，请准时过来。','2016-04-08 01:07:12','1'),(25,'PAR2016040600000006','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/03/03到我处进行复诊，请准时过来。','2016-04-08 01:07:04','1'),(33,'PAR2016040700000007','20160322000001','20160322000001',NULL,1,'多吃青菜，多补充水分','2016-04-07 20:37:33','1'),(35,'PAR2016041100000001','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/04/11到我处进行复诊,请准时过来。','2016-04-11 11:36:39','1'),(36,'PAR2016041100000002','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/04/11到我处进行复诊,请准时过来。','2016-04-11 11:37:02','1'),(37,'PAR2016041100000003','20160322000001','20160322000001',NULL,1,'降压药每天一次用药','2016-04-11 11:43:12','1'),(38,'PAR2016041100000004','20160322000001','20160322000001',NULL,1,'','2016-04-11 11:43:16','1'),(39,'PAR2016041100000005','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/04/11到我处进行复诊,请准时过来。','2016-04-11 15:07:24','1'),(40,'PAR2016041100000006','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/04/11到我处进行复诊,请准时过来。','2016-04-11 15:11:40','1'),(41,'PAR2016041100000007','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/04/07到我处进行复诊,请准时过来。','2016-04-11 15:17:05','1'),(42,'PAR2016041100000008','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/04/10到我处进行复诊,请准时过来。','2016-04-11 15:17:24','1'),(43,'PAR2016041100000009','20160322000001','20160322000001','7123766',2,'李碧玉小姐您预约了2016/01/11到我处进行复诊,请准时过来。','2016-04-11 15:38:16','1'),(44,'PAR2016041200000001','20160322000001','20160322000001',NULL,1,'','2016-04-12 15:11:52','1');

/*Table structure for table `wlyy_patient_reservation` */

DROP TABLE IF EXISTS `wlyy_patient_reservation`;

CREATE TABLE `wlyy_patient_reservation` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '预约号/预约流水号',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识(医生帮患者预约时才会有值)',
  `dname` varchar(50) DEFAULT NULL COMMENT '医生姓名(医生帮患者预约时才会有值)',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `idcard` varchar(20) NOT NULL COMMENT '患者身份证',
  `name` varchar(50) NOT NULL COMMENT '患者姓名',
  `phone` varchar(20) NOT NULL COMMENT '患者手机号',
  `ssc` varchar(20) NOT NULL COMMENT '患者社保卡号',
  `section_type` varchar(4) NOT NULL COMMENT '预约时间段：AM (上午)或者PM (下午)',
  `start_time` varchar(20) NOT NULL COMMENT '一次预约段的开始时间',
  `org_code` varchar(50) NOT NULL COMMENT '医生所在医疗机构编码',
  `org_name` varchar(50) NOT NULL COMMENT '医院机构名称',
  `dept_code` varchar(50) NOT NULL COMMENT '科室编码',
  `dept_name` varchar(30) NOT NULL COMMENT '科室名称',
  `doctor_code` varchar(50) NOT NULL COMMENT '专家ID/编码',
  `doctor_name` varchar(50) NOT NULL COMMENT '专家姓名',
  `doctor_photo` varchar(300) DEFAULT NULL COMMENT '专家头像',
  `doctor_job` varchar(50) DEFAULT NULL COMMENT '专家职称',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT '状态：1预约成功，0预约取消',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '预约时间',
  `del` varchar(1) NOT NULL DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_reservation_1` (`patient`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='患者预约挂号记录表';

/*Data for the table `wlyy_patient_reservation` */

/*Table structure for table `wlyy_patient_reservation_doctors` */

DROP TABLE IF EXISTS `wlyy_patient_reservation_doctors`;

CREATE TABLE `wlyy_patient_reservation_doctors` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `org_code` varchar(50) NOT NULL COMMENT '医院编码',
  `org_name` varchar(100) NOT NULL COMMENT '医院名称',
  `dept_code` varchar(50) NOT NULL COMMENT '科室编码',
  `dept_name` varchar(30) NOT NULL COMMENT '科室名称',
  `doctor_code` varchar(50) NOT NULL COMMENT '专家ID/编码',
  `doctor_name` varchar(50) NOT NULL COMMENT '专家姓名',
  `doctor_photo` varchar(300) DEFAULT NULL COMMENT '专家头像',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_reservation_doctors_1` (`patient`),
  KEY `idx_wlyy_patient_reservation_doctors_2` (`patient`,`org_code`,`dept_code`,`doctor_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='患者预约过的医生/专家';

/*Data for the table `wlyy_patient_reservation_doctors` */

/*Table structure for table `wlyy_patient_self_inspection` */

DROP TABLE IF EXISTS `wlyy_patient_self_inspection`;

CREATE TABLE `wlyy_patient_self_inspection` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '自查标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `doctor_name` varchar(100) DEFAULT NULL COMMENT '医生姓名',
  `title` varchar(300) DEFAULT NULL COMMENT '标题',
  `consult` varchar(50) DEFAULT NULL COMMENT '咨询标识',
  `type` int(11) DEFAULT NULL COMMENT '咨询类型：1三师咨询（即时咨询），2视频咨询',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识：1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_self_inspection_1` (`patient`),
  KEY `idx_wlyy_patient_self_inspection_2` (`doctor`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8mb4 COMMENT='患者自查医生建议表';

/*Data for the table `wlyy_patient_self_inspection` */

insert  into `wlyy_patient_self_inspection`(`id`,`code`,`patient`,`doctor`,`doctor_name`,`title`,`consult`,`type`,`czrq`,`del`) values (1,'4f39379e1eec473b9d8f27160fe95646','U20160322000001','D20160322000002','聂青\r\n',NULL,'eaf5f669c720403bb35966f6ae1d3680',1,'2016-05-19 13:04:12','1'),(2,'f86aad78318b44b4a81c8892572fd145','U20160322000001','D20160322000002','聂青\r\n',NULL,NULL,1,'2016-05-19 13:04:12','1'),(3,'141d7d1b9d9e4d23bb30e999761f857d','U20160322000001','D20160322000002','聂青\r\n',NULL,'eaf5f669c720403bb35966f6ae1d3680',1,'2016-05-19 13:08:35','1'),(4,'f465a831a02c4fe9bb6272b094aa5a3a','U20160322000001','D20160322000002','聂青\r\n',NULL,NULL,1,'2016-05-19 13:08:36','1'),(5,'f6fd1fa876fb4932a4367f7a9d80bf03','U20160322000001','D20160322000002','聂青\r\n',NULL,'eaf5f669c720403bb35966f6ae1d3680',1,'2016-05-19 13:14:20',NULL),(6,'2cee31a8929249ac9cea186b2cac304d','U20160322000001','D20160322000002','聂青\r\n',NULL,NULL,1,'2016-05-19 13:15:23',NULL),(7,'5f59a549a1074153b18499f894b9c61b','U20160322000001','D20160322000002','聂青\r\n',NULL,NULL,1,'2016-05-19 13:17:29',NULL),(8,'e440b0ac110c4efe92ee6145e17486e8','U20160322000001','D20160322000002','聂青\r\n','血糖仪1','eaf5f669c720403bb35966f6ae1d3680',1,'2016-05-23 08:58:18','1'),(9,'eb884d086c9844ecb050da3e71d2400a','U20160322000001','D20160322000002','聂青\r\n','血糖仪1',NULL,1,'2016-05-23 08:58:42','1'),(10,'b1569b56a33041978af7fd0b51853deb','U20160322000001','D20160322000002','聂青\r\n','血糖仪1、222211',NULL,1,'2016-05-25 02:34:48','1'),(11,'bdec160506cb4784adba06e9b8a9cd9b','U20160322000001','D20160322000002','聂青\r\n','血糖仪1、11111、222211',NULL,1,'2016-05-25 02:37:27','1'),(12,'99671ebd9b344defae04dce64bc82062','U20160322000001','D20160322000002','聂青\r\n','血糖仪1、11111、222211',NULL,1,'2016-05-25 02:38:56','1'),(13,'6043af05292b40dfa0d35e91e9fef1e7','U20160322000001','D20160322000002','聂青\r\n','血糖仪1','eaf5f669c720403bb35966f6ae1d3680',1,'2016-05-25 05:38:13','1'),(14,'59ea0e7805ca41798265503fdcd36951','U20160322000001','D20160322000002','聂青\r\n','血糖仪1',NULL,1,'2016-05-25 09:02:42','1');

/*Table structure for table `wlyy_patient_self_inspection_item` */

DROP TABLE IF EXISTS `wlyy_patient_self_inspection_item`;

CREATE TABLE `wlyy_patient_self_inspection_item` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `inspection` varchar(50) DEFAULT NULL COMMENT '自查标识',
  `device` varchar(50) DEFAULT NULL COMMENT '设备标识',
  `device_name` varchar(100) DEFAULT NULL COMMENT '设备名称',
  `content` varchar(300) DEFAULT NULL COMMENT '备注内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_self_inspection_item_1` (`inspection`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8mb4 COMMENT='患者自查医生建议细项表';

/*Data for the table `wlyy_patient_self_inspection_item` */

insert  into `wlyy_patient_self_inspection_item`(`id`,`inspection`,`device`,`device_name`,`content`,`czrq`) values (1,'4f39379e1eec473b9d8f27160fe95646',NULL,'血糖仪1','餐前饭后测试','2016-05-19 12:56:55'),(2,'f86aad78318b44b4a81c8892572fd145',NULL,'血糖仪1','餐前饭后使用','2016-05-19 12:58:21'),(3,'141d7d1b9d9e4d23bb30e999761f857d',NULL,'222211','ffanqianchiefa','2016-05-19 13:06:20'),(4,'f465a831a02c4fe9bb6272b094aa5a3a',NULL,'血糖仪1','11111','2016-05-19 13:08:18'),(5,'f465a831a02c4fe9bb6272b094aa5a3a',NULL,'11111','11111ffff','2016-05-19 13:08:18'),(6,'f6fd1fa876fb4932a4367f7a9d80bf03',NULL,'血糖仪1','餐前饭后策划is，睡前醒后也要测试','2016-05-19 13:14:20'),(7,'f6fd1fa876fb4932a4367f7a9d80bf03',NULL,'11111','餐前饭后策划is，睡前醒后也要测试11','2016-05-19 13:14:20'),(8,'f6fd1fa876fb4932a4367f7a9d80bf03',NULL,'222211','餐前饭后策划is，睡前醒后也要测试11222','2016-05-19 13:14:20'),(9,'2cee31a8929249ac9cea186b2cac304d',NULL,'血糖仪1','aaa','2016-05-19 13:15:23'),(10,'2cee31a8929249ac9cea186b2cac304d',NULL,'11111','aaaaa','2016-05-19 13:15:23'),(11,'5f59a549a1074153b18499f894b9c61b',NULL,'血糖仪1','fafdadf','2016-05-19 13:17:29'),(12,'e440b0ac110c4efe92ee6145e17486e8',NULL,'血糖仪1','fa','2016-05-23 08:58:18'),(13,'eb884d086c9844ecb050da3e71d2400a',NULL,'血糖仪1','sdfasdfasdfasf','2016-05-23 08:58:42'),(14,'b1569b56a33041978af7fd0b51853deb',NULL,'血糖仪1','啊打发','2016-05-25 02:34:48'),(15,'b1569b56a33041978af7fd0b51853deb',NULL,'222211','啊打发发','2016-05-25 02:34:48'),(16,'bdec160506cb4784adba06e9b8a9cd9b',NULL,'血糖仪1','每天必须测量至少一次','2016-05-25 02:37:27'),(17,'bdec160506cb4784adba06e9b8a9cd9b',NULL,'11111','每天必须测量至少一次111','2016-05-25 02:37:27'),(18,'bdec160506cb4784adba06e9b8a9cd9b',NULL,'222211','每天必须测量至少一次12221','2016-05-25 02:37:27'),(19,'99671ebd9b344defae04dce64bc82062',NULL,'血糖仪1','每天必须测一测','2016-05-25 02:38:56'),(20,'99671ebd9b344defae04dce64bc82062',NULL,'11111','每天必须测一测','2016-05-25 02:38:56'),(21,'99671ebd9b344defae04dce64bc82062',NULL,'222211','每天必须测一测','2016-05-25 02:38:56'),(22,'6043af05292b40dfa0d35e91e9fef1e7',NULL,'血糖仪1','天天测血糖','2016-05-25 05:38:13'),(23,'59ea0e7805ca41798265503fdcd36951',NULL,'血糖仪1','爱的色放阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿斯蒂芬阿迪斯','2016-05-25 09:02:42');

/*Table structure for table `wlyy_patient_treatment` */

DROP TABLE IF EXISTS `wlyy_patient_treatment`;

CREATE TABLE `wlyy_patient_treatment` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '就诊标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `hospital` varchar(100) DEFAULT NULL COMMENT '医院名称',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '就诊日期',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_patient_treatment_1` (`patient`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='就诊记录表';

/*Data for the table `wlyy_patient_treatment` */

insert  into `wlyy_patient_treatment`(`id`,`code`,`patient`,`hospital`,`czrq`,`del`) values (1,'1','20160322000001','厦门中医院','2016-03-03 09:15:47','1'),(2,'2','20160322000001','厦门中医院','2016-02-10 09:16:07','1'),(3,'3','20160322000001','厦门中医院','2016-01-05 09:16:19','1');

/*Table structure for table `wlyy_pharmacist` */

DROP TABLE IF EXISTS `wlyy_pharmacist`;

CREATE TABLE `wlyy_pharmacist` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '药师标识',
  `mobile` varchar(20) NOT NULL COMMENT '登录手机号',
  `password` varchar(50) NOT NULL COMMENT '登录密码',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '注册时间',
  `status` int(11) DEFAULT '1' COMMENT '用户状态，1正常，0禁用',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_pharmacist_1` (`code`),
  UNIQUE KEY `idx_wlyy_pharmacist_2` (`mobile`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='药师信息表';

/*Data for the table `wlyy_pharmacist` */

insert  into `wlyy_pharmacist`(`id`,`code`,`mobile`,`password`,`name`,`czrq`,`status`) values (1,'PHA20160324000001','13693066634','123456','è¯å¸1','2016-03-24 09:31:17',0);

/*Table structure for table `wlyy_pharmacist_checked` */

DROP TABLE IF EXISTS `wlyy_pharmacist_checked`;

CREATE TABLE `wlyy_pharmacist_checked` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '审核标识',
  `pharmacist` varchar(50) DEFAULT NULL COMMENT '药师标识',
  `prescription` varchar(50) DEFAULT NULL COMMENT '处方标识',
  `status` int(11) DEFAULT NULL COMMENT '审核状态，-1审核未通过，0待审核，1审核通过，2复核通过',
  `content` varchar(1000) DEFAULT NULL COMMENT '审核结果说明内容',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '审核时间',
  `del` varchar(1) DEFAULT NULL COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=36 DEFAULT CHARSET=utf8mb4 COMMENT='药师处方审核记录表';

/*Data for the table `wlyy_pharmacist_checked` */

insert  into `wlyy_pharmacist_checked`(`id`,`code`,`pharmacist`,`prescription`,`status`,`content`,`czrq`,`del`) values (1,'CHK2016032800000001','20160322000001','PRE2016032600000002',1,'checked pass','2016-03-31 20:33:47','1'),(2,'CHK2016033100000001','20160322000001','PRE2016032600000003',1,'éå','2016-03-31 20:09:21','1'),(3,'CHK2016033100000002','20160322000001','PRE2016032600000003',-1,'éå','2016-03-31 20:14:15','1'),(4,'CHK2016033100000003','20160322000001','PRE2016033100000003',-1,'åå®¡éå','2016-03-31 20:15:43','1'),(5,'CHK2016033100000004','20160322000001','PRE2016033100000005',-1,'åå®¡éå2','2016-03-31 20:17:35','1'),(6,'CHK2016033100000005','20160322000001','PRE2016032600000003',1,'åå®¡éè¿2','2016-03-31 20:18:32','1'),(7,'CHK2016033100000006','20160322000001','PRE2016033100000002',-1,'å¤å®¡éå','2016-03-31 20:19:39','1'),(8,'CHK2016033100000007','20160322000001','PRE2016032600000003',2,'å¤å®¡éè¿','2016-03-31 20:20:07','1'),(9,'CHK2016033100000008','20160322000001','PRE2016033100000004',1,'check pass','2016-03-31 20:27:30','1'),(10,'CHK2016033100000009','20160322000001','PRE2016033100000004',2,'check fushen pass','2016-03-31 20:27:50','1'),(11,'CHK2016033100000010','20160322000001','PRE2016033100000005',1,'npass','2016-03-31 20:36:41','1'),(12,'CHK2016033100000011','20160322000001','PRE2016033100000004',1,'chushen pass','2016-03-31 20:46:45','1'),(13,'CHK2016033100000012','20160322000001','PRE2016032600000004',3,'fushen pass','2016-03-31 20:47:16','1'),(14,'CHK2016033100000013','20160322000001','PRE2016033100000003',-1,'tuihui','2016-03-31 20:47:47','1'),(15,'CHK2016040100000001','20160322000001','PRE2016040100000002',1,'','2016-04-01 10:23:46','1'),(16,'CHK2016040100000002','20160322000001','PRE2016032600000003',-1,'','2016-04-01 10:23:58','1'),(17,'CHK2016040100000003','20160322000001','PRE2016040100000001',1,'','2016-04-01 10:24:13','1'),(18,'CHK2016040100000004','20160322000001','PRE2016040100000004',1,'å¤æ¹å¯è¡','2016-04-01 11:13:53','1'),(19,'CHK2016040100000005','20160322000001','PRE2016040100000004',3,'å¤å®¡éè¿ï¼å®ç¾','2016-04-01 11:34:19','1'),(20,'CHK2016040100000006','20160322000001','PRE2016040100000004',3,'æ­£æ¯å¥½æ¶å','2016-04-01 12:01:45','1'),(21,'CHK2016040100000007','20160322000001','PRE2016032600000002',3,'checked pass','2016-04-01 12:02:58','1'),(25,'CHK2016040100000008','20160322000001','PRE2016032600000002',2,'checked pass','2016-04-01 12:30:51','1'),(26,'CHK2016040100000009','20160322000001','PRE2016040100000004',2,'checked pass','2016-04-01 12:31:55','1'),(27,'CHK2016040100000010','20160322000001','PRE2016040100000004',3,'checked pass','2016-04-01 12:36:33','1'),(28,'CHK2016040100000011','20160322000001','PRE2016040100000004',3,'checked pass','2016-04-01 12:37:06','1'),(29,'CHK2016040100000012','20160322000001','PRE2016040100000004',3,'éå±å','2016-04-01 12:53:38','1'),(30,'CHK2016040200000001','20160322000001','PRE2016040100000003',1,'','2016-04-02 10:50:13','1'),(31,'CHK2016040200000002','20160322000001','PRE2016040100000002',1,'','2016-04-02 12:36:18','1'),(32,'CHK2016040200000003','20160322000001','PRE2016040100000005',-1,'','2016-04-02 12:36:34','1'),(33,'CHK2016040200000004','20160322000001','PRE2016032600000002',-2,'','2016-04-02 12:39:58','1'),(34,'CHK2016040800000001','20160322000001','PRE2016040700000001',-1,'','2016-04-08 00:31:49','1'),(35,'CHK2016040800000002','20160322000001','PRE2016040200000001',1,'','2016-04-08 13:06:10','1');

/*Table structure for table `wlyy_points_gift` */

DROP TABLE IF EXISTS `wlyy_points_gift`;

CREATE TABLE `wlyy_points_gift` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '礼品标识',
  `name` varchar(50) DEFAULT NULL COMMENT '礼品名称',
  `points` int(11) DEFAULT NULL COMMENT '兑换积分数',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='积分礼品表';

/*Data for the table `wlyy_points_gift` */

/*Table structure for table `wlyy_points_record` */

DROP TABLE IF EXISTS `wlyy_points_record`;

CREATE TABLE `wlyy_points_record` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `user` varchar(50) NOT NULL COMMENT '患者标识',
  `points` int(11) DEFAULT NULL COMMENT '积分数',
  `table` varchar(100) DEFAULT NULL COMMENT '操作来源（对应数据库表名）',
  `oper_id` varchar(20) DEFAULT NULL COMMENT '操作来源标识',
  `des` varchar(500) DEFAULT NULL COMMENT '积分说明',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '操作日期',
  `del` varchar(1) DEFAULT '1' COMMENT '是否作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_points_record_1` (`user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='积分明细表';

/*Data for the table `wlyy_points_record` */

/*Table structure for table `wlyy_prescription` */

DROP TABLE IF EXISTS `wlyy_prescription`;

CREATE TABLE `wlyy_prescription` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '处方标识',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `doctor` varchar(50) NOT NULL COMMENT '医生标识',
  `name` varchar(50) DEFAULT NULL COMMENT '患者姓名',
  `sex` int(11) DEFAULT NULL COMMENT '患者性别',
  `age` int(11) DEFAULT NULL COMMENT '患者年龄',
  `allergy` varchar(200) DEFAULT NULL COMMENT '过敏史',
  `diagnosis` varchar(500) DEFAULT NULL COMMENT '临床诊断',
  `status` int(11) DEFAULT NULL COMMENT '处方状态，-1初审未通过，-2复审未通过，0待审核，1审核通过，2待复审 3复核通过',
  `amount` int(11) DEFAULT '0' COMMENT '续方次数',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '出处方时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废，1正常，0作废',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_prescription_1` (`code`),
  KEY `idx_wlyy_prescription_2` (`patient`),
  KEY `idx_wlyy_prescription_3` (`doctor`)
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=utf8mb4 COMMENT='患者处方记录表';

/*Data for the table `wlyy_prescription` */

insert  into `wlyy_prescription`(`id`,`code`,`patient`,`doctor`,`name`,`sex`,`age`,`allergy`,`diagnosis`,`status`,`amount`,`czrq`,`del`) values (11,'PRE2016040100000002','20160322000001','20160322000001','李碧玉',2,33,'','扁桃体发炎引起发烧',0,0,'2016-04-12 17:15:07','1'),(12,'PRE2016040100000003','20160322000001','20160322000001','李碧玉',2,33,'','身体虚弱冒冷汗',1,0,'2016-04-10 16:10:08','1'),(13,'PRE2016040100000004','20160322000003','20160322000001','窦怡宁',2,45,'','晚上梦多睡眠质量差',3,0,'2016-04-13 09:39:50','1'),(14,'PRE2016040100000005','20160322000003','20160322000001','窦怡宁',2,45,'','最近老感觉恶心，食欲不佳',0,0,'2016-04-13 09:39:51','1'),(15,'PRE2016040200000001','20160322000002','20160322000001','张华',1,26,'','手脚关节处咔咔响',0,0,'2016-04-01 11:26:40','1'),(16,'PRE2016040700000001','20160322000002','20160322000001','张华',1,26,'','感冒一个星期了还没好',0,0,'2016-03-24 10:33:42','1'),(17,'PRE2016041200000001','20160322000001','20160322000001','李碧玉',2,33,'','扁桃体发炎引起发热',0,0,'2016-03-16 15:15:00','1'),(18,'PRE2016041200000002','20160322000001','20160322000001','李碧玉',2,33,'','扁桃体发炎引起发热',0,0,'2016-03-12 14:50:20','1'),(19,'PRE2016041200000003','20160322000001','20160322000001','李碧玉',2,33,'','扁桃体发炎引起发热',0,0,'2016-03-06 16:21:17','1'),(20,'PRE2016041200000004','20160322000001','20160322000001','李碧玉',2,33,'','扁桃体发炎引起发热',0,0,'2016-03-02 15:33:13','1'),(21,'PRE2016041300000001','20160322000001','20160322000001','李碧玉',2,33,'','扁桃体发炎引起发热',0,0,'2016-04-13 09:43:54','1');

/*Table structure for table `wlyy_prescription_continue` */

DROP TABLE IF EXISTS `wlyy_prescription_continue`;

CREATE TABLE `wlyy_prescription_continue` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `prescription` varchar(50) DEFAULT NULL COMMENT '处方标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '续诊时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废，1正常，0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_prescription_continue_1` (`prescription`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='处方续方记录表';

/*Data for the table `wlyy_prescription_continue` */

insert  into `wlyy_prescription_continue`(`id`,`prescription`,`patient`,`doctor`,`czrq`,`del`) values (2,'PRE2016032600000001','20160322000001','20160322000001','2016-03-26 14:03:54','1'),(3,'PRE2016032600000001','20160322000001','20160322000001','2016-03-26 14:09:20','1'),(4,'PRE2016032600000002','20160322000001','20160322000001','2016-03-26 14:10:26','1');

/*Table structure for table `wlyy_prescription_info` */

DROP TABLE IF EXISTS `wlyy_prescription_info`;

CREATE TABLE `wlyy_prescription_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '药品标识',
  `prescription` varchar(50) DEFAULT NULL COMMENT '处方标识',
  `name` varchar(100) DEFAULT NULL COMMENT '药品名称',
  `standard` varchar(50) DEFAULT NULL COMMENT '药品规格',
  `dosage` double DEFAULT NULL COMMENT '次剂量',
  `dosage_unit` varchar(50) DEFAULT NULL COMMENT '次剂量单位',
  `frequency` int(11) DEFAULT NULL COMMENT '频次',
  `days` int(11) DEFAULT NULL COMMENT '天数',
  `total` double DEFAULT NULL COMMENT '总量',
  `total_unit` varchar(50) DEFAULT NULL COMMENT '总量单位',
  `method` varchar(500) DEFAULT NULL COMMENT '用药方法',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废，1正常，0作废',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_prescription_info_2` (`code`),
  KEY `idx_wlyy_prescription_info_1` (`prescription`)
) ENGINE=InnoDB AUTO_INCREMENT=30 DEFAULT CHARSET=utf8mb4 COMMENT='处方明细表';

/*Data for the table `wlyy_prescription_info` */

insert  into `wlyy_prescription_info`(`id`,`code`,`prescription`,`name`,`standard`,`dosage`,`dosage_unit`,`frequency`,`days`,`total`,`total_unit`,`method`,`czrq`,`del`) values (1,'PRIN2016032600000001','PRE2016032600000003','âè¯ååç§°â','âxxxâ',50,'âxxâ',1,1,5,'âxxxâ','âxxxxxâ','2016-03-26 09:47:48','1'),(4,'PRIN2016033100000003','PRE2016033100000002','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-03-31 14:38:20','1'),(5,'PRIN2016033100000004','PRE2016033100000002','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-03-31 14:38:20','1'),(6,'PRIN2016040100000001','PRE2016040100000001','å¤æ¹é¿å¸å¹æé¢ç²','6ç',2,'ç',3,9,9,'ç','é¥­åæç¨','2016-04-01 00:31:22','1'),(7,'PRIN2016040100000002','PRE2016040100000001','999æåçµè½¯è¶å','12ç²',2,'ç²',3,9,5,'ç','é¥­åæç¨','2016-04-01 00:31:22','1'),(8,'PRIN2016040100000003','PRE2016040100000002','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-01 00:32:35','1'),(9,'PRIN2016040100000004','PRE2016040100000002','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-01 00:32:35','1'),(10,'PRIN2016040100000005','PRE2016040100000003','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-01 00:33:16','1'),(11,'PRIN2016040100000006','PRE2016040100000003','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-01 00:33:16','1'),(12,'PRIN2016040100000007','PRE2016040100000004','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-01 11:09:36','1'),(13,'PRIN2016040100000008','PRE2016040100000004','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-01 11:09:36','1'),(14,'PRIN2016040100000009','PRE2016040100000005','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-01 14:11:15','1'),(15,'PRIN2016040100000010','PRE2016040100000005','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-01 14:11:15','1'),(16,'PRIN2016040200000001','PRE2016040200000001','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-02 12:04:36','1'),(17,'PRIN2016040200000002','PRE2016040200000001','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-02 12:04:36','1'),(18,'PRIN2016040700000001','PRE2016040700000001','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-07 19:16:24','1'),(19,'PRIN2016040700000002','PRE2016040700000001','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-07 19:16:24','1'),(20,'PRIN2016041200000001','PRE2016041200000001','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-12 14:36:37','1'),(21,'PRIN2016041200000002','PRE2016041200000001','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-12 14:36:37','1'),(22,'PRIN2016041200000003','PRE2016041200000002','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-12 14:40:28','1'),(23,'PRIN2016041200000004','PRE2016041200000002','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-12 14:40:28','1'),(24,'PRIN2016041200000005','PRE2016041200000003','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-12 16:21:17','1'),(25,'PRIN2016041200000006','PRE2016041200000003','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-12 16:21:17','1'),(26,'PRIN2016041200000007','PRE2016041200000004','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-12 16:22:13','1'),(27,'PRIN2016041200000008','PRE2016041200000004','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-12 16:22:13','1'),(28,'PRIN2016041300000001','PRE2016041300000001','复方阿司匹林颗粒','6片',2,'片',3,9,9,'盒','饭后服用','2016-04-13 09:43:54','1'),(29,'PRIN2016041300000002','PRE2016041300000001','999感冒灵软胶囊','12粒',2,'粒',3,9,5,'盒','饭后服用','2016-04-13 09:43:54','1');

/*Table structure for table `wlyy_prescription_template` */

DROP TABLE IF EXISTS `wlyy_prescription_template`;

CREATE TABLE `wlyy_prescription_template` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '模板标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `name` varchar(100) DEFAULT NULL COMMENT '模板标题',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废，1正常 0作废',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_prescription_template_1` (`doctor`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='处方模板表';

/*Data for the table `wlyy_prescription_template` */

insert  into `wlyy_prescription_template`(`id`,`code`,`doctor`,`name`,`czrq`,`del`) values (1,'TEMP2016032600000001','20160322000001','this is title','2016-03-26 10:20:50','1');

/*Table structure for table `wlyy_prescription_template_info` */

DROP TABLE IF EXISTS `wlyy_prescription_template_info`;

CREATE TABLE `wlyy_prescription_template_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `template` varchar(50) DEFAULT NULL COMMENT '模板标识',
  `code` varchar(50) DEFAULT NULL COMMENT '药品标识',
  `name` varchar(100) DEFAULT NULL COMMENT '药品名称',
  `standard` varchar(50) DEFAULT NULL COMMENT '药品规格',
  `dosage` double DEFAULT NULL COMMENT '次剂量',
  `dosage_unit` varchar(50) DEFAULT NULL COMMENT '次剂量单位',
  `frequency` int(11) DEFAULT NULL COMMENT '频次',
  `days` int(11) DEFAULT NULL COMMENT '天数',
  `total` double DEFAULT NULL COMMENT '总量',
  `total_unit` varchar(50) DEFAULT NULL COMMENT '总量单位',
  `method` varchar(500) DEFAULT NULL COMMENT '用药方法',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废，1正常，0作废',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_wlyy_prescription_template_info_2` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='处方模板明细表';

/*Data for the table `wlyy_prescription_template_info` */

insert  into `wlyy_prescription_template_info`(`id`,`template`,`code`,`name`,`standard`,`dosage`,`dosage_unit`,`frequency`,`days`,`total`,`total_unit`,`method`,`czrq`,`del`) values (1,'TEMP2016032600000001','PRIN2016032600000002','âè¯ååç§°â','âxxxâ',50,'âxxâ',1,1,5,'âxxxâ','âxxxxxâ','2016-03-26 10:07:22','1');

/*Table structure for table `wlyy_referral` */

DROP TABLE IF EXISTS `wlyy_referral`;

CREATE TABLE `wlyy_referral` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) DEFAULT NULL COMMENT '转诊标识',
  `doctor` varchar(50) DEFAULT NULL COMMENT '医生标识',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `hospital` varchar(100) DEFAULT NULL COMMENT '医院名称',
  `dept` varchar(100) DEFAULT NULL COMMENT '科室名称',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '添加转诊时间',
  `del` varchar(1) DEFAULT '1' COMMENT '作废标识，1正常，0作废',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COMMENT='转疹信息表';

/*Data for the table `wlyy_referral` */

insert  into `wlyy_referral`(`id`,`code`,`doctor`,`patient`,`hospital`,`dept`,`czrq`,`del`) values (1,'REF2016032600000001','20160322000001','20160322000001','zhongyiyuan','neike','2016-03-26 15:12:56','1'),(2,'REF2016032600000002','20160322000001','20160322000001','zhongyiyuan','neike','2016-03-26 15:13:33','1');

/*Table structure for table `wlyy_sign_contract` */

DROP TABLE IF EXISTS `wlyy_sign_contract`;

CREATE TABLE `wlyy_sign_contract` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '签约标识',
  `team` varchar(50) DEFAULT NULL COMMENT '签约医生团队，关联wlyy_doctor表',
  `user` varchar(50) DEFAULT NULL COMMENT '签约患者，关联wlyy_patient表',
  `uname` varchar(100) DEFAULT NULL COMMENT '患者姓名',
  `disease_condition` int(11) DEFAULT '0' COMMENT '病情：0绿标，1黄标，2红标',
  `begin` date DEFAULT NULL COMMENT '开始时间',
  `end` date DEFAULT NULL COMMENT '结束时间',
  `months` int(11) DEFAULT NULL COMMENT '一共多少个月',
  `status` int(11) DEFAULT '1' COMMENT '签约状态，1正常，0取消',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_sign_contract_1` (`team`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='三师签约信息表';

/*Data for the table `wlyy_sign_contract` */

insert  into `wlyy_sign_contract`(`id`,`code`,`team`,`user`,`uname`,`disease_condition`,`begin`,`end`,`months`,`status`) values (1,'1','2','U20160322000001','李碧玉',0,'2016-01-01','2016-12-31',12,1),(2,'2','1','U20160322000002','张华',0,'2016-05-07','2017-06-07',12,1),(4,'4','1','U20160322000004','赖小娜',0,'2016-06-15','2016-06-15',12,1);

/*Table structure for table `wlyy_sign_family` */

DROP TABLE IF EXISTS `wlyy_sign_family`;

CREATE TABLE `wlyy_sign_family` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(20) NOT NULL COMMENT '家庭签约标识（年份（两位:例如2016就填写 16）+街道编码（行政区代码）+中心/站（2位）+人数（6位））',
  `lw_code` varchar(20) DEFAULT NULL COMMENT '两网编码',
  `type` int(11) NOT NULL COMMENT '签约类型：1三师签约，2网络签约',
  `patient` varchar(50) DEFAULT NULL COMMENT '患者标识',
  `openid` varchar(50) DEFAULT NULL COMMENT '患者微信公众号openid',
  `name` varchar(50) NOT NULL COMMENT '患者姓名',
  `idcard` varchar(18) NOT NULL COMMENT '身份证号',
  `ssc` varchar(20) NOT NULL COMMENT '社保卡号',
  `mobile` varchar(15) DEFAULT NULL COMMENT '手机号',
  `emer_mobile` varchar(15) DEFAULT NULL COMMENT '紧急联系人手机号',
  `hospital` varchar(50) NOT NULL COMMENT '签约医院标识',
  `hospital_name` varchar(100) NOT NULL COMMENT '签约医院名称',
  `doctor` varchar(50) DEFAULT NULL COMMENT '签约医生',
  `doctor_name` varchar(50) DEFAULT NULL COMMENT '医生姓名',
  `begin` date DEFAULT NULL COMMENT '签约开始日期',
  `end` date DEFAULT NULL COMMENT '签约结束日期',
  `images` varchar(3000) DEFAULT NULL COMMENT '签约图片附件URL，多图以逗号分隔',
  `group_code` varchar(50) DEFAULT NULL COMMENT '分组标识',
  `status` int(11) NOT NULL COMMENT '签约状态(-1患者已取消，-2已拒绝，-3已解约，-4已到期，0待签约，1已签约，2患者申请取消签约，3医生申请取消签约',
  `reason` varchar(500) DEFAULT NULL COMMENT '解决原因',
  `czrq` datetime NOT NULL COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_sign_family_2` (`patient`),
  KEY `idx_wlyy_sign_family_3` (`doctor`),
  KEY `idx_wlyy_sign_family_1` (`idcard`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='家庭签约/三师签约';

/*Data for the table `wlyy_sign_family` */

insert  into `wlyy_sign_family`(`id`,`code`,`lw_code`,`type`,`patient`,`openid`,`name`,`idcard`,`ssc`,`mobile`,`emer_mobile`,`hospital`,`hospital_name`,`doctor`,`doctor_name`,`begin`,`end`,`images`,`group_code`,`status`,`reason`,`czrq`) values (3,'160000101000001',NULL,2,'59c61a2b5cde4c5ebb2d5bd64d23f920','123456','肖红星','620621198309190874','D12345678','18559687019','18559687019','2','厦门湖里区金山街道社区卫生服务中心','D20160322000001','徐小鹏','2016-06-12','2017-06-12',NULL,NULL,-3,'aaaaaaaa','2016-06-12 10:25:47'),(4,'1636100001000001',NULL,2,NULL,NULL,'林开清','350526155486544851','414504156','18606089941','18606089941','2','厦门湖里区金山街道社区卫生服务中心','D20160322000002','聂青\r\n','2016-06-15','2017-06-15','2016/06/15/20160615023633_148.jpg',NULL,1,NULL,'2016-06-15 02:36:33');

/*Table structure for table `wlyy_sign_web` */

DROP TABLE IF EXISTS `wlyy_sign_web`;

CREATE TABLE `wlyy_sign_web` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `code` varchar(50) NOT NULL COMMENT '签约标识',
  `doctor` varchar(50) NOT NULL COMMENT '签约医生',
  `doctor_name` varchar(50) NOT NULL COMMENT '医生姓名',
  `user` varchar(50) NOT NULL COMMENT '签约患者',
  `oper` int(11) DEFAULT NULL COMMENT '操作人（1患者，2医生）',
  `status` int(11) DEFAULT NULL COMMENT '签约状态(0待签约，1已拒绝，2已签约，3患者申请取消签约，4医生申请取消签约，5已解约)',
  `begin` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '签约开始时间',
  `end` timestamp NULL DEFAULT NULL COMMENT '签约结束时间',
  `months` int(11) DEFAULT '0' COMMENT '签约时长（如：12个月）',
  `apply_date` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '操作时间',
  `release_speak` varchar(200) DEFAULT NULL COMMENT '解约说明',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_sign_web_1` (`doctor`),
  KEY `idx_wlyy_sign_web_2` (`user`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb4 COMMENT='网络签约信息表';

/*Data for the table `wlyy_sign_web` */

insert  into `wlyy_sign_web`(`id`,`code`,`doctor`,`doctor_name`,`user`,`oper`,`status`,`begin`,`end`,`months`,`apply_date`,`release_speak`) values (9,'efd015a2ef964423a813459fd95ba654','D20160322000002','','U20160322000004',1,2,'2024-08-01 00:00:00','2025-08-01 00:00:00',0,'2016-05-30 07:40:20',NULL),(10,'efd015a2ef964423a813459fd95ba656','D20160322000002','','U20160322000001',1,1,'2016-05-30 03:52:28',NULL,0,'2016-05-30 03:52:28',NULL),(11,'efd015a2ef964423a813459fd95ba657','D20160322000002','','U20160322000002',1,4,'2016-05-30 03:54:34',NULL,0,'2016-05-30 07:44:07',NULL),(12,'efd015a2ef964423a813459fd95ba656','D20160322000002','','U20160322000003',1,4,'2016-05-30 03:59:46',NULL,0,'2016-05-30 03:59:46','不治了'),(13,'0f4d5258b0e24f36bb6140e52240031f','D20160322000002','','4363b660999c4450a3ae44c3aff55d53',1,4,'2024-11-10 00:00:00','2025-11-10 00:00:00',0,'2016-05-31 08:11:34',NULL);

/*Table structure for table `wlyy_sms` */

DROP TABLE IF EXISTS `wlyy_sms`;

CREATE TABLE `wlyy_sms` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `mobile` varchar(20) DEFAULT NULL COMMENT '接收手机号',
  `type` int(11) DEFAULT NULL COMMENT '消息类型：1微信端注册，2微信端找回密码，3医生端找回密码',
  `captcha` varchar(10) DEFAULT NULL COMMENT '验证码',
  `content` varchar(500) DEFAULT NULL COMMENT '消息内容',
  `deadline` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '过期时间',
  `status` int(11) DEFAULT NULL COMMENT '状态，0未使用，1已使用，2已过期',
  `czrq` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT '发送时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='短信记录表';

/*Data for the table `wlyy_sms` */

/*Table structure for table `wlyy_token` */

DROP TABLE IF EXISTS `wlyy_token`;

CREATE TABLE `wlyy_token` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `user` varchar(50) NOT NULL COMMENT '用户标识',
  `platform` int(11) DEFAULT NULL COMMENT '1患者APP，2医生APP，3患者微信公众号',
  `timeout` date NOT NULL COMMENT '登录超时时间',
  `imei` varchar(50) NOT NULL COMMENT '登录手机的IMEI',
  `token` varchar(100) NOT NULL COMMENT '登录信息标识',
  `czrq` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT '更新时间',
  `del` varchar(1) DEFAULT '1' COMMENT '数据是否作废（1正常，0作废）',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_token_1` (`token`),
  KEY `idx_wlyy_token_2` (`user`)
) ENGINE=InnoDB AUTO_INCREMENT=441 DEFAULT CHARSET=utf8mb4 COMMENT='用户登录信息表';

/*Data for the table `wlyy_token` */

insert  into `wlyy_token`(`id`,`user`,`platform`,`timeout`,`imei`,`token`,`czrq`,`del`) values (1,'D20160322000002',2,'2017-07-13','869515022138389','D20160322000002869515022138389','2016-06-15 00:19:58','1'),(2,'U20160322000001',1,'2017-06-08','869515022138389','U20160322000001869515022138389','2016-06-08 11:54:58','1'),(3,'D20160322000002',2,'2017-06-08','869515022138389','D20160322000001869515022138389','2016-06-12 11:09:02','1'),(45,'U20160322000002',1,'2016-06-04','864394107420848','6774845c827a2ff56c9fbf2f408d389869888a3bc22c1a8a52564e1473952cb5112dc258b77c5630f78fd7ee857fe080757b','2016-05-05 02:51:28','1'),(296,'U20160322000001',1,'2016-07-03','864895027331840','2bae67fcc55cbc773c1a395aa341f044','2016-06-03 08:57:45','1'),(314,'U20160322000004',1,'2016-07-03','864895027424645','6bc7c21cbe930a64288d4dfe515441ef','2016-06-15 16:33:09','1'),(326,'D20160322000002',2,'2016-07-07','864895024171520','391ef5e58b5f5956294f3a8ede8638b5','2016-06-07 00:46:44','1'),(327,'D20160322000002',2,'2016-07-12','864895027074564','9ea7f31ddd29721268571cd66c11ede0','2016-06-12 03:55:14','1'),(328,'D20160322000002',2,'2016-07-12','864895027074564','5f49de0375c64fa615abe7d32c6fae99','2016-06-12 03:55:14','1'),(329,'D20160322000002',2,'2016-07-12','864394104413895','539a870d39a5a15a65109e82ca0271d1','2016-06-12 08:39:52','1'),(330,'D20160322000002',2,'2016-07-12','864895027074564','f92e54577880b2f0069ba8944074daa3','2016-06-12 09:21:40','1'),(331,'D20160322000002',2,'2016-07-12','864895027074564','f92e54577880b2f0069ba8944074daa3','2016-06-12 09:21:40','1'),(332,'D20160322000002',2,'2016-07-13','864394100090390','d0196e38039bd037cb1d0dca2278a771','2016-06-13 07:27:02','1'),(333,'D20160322000002',2,'2016-07-13','864394100090390','e5bd1a15f9176ae501a45f3987303eff','2016-06-13 07:27:02','1'),(334,'D20160322000002',2,'2016-07-13','866184028815368','9c9fba211667c923943ef41c8ba8282c','2016-06-13 08:00:48','1'),(335,'D20160322000002',2,'2016-07-13','866184028815368','a98b1b621322ce44702595d059d3a92f','2016-06-13 08:10:02','1'),(336,'D20160322000002',2,'2016-07-13','864394104413895','1df059c6401fa41170a4c5bd4ce5302f','2016-06-13 09:25:59','1'),(337,'D20160322000002',2,'2016-07-13','864394100090390','be33b6c6cb0967652d85f5fba11374cf','2016-06-13 09:30:06','1'),(338,'D20160322000002',2,'2016-07-13','864394104413895','69a2d744ec30f4255d8bc1adcd07c87e','2016-06-13 09:44:23','1'),(339,'D20160322000002',2,'2016-07-13','864394100090390','2ce319853a5a9ade4f0fb7c70268fbfb','2016-06-13 10:25:26','1'),(340,'D20160322000002',2,'2016-07-13','864394100090390','7474fb796432a1b2ff7f431626214d87','2016-06-13 10:37:15','1'),(341,'D20160322000002',2,'2016-07-13','864394104413895','60e0a366b87dec1569ff6b7cc030ed0d','2016-06-13 10:42:32','1'),(342,'D20160322000002',2,'2016-07-13','866184028815368','29cdbaefd7422d1f427bf00d45eeb5b5','2016-06-13 11:38:07','1'),(343,'D20160322000002',2,'2016-07-13','864895027074564','cfbe66757eb5cfc5a01aa541a0d8ae69','2016-06-13 11:51:31','1'),(344,'D20160322000002',2,'2016-07-13','864394104413895','b76b5f26c7b859fa78d941a383d77b8b','2016-06-13 11:57:33','1'),(345,'D20160322000002',2,'2016-07-13','864895027074564','81ca973d34d5d5ee1a82dbf136b4d6c6','2016-06-13 11:58:59','1'),(346,'D20160322000002',2,'2016-07-13','864895027074564','829e0c123ac903687a5bf827405daeb9','2016-06-13 12:04:45','1'),(347,'D20160322000002',2,'2016-07-13','864895024156166','f968d109a56141ce617f0a3e72dc112d','2016-06-13 12:11:52','1'),(348,'D20160322000002',2,'2016-07-13','864595021519966','0831038017523df4e83d04df9b02c61a','2016-06-13 12:12:04','1'),(349,'D20160322000002',2,'2016-07-13','865763022219379','83a5715eeacccdd422dea3047fe7c125','2016-06-13 12:14:41','1'),(350,'D20160322000002',2,'2016-07-13','864595021519966','02c135d7d939e169efaf7c930fd09807','2016-06-13 12:18:24','1'),(351,'D20160322000002',2,'2016-07-13','864394104413895','e5774da65e21a5e1f3cad8e518fbe706','2016-06-13 12:29:09','1'),(352,'D20160322000002',2,'2016-07-13','864895027074564','12cb7d081e554ba8147cacc7a481c67a','2016-06-13 12:36:53','1'),(353,'D20160322000002',2,'2016-07-13','864895027074564','2df0d222f1908e4e815358ef80a7c1f6','2016-06-13 12:36:53','1'),(354,'D20160322000002',2,'2016-07-13','864587026357435','76d50fab9ba31e27eacccd6cc3ada2b7','2016-06-13 12:47:12','1'),(355,'D20160322000002',2,'2016-07-13','864895027074564','8418107b5ff44015c1286e3349855127','2016-06-13 13:55:07','1'),(356,'D20160322000002',2,'2016-07-13','864895027074564','3067d8ebb1b0239dcbc1a1524e2c9399','2016-06-13 13:55:07','1'),(357,'D20160322000002',2,'2016-07-13','864895027074564','8418107b5ff44015c1286e3349855127','2016-06-13 13:55:07','1'),(358,'D20160322000002',2,'2016-07-13','864895027074564','3067d8ebb1b0239dcbc1a1524e2c9399','2016-06-13 13:55:07','1'),(359,'D20160322000002',2,'2016-07-13','864895027074564','3067d8ebb1b0239dcbc1a1524e2c9399','2016-06-13 13:55:07','1'),(360,'D20160322000002',2,'2016-07-13','864895027074564','3067d8ebb1b0239dcbc1a1524e2c9399','2016-06-13 13:55:07','1'),(361,'D20160322000002',2,'2016-07-13','864895027074564','3dd8950453d5066df61735ca139d5410','2016-06-13 13:55:07','1'),(362,'D20160322000002',2,'2016-07-13','864895027074564','b99f0344a4796f257b134150160f144b','2016-06-13 13:55:07','1'),(363,'D20160322000002',2,'2016-07-13','864895027074564','743f2e957ea52e9a8475e0507918e5a6','2016-06-13 13:55:07','1'),(364,'D20160322000002',2,'2016-07-13','864895027074564','066f4db4efc939f7b62f6aa436db6d5a','2016-06-13 13:55:07','1'),(365,'D20160322000002',2,'2016-07-13','864394100090390','7d9f7998c4bbe25b600f0326be100e1f','2016-06-13 14:19:03','1'),(366,'D20160322000002',2,'2016-07-13','864895027074564','a793facecf727d608edb118053f3f010','2016-06-13 15:10:11','1'),(367,'D20160322000002',2,'2016-07-13','864895027074564','74cfc9382bfa6393d8ab9842dfe1f2a2','2016-06-13 15:10:11','1'),(368,'D20160322000002',2,'2016-07-13','864895027074564','f1033581e7c927435cc8fcad047f742e','2016-06-13 15:27:58','1'),(369,'D20160322000002',2,'2016-07-13','864895027074564','fc186bfd2e36c957e30b022fddbed45c','2016-06-13 15:27:58','1'),(370,'D20160322000002',2,'2016-07-13','864895027074564','84e7cf08f77e49ed35aa244fc7cf001e','2016-06-13 15:35:59','1'),(371,'D20160322000002',2,'2016-07-13','864895027074564','164f28a9aa4d68af0f76a8669871d1d4','2016-06-13 15:35:59','1'),(372,'D20160322000002',2,'2016-07-13','866184028815368','1987c499f2fd24ab3fdd4ffcc0475847','2016-06-13 15:37:57','1'),(373,'D20160322000002',2,'2016-07-13','864895027074564','bcbaf8a941480dc77d5d7414c0389c14','2016-06-13 15:52:03','1'),(374,'D20160322000002',2,'2016-07-13','864895027074564','290ab7c3210f740b5a947fca52954ce6','2016-06-13 15:52:04','1'),(375,'D20160322000002',2,'2016-07-13','864394104413895','9196ef70823f046ab762553ec079f717','2016-06-13 15:55:20','1'),(376,'D20160322000002',2,'2016-07-13','866184028815368','12ab32edc9fa0affae873d619d2fe6bc','2016-06-13 15:55:45','1'),(377,'D20160322000002',2,'2016-07-13','864895027074564','080d082b73202954400b63952b532e8b','2016-06-13 15:57:41','1'),(378,'D20160322000002',2,'2016-07-13','864895027074564','2954b83147786f3e1be118aaacbc708d','2016-06-13 15:57:41','1'),(379,'D20160322000002',2,'2016-07-13','866184028815368','b986acaf849c8f1e21348ac687845801','2016-06-13 16:01:00','1'),(380,'D20160322000002',2,'2016-07-13','864895027074564','4c662665633d3acac1dbcdd3415440a9','2016-06-13 16:01:46','1'),(381,'D20160322000002',2,'2016-07-13','864895027074564','773d639591cf91101cd1f5021af17ac0','2016-06-13 16:01:46','1'),(382,'D20160322000002',2,'2016-07-13','864895027074564','cffbcf9ddb9d14e0417c0989dc1c27e3','2016-06-13 16:03:52','1'),(383,'D20160322000002',2,'2016-07-13','864895027074564','9f00528648c34d50b5069d319367bc0e','2016-06-13 16:03:52','1'),(384,'D20160322000002',2,'2016-07-13','864895027074564','886a9bfc3b6e35b8a165419062f02f2a','2016-06-13 16:06:53','1'),(385,'D20160322000002',2,'2016-07-13','864895027074564','44cf88d8433f551eedd81321f5667f42','2016-06-13 16:06:53','1'),(386,'D20160322000002',2,'2016-07-13','864895027074564','64f969ca0ba48f0e81b6cb9d68cf106c','2016-06-13 16:09:11','1'),(387,'D20160322000002',2,'2016-07-13','864895027074564','e9ba4adce696ffc31877ea5f080a1cfb','2016-06-13 16:09:11','1'),(388,'D20160322000002',2,'2016-07-13','866184028815368','9baebe116dba11d093deb444a8537be9','2016-06-13 16:09:13','1'),(389,'D20160322000002',2,'2016-07-13','864895027074564','3cc9a8495c4b274aadfa236cf4c2802b','2016-06-13 16:19:25','1'),(390,'D20160322000002',2,'2016-07-13','864895027074564','73f761fb647a65fff7274cc6f9cec49f','2016-06-13 16:19:25','1'),(391,'D20160322000002',2,'2016-07-13','864895027074564','2921334a65be0e84683cc0dfb7caa2a4','2016-06-13 16:23:52','1'),(392,'D20160322000002',2,'2016-07-13','864895027074564','8b753c5a7aff7c9bf66241baf00f61df','2016-06-13 16:23:52','1'),(393,'D20160322000002',2,'2016-07-13','867633021007406','336f10c407f9cb0cbf55b45a332e40c8','2016-06-13 16:45:30','1'),(394,'D20160322000002',2,'2016-07-13','867633021007406','031b5e550ec63bd35b9cd2beffce22b4','2016-06-13 16:45:30','1'),(395,'D20160322000002',2,'2016-07-13','867633021007406','31d79e8de641c73f4c71be2f3ed43924','2016-06-13 16:47:27','1'),(396,'D20160322000002',2,'2016-07-13','867633021007406','d6538be4e1e0e1c8aaf5ae5481ceafb0','2016-06-13 16:47:27','1'),(397,'D20160322000002',2,'2016-07-13','864895027074564','1f654aa328dcfa058836811f8bf5ae80','2016-06-13 16:52:35','1'),(398,'D20160322000002',2,'2016-07-13','864895027074564','5e6a496b9ec33577f97fde68f478bd27','2016-06-13 16:52:35','1'),(399,'D20160322000001',2,'2016-07-13','867633021007406','6b30f4c99e9af0d1582924bccf81a4a3','2016-06-13 16:57:01','1'),(400,'D20160322000001',2,'2016-07-13','867633021007406','a50c25ebde389aac9911e4358af0bdd5','2016-06-13 16:57:01','1'),(401,'D20160322000002',2,'2016-07-13','864895027074564','90242b9d52fad3c96f5647fb3721e3f0','2016-06-13 17:08:12','1'),(402,'D20160322000002',2,'2016-07-13','864895027074564','ed97d7825c909161e20c88fcd00187d1','2016-06-13 17:08:12','1'),(403,'D20160322000001',2,'2016-07-13','867633021007406','6b9ffccb2b1dd6f29b0d1cb7d2c131bc','2016-06-13 17:10:59','1'),(404,'D20160322000001',2,'2016-07-13','867633021007406','a4be501ebc8ca607f1623052d7df7849','2016-06-13 17:11:00','1'),(405,'D20160322000001',2,'2016-07-13','867633021007406','2ceb9ec65c552bcaaad36fb7ec51e70a','2016-06-13 17:24:47','1'),(406,'D20160322000001',2,'2016-07-13','867633021007406','733e5cfdaa1bbe0a3565869603898b8c','2016-06-13 17:24:47','1'),(407,'D20160322000002',2,'2016-07-13','864895027074564','e6825ca0bbd9cf2218ef67d5ced0d25a','2016-06-13 17:39:06','1'),(408,'D20160322000002',2,'2016-07-13','864895027074564','952d2b1057ac5db4b195ed932ed1520d','2016-06-13 17:39:06','1'),(409,'D20160322000001',2,'2016-07-13','867633021007406','f3a4055ee1bb457f8498a9c56a2de5d4','2016-06-13 17:40:35','1'),(410,'D20160322000001',2,'2016-07-13','867633021007406','1bb66a47de5e8d09b263518e0ae0e445','2016-06-13 17:40:35','1'),(411,'D20160322000001',2,'2016-07-13','864895021692171','a0b6da6ae4a58a03cbafb4af37ba88c2','2016-06-13 17:51:36','1'),(412,'D20160322000001',2,'2016-07-13','864895021692171','8a452987c942449c82a5cb5264cd61a8','2016-06-13 17:51:36','1'),(413,'D20160322000002',2,'2016-07-13','864895027074564','1f95168684038bab443fadbc4a32e503','2016-06-13 18:05:18','1'),(414,'D20160322000002',2,'2016-07-13','864895027074564','0573c795913c574c5868932582293f46','2016-06-13 18:05:18','1'),(415,'D20160322000001',2,'2016-07-13','867633021007406','781ae224baea4aafdf81f5c977747d05','2016-06-13 18:06:33','1'),(416,'D20160322000001',2,'2016-07-13','867633021007406','b716c76b60959e3705783101efd1bce3','2016-06-13 18:06:33','1'),(417,'D20160322000001',2,'2016-07-13','867633021007406','13359b2cb8adad577be2866c16aed21a','2016-06-13 18:21:31','1'),(418,'D20160322000001',2,'2016-07-13','867633021007406','af629bb1c1db23fdb785ddbbb5185abf','2016-06-13 18:21:31','1'),(419,'D20160322000001',2,'2016-07-13','867633021007406','1823083b5f4e07b4371e5fd5a8a2e626','2016-06-13 18:27:52','1'),(420,'D20160322000001',2,'2016-07-13','867633021007406','9b09f3b31b3ec438213c6e6da1cc9f95','2016-06-13 18:27:52','1'),(421,'D20160322000001',2,'2016-07-13','867633021007406','cf0ed539976be9b612be9bb22c3996f9','2016-06-13 18:34:30','1'),(422,'D20160322000001',2,'2016-07-13','867633021007406','5828365b329ba0a4284091d6477e4f33','2016-06-13 18:34:30','1'),(423,'D20160322000002',2,'2016-07-14','864895029027842','08f13bb09c843646f288d5368c719d46','2016-06-14 02:22:12','1'),(424,'D20160322000002',2,'2016-07-14','864103023172734','f75ac5e47946c87fdccad6a4eb5bbaf3','2016-06-14 02:35:26','1'),(425,'D20160322000002',2,'2016-07-14','864103023172734','8e95dc1060060e52b49ef0946e5e246f','2016-06-14 02:45:13','1'),(426,'D20160322000002',2,'2016-07-14','866184028815368','b5f1533da611436f8cd69f2b24065b3c','2016-06-14 02:45:15','1'),(427,'D20160322000002',2,'2016-07-14','864587026357435','7b50fd43db434b049512c9f03ace07ae','2016-06-14 02:49:19','1'),(428,'D20160322000002',2,'2016-07-14','864587026357435','86ea77598dab65aac052d27d87f20209','2016-06-14 02:49:37','1'),(429,'D20160322000002',2,'2016-07-14','864587026357435','801b2bf5a95b0474ba7d6b6e42522ad0','2016-06-14 02:50:01','1'),(430,'D20160322000002',2,'2016-07-14','864587026357435','b1d7c2fac4fa72eed715caa227ac2ade','2016-06-14 03:27:54','1'),(431,'D20160322000002',2,'2016-07-14','864394104413895','b9e0ab1d8b04ec2b6b2e288f0c6ca370','2016-06-14 07:26:46','1'),(432,'D20160322000002',2,'2016-07-14','864394104413895','1c23c1e0e78e9f61b7e8957edce462cd','2016-06-14 08:20:11','1'),(433,'D20160322000002',2,'2016-07-14','864595021519966','32cd7f8b3a871eb0aedadbff16e5f4f4','2016-06-14 08:20:25','1'),(434,'D20160322000002',2,'2016-07-14','864587026357435','d15e3fd6a104c7ac06694e96494baa04','2016-06-14 08:46:08','1'),(435,'D20160322000002',2,'2016-07-14','864394104413895','b71581e12e7d42a3043536a96c2ae412','2016-06-14 09:29:11','1'),(436,'D20160322000002',2,'2016-07-14','864595021519966','395a0b040dde051f403960ac08b2d591','2016-06-14 09:35:46','1'),(437,'D20160322000002',2,'2016-07-14','864595021519966','d3ba4e61a8cbcbc6dd588849ae6bc642','2016-06-14 10:13:15','1'),(438,'D20160322000002',2,'2016-07-14','865763022219379','bc7c8f2637f5fa7b085eae5197ae5c3c','2016-06-14 10:17:06','1'),(439,'D20160322000002',2,'2016-07-15','864394104413895','7d61ac60c279f0dbe164cadf07569357','2016-06-15 02:30:16','1'),(440,'D20160322000002',2,'2016-07-15','864394104413895','01a76797eb4b1a9a31c1a16654712d08','2016-06-15 06:09:12','1');

/*Table structure for table `wlyy_version` */

DROP TABLE IF EXISTS `wlyy_version`;

CREATE TABLE `wlyy_version` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `code` varchar(10) NOT NULL COMMENT '版本编码',
  `name` varchar(10) NOT NULL COMMENT '版本名称',
  `version_int` double DEFAULT NULL COMMENT '数字版本号',
  `version_str` varchar(10) DEFAULT NULL COMMENT '字符串版本号',
  `url` varchar(300) DEFAULT NULL COMMENT '更新链接地址',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_version_1` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COMMENT='版本号表';

/*Data for the table `wlyy_version` */

insert  into `wlyy_version`(`id`,`code`,`name`,`version_int`,`version_str`,`url`) values (1,'app_doc','医生端版本号',2,'2.0','http://www.xmtyw.cn/wlyy/doctor.app');

/*Table structure for table `wlyy_wx_patient` */

DROP TABLE IF EXISTS `wlyy_wx_patient`;

CREATE TABLE `wlyy_wx_patient` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '业务无关主键',
  `openid` varchar(50) NOT NULL COMMENT '微信openid',
  `patient` varchar(50) NOT NULL COMMENT '患者标识',
  `status` int(11) DEFAULT '1' COMMENT '状态（1正常，0注销）',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `idx_wlyy_user_3` (`openid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='微信与患者关联表/微信登录信息表';

/*Data for the table `wlyy_wx_patient` */

/*Table structure for table `wx_access_token` */

DROP TABLE IF EXISTS `wx_access_token`;

CREATE TABLE `wx_access_token` (
  `access_token` varchar(300) NOT NULL COMMENT '微信中控服务器access_token',
  `add_timestamp` decimal(15,0) NOT NULL COMMENT '添加时的秒数',
  `expires_in` int(11) NOT NULL COMMENT '	凭证有效时间（秒）',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '操作时间',
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4;

/*Data for the table `wx_access_token` */

insert  into `wx_access_token`(`access_token`,`add_timestamp`,`expires_in`,`czrq`,`id`) values ('-HZGhmY3OlHszK4YXWyYpLYNKVycfJQUEApKC7r0RHuQipSVpDKwvsCGZObIQWrLlMhq9xMG4DyhJtbzYQKx66PwGbqp7_Oc5J9M3YRPMowNUIoNz45Qz-O-XkxJQGK3QGXjCBAFVM','1465970332147',7200,'2016-06-15 13:58:52',6);

/*Table structure for table `wx_jsapi_ticket` */

DROP TABLE IF EXISTS `wx_jsapi_ticket`;

CREATE TABLE `wx_jsapi_ticket` (
  `jsapi_ticket` varchar(300) NOT NULL COMMENT '调用微信JS接口的临时票据',
  `add_timestamp` decimal(15,0) NOT NULL COMMENT '添加时的秒数',
  `expires_in` int(11) NOT NULL COMMENT '	凭证有效时间（秒）',
  `czrq` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '操作时间',
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4;

/*Data for the table `wx_jsapi_ticket` */

insert  into `wx_jsapi_ticket`(`jsapi_ticket`,`add_timestamp`,`expires_in`,`czrq`,`id`) values ('kgt8ON7yVITDhtdwci0qeZlmjdYaPVYWRn6cmBRozdGWUQnOF0LquBEge9QRSNiZI57dw1aEQq2s38-xvbaG2w','1465974892170',7200,'2016-06-15 15:14:52',1);

/*Table structure for table `wx_menu` */

DROP TABLE IF EXISTS `wx_menu`;

CREATE TABLE `wx_menu` (
  `sup_menuid` varchar(50) DEFAULT NULL,
  `menuid` varchar(50) DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `name` varchar(50) DEFAULT NULL,
  `key` varchar(50) DEFAULT NULL,
  `url` varchar(100) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='微信自定义菜单表';

/*Data for the table `wx_menu` */

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
